function WsClient() {
    this.ws = null;
    this.url = "";
    this.evtTarget = null;
    this.evtHandler = {};
    this.isWsUseFileReader = globalparams.get("isWsUseFileReader");
    this.userCertUrl = globalparams.get("wsCertUrl");
    WsClient.prototype.connect = function(url, fun_create_ws) {
        if (this.ws != null) {
            this.ws.close(3001, "");
            this.ws.onopen = null;
            this.ws.onclose = null;
            this.ws.onmessage = null;
            this.ws.onerror = null;
            this.ws = null;
        }
        this.url = url;
        if (fun_create_ws == null) {
            if (globalparams.get("platType") == "VIVO_QG") {
                this.ws = qg.createWebSocket({
                    url: url,
                    protocols: ["protocols1"]
                });
            } else if (globalparams.get("platType") == "OPPO_QG" && this.userCertUrl) {
                this.ws = new WebSocket(this.url, [], this.userCertUrl);
            } else if (globalparams.get("platType") == "QQPLAY") {
                console.log("new bk websocket");
                this.ws = new BK.WebSocket(this.url);
            } else {
                this.ws = new WebSocket(this.url);
            }
        } else {
            this.ws = fun_create_ws(this.url);
        }
        var _wsclient = this;
        if (globalparams.get("platType") == "QQPLAY") {
            console.log("wsclient set qqplay callback");
            this.ws.onOpen = function(evt) {
                console.log("wsclient  qqplay callback onOpen", evt);
                if (_wsclient.evtTarget != null) {
                    _wsclient.evtHandler["on_open"].call(_wsclient.evtTarget);
                } else {
                    _wsclient.evtHandler["on_open"]();
                }
            };
            this.ws.onClose = function(evt) {
                console.log("wsclient  qqplay callback onClose", JSON.stringify(evt));
                if (_wsclient.evtTarget != null) {
                    _wsclient.evtHandler["on_close"].call(_wsclient.evtTarget, evt.code);
                } else {
                    _wsclient.evtHandler["on_close"](evt.code);
                }
            };
            this.ws.onMessage = function(evt_1, evt) {
                var cc = cc || null;
                if (cc == null) {
                    if (_wsclient.evtTarget != null) {
                        _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, evt.data);
                    } else {
                        if (_wsclient.isWsUseFileReader) {
                            var file_reader = new FileReader();
                            file_reader.onload = function() {
                                if (_wsclient.ws.readyState == WebSocket.OPEN) {
                                    if (_wsclient.evtTarget != null) {
                                        _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, this.result);
                                    } else {
                                        _wsclient.evtHandler["on_message"](this.result);
                                    }
                                }
                            };
                            file_reader.readAsArrayBuffer(evt.data);
                        } else {
                            if (evt.isBinary) {
                                var buf = evt.data;
                                buf.rewind();
                                var ab = new ArrayBuffer(buf.length);
                                var dv = new DataView(ab);
                                while (!buf.eof) {
                                    dv.setUint8(buf.pointer, buf.readUint8Buffer());
                                }
                                _wsclient.evtHandler["on_message"](ab);
                            } else {
                                console.log("BK.WebSocket data type is not binary");
                            }
                        }
                    }
                } else {
                    if (cc.sys.isNative) {
                        if (_wsclient.evtTarget != null) {
                            _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, evt.data);
                        } else {
                            _wsclient.evtHandler["on_message"](evt.data);
                        }
                    } else {
                        if (_wsclient.isWsUseFileReader) {
                            var file_reader = new FileReader();
                            file_reader.readAsArrayBuffer(evt.data);
                            file_reader.onload = function() {
                                if (_wsclient.ws.readyState == WebSocket.OPEN) {
                                    if (_wsclient.evtTarget != null) {
                                        _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, this.result);
                                    } else {
                                        _wsclient.evtHandler["on_message"](this.result);
                                    }
                                }
                            };
                        } else {
                            if (_wsclient.ws.readyState == WebSocket.OPEN) {
                                if (_wsclient.evtTarget != null) {
                                    _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, evt.data);
                                } else {
                                    _wsclient.evtHandler["on_message"](evt.data);
                                }
                            }
                        }
                    }
                }
            };
            this.ws.onError = function(evt) {
                console.log("wsclient  qqplay callback onError", JSON.stringify(evt));
                var cb = _wsclient.evtHandler["on_error"];
                if (cb) {
                    if (_wsclient.evtTarget != null) {
                        cb.call(_wsclient.evtTarget, evt);
                    } else {
                        cb(evt);
                    }
                }
                this.close();
            };
        } else {
            console.log("wsclient other callback");
            this.ws.onopen = function(evt) {
                if (_wsclient.evtTarget != null) {
                    _wsclient.evtHandler["on_open"].call(_wsclient.evtTarget);
                } else {
                    _wsclient.evtHandler["on_open"]();
                }
            };
            this.ws.onclose = function(evt) {
                if (_wsclient.evtTarget != null) {
                    _wsclient.evtHandler["on_close"].call(_wsclient.evtTarget, evt.code);
                } else {
                    _wsclient.evtHandler["on_close"](evt.code);
                }
            };
            this.ws.onmessage = function(evt) {
                var cc = cc || null;
                if (cc == null) {
                    if (_wsclient.evtTarget != null) {
                        _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, evt.data);
                    } else {
                        if (_wsclient.isWsUseFileReader) {
                            var file_reader = new FileReader();
                            file_reader.readAsArrayBuffer(evt.data);
                            file_reader.onload = function() {
                                if (_wsclient.ws.readyState == WebSocket.OPEN) {
                                    if (_wsclient.evtTarget != null) {
                                        _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, this.result);
                                    } else {
                                        _wsclient.evtHandler["on_message"](this.result);
                                    }
                                }
                            };
                        } else {
                            _wsclient.evtHandler["on_message"](evt.data);
                        }
                    }
                } else {
                    if (cc.sys.isNative) {
                        if (_wsclient.evtTarget != null) {
                            _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, evt.data);
                        } else {
                            _wsclient.evtHandler["on_message"](evt.data);
                        }
                    } else {
                        if (_wsclient.isWsUseFileReader) {
                            var file_reader = new FileReader();
                            file_reader.readAsArrayBuffer(evt.data);
                            file_reader.onload = function() {
                                if (_wsclient.ws.readyState == WebSocket.OPEN) {
                                    if (_wsclient.evtTarget != null) {
                                        _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, this.result);
                                    } else {
                                        _wsclient.evtHandler["on_message"](this.result);
                                    }
                                }
                            };
                        } else {
                            if (_wsclient.ws.readyState == WebSocket.OPEN) {
                                if (_wsclient.evtTarget != null) {
                                    _wsclient.evtHandler["on_message"].call(_wsclient.evtTarget, evt.data);
                                } else {
                                    _wsclient.evtHandler["on_message"](evt.data);
                                }
                            }
                        }
                    }
                }
            };
            this.ws.onerror = function(evt) {
                var cb = _wsclient.evtHandler["on_error"];
                if (cb) {
                    if (_wsclient.evtTarget != null) {
                        cb.call(_wsclient.evtTarget, evt);
                    } else {
                        cb(evt);
                    }
                }
                this.close();
            };
        }
    };
    WsClient.prototype.close = function(code, error) {
        console.log("WsClient.close", code, error, this.ws, this.ws != null);
        code = code || 1e3;
        error = error || "unknow";
        if (this.ws != null) {
            console.log("WsClient == null");
            this.ws.close(code, error);
        }
    };
    WsClient.prototype.setEvtTarget = function(target) {
        this.evtTarget = target;
    };
    WsClient.prototype.setEvtHandler = function(event, handler) {
        this.evtHandler[event] = handler;
    };
    WsClient.prototype.send = function(bytebuf) {
        if (this.ws == null) return false;
        if (this.ws.readyState == WebSocket.OPEN) {
            this.ws.send(bytebuf);
            return true;
        }
        return false;
    };
    WsClient.prototype.getState = function() {
        if (this.ws == null) {
            return "closed";
        }
        if (this.ws.readyState == WebSocket.OPEN) {
            return "open";
        }
        if (this.ws.readyState == WebSocket.CLOSED) {
            return "closed";
        }
        if (this.ws.readyState == WebSocket.CLOSING) {
            return "closeing";
        }
        return "closed";
    };
}

window["WsClient"] = WsClient;