var tpfplat = function(protoChannel, eventHandler, version) {
    this.protoChannel = protoChannel;
    this.eventHandler = eventHandler;
    this.platUserInfo = {};
    this.appId = 0;
    this.channelId = 0;
    this.battle = null;
    this.url = "";
    this.isReconnecting = false;
    this.isLogin = false;
    this.funcCreateWS = null;
    this.version = version;
    this.clientVersionCode = version;
    var self = this;
    /**
     * 登录返回
     * */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_LoginPlatRspID"], function(buf, len) {
        var rsp = platform_proto.platform.login.LoginPlatRsp.decode(buf, len);
        self._onPlatLogin(rsp);
    });
    /**
     * 重连返回
     * */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_ReConnectRspID"], function(buf, len) {
        var rsp = platform_proto.platform.login.ReConnectRsp.decode(buf, len);
        self._onPlatReLogin(rsp);
    });
    /**
     * 强制离线返回
     * */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_ForceOfflineID"], function(buf, len) {
        self._onForceOffline();
    });
    /**
     * 心跳
     * */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_COM_HeartBeat"], function(buf, len) {
        var rsp = platform_proto.platform.login.HeartBeat.decode(buf, len);
        self._onHeartbeat(rsp);
    });
    /**
     * 匹配返回
     * */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_StartMatchRspID"], function(buf, len) {
        var rsp = platform_proto.platform.match.MatchStartRsp.decode(buf, len);
        self._onMatchRsp(rsp);
    });
    /**
     * 匹配取消返回
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_CancelMatchRspID"], function(buf, len) {
        var rsp = platform_proto.platform.match.CancelMatchRsp.decode(buf, len);
        self._onMathCancel(rsp);
    });
    /**
     * 匹配结果返回
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_MatchResultRspID"], function(buf, len) {
        var rsp = platform_proto.platform.match.MatchResultRsp.decode(buf, len);
        self._onMatchResult(rsp);
    });
    /**
     * 玩家信息返回
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_UserInfoRspID"], function(buf, len) {
        var UserInfoRsp = platform_proto.platform.Basic.UserInfoRsp;
        var userinfoRsp = UserInfoRsp.decode(buf, len);
        console.log(userinfoRsp);
        var userInfo = userinfoRsp.userInfo;
        self._onUserInfoRsp(userInfo);
    });
    /**
     * 更新存储返回
     * Msg_C2S_UpdateStorageRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_UpdateStorageRspID"], function(buf, len) {
        var UpdateStorageRsp = platform_proto.platform.storage.UpdateStorageRsp;
        var updateStorage = UpdateStorageRsp.decode(buf, len);
        console.log(updateStorage);
        self._onUpdateStorageRsp(updateStorage);
    });
    /**
     * 获取存储返回
     * Msg_C2S_UserStorageInfoRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_UserStorageInfoRspID"], function(buf, len) {
        var UserStorageInfoRsp = platform_proto.platform.storage.UserStorageInfoRsp;
        var userStorageInfoRsp = UserStorageInfoRsp.decode(buf, len);
        console.log(userStorageInfoRsp);
        self._onUserStorageInfoRsp(userStorageInfoRsp);
    });
    /**
     * 更新排行榜返回
     * Msg_C2S_RankInfoRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_UpdRankRspID"], function(buf, len) {
        var UpdRankRsp = platform_proto.platform.rank.UpdRankRsp;
        var updRankRsp = UpdRankRsp.decode(buf, len);
        console.log(updRankRsp);
        self._onUpdRankRsp(updRankRsp);
    });
    /**
     * 更新排行榜返回
     * Msg_C2S_RankInfoRspV2ID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_UpdRankRspV2ID"], function(buf, len) {
        var UpdRankRspV2 = platform_proto.platform.rank.UpdRankRspV2;
        var updRankRspV2 = UpdRankRspV2.decode(buf, len);
        console.log(updRankRspV2);
        self._onUpdRankRspV2(updRankRspV2);
    });
    /**
     * 更新一个参数排行榜返回
     * Msg_C2S_RankInfoRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_UpdRankOneParamRspID"], function(buf, len) {
        var UpdRankOneParamRsp = platform_proto.platform.rank.UpdRankOneParamRsp;
        var updRankOneParamRsp = UpdRankOneParamRsp.decode(buf, len);
        console.log(updRankOneParamRsp);
        self._onUpdRankOneParamRsp(updRankOneParamRsp);
    });
    /**
     * 排行榜返回
     * Msg_C2S_RankInfoRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_RankInfoRspID"], function(buf, len) {
        var RankInfoRsp = platform_proto.platform.rank.RankInfoRsp;
        var rankInfoRsp = RankInfoRsp.decode(buf, len);
        console.log(rankInfoRsp);
        self._onRankInfoRsp(rankInfoRsp);
    });
    /**
     * 新的排行榜返回
     * Msg_C2S_RankInfoRspV2ID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef.Msg_C2S_RankInfoRspV2ID, function(buf, len) {
        var RankInfoRspV2 = platform_proto.platform.rank.RankInfoRspV2;
        var rsp = RankInfoRspV2.decode(buf, len);
        console.log(rsp);
        self._onRankInfoRspV2(rsp);
    });
    /**
     * 获取个人排行榜信息返回
     * Msg_C2S_UserInRankInfoRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_UserInRankInfoRspID"], function(buf, len) {
        var UserInRankInfoRsp = platform_proto.platform.rank.UserInRankInfoRsp;
        var userInRankInfoRsp = UserInRankInfoRsp.decode(buf, len);
        self._onUserInRankInfoRsp(userInRankInfoRsp);
    });
    /**
     * 新的获取个人排行榜信息返回
     * Msg_C2S_UserInRankInfoRspV2ID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef.Msg_C2S_UserInRankInfoRspV2ID, function(buf, len) {
        var UserInRankInfoRspV2 = platform_proto.platform.rank.UserInRankInfoRspV2;
        var UserInRankInfoRspV2 = UserInRankInfoRspV2.decode(buf, len);
        self._onUserInRankInfoRspV2(UserInRankInfoRspV2);
    });
    /**
     * 获取个人对战信息返回
     * Msg_C2S_UserBattleInfoRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_UserBattleInfoRspID"], function(buf, len) {
        var UserGameBattleInfoRsp = platform_proto.platform.Basic.UserGameBattleInfoRsp;
        var userGameBattleInfoRsp = UserGameBattleInfoRsp.decode(buf, len);
        self._onUserBattleInfoRsp(userGameBattleInfoRsp);
    });
    /**
     * 获取宝箱信息返回
     * Msg_C2S_BoxDetailRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_BoxDetailRspID"], function(buf, len) {
        var BoxDetailRsp = platform_proto.platform.Box.BoxDetailRsp;
        var boxDetailRsp = BoxDetailRsp.decode(buf, len);
        self._onBoxDetailRsp(boxDetailRsp.bFinish, boxDetailRsp.currboxDetail);
    });
    /**
     * 获取宝箱奖励信息返回
     * Msg_C2S_BoxAwardRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_BoxAwardRspID"], function(buf, len) {
        var BoxAwardRsp = platform_proto.platform.Box.BoxAwardRsp;
        var boxAwardRsp = BoxAwardRsp.decode(buf, len);
        self._onBoxAwardRsp(boxAwardRsp.gameInfo, boxAwardRsp.nextBoxDetail);
    });
    /**
     * 获取游戏配置信息返回
     * Msg_C2S_BoxDetailRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_GameCfgRspID"], function(buf, len) {
        var GameCfgRsp = platform_proto.platform.Basic.GameCfgRsp;
        var gameCfgRsp = GameCfgRsp.decode(buf, len);
        self._onGameCfgRsp(gameCfgRsp);
    });
    /**
     * 获取随机数返回
     * Msg_C2S_RandomRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_RandomRspID"], function(buf, len) {
        var RandomRsp = platform_proto.platform.Basic.RandomRsp;
        var randomRsp = RandomRsp.decode(buf, len);
        self._onRandomRsp(randomRsp);
    });
    /**
     * 加入匹配池的应答
     * Msg_C2S_StandGameAddMatchPoolRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_StandGameAddMatchPoolRspID"], function(buf, len) {
        var StandGameAddMatchPoolRsp = platform_proto.platform.match.StandGameAddMatchPoolRsp;
        var rsp = StandGameAddMatchPoolRsp.decode(buf, len);
        self._onStandGameAddMatchPoolRsp(rsp);
    });
    /**
     * 离开匹配池的应答
     * Msg_C2S_StandGameQuitMatchPoolRspID 
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_StandGameQuitMatchPoolRspID"], function(buf, len) {
        var StandGameQuitMatchPoolRsp = platform_proto.platform.match.StandGameQuitMatchPoolRsp;
        var rsp = StandGameQuitMatchPoolRsp.decode(buf, len);
        self._onStandGameQuitMatchPoolRsp(rsp);
    });
    /**
     * 从匹配池获取玩家的响应
     * Msg_C2S_StandGameMatchRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_StandGameMatchRspID"], function(buf, len) {
        var StandGameMatchRsp = platform_proto.platform.match.StandGameMatchRsp;
        var rsp = StandGameMatchRsp.decode(buf, len);
        self._onStandGameMatchRsp(rsp);
    });
    /**
     * 发送Model响应
     * Msg_C2S_SendModelRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_SendModelRspID"], function(buf, len) {
        var SendModelRsp = platform_proto.platform.pip.SendModelRsp;
        var rsp = SendModelRsp.decode(buf, len);
        self._onSendModelRsp(rsp);
    });
    /**
     * 获取Model响应
     * Msg_C2S_GetModelRspID
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_GetModelRspID"], function(buf, len) {
        var GetModelRsp = platform_proto.platform.pip.GetModelRsp;
        var rsp = GetModelRsp.decode(buf, len);
        self._onGetModelRsp(rsp);
    });
    /**
     *   修改标记的返回，格式等同于请求，详情参见reqMarkModel
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_MarkModelRspID"], function(buf, len) {
        var MarkModelRsp = platform_proto.platform.pip.MarkModelRsp;
        var rsp = MarkModelRsp.decode(buf, len);
        self._onMarkModelRsp(rsp);
    });
    /**
     *   请求查询附件（获取）返回
     *   
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_DetailModelAnnexRspID"], function(buf, len) {
        var DetailModelAnnexRsp = platform_proto.platform.pip.DetailModelAnnexRsp;
        var rsp = DetailModelAnnexRsp.decode(buf, len);
        self._onDetailModelAnnexRsp(rsp);
    });
    /**
     *   上报行为的返回
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_PromotionBehaviorRspID"], function(buf, len) {
        var PromotionBehaviorRsp = platform_proto.platform.promotion.PromotionBehaviorRsp;
        var rsp = PromotionBehaviorRsp.decode(buf, len);
        self._onPromotionBehaviorRsp(rsp);
    });
    /**
     *   请求活动、成就、任务配置信息（promotionId是唯一标示）的返回
     *   注意各个模块要对promotion进行筛选，不是自己模块的promotionId不允处理
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_PromotionInfoRspID"], function(buf, len) {
        var PromotionInfoRsp = platform_proto.platform.promotion.PromotionInfoRsp;
        var rsp = PromotionInfoRsp.decode(buf, len);
        self._onPromotionInfoRsp(rsp);
    });
    /**
     *   请求领取奖励的返回
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_PromotionRewardRspID"], function(buf, len) {
        var PromotionRewardRsp = platform_proto.platform.promotion.PromotionRewardRsp;
        var rsp = PromotionRewardRsp.decode(buf, len);
        self._onPromotionRewardRsp(rsp);
    });
    /**
     * 发送消息服务端的响应
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_SendMsgsFromStandClientRspID"], function(buf, len) {
        var SendMsgsFromStandClientRsp = platform_proto.platform.IM.SendMsgsFromStandClientRsp;
        var rsp = SendMsgsFromStandClientRsp.decode(buf, len);
        self._onSendMsgsFromStandClientRsp(rsp);
    });
    /**
     * 服务端推送消息
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_RecentRecordsRspID"], function(buf, len) {
        var RecentRecordsRsp = platform_proto.platform.IM.RecentRecordsRsp;
        var rsp = RecentRecordsRsp.decode(buf, len);
        self._onRecentRecordsRsp(rsp);
    });
    /**
     * 
     * Msg_C2S_RedEnvelopeDetailRspID
     * 获取红包信息的返回
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_RedEnvelopeDetailRspID"], function(buf, len) {
        var RedEnvelopeDetailRsp = platform_proto.platform.RedEnvelope.RedEnvelopeDetailRsp;
        var rsp = RedEnvelopeDetailRsp.decode(buf, len);
        self._onRedEnvelopeDetailRsp(rsp);
    });
    /**
     * 
     * Msg_C2S_RedEnvelopeRewardRspID
     * 红包领取的返回
     */
    this.protoChannel.getProtoProxy().registProtoHandler(platform_proto.Base.MsgIdDef["Msg_C2S_RedEnvelopeRewardRspID"], function(buf, len) {
        var RedEnvelopeRewardRsp = platform_proto.platform.RedEnvelope.RedEnvelopeRewardRsp;
        var rsp = RedEnvelopeRewardRsp.decode(buf, len);
        self._onRedEnvelopeRewardRsp(rsp);
    });
    /**
     * 设置 appid 
     * @param {*} appId 
     */
    tpfplat.prototype.setAppId = function(appId) {
        this.appId = appId;
    };
    tpfplat.prototype.setChannelId = function(channelId) {
        this.channelId = channelId;
    }
    /**
     * 设置登录信息
     * @param {*} id    从loginServer返回的uid
     * @param {*} token 从loginServer返回的token
     */
    ;
    tpfplat.prototype.setPlatUserInfo = function(id, token) {
        this.platUserInfo.id = id;
        this.platUserInfo.token = token;
    }
    /**
     * 开始登录大厅
     * @param {*} url 大厅连接地址 
     * @param {*} func_create_ws 可选参数，实现创建ws的function 原型为    WebSocket function create_ws(url)
     */
    ;
    tpfplat.prototype.connectAndLoginPlat = function(url, func_create_ws) {
        this.isReconnecting = false;
        this.protoChannel.close();
        this.url = url;
        this.funcCreateWS = func_create_ws;
        var self = this;
        this.protoChannel.setEventHandler("on_open", function() {
            self._onPlatConnected();
        });
        this.protoChannel.setEventHandler("on_close", function(code) {
            self._onPlatDisconnected(code);
        });
        this.protoChannel.setEventHandler("on_error", function(err) {
            self._onPlatConnectError(err);
        });
        this.protoChannel.create(url, this.funcCreateWS);
    }
    /**
     * 断线重连大厅 
     */
    ;
    tpfplat.prototype.reconnectAndLoginPlat = function() {
        this.isReconnecting = true;
        this.protoChannel.close();
        var self = this;
        this.protoChannel.setEventHandler("on_open", function() {
            self._onPlatConnected();
        });
        this.protoChannel.setEventHandler("on_close", function(code) {
            self._onPlatDisconnected(code);
        });
        this.protoChannel.setEventHandler("on_error", function(err) {
            self._onPlatConnectError(err);
        });
        this.protoChannel.create(this.url, this.funcCreateWS);
    };
    tpfplat.prototype.disconnectPlat = function() {
        this.protoChannel.close();
    }
    /**
     * 开始匹配
     * @param {*} addiContent 
     */
    ;
    tpfplat.prototype.match = function(addiContent) {
        var req = platform_proto.platform.match.MatchReq.create({
            gameId: this.appId + "",
            addiContent: addiContent
        });
        var buffer = platform_proto.platform.match.MatchReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_StartMatchReqID"], buffer);
    }
    /**
     * 取消匹配
     */
    ;
    tpfplat.prototype.cancelMatch = function() {
        var req = platform_proto.platform.match.CancelMatchReq.create({
            gameId: this.appId + ""
        });
        var buffer = platform_proto.platform.match.CancelMatchReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_CancelMatchReqID"], buffer);
    };
    tpfplat.prototype.getUserInfo = function() {
        var UserInfoReq = platform_proto.platform.Basic.UserInfoReq;
        var req = UserInfoReq.create({});
        var buffer = UserInfoReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UserInfoReqID"], buffer);
    }
    /**
     * 添加存储
     * 
     * @param {*} uid 
     * @param {*} param 
     * @param {updateWay} 更新方式 0 - 替换更新  1 - 追加更新
     */
    ;
    tpfplat.prototype.updateStorage = function(uid, paramMap, version, updateWay) {
        if (uid == null) {
            console.error("error uid");
            return;
        }
        if (paramMap == null) {
            console.error("error paramMap");
            return;
        }
        var storageValueList = new Array();
        for (var key in paramMap) {
            var StorageInfo = platform_proto.platform.storage.StorageInfo;
            var info = StorageInfo.create({
                storageKey: key,
                storageValue: paramMap[key]
            });
            storageValueList.push(info);
        }
        var UpdateStorageReq = platform_proto.platform.storage.UpdateStorageReq;
        var req = UpdateStorageReq.create({
            gameId: this.appId + "",
            uid: uid + "",
            storageInfo: storageValueList,
            version: version,
            updateWay: updateWay || 0
        });
        console.log("当前版本号:", req.version);
        var buffer = UpdateStorageReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UpdateStorageReqID"], buffer);
    }
    /**
     * 获取存储信息
     * 
     * @param {*} uid 
     * @param {*} storageKeys 
     */
    ;
    tpfplat.prototype.getStorageInfo = function(uid, storageKeys) {
        if (uid == null) {
            console.error("error uid");
            return;
        }
        if (storageKeys == null || storageKeys.size <= 0) {
            console.error("error storageKeys");
            return;
        }
        var UserStorageInfoReq = platform_proto.platform.storage.UserStorageInfoReq;
        var req = UserStorageInfoReq.create({
            gameId: this.appId + "",
            uid: uid + "",
            storageKeys: storageKeys
        });
        var buffer = UserStorageInfoReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UserStorageInfoReqID"], buffer);
    }
    /**
     * 更新一个参数的排行榜
     * 
     * @param {*} rankId 排行榜ID
     * @param {*} uid 玩家ID
     * @param {*} paramList 加入排行榜的参数列表
     */
    ;
    tpfplat.prototype.updateOneParamRank = function(rankId, uid, param) {
        if (rankId == null) {
            console.error("error rankId");
            return;
        }
        if (uid == null) {
            console.error("error uid");
            return;
        }
        if (param == null) {
            console.error("error param");
            return;
        }
        var UpdRankOneParamReq = platform_proto.platform.rank.UpdRankOneParamReq;
        var req = UpdRankOneParamReq.create({
            gameId: this.appId + "",
            rankId: rankId + "",
            uid: uid + "",
            param: param
        });
        var buffer = UpdRankOneParamReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UpdRankOneParamReqID"], buffer);
    }
    /**
     * 更新排行榜
     * 
     * @param {*} rankId 排行榜ID
     * @param {*} uid 玩家ID
     * @param {*} paramList 加入排行榜的参数列表
     */
    ;
    tpfplat.prototype.updateRank = function(rankId, uid, paramList) {
        if (rankId == null) {
            console.error("error rankId");
            return;
        }
        if (uid == null) {
            console.error("error uid");
            return;
        }
        if (paramList == null || paramList.size <= 0) {
            console.error("paramList uid");
            return;
        }
        var UpdRankReq = platform_proto.platform.rank.UpdRankReq;
        var req = UpdRankReq.create({
            gameId: this.appId + "",
            rankId: rankId + "",
            uid: uid + "",
            param: paramList
        });
        var buffer = UpdRankReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UpdRankReqID"], buffer);
    }
    /**
     * 获取排行榜信息
     * @param {*} rankId 排行榜Id 
     * @param {*} start  起始位置
     * @param {*} size   数量
     */
    ;
    tpfplat.prototype.getRankInfo = function(rankId, start, size) {
        if (rankId == null) {
            console.error("error rankId");
            return;
        }
        if (start < 0 || size < 0) {
            console.error("error param");
            return;
        }
        if (start - 1 < 0) {
            console.log("start from 1, please check your param");
            return;
        }
        var RankInfoReq = platform_proto.platform.rank.RankInfoReq;
        var req = RankInfoReq.create({
            gameId: this.appId + "",
            rankId: rankId + "",
            start: start,
            size: size
        });
        var buffer = RankInfoReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_RankInfoReqID"], buffer);
    }
    /**
     * 新的获取排行榜信息
     * @param {number} [timestamp] 时间戳
     * @param {string} [reqId] 请求ID
     */
    ;
    tpfplat.prototype.getRankInfoV2 = function(rankId, start, size, timestamp, reqId) {
        if (rankId == null) {
            console.error("error rankId");
            return;
        }
        if (start < 0 || size < 0) {
            console.error("error param");
            return;
        }
        if (start - 1 < 0) {
            console.log("start from 1, please check your param");
            return;
        }
        var RankInfoReqV2 = platform_proto.platform.rank.RankInfoReqV2;
        var req = RankInfoReqV2.create({
            gameId: this.appId + "",
            rankId: rankId + "",
            start: start,
            size: size,
            timestamp: timestamp,
            reqId: reqId
        });
        var buffer = RankInfoReqV2.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef.Msg_C2S_RankInfoReqV2ID, buffer);
    }
    /**
     * 根据时间获取滚动排行榜信息
     * @param {*} rankId 排行榜Id 
     * @param {*} start  起始位置
     * @param {*} size   数量
     */
    ;
    tpfplat.prototype.getRankInfoByTime = function(rankId, start, size, timestamp) {
        if (rankId == null) {
            console.error("error rankId");
            return;
        }
        if (timestamp == null) {
            console.error("error timestamp");
            return;
        }
        if (start < 0 || size < 0) {
            console.error("error param");
            return;
        }
        if (start - 1 < 0) {
            console.log("start from 1, please check your param");
            return;
        }
        var RankInfoByTimeReq = platform_proto.platform.rank.RankInfoByTimeReq;
        var req = RankInfoByTimeReq.create({
            gameId: this.appId + "",
            rankId: rankId + "",
            start: start,
            size: size,
            timestamp: timestamp
        });
        var buffer = RankInfoByTimeReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_RankInfoByTimeReqID"], buffer);
    }
    /**
     * 获取指定玩家的排行榜信息
     * @param {*} rankId 
     * @param {*} uid 
     */
    ;
    tpfplat.prototype.getUserRankInfo = function(rankId, uid) {
        if (rankId == null) {
            console.error("error rankId");
            return;
        }
        if (uid == null) {
            console.error("error param");
            return;
        }
        var UserInRankInfoReq = platform_proto.platform.rank.UserInRankInfoReq;
        var req = UserInRankInfoReq.create({
            gameId: this.appId + "",
            rankId: rankId + "",
            uid: uid + ""
        });
        var buffer = UserInRankInfoReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UserInRankInfoReqID"], buffer);
    }
    /**
     * 根据时间获取指定玩家的滚动排行榜信息
     * @param {*} rankId 
     * @param {*} uid 
     */
    ;
    tpfplat.prototype.getUserRankInfoByTime = function(rankId, uid, timestamp) {
        if (rankId == null) {
            console.error("error rankId");
            return;
        }
        if (uid == null) {
            console.error("error param");
            return;
        }
        if (timestamp == null) {
            console.error("error timestamp");
            return;
        }
        var UserInRankInfoByTimeReq = platform_proto.platform.rank.UserInRankInfoByTimeReq;
        var req = UserInRankInfoByTimeReq.create({
            gameId: this.appId + "",
            rankId: rankId + "",
            uid: uid + "",
            timestamp: timestamp
        });
        var buffer = UserInRankInfoByTimeReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UserInRankInfoByTimeReqID"], buffer);
    }
    /**
     * 新的获取指定玩家的排行榜信息
     * @param {number} [timestamp] 时间戳
     */
    ;
    tpfplat.prototype.getUserRankInfoV2 = function(rankId, uid, timestamp) {
        if (rankId == null) {
            console.error("error rankId");
            return;
        }
        if (uid == null) {
            console.error("error param");
            return;
        }
        var UserInRankInfoReqV2 = platform_proto.platform.rank.UserInRankInfoReqV2;
        var req = UserInRankInfoReqV2.create({
            gameId: this.appId + "",
            rankId: rankId + "",
            uid: uid + "",
            timestamp: timestamp
        });
        var buffer = UserInRankInfoReqV2.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef.Msg_C2S_UserInRankInfoReqV2ID, buffer);
    }
    /**
     * 更新排行榜
     * 
     * @param {*} rankId 排行榜ID
     * @param {*} uid 玩家ID
     * @param {*} paramList 加入排行榜的参数列表  参数可支持到long型
     */
    ;
    tpfplat.prototype.updateRankV2 = function(rankId, uid, paramList) {
        if (rankId == null) {
            console.error("error rankId");
            return;
        }
        if (uid == null) {
            console.error("error uid");
            return;
        }
        if (paramList == null || paramList.size <= 0) {
            console.error("paramList uid");
            return;
        }
        //////////////
        var UpdRankReqV2 = platform_proto.platform.rank.UpdRankReqV2;
        var req = UpdRankReqV2.create({
            gameId: this.appId + "",
            rankId: rankId + "",
            uid: uid + "",
            param: paramList
        });
        var buffer = UpdRankReqV2.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UpdRankReqV2ID"], buffer);
        //////////////////////////////
    }
    /**
     * 获取玩家游戏对战信息
     */
    ;
    tpfplat.prototype.getBattleInfo = function() {
        var UserGameBattleInfoReq = platform_proto.platform.Basic.UserGameBattleInfoReq;
        var req = UserGameBattleInfoReq.create({});
        var buffer = UserGameBattleInfoReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UserBattleInfoReqID"], buffer);
    }
    /**
     * 获取游戏配置信息
     */
    ;
    tpfplat.prototype.getGameConfig = function() {
        var GameCfgReq = platform_proto.platform.Basic.GameCfgReq;
        var req = GameCfgReq.create({});
        var buffer = GameCfgReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_GameCfgReqID"], buffer);
    }
    /**
     * 
     * @param {*} boxType 宝箱类型
     */
    ;
    tpfplat.prototype.getBoxDetail = function(boxType) {
        var BoxDetailReq = platform_proto.platform.Box.BoxDetailReq;
        var boxDetailReq = BoxDetailReq.create({
            boxType: boxType,
            gameId: this.appId + ""
        });
        var buffer = BoxDetailReq.encode(boxDetailReq).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_BoxDetailReqID"], buffer);
    }
    /**
     * 
     * @param {*} boxType  宝箱类型
     * @param {*} boxIndex 宝箱索引
     */
    ;
    tpfplat.prototype.getBoxAward = function(boxType, boxIndex) {
        var BoxAwardReq = platform_proto.platform.Box.BoxAwardReq;
        var boxAwardReq = BoxAwardReq.create({
            boxType: boxType,
            boxIndex: boxIndex,
            gameId: this.appId + ""
        });
        var buffer = BoxAwardReq.encode(boxAwardReq).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_BoxAwardReqID"], buffer);
    }
    /**
     * 获取随机数
     * @param {*} randomId 
     */
    ;
    tpfplat.prototype.getRandom = function(randomId) {
        var RandomReq = platform_proto.platform.Basic.RandomReq;
        var randomReq = RandomReq.create({
            randomId: randomId + ""
        });
        var buffer = RandomReq.encode(randomReq).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_RandomReqID"], buffer);
    }
    /**
     * 根据时间获取随机数
     * @param {*} randomId 
     */
    ;
    tpfplat.prototype.getRandomByTime = function(randomId, timestamp) {
        var RandomByTimeReq = platform_proto.platform.Basic.RandomByTimeReq;
        var randomReqByTime = RandomByTimeReq.create({
            randomId: randomId + "",
            timestamp: timestamp
        });
        var buffer = RandomByTimeReq.encode(randomReqByTime).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_RandomByTimeReqID"], buffer);
    }
    // 匹配池相关
    /**
     * 进入匹配池
     * @param {object} options 
     */
    ;
    tpfplat.prototype.enterMatchPool = function(options) {
        var optionList = [];
        if (options) {
            for (var k in options) {
                var optionDto = platform_proto.platform.match.OptionDto.create({
                    key: k,
                    value: options[k]
                });
                optionList.push(optionDto);
            }
        }
        var StandGameAddMatchPoolReq = platform_proto.platform.match.StandGameAddMatchPoolReq;
        var req = StandGameAddMatchPoolReq.create({
            options: optionList
        });
        var buffer = StandGameAddMatchPoolReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_StandGameAddMatchPoolReqID"], buffer);
    }
    /**
     * 离开匹配池
     */
    ;
    tpfplat.prototype.leaveMatchPool = function() {
        var StandGameQuitMatchPoolReq = platform_proto.platform.match.StandGameQuitMatchPoolReq;
        var req = StandGameQuitMatchPoolReq.create({});
        var buffer = StandGameQuitMatchPoolReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_StandGameQuitMatchPoolReqID"], buffer);
    }
    /**
     * 从匹配池获取数据
     * @param {object} options 
     * @param {number} count 
     */
    ;
    tpfplat.prototype.fetchFromMatchPool = function(options, count) {
        var optionList = [];
        if (options) {
            for (var k in options) {
                var optionDto = platform_proto.platform.match.OptionDto.create({
                    key: k,
                    value: options[k]
                });
                optionList.push(optionDto);
            }
        }
        var StandGameMatchReq = platform_proto.platform.match.StandGameMatchReq;
        var req = StandGameMatchReq.create({
            options: optionList,
            count: count
        });
        var buffer = StandGameMatchReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_StandGameMatchReqID"], buffer);
    }
    // 会话消息相关
    /**
     * 发送消息
     * @param {string} fUid 发送到对方的Uid
     * @param {number} msgType 消息类型， 默认为0
     * @param {string} msg 消息内容
     * @param {string} clientCode 消息附带值，发送成功后服务端会把该值返回回来，业务层用于判断消息是否发送成功
     */
    ;
    tpfplat.prototype.sendMsgsFromStandClient = function(fUid, msgType, msg, clientCode) {
        var MsgDto = platform_proto.platform.IM.MsgDtoP;
        var msgDto = MsgDto.create({
            msgType: msgType,
            content: msg
        });
        var SendMsgsFromStandClientReq = platform_proto.platform.IM.SendMsgsFromStandClientReq;
        var req = SendMsgsFromStandClientReq.create({
            fUid: fUid,
            msg: msgDto,
            clientCode: clientCode
        });
        var buffer = SendMsgsFromStandClientReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_SendMsgsFromStandClientReqID"], buffer);
    }
    /**
     * 拉取未读消息
     * @param {number} count 数量
     * @param {boolean} readFlg 是否拉取已读消息
     */
    ;
    tpfplat.prototype.pullRecentRecords = function(count, readFlg) {
        var RecentRecordsReq = platform_proto.platform.IM.RecentRecordsReq;
        var req = RecentRecordsReq.create({
            count: count,
            readFlg: readFlg
        });
        var buffer = RecentRecordsReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_RecentRecordsReqID"], buffer);
    }
    /**
     * 设置消息已读状态
     * @param {array} msgIdArray 消息Id数组
     */
    ;
    tpfplat.prototype.setMsgsReadStatus = function(msgIdArray) {
        var UnReadRecordsACKReq = platform_proto.platform.IM.UnReadRecordsACKReq;
        var req = UnReadRecordsACKReq.create({
            msgIds: msgIdArray
        });
        var buffer = UnReadRecordsACKReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_UnReadRecordsACKReqID"], buffer);
    }
    /**
     * 发送Model
     * type 是区分聊天、邮件、公告的类型
     * subType 是具体逻辑跟约定好的
     * 发送的内容，包含键值对，数据体见ModelPropEntry  Pb
     * extra 扩展字段
     * 
     * 
     * 
     * 
     * @param type tpfdefine.pipModelType 类型
     * @param subType 应用自定义类型
     * @param modelPropEntry {key: '', value: ''}
     */
    /*
        var data = {
            "type":tpfdefine.pipModelType.CHAT,
            "subType": 0,
            "propEntries": [
                {
                    "key": "msgType",
                    "value": Global.typeConfig.ChatType.World+""
                },
                {
                    "key": "sender",
                    "value": Global.gameMgr.getUserId() 
                },
                {
                    "key": "senderName",
                    "value": Global.gameMgr.getUserName() 
                },
                {
                    "key": "content",
                    "value": chatData.info
                },
                {
                    "key": "vip",
                    "value": chatData.vip+""
                }
            ]
        }
    */
    ;
    tpfplat.prototype.sendPipModel = function(model) {
        var SendModelReq = platform_proto.platform.pip.SendModelReq;
        var req = SendModelReq.create({
            appAreaId: Global.gameMgr.getExtraId(),
            type: model.type,
            subType: 0,
            propEntries: model.propEntries,
            extra: ""
        });
        console.log("chatmgr==============>", req);
        var buffer = SendModelReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_SendModelReqID"], buffer);
    }
    /*
    tpfplat.prototype.sendPipModel = function (type, subType, modelPropEntrys) {
        var propEntries = []
        if (modelPropEntrys) {
            for (var key in modelPropEntrys) {
                var entry = platform_proto.platform.pip.ModelPropEntry.create({
                    key: k,
                    value: modelPropEntrys[k]
                })

                propEntries.push(entry);
            }
        }
        var SendModelReq = platform_proto.platform.pip.SendModelReq;
        var req = SendModelReq.create({
            "type": type,
            "subType": subType,
            "propEntries": propEntries
        })
        var buffer = SendModelReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_SendModelReqID"], buffer);
    }
    */
    /**
     * 获取Model
     * @param type tpfdefine.pipModelType 类型
     * @param subType 应用自定义类型
     * @param maxVersion 该类型定义下已接受过的最大偏移量
     * @param indexValue 该类型定义下索引值
     * @param count 所需返回最大个数 
     */
    ;
    tpfplat.prototype.getPipModel = function(appAreaId, type, subType, maxVersion, indexValue, count) {
        var GetModelReq = platform_proto.platform.pip.GetModelReq;
        var req = GetModelReq.create({
            appAreaId: appAreaId,
            type: type,
            subType: subType,
            version: maxVersion,
            indexValue: indexValue,
            count: count
            /*
            "type": type,
            "subType": subType,
            "version": maxVersion,
            "indexValue": indexValue,
            "count": count
            */
        });
        var buffer = GetModelReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_GetModelReqID"], buffer);
    }
    /**
     *   请求修改邮件状态（暂时只有邮件需要用，若有扩展，将tpfdefine.pipModelType.MAIL用参数传进来即可）
     *   请求标记 修改标记
     *   type 是区分聊天、邮件、公告的类型
     *   subType 是具体逻辑跟约定好的
     *   versions 上次更新状态时服务器下发的version
     *   indexValue 接收者
     *   markFlg 状态
     *   appAreaId 区服
     *   extra 扩展字段
     */
    ;
    tpfplat.prototype.reqMarkPipModel = function(appAreaId, type, subType, versions, indexValue, markFlg, extra) {
        var req = platform_proto.platform.pip.MarkModelReq.create({
            type: type,
            //tpfdefine.pipModelType.MAIL,
            subType: subType,
            //0,
            versions: versions,
            //[mailModel.version],
            indexValue: indexValue,
            //mailModel.sendUserId,
            markFlg: markFlg,
            //Global.typeConfig.MailState.HasRead,
            appAreaId: appAreaId,
            //Global.gameMgr.getExtraId(),
            extra: extra
        });
        console.log("sdkmgr reqMarkModel run", req);
        var buffer = platform_proto.platform.pip.MarkModelReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_MarkModelReqID"], buffer);
    }
    /**
     *   请求查询附件（获取）
     *   annexStatusDtos 对应客户端AnnexData数据体
     *   
     *    opIndex 为与服务器约定好的字段
     *    [{
     *        "annexIndex":1,
     *        "recCount":2
     *    },{
     *        "annexIndex":2,
     *        "recCount":2
     *    }]
     */
    ;
    tpfplat.prototype.reqDetailModelAnne = function(appAreaId, type, subType, indexValue, annexStatusDtos, extra) {
        var DetailModelAnnexReq = platform_proto.platform.pip.DetailModelAnnexReq;
        var req = DetailModelAnnexReq.create({
            type: type,
            //tpfdefine.pipModelType.MAIL,
            subType: subType,
            //0,
            indexValue: indexValue,
            //Global.gameMgr.getUserId(),
            annexStatusDtos: annexStatusDtos,
            //annexDtos,
            appAreaId: appAreaId,
            //Global.gameMgr.getExtraId(),
            extra: extra
        });
        console.log("sdkMgr reqDetailModelAnnex run ", req);
        var buffer = DetailModelAnnexReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_DetailModelAnnexReqID"], buffer);
    }
    /**
     *   上报行为的请求
     */
    ;
    tpfplat.prototype.reqPromotionBehavior = function(appAreaId, behaviorType, num, index, callerId, extra) {
        var req = platform_proto.platform.promotion.PromotionBehaviorReq.create({
            appAreaId: appAreaId,
            //Global.gameMgr.getExtraId(),
            behaviorType: behaviorType,
            //promotionModel.behaviorId,
            num: num,
            index: index,
            //promotionModel.userId,
            callerId: callerId,
            //Global.typeConfig.CallerId.Client,
            extra: extra
        });
        console.log("sdkMgr reqPromotionBehavior ->", req);
        var buffer = platform_proto.platform.promotion.PromotionBehaviorReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_PromotionBehaviorReqID"], buffer);
    }
    /**
     *   请求活动、成就、任务配置信息（promotionId是唯一标示）
     */
    ;
    tpfplat.prototype.reqPromotionInfo = function(appAreaId, promotionId, index, extra, stageIds) {
        var req = platform_proto.platform.promotion.PromotionInfoReq.create({
            appAreaId: appAreaId,
            //Global.gameMgr.getExtraId(),
            promotionId: promotionId,
            //promotionModel.promotionId,
            index: index,
            //promotionModel.userId,
            extra: extra,
            //Global.csvMgr.getConfigVersion(),
            stageIds: stageIds
        });
        var buffer = platform_proto.platform.promotion.PromotionInfoReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_PromotionInfoReqID"], buffer);
    }
    /**
     *   请求领取奖励
     */
    ;
    tpfplat.prototype.reqPromotionReward = function(appAreaId, promotionId, stageId, index, rewardOp, extra) {
        console.log("sdkMgr reqPromotionReward -> ", promotionModel, opt);
        var req = platform_proto.platform.promotion.PromotionRewardReq.create({
            appAreaId: appAreaId,
            //Global.gameMgr.getExtraId(),
            promotionId: promotionId,
            //promotionModel.promotionId,
            stageId: stageId,
            index: index,
            //promotionModel.userId,
            rewardOp: rewardOp,
            //opt,
            extra: extra
        });
        var buffer = platform_proto.platform.promotion.PromotionRewardReq.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_PromotionRewardReqID"], buffer);
    }
    //增加红包请求
    /**
     * 
     * @param {*} redEnvelopeType 红包类型红包ID
     */
    ;
    tpfplat.prototype.getRedEnvelopeDetail = function(redEnvelopeType) {
        var RedEnvelopeDetailReq = platform_proto.platform.RedEnvelope.RedEnvelopeDetailReq;
        var redEnvelopeDetailReq = RedEnvelopeDetailReq.create({
            gameId: this.appId + "",
            channelId: this.channelId + "",
            redEnvelopeType: redEnvelopeType
        });
        var buffer = RedEnvelopeDetailReq.encode(redEnvelopeDetailReq).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_RedEnvelopeDetailReqID"], buffer);
        console.log("getRedEnvelopeDetail send");
    }
    /**
     * 
     * @param {*} redEnvelopeType 红包类型红包ID
     */
    ;
    tpfplat.prototype.getRedEnvelopeReward = function(redEnvelopeType, opType, phone, wechat) {
        var RedEnvelopeRewardReq = platform_proto.platform.RedEnvelope.RedEnvelopeRewardReq;
        var redEnvelopeRewardReq = RedEnvelopeRewardReq.create({
            gameId: this.appId + "",
            channelId: this.channelId + "",
            redEnvelopeType: redEnvelopeType,
            opType: opType,
            phone: phone,
            wechat: wechat
        });
        var buffer = RedEnvelopeRewardReq.encode(redEnvelopeRewardReq).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_RedEnvelopeRewardReqID"], buffer);
    }
    //-private----------------------------------------------
    ;
    tpfplat.prototype._onPlatConnected = function() {
        if (this.isReconnecting) {
            this.isReconnecting = false;
            var message = platform_proto.platform.login.ReConnectReq.create({
                uid: this.platUserInfo.id,
                token: this.platUserInfo.token,
                oppoToken: "",
                did: "jsclient",
                version: this.version,
                cfg: "",
                clientVersionCode: this.clientVersionCode
            });
            var buffer = platform_proto.platform.login.ReConnectReq.encode(message).finish();
            this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_ReConnectReqID"], buffer);
        } else {
            var message = platform_proto.platform.login.LoginPlatReq.create({
                uid: this.platUserInfo.id,
                token: this.platUserInfo.token,
                oppoToken: "",
                did: "jsclient",
                version: this.version,
                cfg: "",
                clientVersionCode: this.clientVersionCode
            });
            var buffer = platform_proto.platform.login.LoginPlatReq.encode(message).finish();
            this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_C2S_LoginPlatReqID"], buffer);
        }
    };
    tpfplat.prototype._onPlatDisconnected = function(code) {
        this.isLogin = false;
        //fire event
        this.eventHandler[tpfdefine.eventType.ON_PLAT_DISCONNECT](code);
    };
    tpfplat.prototype._onPlatConnectError = function(err) {
        this.isLogin = false;
        console.log("ws connect error", JSON.stringify(err));
        //fire event
        this.eventHandler[tpfdefine.eventType.ON_PLAT_CONNECT_ERROR]();
    };
    tpfplat.prototype._onPlatLogin = function(rsp) {
        if (rsp.result) {
            this.isLogin = true;
            this._onHeartbeatTimer();
        }
        this.eventHandler[tpfdefine.eventType.ON_PLAT_LOGIN_RESULT](rsp.result, rsp.serverVersion, parseInt(JSON.parse(JSON.stringify(rsp)).timeStamp));
    };
    tpfplat.prototype._onHeartbeatTimer = function() {
        var self = this;
        if (this.isLogin == true) {
            self._heartBeat(0);
            setTimeout(function() {
                self._onHeartbeatTimer();
            }, 5e3);
        }
    };
    tpfplat.prototype._heartBeat = function(timeStamp) {
        var req = platform_proto.platform.login.HeartBeat.create({
            timeStamp: timeStamp
        });
        var buf = platform_proto.platform.login.HeartBeat.encode(req).finish();
        this.protoChannel.send(platform_proto.Base.MsgIdDef["Msg_COM_HeartBeat"], buf);
    };
    tpfplat.prototype._onPlatReLogin = function(rsp) {
        if (rsp.result) {
            this.isLogin = true;
            this._onHeartbeatTimer();
        }
        this.eventHandler[tpfdefine.eventType.ON_PLAT_RELOGIN_RESULT](rsp.result, rsp.playerStatus, rsp.serverVersion, parseInt(JSON.parse(JSON.stringify(rsp)).timeStamp));
    };
    tpfplat.prototype._onForceOffline = function() {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_FORCE_OFFLINE]();
    };
    tpfplat.prototype._onHeartbeat = function(rsp) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_HEART_BEAT](parseInt(JSON.parse(JSON.stringify(rsp)).timeStamp), rsp.serverVersion);
    };
    tpfplat.prototype._onMatchRsp = function(rsp) {
        //fire event
        var matchStartCode = tpflogicdef.plat.matchStartCode;
        if (rsp.code != matchStartCode.OK) {
            console.warn("match req error: code: " + rsp.code);
        }
        this.eventHandler[tpfdefine.eventType.ON_PLAT_MATCH_RSP](rsp.code);
    };
    tpfplat.prototype._onMathCancel = function(rsp) {
        //fire event
        var cancelMatchCode = tpflogicdef.plat.cancelMatchCode;
        if (cancelMatchCode.OK != rsp.code) {
            console.warn("cancel match req error code: " + rsp.code);
        }
        this.eventHandler[tpfdefine.eventType.ON_PLAT_MATCH_CANCEL_RSP](rsp.code);
    };
    tpfplat.prototype.getBattleInfoByMatchResult = function(uid, matchResult) {
        if (matchResult == null) {
            return null;
        }
        var battleInfo = {};
        battleInfo.tableUrl = matchResult.tableInfoDto.url;
        battleInfo.tblToken = matchResult.tableInfoDto.tableToken;
        battleInfo.tblId = matchResult.tableInfoDto.tableID;
        battleInfo.gameId = matchResult.gameInfoDto.gameID;
        //first is self
        //这里改错了  id相同时会跳出双循环
        // var playerId = null;
        // var battleCampDtoList = matchResult.battleCampDtoList;
        // for (var i in battleCampDtoList) {
        //     var battleCampDto = battleCampDtoList[i]
        //     for (var j in battleCampDto.userInfoDtoList) {
        //         var userInfo = battleCampDto.userInfoDtoList[j]
        //         if (uid == userInfo.uid) {
        //             playerId = userInfo.gamePlayerId;
        //             return;
        //         }
        //     }
        //     if (playerId != null) {
        //         return;
        //     }
        // }
        //正确版
        var playerId = null;
        var battleCampDtoList = matchResult.battleCampDtoList;
        battleCampDtoList.forEach(battleCampDto => {
            battleCampDto.userInfoDtoList.forEach(userInfo => {
                if (uid == userInfo.uid) {
                    playerId = userInfo.gamePlayerId;
                    return;
                }
            });
            if (playerId != null) {
                return;
            }
        });
        if (playerId == null) {
            console.log(uid);
            console.log(matchResult);
            console.warn("battle init error! playerId not find: " + playerId);
            return;
        }
        battleInfo.playerId = playerId;
        return battleInfo;
    };
    tpfplat.prototype._onMatchResult = function(rsp) {
        console.info("_onMatchResult : ", rsp);
        var battleInfo = this.getBattleInfoByMatchResult(this.platUserInfo.id, rsp.matchResult);
        if (rsp.matchResult.code == tpflogicdef.plat.matchResultCode.OK) {
            this.battle.initBattle(battleInfo);
        } else {
            this.battle.initBattle(battleInfo);
        }
        //fire event
        this.eventHandler[tpfdefine.eventType.ON_PLAT_MATCH_RESULT](rsp.matchResult.code, rsp.matchResult);
    };
    tpfplat.prototype._onUserInfoRsp = function(userinfo) {
        //fire event
        this.eventHandler[tpfdefine.eventType.ON_PLAT_USERINFO_RSP](userinfo);
    };
    tpfplat.prototype._onRankInfoRsp = function(rankInfoRsp) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_RANKINFO_RSP](rankInfoRsp.rankId, rankInfoRsp.rankName, rankInfoRsp.userInRankInfoList, parseInt(rankInfoRsp.timestamp));
    };
    tpfplat.prototype._onRankInfoRspV2 = function(rsp) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_RANK_INFO_RSP_V2](rsp.rankId, rsp.rankName, rsp.userInRankInfoList, parseInt(rsp.timestamp), rsp.reqId);
    };
    tpfplat.prototype._onUpdRankRsp = function(updRankRsp) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_UPD_RNAK_RSP](updRankRsp.updResult);
    }
    //
    ;
    tpfplat.prototype._onUpdRankRspV2 = function(updRankRspV2) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_UPD_RNAK_RSP_V2](updRankRspV2.updResult);
    };
    tpfplat.prototype._onUpdRankOneParamRsp = function(updRankOneParamRsp) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_UPD_RNAK_ONE_PARAM_RSP](updRankOneParamRsp.updResult);
    };
    tpfplat.prototype._onUpdateStorageRsp = function(updStorageRsp) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_UPD_STORAGE_RSP](updStorageRsp.result, updStorageRsp.errCode, updStorageRsp.errMsg, updStorageRsp.version);
    };
    tpfplat.prototype._onUserStorageInfoRsp = function(userStorageInfoRsp) {
        var map = {};
        for (var i = 0; i < userStorageInfoRsp.storageInfo.length; i++) {
            var veh = userStorageInfoRsp.storageInfo[i];
            map[veh.storageKey] = veh.storageValue;
        }
        this.eventHandler[tpfdefine.eventType.ON_PLAT_USER_STORAGE_INFO_RSP](userStorageInfoRsp.uid, map, userStorageInfoRsp.errCode, userStorageInfoRsp.errMsg, userStorageInfoRsp.version);
    };
    tpfplat.prototype._onUserInRankInfoRsp = function(rankUserInfoRsp) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_USER_RANKINFO_RSP](rankUserInfoRsp.rankId, rankUserInfoRsp.rankName, parseInt(rankUserInfoRsp.ranking), rankUserInfoRsp.uid, rankUserInfoRsp.userInRankInfo, rankUserInfoRsp.rankRate, parseInt(rankUserInfoRsp.timestamp));
    };
    tpfplat.prototype._onUserInRankInfoRspV2 = function(rsp) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_USER_RANK_INFO_RSP_V2](rsp.rankId, rsp.rankName, rsp.userInRankInfo.rank, rsp.uid, rsp.userInRankInfo, rsp.rankRate, parseInt(rsp.timestamp));
    };
    tpfplat.prototype._onUserBattleInfoRsp = function(userGameBattleInfoRsp) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_USER_BATTLEINFO_RSP](userGameBattleInfoRsp);
    }
    /**
     * 
     * @param {*} bFinish 是否已经领完了
     * @param {*} currboxDetail bFinish 为true的情况下 为null
     */
    ;
    tpfplat.prototype._onBoxDetailRsp = function(bFinish, currboxDetail) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_BOX_DETAIL_RSP](bFinish, currboxDetail);
    }
    /**
     * 
     * @param {*} gameInfo          游戏信息
     * @param {*} nextBoxDetail     下一个宝箱信息，如果已经领完了为null
     */
    ;
    tpfplat.prototype._onBoxAwardRsp = function(gameInfo, nextBoxDetail) {
        this.eventHandler[tpfdefine.eventType.ON_PLAT_BOX_AWARD_RSP](gameInfo, nextBoxDetail);
    }
    /**
     * 
     * @param {*} rsp 返回信息 
     */
    ;
    tpfplat.prototype._onGameCfgRsp = function(rsp) {
        this.eventHandler[tpfdefine.eventType.ON_GAME_CONFIG_RSP](rsp.gameCfg, rsp.errorCode, rsp.errorMsg);
    }
    /**
     * 随机数返回信息
     * @param {*} rsp 
     */
    ;
    tpfplat.prototype._onRandomRsp = function(rsp) {
        this.eventHandler[tpfdefine.eventType.ON_GAME_RANDOM_RSP](parseInt(rsp.random), rsp.errorCode, rsp.errorMsg, rsp.randomId, parseInt(rsp.timestamp));
    }
    /**
     * 加入匹配池的返回
     */
    ;
    tpfplat.prototype._onStandGameAddMatchPoolRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_ENTER_MATCH_POOL_RSP];
        cb && cb(rsp.code);
    }
    /**
     * 离开匹配池的返回
     */
    ;
    tpfplat.prototype._onStandGameQuitMatchPoolRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_LEAVE_MATCH_POOL_RSP];
        cb && cb(rsp.code);
    }
    /**
     * 从匹配池获取数据的响应
     * @param {object} rsp 
     * 
     * appId: string
     * uid: string
     * players: array
     */
    ;
    tpfplat.prototype._onStandGameMatchRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_FETCH_FROM_MATCH_POOL_RSP];
        cb && cb(rsp);
    }
    /**
     * 发送Model的响应
     * @param {object} rsp 
     */
    ;
    tpfplat.prototype._onSendModelRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_SEND_MODEL_RSP];
        cb && cb(rsp);
    }
    /**
     * 获取Model的响应
     * @param {object} rsp 
     */
    ;
    tpfplat.prototype._onGetModelRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_GET_MODEL_RSP];
        cb && cb(rsp);
    }
    /**
     * /修改标记的返回，格式等同于请求，详情参见reqMarkModel 
     */
    ;
    tpfplat.prototype._onMarkModelRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_MARK_MODEL_RSP];
        cb && cb(rsp);
    }
    /**
     * 请求查询附件（获取）返回
     */
    ;
    tpfplat.prototype._onDetailModelAnnexRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_DETAIL_MODEL_ANNEX_RSP];
        cb && cb(rsp);
    }
    /**
     * 上报行为的返回
     */
    ;
    tpfplat.prototype._onPromotionBehaviorRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_PROMOTION_BEHAVIOR_RSP];
        cb && cb(rsp);
    }
    /**
     * 请求活动、成就、任务配置信息（promotionId是唯一标示）的返回
     */
    ;
    tpfplat.prototype._onPromotionInfoRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_PROMOTION_INFO_RSP];
        cb && cb(rsp);
    }
    /**
     * 请求领取奖励的返回
     */
    ;
    tpfplat.prototype._onPromotionRewardRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_PROMOTION_REWARD_RSP];
        cb && cb(rsp);
    }
    /**
     * 发送消息的服务端响应 
     */
    ;
    tpfplat.prototype._onSendMsgsFromStandClientRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_SEND_MSG_FROM_STAND_CLIENT_RSP];
        cb && cb(rsp.code, rsp.clientCode);
    };
    /**
     * 服务端推送消息
     */
    tpfplat.prototype._onRecentRecordsRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_STAND_CLIENT_NEW_MSG];
        cb && cb(rsp.code, rsp.msgs);
    }
    /**
     * 获取红包信息
     */
    ;
    tpfplat.prototype._onRedEnvelopeDetailRsp = function(rsp) {
        console.log("_onRedEnvelopeDetailRsp");
        var cb = this.eventHandler[tpfdefine.eventType.ON_REDENVELOPE_DETAIL_RSP];
        cb && cb(rsp);
    }
    /**
     * 领取红包奖励
     */
    ;
    tpfplat.prototype._onRedEnvelopeRewardRsp = function(rsp) {
        var cb = this.eventHandler[tpfdefine.eventType.ON_REDENVELOPE_REWARD_RSP];
        cb && cb(rsp);
    };
};

window["tpfplat"] = tpfplat;