(function() {
    "use strict";
    class ui_button_scale extends Laya.Script {
        constructor() {
            super();
            this.this_scale_x = 0;
            this.this_scale_y = 0;
        }
        set owner(value) {
            this.this_sprite = value;
            igc.igc_timer.frameOnce(1, this, () => {
                this.this_scale_x = this.this_sprite.scaleX;
                this.this_scale_y = this.this_sprite.scaleY;
            }, undefined, true);
        }
        get owner() {
            return this.this_sprite;
        }
        onEnable() {
            igc.igc_timer.frameOnce(2, this, this.set_scale, undefined, true);
        }
        onDisable() {
            this.this_sprite.offAll(Laya.Event.MOUSE_DOWN);
            this.this_sprite.offAll(Laya.Event.MOUSE_UP);
            this.this_sprite.offAll(Laya.Event.MOUSE_OUT);
        }
        set_scale() {
            this.this_sprite.on(Laya.Event.MOUSE_DOWN, this, () => {
                Laya.Tween.clearTween(this.this_sprite);
                Laya.Tween.to(this.this_sprite, {
                    scaleX: .9 * this.this_scale_x,
                    scaleY: .9 * this.this_scale_y
                }, 75);
            });
            this.this_sprite.on(Laya.Event.MOUSE_UP, this, () => {
                Laya.Tween.clearTween(this.this_sprite);
                Laya.Tween.to(this.this_sprite, {
                    scaleX: 1 * this.this_scale_x,
                    scaleY: 1 * this.this_scale_y
                }, 100);
            });
            this.this_sprite.on(Laya.Event.MOUSE_OUT, this, () => {
                Laya.Tween.clearTween(this.this_sprite);
                this.this_sprite.scale(1 * this.this_scale_x, 1 * this.this_scale_y);
            });
        }
    }
    var e_login_type;
    (function(e_login_type) {
        e_login_type[e_login_type["login_type_local"] = 0] = "login_type_local";
        e_login_type[e_login_type["login_type_channel"] = 1] = "login_type_channel";
        e_login_type[e_login_type["login_type_tpf"] = 2] = "login_type_tpf";
    })(e_login_type || (e_login_type = {}));
    var e_special_item;
    (function(e_special_item) {
        e_special_item[e_special_item["gold"] = 300000001] = "gold";
        e_special_item[e_special_item["diamond"] = 300000003] = "diamond";
    })(e_special_item || (e_special_item = {}));
    var e_enemy_type;
    (function(e_enemy_type) {
        e_enemy_type[e_enemy_type["disabled"] = 0] = "disabled";
        e_enemy_type[e_enemy_type["ground_defend_weapon"] = 1] = "ground_defend_weapon";
        e_enemy_type[e_enemy_type["building_resource"] = 2] = "building_resource";
        e_enemy_type[e_enemy_type["building_wall"] = 3] = "building_wall";
        e_enemy_type[e_enemy_type["building_main"] = 4] = "building_main";
        e_enemy_type[e_enemy_type["air_defend_weapon"] = 5] = "air_defend_weapon";
        e_enemy_type[e_enemy_type["defend_weapon_invisible"] = 6] = "defend_weapon_invisible";
        e_enemy_type[e_enemy_type["common_defend_weapon"] = 7] = "common_defend_weapon";
    })(e_enemy_type || (e_enemy_type = {}));
    var e_building_ids;
    (function(e_building_ids) {
        e_building_ids[e_building_ids["main"] = 201000004] = "main";
        e_building_ids[e_building_ids["gold"] = 201000006] = "gold";
        e_building_ids[e_building_ids["wall"] = 201000007] = "wall";
    })(e_building_ids || (e_building_ids = {}));
    var e_resource_building;
    (function(e_resource_building) {
        e_resource_building[e_resource_building["diamond"] = 0] = "diamond";
        e_resource_building[e_resource_building["population"] = 1] = "population";
        e_resource_building[e_resource_building["box"] = 2] = "box";
    })(e_resource_building || (e_resource_building = {}));
    var e_player_move_type;
    (function(e_player_move_type) {
        e_player_move_type[e_player_move_type["ground"] = 0] = "ground";
        e_player_move_type[e_player_move_type["fly"] = 1] = "fly";
    })(e_player_move_type || (e_player_move_type = {}));
    var e_enemy_ai_type;
    (function(e_enemy_ai_type) {
        e_enemy_ai_type[e_enemy_ai_type["none"] = -1] = "none";
        e_enemy_ai_type[e_enemy_ai_type["normal"] = 1] = "normal";
        e_enemy_ai_type[e_enemy_ai_type["defend_weapon_normal"] = 20] = "defend_weapon_normal";
        e_enemy_ai_type[e_enemy_ai_type["building_normal"] = 21] = "building_normal";
        e_enemy_ai_type[e_enemy_ai_type["defend_weapon_invisible"] = 43] = "defend_weapon_invisible";
        e_enemy_ai_type[e_enemy_ai_type["player_decoration"] = 47] = "player_decoration";
    })(e_enemy_ai_type || (e_enemy_ai_type = {}));
    var e_player_target_count;
    (function(e_player_target_count) {
        e_player_target_count[e_player_target_count["single"] = 1] = "single";
        e_player_target_count[e_player_target_count["multi"] = 2] = "multi";
    })(e_player_target_count || (e_player_target_count = {}));
    var e_player_action_type;
    (function(e_player_action_type) {
        e_player_action_type[e_player_action_type["attack"] = 0] = "attack";
        e_player_action_type[e_player_action_type["defend"] = 1] = "defend";
        e_player_action_type[e_player_action_type["treat"] = 2] = "treat";
    })(e_player_action_type || (e_player_action_type = {}));
    var e_player_action_type_desc;
    (function(e_player_action_type_desc) {
        e_player_action_type_desc["attack"] = "输出";
        e_player_action_type_desc["defend"] = "肉盾";
        e_player_action_type_desc["treat"] = "辅助";
    })(e_player_action_type_desc || (e_player_action_type_desc = {}));
    var e_effect_ids;
    (function(e_effect_ids) {
        e_effect_ids[e_effect_ids["attack"] = 400000001] = "attack";
        e_effect_ids[e_effect_ids["attacked_by_cannon"] = 400000002] = "attacked_by_cannon";
        e_effect_ids[e_effect_ids["cannon_attack"] = 400000003] = "cannon_attack";
        e_effect_ids[e_effect_ids["building_damage"] = 400000004] = "building_damage";
        e_effect_ids[e_effect_ids["building_dead"] = 400000005] = "building_dead";
        e_effect_ids[e_effect_ids["explore"] = 400000006] = "explore";
        e_effect_ids[e_effect_ids["small_building_dead"] = 400000007] = "small_building_dead";
        e_effect_ids[e_effect_ids["big_building_dead"] = 400000008] = "big_building_dead";
        e_effect_ids[e_effect_ids["player_birth"] = 41e7] = "player_birth";
        e_effect_ids[e_effect_ids["lightning_refraction"] = 430000001] = "lightning_refraction";
        e_effect_ids[e_effect_ids["lightning_link"] = 430000002] = "lightning_link";
        e_effect_ids[e_effect_ids["ui_test"] = 440000001] = "ui_test";
        e_effect_ids[e_effect_ids["ui_win"] = 440000002] = "ui_win";
        e_effect_ids[e_effect_ids["ui_caidai"] = 440000003] = "ui_caidai";
        e_effect_ids[e_effect_ids["ui_xingxing"] = 440000004] = "ui_xingxing";
        e_effect_ids[e_effect_ids["ui_shibai_caidai"] = 440000005] = "ui_shibai_caidai";
        e_effect_ids[e_effect_ids["ui_shibai_paizi"] = 440000006] = "ui_shibai_paizi";
        e_effect_ids[e_effect_ids["ui_main"] = 440000007] = "ui_main";
        e_effect_ids[e_effect_ids["ui_zong"] = 440000008] = "ui_zong";
        e_effect_ids[e_effect_ids["ui_lihua"] = 440000009] = "ui_lihua";
        e_effect_ids[e_effect_ids["ui_coin_collect"] = 440000010] = "ui_coin_collect";
        e_effect_ids[e_effect_ids["ui_diamond_collect"] = 440000011] = "ui_diamond_collect";
        e_effect_ids[e_effect_ids["ui_baoxiang"] = 440000012] = "ui_baoxiang";
        e_effect_ids[e_effect_ids["ui_get_diamond"] = 440000013] = "ui_get_diamond";
        e_effect_ids[e_effect_ids["ui_get_diamond_effect"] = 440000014] = "ui_get_diamond_effect";
        e_effect_ids[e_effect_ids["ui_get_population"] = 440000015] = "ui_get_population";
        e_effect_ids[e_effect_ids["ui_get_population_effect"] = 440000016] = "ui_get_population_effect";
        e_effect_ids[e_effect_ids["rage_effect_id"] = 410000009] = "rage_effect_id";
        e_effect_ids[e_effect_ids["select_effect"] = 420000007] = "select_effect";
        e_effect_ids[e_effect_ids["box_effect_click"] = 440000017] = "box_effect_click";
        e_effect_ids[e_effect_ids["box_effect_loop"] = 440000018] = "box_effect_loop";
        e_effect_ids[e_effect_ids["hero_upgrade_1"] = 440000019] = "hero_upgrade_1";
        e_effect_ids[e_effect_ids["hero_upgrade_2"] = 440000020] = "hero_upgrade_2";
        e_effect_ids[e_effect_ids["win_box_pro"] = 440000021] = "win_box_pro";
        e_effect_ids[e_effect_ids["win_box_move"] = 440000022] = "win_box_move";
        e_effect_ids[e_effect_ids["win_box_move_complete"] = 440000023] = "win_box_move_complete";
        e_effect_ids[e_effect_ids["ui_battle_lose"] = 440000024] = "ui_battle_lose";
    })(e_effect_ids || (e_effect_ids = {}));
    var e_bullet_type;
    (function(e_bullet_type) {
        e_bullet_type[e_bullet_type["line"] = 0] = "line";
        e_bullet_type[e_bullet_type["parabola"] = 1] = "parabola";
        e_bullet_type[e_bullet_type["refraction"] = 2] = "refraction";
        e_bullet_type[e_bullet_type["ejection"] = 3] = "ejection";
    })(e_bullet_type || (e_bullet_type = {}));
    var e_level_config_model_property;
    (function(e_level_config_model_property) {
        e_level_config_model_property[e_level_config_model_property["id"] = 0] = "id";
        e_level_config_model_property[e_level_config_model_property["p_x"] = 1] = "p_x";
        e_level_config_model_property[e_level_config_model_property["p_y"] = 2] = "p_y";
        e_level_config_model_property[e_level_config_model_property["p_z"] = 3] = "p_z";
        e_level_config_model_property[e_level_config_model_property["r_x"] = 4] = "r_x";
        e_level_config_model_property[e_level_config_model_property["r_y"] = 5] = "r_y";
        e_level_config_model_property[e_level_config_model_property["r_z"] = 6] = "r_z";
        e_level_config_model_property[e_level_config_model_property["r_w"] = 7] = "r_w";
        e_level_config_model_property[e_level_config_model_property["s_x"] = 8] = "s_x";
        e_level_config_model_property[e_level_config_model_property["s_y"] = 9] = "s_y";
        e_level_config_model_property[e_level_config_model_property["s_z"] = 10] = "s_z";
        e_level_config_model_property[e_level_config_model_property["unit_level"] = 11] = "unit_level";
    })(e_level_config_model_property || (e_level_config_model_property = {}));
    var battle_state;
    (function(battle_state) {
        battle_state[battle_state["stop"] = 0] = "stop";
        battle_state[battle_state["battle"] = 1] = "battle";
        battle_state[battle_state["win"] = 2] = "win";
        battle_state[battle_state["lose"] = 3] = "lose";
    })(battle_state || (battle_state = {}));
    var num_type = ["", "k", "m", "b", "t", "aa", "ab", "ac", "ad", "ae", "af", "ag", "ah", "ai", "aj", "ak", "al", "am", "an", "ao", "ap", "aq", "ar", "as", "at", "au", "av", "aw", "ax", "ay", "az", "ba", "bb", "bc", "bd", "be", "bf", "bg", "bh", "bi", "bj", "bk", "bl", "bm", "bn", "bo", "bp", "bq", "br", "bs", "bt", "bu", "bv", "bw", "bx", "by", "bz"];
    var e_ballistic_type;
    (function(e_ballistic_type) {
        e_ballistic_type[e_ballistic_type["line"] = 0] = "line";
        e_ballistic_type[e_ballistic_type["parabola"] = 1] = "parabola";
        e_ballistic_type[e_ballistic_type["refraction"] = 2] = "refraction";
        e_ballistic_type[e_ballistic_type["ejection"] = 3] = "ejection";
        e_ballistic_type[e_ballistic_type["link"] = 4] = "link";
        e_ballistic_type[e_ballistic_type["track"] = 5] = "track";
        e_ballistic_type[e_ballistic_type["scattering"] = 6] = "scattering";
    })(e_ballistic_type || (e_ballistic_type = {}));
    var sign_status;
    (function(sign_status) {
        sign_status[sign_status["has_sign"] = 0] = "has_sign";
        sign_status[sign_status["cur_sign"] = 1] = "cur_sign";
        sign_status[sign_status["not_sign"] = 2] = "not_sign";
    })(sign_status || (sign_status = {}));
    var window_type;
    (function(window_type) {
        window_type[window_type["ui_main"] = 4] = "ui_main";
        window_type[window_type["ui_battle_hud"] = 5] = "ui_battle_hud";
        window_type[window_type["ui_battle_menu_top"] = 6] = "ui_battle_menu_top";
        window_type[window_type["ui_battle_menu_bottom"] = 7] = "ui_battle_menu_bottom";
        window_type[window_type["ui_battle_account"] = 8] = "ui_battle_account";
        window_type[window_type["ui_battle_pause"] = 9] = "ui_battle_pause";
        window_type[window_type["ui_battle_revive"] = 10] = "ui_battle_revive";
        window_type[window_type["ui_character_hud"] = 11] = "ui_character_hud";
        window_type[window_type["ui_soldier_compose"] = 12] = "ui_soldier_compose";
        window_type[window_type["ui_soldier_purchase"] = 13] = "ui_soldier_purchase";
        window_type[window_type["ui_soldier_info"] = 14] = "ui_soldier_info";
        window_type[window_type["ui_soldier_unlock"] = 15] = "ui_soldier_unlock";
        window_type[window_type["ui_qiandao"] = 16] = "ui_qiandao";
        window_type[window_type["ui_soldier_reward"] = 17] = "ui_soldier_reward";
    })(window_type || (window_type = {}));
    var ui_animation_type;
    (function(ui_animation_type) {
        ui_animation_type[ui_animation_type["open"] = 0] = "open";
        ui_animation_type[ui_animation_type["close"] = 1] = "close";
        ui_animation_type[ui_animation_type["during"] = 2] = "during";
        ui_animation_type[ui_animation_type["click"] = 3] = "click";
        ui_animation_type[ui_animation_type["appear"] = 4] = "appear";
        ui_animation_type[ui_animation_type["disappear"] = 5] = "disappear";
        ui_animation_type[ui_animation_type["code_control1"] = 6] = "code_control1";
        ui_animation_type[ui_animation_type["code_control2"] = 7] = "code_control2";
        ui_animation_type[ui_animation_type["count"] = 8] = "count";
    })(ui_animation_type || (ui_animation_type = {}));
    var reward_win_type;
    (function(reward_win_type) {
        reward_win_type[reward_win_type["free_gold"] = 0] = "free_gold";
        reward_win_type[reward_win_type["offline_reward"] = 1] = "offline_reward";
        reward_win_type[reward_win_type["speed_up"] = 2] = "speed_up";
        reward_win_type[reward_win_type["free_energy"] = 3] = "free_energy";
    })(reward_win_type || (reward_win_type = {}));
    var e_buff_type;
    (function(e_buff_type) {
        e_buff_type[e_buff_type["buff"] = 1] = "buff";
        e_buff_type[e_buff_type["debuff"] = 2] = "debuff";
    })(e_buff_type || (e_buff_type = {}));
    var e_buff_result_type;
    (function(e_buff_result_type) {
        e_buff_result_type[e_buff_result_type["rage"] = 1] = "rage";
        e_buff_result_type[e_buff_result_type["wild"] = 2] = "wild";
        e_buff_result_type[e_buff_result_type["crit"] = 3] = "crit";
        e_buff_result_type[e_buff_result_type["summon"] = 4] = "summon";
        e_buff_result_type[e_buff_result_type["cure"] = 5] = "cure";
        e_buff_result_type[e_buff_result_type["invisible"] = 6] = "invisible";
        e_buff_result_type[e_buff_result_type["frozen"] = 7] = "frozen";
        e_buff_result_type[e_buff_result_type["cure_self"] = 8] = "cure_self";
    })(e_buff_result_type || (e_buff_result_type = {}));
    var preview_type;
    (function(preview_type) {
        preview_type[preview_type["none"] = 0] = "none";
        preview_type[preview_type["soldier"] = 1] = "soldier";
        preview_type[preview_type["facility"] = 2] = "facility";
        preview_type[preview_type["mission"] = 3] = "mission";
    })(preview_type || (preview_type = {}));
    var e_skill_trigger_type;
    (function(e_skill_trigger_type) {
        e_skill_trigger_type[e_skill_trigger_type["attack"] = 0] = "attack";
        e_skill_trigger_type[e_skill_trigger_type["birth"] = 1] = "birth";
        e_skill_trigger_type[e_skill_trigger_type["death"] = 2] = "death";
        e_skill_trigger_type[e_skill_trigger_type["extra"] = 3] = "extra";
        e_skill_trigger_type[e_skill_trigger_type["manual"] = 4] = "manual";
    })(e_skill_trigger_type || (e_skill_trigger_type = {}));
    var e_move_type;
    (function(e_move_type) {
        e_move_type[e_move_type["walk"] = 0] = "walk";
        e_move_type[e_move_type["fly"] = 1] = "fly";
        e_move_type[e_move_type["burrow"] = 2] = "burrow";
        e_move_type[e_move_type["jump"] = 3] = "jump";
    })(e_move_type || (e_move_type = {}));
    var e_skill_target;
    (function(e_skill_target) {
        e_skill_target[e_skill_target["enemy"] = 0] = "enemy";
        e_skill_target[e_skill_target["ally"] = 1] = "ally";
        e_skill_target[e_skill_target["self"] = 2] = "self";
    })(e_skill_target || (e_skill_target = {}));
    var e_skill_target_select_type;
    (function(e_skill_target_select_type) {
        e_skill_target_select_type[e_skill_target_select_type["target"] = 0] = "target";
        e_skill_target_select_type[e_skill_target_select_type["circle"] = 1] = "circle";
    })(e_skill_target_select_type || (e_skill_target_select_type = {}));
    var e_character_animation_state;
    (function(e_character_animation_state) {
        e_character_animation_state[e_character_animation_state["empty"] = 0] = "empty";
        e_character_animation_state[e_character_animation_state["idle"] = 1] = "idle";
        e_character_animation_state[e_character_animation_state["run"] = 2] = "run";
        e_character_animation_state[e_character_animation_state["attack"] = 3] = "attack";
        e_character_animation_state[e_character_animation_state["attacked"] = 4] = "attacked";
        e_character_animation_state[e_character_animation_state["dead"] = 5] = "dead";
        e_character_animation_state[e_character_animation_state["born"] = 6] = "born";
    })(e_character_animation_state || (e_character_animation_state = {}));
    var e_character_type;
    (function(e_character_type) {
        e_character_type[e_character_type["player"] = 0] = "player";
        e_character_type[e_character_type["enemy"] = 1] = "enemy";
        e_character_type[e_character_type["decoration"] = 2] = "decoration";
    })(e_character_type || (e_character_type = {}));
    var e_effect_type;
    (function(e_effect_type) {
        e_effect_type[e_effect_type["normal"] = 0] = "normal";
        e_effect_type[e_effect_type["lightning"] = 1] = "lightning";
        e_effect_type[e_effect_type["ui"] = 2] = "ui";
    })(e_effect_type || (e_effect_type = {}));
    var purchase_type;
    (function(purchase_type) {
        purchase_type[purchase_type["none"] = 0] = "none";
        purchase_type[purchase_type["gold"] = 1] = "gold";
        purchase_type[purchase_type["diamond"] = 2] = "diamond";
    })(purchase_type || (purchase_type = {}));
    var e_star_place;
    (function(e_star_place) {
        e_star_place[e_star_place["main"] = 0] = "main";
        e_star_place[e_star_place["target"] = 1] = "target";
        e_star_place[e_star_place["all_pass"] = 2] = "all_pass";
    })(e_star_place || (e_star_place = {}));
    var e_loading_type;
    (function(e_loading_type) {
        e_loading_type[e_loading_type["enter_game"] = 0] = "enter_game";
        e_loading_type[e_loading_type["enter_battle"] = 1] = "enter_battle";
    })(e_loading_type || (e_loading_type = {}));
    var e_chapter_item_type;
    (function(e_chapter_item_type) {
        e_chapter_item_type[e_chapter_item_type["normal"] = 0] = "normal";
        e_chapter_item_type[e_chapter_item_type["select"] = 1] = "select";
        e_chapter_item_type[e_chapter_item_type["lock"] = 2] = "lock";
    })(e_chapter_item_type || (e_chapter_item_type = {}));
    var e_destroy_model;
    (function(e_destroy_model) {
        e_destroy_model[e_destroy_model["full"] = 0] = "full";
        e_destroy_model[e_destroy_model["half"] = 1] = "half";
        e_destroy_model[e_destroy_model["zero"] = 2] = "zero";
    })(e_destroy_model || (e_destroy_model = {}));
    var e_get_coin;
    (function(e_get_coin) {
        e_get_coin["chapter"] = "e_get_coin_chapter";
        e_get_coin["win_star"] = "e_get_coin_win_star";
        e_get_coin["soldier_production"] = "e_get_coin_soldier_production";
        e_get_coin["newbie"] = "e_get_coin_newbie";
        e_get_coin["del_soldier"] = "e_get_coin_del_soldier";
        e_get_coin["sign"] = "e_get_coin_sign";
        e_get_coin["offline"] = "e_get_coin_offline";
        e_get_coin["supply"] = "e_get_coin_supply";
        e_get_coin["compose"] = "e_get_coin_compose";
        e_get_coin["select_chapter"] = "e_get_coin_select_chapter";
        e_get_coin["chip"] = "e_get_coin_chip";
        e_get_coin["building_box"] = "building_box";
        e_get_coin["chapter_ad"] = "chapter_ad";
    })(e_get_coin || (e_get_coin = {}));
    var e_use_coin;
    (function(e_use_coin) {
        e_use_coin["buy_soldier"] = "e_use_coin_buy_soldier";
        e_use_coin["speed_up"] = "e_use_coin_speed_up";
        e_use_coin["upgrade_hero"] = "e_use_coin_upgrade_hero";
    })(e_use_coin || (e_use_coin = {}));
    var e_ground_offset;
    (function(e_ground_offset) {
        e_ground_offset[e_ground_offset["地面"] = 0] = "地面";
        e_ground_offset[e_ground_offset["建筑底"] = 1] = "建筑底";
        e_ground_offset[e_ground_offset["阴影"] = 2] = "阴影";
        e_ground_offset[e_ground_offset["格子"] = 3] = "格子";
        e_ground_offset[e_ground_offset["禁止放兵"] = 4] = "禁止放兵";
    })(e_ground_offset || (e_ground_offset = {}));
    var e_quality;
    (function(e_quality) {
        e_quality[e_quality["white"] = 1] = "white";
        e_quality[e_quality["green"] = 2] = "green";
        e_quality[e_quality["blue"] = 3] = "blue";
        e_quality[e_quality["purple"] = 4] = "purple";
    })(e_quality || (e_quality = {}));
    var e_fragment_box_type;
    (function(e_fragment_box_type) {
        e_fragment_box_type[e_fragment_box_type["all"] = 0] = "all";
        e_fragment_box_type[e_fragment_box_type["ground"] = 1] = "ground";
        e_fragment_box_type[e_fragment_box_type["fly"] = 2] = "fly";
        e_fragment_box_type[e_fragment_box_type["defend"] = 3] = "defend";
        e_fragment_box_type[e_fragment_box_type["attack"] = 4] = "attack";
        e_fragment_box_type[e_fragment_box_type["treat"] = 5] = "treat";
    })(e_fragment_box_type || (e_fragment_box_type = {}));
    var e_equal;
    (function(e_equal) {
        e_equal[e_equal["less"] = -1] = "less";
        e_equal[e_equal["equal"] = 0] = "equal";
        e_equal[e_equal["large"] = 1] = "large";
    })(e_equal || (e_equal = {}));
    var e_box_card_type;
    (function(e_box_card_type) {
        e_box_card_type[e_box_card_type["coin"] = 0] = "coin";
        e_box_card_type[e_box_card_type["fragment"] = 1] = "fragment";
    })(e_box_card_type || (e_box_card_type = {}));
    var e_upgrade_coin_type;
    (function(e_upgrade_coin_type) {
        e_upgrade_coin_type[e_upgrade_coin_type["none"] = 0] = "none";
        e_upgrade_coin_type[e_upgrade_coin_type["gold"] = 1] = "gold";
        e_upgrade_coin_type[e_upgrade_coin_type["diamond"] = 2] = "diamond";
        e_upgrade_coin_type[e_upgrade_coin_type["gold_and_diamond"] = 3] = "gold_and_diamond";
    })(e_upgrade_coin_type || (e_upgrade_coin_type = {}));
    var NewbieState;
    (function(NewbieState) {
        NewbieState[NewbieState["UnDone"] = 0] = "UnDone";
        NewbieState[NewbieState["Doing"] = 1] = "Doing";
        NewbieState[NewbieState["Done"] = 2] = "Done";
    })(NewbieState || (NewbieState = {}));
    var NewbieType;
    (function(NewbieType) {
        NewbieType[NewbieType["Strong"] = 1] = "Strong";
        NewbieType[NewbieType["Weak"] = 2] = "Weak";
    })(NewbieType || (NewbieType = {}));
    var EventIds;
    (function(EventIds) {
        EventIds[EventIds["INIT_NEWBIE_DATA"] = 900] = "INIT_NEWBIE_DATA";
        EventIds[EventIds["NEWBIE_SHOW_COMPLETE"] = 901] = "NEWBIE_SHOW_COMPLETE";
        EventIds[EventIds["NEWBIE_ADVANCE_END"] = 902] = "NEWBIE_ADVANCE_END";
        EventIds[EventIds["NEWBIE_COMPLETE"] = 903] = "NEWBIE_COMPLETE";
        EventIds[EventIds["NEWBIE_MANUAL_END"] = 904] = "NEWBIE_MANUAL_END";
        EventIds[EventIds["FORCE_COMPLETE_NEWBIE"] = 905] = "FORCE_COMPLETE_NEWBIE";
        EventIds[EventIds["NEWBIE_START_SHOW"] = 906] = "NEWBIE_START_SHOW";
        EventIds[EventIds["FORCE_RECYLE_NEWBIE"] = 907] = "FORCE_RECYLE_NEWBIE";
        EventIds[EventIds["RESET_WEAK_NEWBIE"] = 908] = "RESET_WEAK_NEWBIE";
    })(EventIds || (EventIds = {}));
    var PhoneIds;
    (function(PhoneIds) {
        PhoneIds[PhoneIds["CHECK_NEWBIE_COMPLETE"] = 900] = "CHECK_NEWBIE_COMPLETE";
        PhoneIds[PhoneIds["CHECK_NEWBIE_SHOWING"] = 901] = "CHECK_NEWBIE_SHOWING";
    })(PhoneIds || (PhoneIds = {}));
    var e_guide_node;
    (function(e_guide_node) {
        e_guide_node["enter_battle"] = "enter_battle";
        e_guide_node["first_card"] = "first_card";
        e_guide_node["buy_soldier"] = "buy_soldier";
        e_guide_node["close_unlock_view"] = "close_unlock_view";
        e_guide_node["first_hero_node"] = "first_hero_node";
        e_guide_node["btn_formation"] = "btn_formation";
        e_guide_node["btn_uninstall"] = "btn_uninstall";
        e_guide_node["btn_install"] = "btn_install";
        e_guide_node["add_player"] = "add_player";
        e_guide_node["show_battle_tips"] = "show_battle_tips";
        e_guide_node["hero_btn_node"] = "hero_btn_node";
        e_guide_node["upgrade_hero_icon"] = "upgrade_hero_icon";
        e_guide_node["btn_upgrade"] = "btn_upgrade";
    })(e_guide_node || (e_guide_node = {}));
    var e_newbie_mask;
    (function(e_newbie_mask) {
        e_newbie_mask[e_newbie_mask["left"] = 0] = "left";
        e_newbie_mask[e_newbie_mask["right"] = 1] = "right";
        e_newbie_mask[e_newbie_mask["up"] = 2] = "up";
        e_newbie_mask[e_newbie_mask["down"] = 3] = "down";
        e_newbie_mask[e_newbie_mask["center"] = 4] = "center";
    })(e_newbie_mask || (e_newbie_mask = {}));
    var e_newbie_need_mask;
    (function(e_newbie_need_mask) {
        e_newbie_need_mask[e_newbie_need_mask["none"] = 0] = "none";
        e_newbie_need_mask[e_newbie_need_mask["need"] = 1] = "need";
    })(e_newbie_need_mask || (e_newbie_need_mask = {}));
    var e_box_view_type;
    (function(e_box_view_type) {
        e_box_view_type[e_box_view_type["total"] = 1] = "total";
        e_box_view_type[e_box_view_type["one_by_one"] = 2] = "one_by_one";
    })(e_box_view_type || (e_box_view_type = {}));
    var e_adv_show_scene;
    (function(e_adv_show_scene) {
        e_adv_show_scene["video_coin"] = "video_coin";
        e_adv_show_scene["video_energy"] = "video_energy";
        e_adv_show_scene["video_hero"] = "video_hero";
        e_adv_show_scene["video_offline"] = "video_offline";
        e_adv_show_scene["video_speedup"] = "video_speedup";
        e_adv_show_scene["video_rebirth"] = "video_rebirth";
        e_adv_show_scene["video_success"] = "video_success";
        e_adv_show_scene["video_fail"] = "video_fail";
        e_adv_show_scene["banner_all"] = "banner_all";
    })(e_adv_show_scene || (e_adv_show_scene = {}));
    var e_ad_id;
    (function(e_ad_id) {
        e_ad_id[e_ad_id["video_coin"] = 1001] = "video_coin";
        e_ad_id[e_ad_id["video_energy"] = 1002] = "video_energy";
        e_ad_id[e_ad_id["video_hero"] = 1003] = "video_hero";
        e_ad_id[e_ad_id["video_offline"] = 1004] = "video_offline";
        e_ad_id[e_ad_id["video_speedup"] = 1005] = "video_speedup";
        e_ad_id[e_ad_id["video_rebirth"] = 1006] = "video_rebirth";
        e_ad_id[e_ad_id["video_success"] = 1007] = "video_success";
        e_ad_id[e_ad_id["video_fail"] = 1008] = "video_fail";
        e_ad_id[e_ad_id["banner_all"] = 1020] = "banner_all";
    })(e_ad_id || (e_ad_id = {}));
    var e_ad_state;
    (function(e_ad_state) {
        e_ad_state[e_ad_state["error"] = 0] = "error";
        e_ad_state[e_ad_state["normal"] = 1] = "normal";
        e_ad_state[e_ad_state["show_max"] = 2] = "show_max";
        e_ad_state[e_ad_state["in_cd"] = 3] = "in_cd";
        e_ad_state[e_ad_state["is_lock"] = 4] = "is_lock";
    })(e_ad_state || (e_ad_state = {}));
    var e_adv_unlock_condition;
    (function(e_adv_unlock_condition) {
        e_adv_unlock_condition[e_adv_unlock_condition["level"] = 1] = "level";
        e_adv_unlock_condition[e_adv_unlock_condition["chapter"] = 2] = "chapter";
    })(e_adv_unlock_condition || (e_adv_unlock_condition = {}));
    var e_dot_type;
    (function(e_dot_type) {
        e_dot_type[e_dot_type["loading"] = 1e3] = "loading";
        e_dot_type[e_dot_type["loading_complete"] = 1500] = "loading_complete";
        e_dot_type[e_dot_type["unlock_new_player"] = 3e3] = "unlock_new_player";
        e_dot_type[e_dot_type["upgrade_player"] = 3010] = "upgrade_player";
        e_dot_type[e_dot_type["use_player_in_chapter"] = 3020] = "use_player_in_chapter";
        e_dot_type[e_dot_type["chapter_battle"] = 3030] = "chapter_battle";
        e_dot_type[e_dot_type["chapter_pass"] = 3040] = "chapter_pass";
        e_dot_type[e_dot_type["chapter_pass_one"] = 3050] = "chapter_pass_one";
        e_dot_type[e_dot_type["chapter_pass_two"] = 3060] = "chapter_pass_two";
        e_dot_type[e_dot_type["chapter_pass_three"] = 3070] = "chapter_pass_three";
        e_dot_type[e_dot_type["chapter_fail"] = 3080] = "chapter_fail";
        e_dot_type[e_dot_type["win_star_full"] = 3090] = "win_star_full";
        e_dot_type[e_dot_type["first_player_position"] = 3100] = "first_player_position";
        e_dot_type[e_dot_type["upload_battle_frame"] = 3110] = "upload_battle_frame";
        e_dot_type[e_dot_type["daily_login_chapter"] = 4e3] = "daily_login_chapter";
    })(e_dot_type || (e_dot_type = {}));
    var e_banner_scene;
    (function(e_banner_scene) {
        e_banner_scene["ui"] = "ui";
        e_banner_scene["battle"] = "battle";
    })(e_banner_scene || (e_banner_scene = {}));
    var e_newbie_type;
    (function(e_newbie_type) {
        e_newbie_type[e_newbie_type["strong"] = 1] = "strong";
        e_newbie_type[e_newbie_type["weak"] = 2] = "weak";
    })(e_newbie_type || (e_newbie_type = {}));
    var sound_id;
    (function(sound_id) {
        sound_id[sound_id["win"] = 1] = "win";
        sound_id[sound_id["lose"] = 2] = "lose";
        sound_id[sound_id["bgm"] = 3] = "bgm";
        sound_id[sound_id["btn"] = 9] = "btn";
        sound_id[sound_id["fire"] = 10] = "fire";
        sound_id[sound_id["hit_unit"] = 11] = "hit_unit";
    })(sound_id || (sound_id = {}));
    var e_fail_reason;
    (function(e_fail_reason) {
        e_fail_reason[e_fail_reason["turn_over"] = 1] = "turn_over";
        e_fail_reason[e_fail_reason["no_coal"] = 2] = "no_coal";
    })(e_fail_reason || (e_fail_reason = {}));
    var e_model_type;
    (function(e_model_type) {
        e_model_type[e_model_type["train_head"] = 1] = "train_head";
        e_model_type[e_model_type["train_model"] = 2] = "train_model";
        e_model_type[e_model_type["train_gift"] = 3] = "train_gift";
        e_model_type[e_model_type["train_passenger_1"] = 4] = "train_passenger_1";
        e_model_type[e_model_type["train_passenger_2"] = 5] = "train_passenger_2";
        e_model_type[e_model_type["train_passenger_3"] = 6] = "train_passenger_3";
        e_model_type[e_model_type["train_passenger_4"] = 7] = "train_passenger_4";
    })(e_model_type || (e_model_type = {}));
    var e_attr_type;
    (function(e_attr_type) {
        e_attr_type[e_attr_type["coal"] = 1] = "coal";
        e_attr_type[e_attr_type["power"] = 2] = "power";
        e_attr_type[e_attr_type["offline"] = 3] = "offline";
    })(e_attr_type || (e_attr_type = {}));
    (function(e_move_type) {
        e_move_type[e_move_type["empty"] = 1] = "empty";
        e_move_type[e_move_type["run"] = 2] = "run";
    })(e_move_type || (e_move_type = {}));
    var e_env_type;
    (function(e_env_type) {
        e_env_type[e_env_type["grass"] = 1] = "grass";
        e_env_type[e_env_type["sand"] = 3] = "sand";
        e_env_type[e_env_type["snow"] = 2] = "snow";
    })(e_env_type || (e_env_type = {}));
    var e_tt_mutual_push_type;
    (function(e_tt_mutual_push_type) {
        e_tt_mutual_push_type[e_tt_mutual_push_type["not_support"] = 0] = "not_support";
        e_tt_mutual_push_type[e_tt_mutual_push_type["new"] = 1] = "new";
        e_tt_mutual_push_type[e_tt_mutual_push_type["old"] = 2] = "old";
    })(e_tt_mutual_push_type || (e_tt_mutual_push_type = {}));
    var e_game_state;
    (function(e_game_state) {
        e_game_state[e_game_state["win"] = 1] = "win";
        e_game_state[e_game_state["fail"] = 2] = "fail";
        e_game_state[e_game_state["play"] = 3] = "play";
    })(e_game_state || (e_game_state = {}));
    var e_track_type;
    (function(e_track_type) {
        e_track_type[e_track_type["none"] = 0] = "none";
        e_track_type[e_track_type["foundation"] = 1] = "foundation";
        e_track_type[e_track_type["viaduct"] = 2] = "viaduct";
    })(e_track_type || (e_track_type = {}));
    var global = {
        game: {
            channel_type: igc.e_channel_type.wx,
            login_account: false,
            login_plat: false,
            load_config: false,
            is_get_storage: false,
            is_local_stat: 1,
            supportVideo: true,
            is_support_tt_push: false,
            id: "",
            nickName: "",
            avatar: "",
            tpfUserId: "",
            platUserId: "",
            tpfToken: "",
            max_chapter: 80,
            adv_count: 1,
            diamond_reborn_num: 0,
            ui_login: null,
            chapter_init: 0,
            editor: false,
            version: 5
        },
        ad_type: {
            video: {
                challenge_fail: 1,
                chapter_double_reward: 9,
                offline_double: 10,
                fail_double: 11,
                supply: 12,
                video_up_lv: 13
            },
            banner: {
                normal: 2,
                normal2: 3
            },
            inster: {
                challenge_success: 4,
                challenge_fail: 5,
                exit_game: 31
            },
            native: {
                challenge_success: 6,
                challenge_fail: 7,
                pause: 8
            },
            app_box: {
                challenge_success: 6,
                challenge_fail: 7,
                pause: 8,
                normal: 21
            }
        },
        dot_type: {
            enter_scene: 1,
            win: 2,
            lose: 3,
            restart: 4,
            continue: 5,
            start: 6,
            relife: 7,
            coal_level: 11,
            power_level: 12,
            offline_level: 13,
            kill_ball: 100
        },
        luck: {
            sand: 10,
            snow: 5
        }
    };
    class ui_more_games extends Laya.Script {
        constructor() {
            super();
        }
        set owner(value) {
            this.this_sprite = value;
            igc.igc_timer.frameOnce(1, this, this.handle_more_games, undefined, true);
        }
        get owner() {
            return this.this_sprite;
        }
        onEnable() {
            igc.igc_timer.frameOnce(1, this, this.init_btn_event, undefined, true);
        }
        init_btn_event() {
            this.this_sprite.on(Laya.Event.CLICK, this, this.on_click_more_games);
            if (this.cur_tt_show_type == e_tt_mutual_push_type.old) {
                igc.igc_main.instance.more_game_btn_show();
            }
        }
        release_btn_event() {
            this.this_sprite.off(Laya.Event.CLICK, this, this.on_click_more_games);
        }
        onDisable() {
            this.release_btn_event();
            if (this.cur_tt_show_type == e_tt_mutual_push_type.old) {
                igc.igc_main.instance.more_game_btn_hide();
            }
        }
        on_click_more_games() {
            console.log("show_more_games !");
            igc.igc_main.instance.show_more_game_modal();
        }
        handle_more_games() {
            let param = {
                btn_info: {
                    type: "image",
                    image: "res/sprite/common/bt_ys_anniu.png",
                    style: {
                        left: 270,
                        top: 300,
                        width: 100,
                        height: 30,
                        lineHeight: 0,
                        borderRadius: 0,
                        borderWidth: 0
                    }
                },
                app_list: ["ttc636b08b591ce063", "tt149a62278bb0dcfd", "ttde4ba8f64161ecbf", "ttfcdc8a6163f63342", "tt4b413dfcd46b8512", "ttd4e6a25b4bcc1c8d", "tt249f5222bbb5ecc7", "tta59ed3233ab46e4e", "tt6b191da4f433a52c", "tt049972249bb3ccff"]
            };
            this.cur_tt_show_type = igc.igc_main.instance.check_show_more_game(param);
            console.log(">>>>>> cur_tt_show_type", this.cur_tt_show_type);
            switch (this.cur_tt_show_type) {
                case e_tt_mutual_push_type.not_support:
                    this.this_sprite.visible = false;
                    break;

                case e_tt_mutual_push_type.new:
                    global.game.is_support_tt_push = true;
                    this.this_sprite.visible = true;
                    break;

                case e_tt_mutual_push_type.old:
                    this.this_sprite.visible = false;
                    break;

                default:
                    this.this_sprite.visible = false;
                    break;
            }
        }
    }
    var broadcast_ids;
    (function(broadcast_ids) {
        broadcast_ids[broadcast_ids["game_resume"] = 1e3] = "game_resume";
        broadcast_ids[broadcast_ids["game_pause"] = 1001] = "game_pause";
        broadcast_ids[broadcast_ids["game_paused"] = 1002] = "game_paused";
        broadcast_ids[broadcast_ids["game_resumed"] = 1003] = "game_resumed";
        broadcast_ids[broadcast_ids["update_login_progrss"] = 1004] = "update_login_progrss";
        broadcast_ids[broadcast_ids["begin_load_battle_scene"] = 1005] = "begin_load_battle_scene";
        broadcast_ids[broadcast_ids["load_battle_scene"] = 1006] = "load_battle_scene";
        broadcast_ids[broadcast_ids["load_battle_scene_finished"] = 1007] = "load_battle_scene_finished";
        broadcast_ids[broadcast_ids["unload_battle_scene"] = 1008] = "unload_battle_scene";
        broadcast_ids[broadcast_ids["unload_battle_scene_finished"] = 1009] = "unload_battle_scene_finished";
        broadcast_ids[broadcast_ids["click_scene"] = 1010] = "click_scene";
        broadcast_ids[broadcast_ids["destroy_character"] = 1011] = "destroy_character";
        broadcast_ids[broadcast_ids["destroy_all_enemies"] = 1012] = "destroy_all_enemies";
        broadcast_ids[broadcast_ids["destroy_all_active_characters"] = 1013] = "destroy_all_active_characters";
        broadcast_ids[broadcast_ids["path_find_obstacles_changed"] = 1014] = "path_find_obstacles_changed";
        broadcast_ids[broadcast_ids["enter_battle"] = 1015] = "enter_battle";
        broadcast_ids[broadcast_ids["exit_battle"] = 1016] = "exit_battle";
        broadcast_ids[broadcast_ids["set_destroy_pro"] = 1017] = "set_destroy_pro";
        broadcast_ids[broadcast_ids["formation_change"] = 1018] = "formation_change";
        broadcast_ids[broadcast_ids["auto_formation_change"] = 1019] = "auto_formation_change";
        broadcast_ids[broadcast_ids["change_charater_animation"] = 1020] = "change_charater_animation";
        broadcast_ids[broadcast_ids["attack"] = 1021] = "attack";
        broadcast_ids[broadcast_ids["attacked"] = 1022] = "attacked";
        broadcast_ids[broadcast_ids["character_dead"] = 1023] = "character_dead";
        broadcast_ids[broadcast_ids["item_update"] = 1024] = "item_update";
        broadcast_ids[broadcast_ids["save"] = 1025] = "save";
        broadcast_ids[broadcast_ids["clear_save"] = 1026] = "clear_save";
        broadcast_ids[broadcast_ids["load_save_begin"] = 1027] = "load_save_begin";
        broadcast_ids[broadcast_ids["load_save_end"] = 1028] = "load_save_end";
        broadcast_ids[broadcast_ids["show_enemy_cells"] = 1029] = "show_enemy_cells";
        broadcast_ids[broadcast_ids["show_enemy_neighbour_cells"] = 1030] = "show_enemy_neighbour_cells";
        broadcast_ids[broadcast_ids["show_enemy_non_obstacle_neighbour_cells"] = 1031] = "show_enemy_non_obstacle_neighbour_cells";
        broadcast_ids[broadcast_ids["show_enemy_movable_neighbour_cells"] = 1032] = "show_enemy_movable_neighbour_cells";
        broadcast_ids[broadcast_ids["hide_effect"] = 1033] = "hide_effect";
        broadcast_ids[broadcast_ids["hide_all_effects"] = 1034] = "hide_all_effects";
        broadcast_ids[broadcast_ids["recycle_effect_sprite3d"] = 1035] = "recycle_effect_sprite3d";
        broadcast_ids[broadcast_ids["effect_hidden"] = 1036] = "effect_hidden";
        broadcast_ids[broadcast_ids["hide_bullet"] = 1037] = "hide_bullet";
        broadcast_ids[broadcast_ids["hide_all_bullets"] = 1038] = "hide_all_bullets";
        broadcast_ids[broadcast_ids["recycle_bullet_sprite3d"] = 1039] = "recycle_bullet_sprite3d";
        broadcast_ids[broadcast_ids["bullet_hidden"] = 1040] = "bullet_hidden";
        broadcast_ids[broadcast_ids["battle_time_change"] = 1041] = "battle_time_change";
        broadcast_ids[broadcast_ids["battle_population_change"] = 1042] = "battle_population_change";
        broadcast_ids[broadcast_ids["hide_battle_top"] = 1043] = "hide_battle_top";
        broadcast_ids[broadcast_ids["battle_pause"] = 1044] = "battle_pause";
        broadcast_ids[broadcast_ids["battle_resume"] = 1045] = "battle_resume";
        broadcast_ids[broadcast_ids["battle_revive"] = 1046] = "battle_revive";
        broadcast_ids[broadcast_ids["hide_account_complete"] = 1047] = "hide_account_complete";
        broadcast_ids[broadcast_ids["battle_gold_change"] = 1048] = "battle_gold_change";
        broadcast_ids[broadcast_ids["battle_diamond_change"] = 1049] = "battle_diamond_change";
        broadcast_ids[broadcast_ids["get_cur_chapter_id"] = 1050] = "get_cur_chapter_id";
        broadcast_ids[broadcast_ids["set_battle_state"] = 1051] = "set_battle_state";
        broadcast_ids[broadcast_ids["req_enter_battle"] = 1052] = "req_enter_battle";
        broadcast_ids[broadcast_ids["on_select_battle_card"] = 1053] = "on_select_battle_card";
        broadcast_ids[broadcast_ids["on_select_battle_wait_card"] = 1054] = "on_select_battle_wait_card";
        broadcast_ids[broadcast_ids["del_soldier"] = 1055] = "del_soldier";
        broadcast_ids[broadcast_ids["ref_compose_list"] = 1056] = "ref_compose_list";
        broadcast_ids[broadcast_ids["production_speed_up"] = 1057] = "production_speed_up";
        broadcast_ids[broadcast_ids["production_speed_up_end"] = 1058] = "production_speed_up_end";
        broadcast_ids[broadcast_ids["enter_scene"] = 1059] = "enter_scene";
        broadcast_ids[broadcast_ids["chapter_success"] = 1060] = "chapter_success";
        broadcast_ids[broadcast_ids["chapter_fail"] = 1061] = "chapter_fail";
        broadcast_ids[broadcast_ids["chapter_restart"] = 1062] = "chapter_restart";
        broadcast_ids[broadcast_ids["chapter_continue"] = 1063] = "chapter_continue";
        broadcast_ids[broadcast_ids["chapter_play"] = 1064] = "chapter_play";
        broadcast_ids[broadcast_ids["chapter_relife"] = 1065] = "chapter_relife";
        broadcast_ids[broadcast_ids["chapter_relife_play"] = 1066] = "chapter_relife_play";
        broadcast_ids[broadcast_ids["character_success"] = 1067] = "character_success";
        broadcast_ids[broadcast_ids["character_fail"] = 1068] = "character_fail";
        broadcast_ids[broadcast_ids["character_restart"] = 1069] = "character_restart";
        broadcast_ids[broadcast_ids["character_continue"] = 1070] = "character_continue";
        broadcast_ids[broadcast_ids["character_play"] = 1071] = "character_play";
        broadcast_ids[broadcast_ids["character_relife"] = 1072] = "character_relife";
        broadcast_ids[broadcast_ids["shake_camera"] = 1073] = "shake_camera";
        broadcast_ids[broadcast_ids["create_unit"] = 1074] = "create_unit";
        broadcast_ids[broadcast_ids["delete_unit"] = 1075] = "delete_unit";
        broadcast_ids[broadcast_ids["create_hit_effect"] = 1076] = "create_hit_effect";
        broadcast_ids[broadcast_ids["little_shake_camera"] = 1077] = "little_shake_camera";
        broadcast_ids[broadcast_ids["add_anim_node"] = 1078] = "add_anim_node";
        broadcast_ids[broadcast_ids["update_chapter_progress"] = 1079] = "update_chapter_progress";
        broadcast_ids[broadcast_ids["update_vol"] = 1080] = "update_vol";
        broadcast_ids[broadcast_ids["play_sound"] = 1081] = "play_sound";
        broadcast_ids[broadcast_ids["play_music"] = 1082] = "play_music";
        broadcast_ids[broadcast_ids["update_shake"] = 1083] = "update_shake";
        broadcast_ids[broadcast_ids["play_shake"] = 1084] = "play_shake";
        broadcast_ids[broadcast_ids["device_shake"] = 1085] = "device_shake";
        broadcast_ids[broadcast_ids["window_resize"] = 1086] = "window_resize";
        broadcast_ids[broadcast_ids["add_character_to_scene"] = 1087] = "add_character_to_scene";
        broadcast_ids[broadcast_ids["little_shake"] = 1088] = "little_shake";
        broadcast_ids[broadcast_ids["load_character_complete"] = 1089] = "load_character_complete";
        broadcast_ids[broadcast_ids["record_screen"] = 1090] = "record_screen";
        broadcast_ids[broadcast_ids["record_screen_suc"] = 1091] = "record_screen_suc";
        broadcast_ids[broadcast_ids["login_success"] = 1092] = "login_success";
        broadcast_ids[broadcast_ids["account_login_success"] = 1093] = "account_login_success";
        broadcast_ids[broadcast_ids["plat_login_success"] = 1094] = "plat_login_success";
        broadcast_ids[broadcast_ids["show_video"] = 1095] = "show_video";
        broadcast_ids[broadcast_ids["show_banner"] = 1096] = "show_banner";
        broadcast_ids[broadcast_ids["hide_banner"] = 1097] = "hide_banner";
        broadcast_ids[broadcast_ids["destroy_banner"] = 1098] = "destroy_banner";
        broadcast_ids[broadcast_ids["update_banner"] = 1099] = "update_banner";
        broadcast_ids[broadcast_ids["show_insert_ad"] = 1100] = "show_insert_ad";
        broadcast_ids[broadcast_ids["pre_load_native"] = 1101] = "pre_load_native";
        broadcast_ids[broadcast_ids["show_natvie"] = 1102] = "show_natvie";
        broadcast_ids[broadcast_ids["report_show"] = 1103] = "report_show";
        broadcast_ids[broadcast_ids["report_click"] = 1104] = "report_click";
        broadcast_ids[broadcast_ids["clear_data"] = 1105] = "clear_data";
        broadcast_ids[broadcast_ids["set_can_show_banner"] = 1106] = "set_can_show_banner";
        broadcast_ids[broadcast_ids["show_game_banner_wx"] = 1107] = "show_game_banner_wx";
        broadcast_ids[broadcast_ids["display_native"] = 1108] = "display_native";
        broadcast_ids[broadcast_ids["close_native"] = 1109] = "close_native";
        broadcast_ids[broadcast_ids["camera_win"] = 1110] = "camera_win";
        broadcast_ids[broadcast_ids["camera_begin_move"] = 1111] = "camera_begin_move";
        broadcast_ids[broadcast_ids["camera_idle"] = 1112] = "camera_idle";
        broadcast_ids[broadcast_ids["camera_zoom_in"] = 1113] = "camera_zoom_in";
        broadcast_ids[broadcast_ids["camera_zoom_out"] = 1114] = "camera_zoom_out";
        broadcast_ids[broadcast_ids["update_chapter_info"] = 1115] = "update_chapter_info";
        broadcast_ids[broadcast_ids["arrive_final"] = 1116] = "arrive_final";
        broadcast_ids[broadcast_ids["draw_area_done"] = 1117] = "draw_area_done";
        broadcast_ids[broadcast_ids["player_update_area"] = 1118] = "player_update_area";
        broadcast_ids[broadcast_ids["show_qiu_eat"] = 1119] = "show_qiu_eat";
        broadcast_ids[broadcast_ids["send_dot"] = 1120] = "send_dot";
        broadcast_ids[broadcast_ids["change_collider_state"] = 1121] = "change_collider_state";
        broadcast_ids[broadcast_ids["change_jiasu_state"] = 1122] = "change_jiasu_state";
        broadcast_ids[broadcast_ids["load_obstacle_complete"] = 1123] = "load_obstacle_complete";
        broadcast_ids[broadcast_ids["out_joint"] = 1124] = "out_joint";
        broadcast_ids[broadcast_ids["draw_race_end"] = 1125] = "draw_race_end";
        broadcast_ids[broadcast_ids["collider_diamond"] = 1126] = "collider_diamond";
        broadcast_ids[broadcast_ids["update_diamond"] = 1127] = "update_diamond";
        broadcast_ids[broadcast_ids["add_diamond"] = 1128] = "add_diamond";
        broadcast_ids[broadcast_ids["energy_update"] = 1129] = "energy_update";
        broadcast_ids[broadcast_ids["pause_sound"] = 1130] = "pause_sound";
        broadcast_ids[broadcast_ids["show_native_success"] = 1131] = "show_native_success";
        broadcast_ids[broadcast_ids["show_diamond_anim"] = 1132] = "show_diamond_anim";
        broadcast_ids[broadcast_ids["set_skin_chapter"] = 1133] = "set_skin_chapter";
        broadcast_ids[broadcast_ids["change_material"] = 1134] = "change_material";
        broadcast_ids[broadcast_ids["dnsdk_init"] = 1135] = "dnsdk_init";
        broadcast_ids[broadcast_ids["dnsdk_share"] = 1136] = "dnsdk_share";
        broadcast_ids[broadcast_ids["dnsdk_send_event"] = 1137] = "dnsdk_send_event";
        broadcast_ids[broadcast_ids["dnsdk_chapter_start"] = 1138] = "dnsdk_chapter_start";
        broadcast_ids[broadcast_ids["dnsdk_chapter_running"] = 1139] = "dnsdk_chapter_running";
        broadcast_ids[broadcast_ids["dnsdk_chapter_end"] = 1140] = "dnsdk_chapter_end";
        broadcast_ids[broadcast_ids["dnsdk_get_data"] = 1141] = "dnsdk_get_data";
        broadcast_ids[broadcast_ids["dnsdk_report_show"] = 1142] = "dnsdk_report_show";
        broadcast_ids[broadcast_ids["dnsdk_report_click"] = 1143] = "dnsdk_report_click";
        broadcast_ids[broadcast_ids["dnsdk_show_push_view"] = 1144] = "dnsdk_show_push_view";
        broadcast_ids[broadcast_ids["dnsdk_show_game_share"] = 1145] = "dnsdk_show_game_share";
        broadcast_ids[broadcast_ids["dnsdk_show_splash_list"] = 1146] = "dnsdk_show_splash_list";
        broadcast_ids[broadcast_ids["dnsdk_show_single_splash"] = 1147] = "dnsdk_show_single_splash";
        broadcast_ids[broadcast_ids["dnsdk_push_view_show_icon"] = 1148] = "dnsdk_push_view_show_icon";
        broadcast_ids[broadcast_ids["dnsdk_show_banner"] = 1149] = "dnsdk_show_banner";
        broadcast_ids[broadcast_ids["dnsdk_init_compelete"] = 1150] = "dnsdk_init_compelete";
        broadcast_ids[broadcast_ids["real_begin_game"] = 1151] = "real_begin_game";
        broadcast_ids[broadcast_ids["set_skin_id"] = 1152] = "set_skin_id";
        broadcast_ids[broadcast_ids["set_reddot_chapter_id"] = 1153] = "set_reddot_chapter_id";
        broadcast_ids[broadcast_ids["load_mat_end"] = 1154] = "load_mat_end";
        broadcast_ids[broadcast_ids["banner_show"] = 1155] = "banner_show";
        broadcast_ids[broadcast_ids["load_model_complete"] = 1156] = "load_model_complete";
        broadcast_ids[broadcast_ids["pre_load_model_complete"] = 1157] = "pre_load_model_complete";
        broadcast_ids[broadcast_ids["video_not_complete"] = 1158] = "video_not_complete";
        broadcast_ids[broadcast_ids["load_data_complete"] = 1159] = "load_data_complete";
        broadcast_ids[broadcast_ids["show_add_enegy"] = 1160] = "show_add_enegy";
        broadcast_ids[broadcast_ids["load_save"] = 1161] = "load_save";
        broadcast_ids[broadcast_ids["reset_drag"] = 1162] = "reset_drag";
        broadcast_ids[broadcast_ids["enter_some_view"] = 1163] = "enter_some_view";
        broadcast_ids[broadcast_ids["close_some_view"] = 1164] = "close_some_view";
        broadcast_ids[broadcast_ids["ui_gm_close"] = 1165] = "ui_gm_close";
        broadcast_ids[broadcast_ids["item_update_failed"] = 1166] = "item_update_failed";
        broadcast_ids[broadcast_ids["add_decorations_model_to_scene"] = 1167] = "add_decorations_model_to_scene";
        broadcast_ids[broadcast_ids["battle_loading_complete"] = 1168] = "battle_loading_complete";
        broadcast_ids[broadcast_ids["recycle_effect"] = 1169] = "recycle_effect";
        broadcast_ids[broadcast_ids["recycle_scene_effect"] = 1170] = "recycle_scene_effect";
        broadcast_ids[broadcast_ids["end_animation"] = 1171] = "end_animation";
        broadcast_ids[broadcast_ids["end_all_animation"] = 1172] = "end_all_animation";
        broadcast_ids[broadcast_ids["stop_music"] = 1173] = "stop_music";
        broadcast_ids[broadcast_ids["do_after_account"] = 1174] = "do_after_account";
        broadcast_ids[broadcast_ids["hide_battle_loading"] = 1175] = "hide_battle_loading";
        broadcast_ids[broadcast_ids["energy_changed"] = 1176] = "energy_changed";
        broadcast_ids[broadcast_ids["add_energy"] = 1177] = "add_energy";
        broadcast_ids[broadcast_ids["use_energy_failed"] = 1178] = "use_energy_failed";
        broadcast_ids[broadcast_ids["loading_complete"] = 1179] = "loading_complete";
        broadcast_ids[broadcast_ids["new_player_init"] = 1180] = "new_player_init";
        broadcast_ids[broadcast_ids["reset_data_next_day"] = 1181] = "reset_data_next_day";
        broadcast_ids[broadcast_ids["login_unlock_new_player"] = 1182] = "login_unlock_new_player";
        broadcast_ids[broadcast_ids["upgrade_player"] = 1183] = "upgrade_player";
        broadcast_ids[broadcast_ids["add_player_to_scene"] = 1184] = "add_player_to_scene";
        broadcast_ids[broadcast_ids["show_account_view"] = 1185] = "show_account_view";
        broadcast_ids[broadcast_ids["effect_show_complete"] = 1186] = "effect_show_complete";
        broadcast_ids[broadcast_ids["update_burn_progress"] = 1187] = "update_burn_progress";
        broadcast_ids[broadcast_ids["turn_speed_out"] = 1188] = "turn_speed_out";
        broadcast_ids[broadcast_ids["add_gold"] = 1189] = "add_gold";
        broadcast_ids[broadcast_ids["update_gold"] = 1190] = "update_gold";
        broadcast_ids[broadcast_ids["update_coal"] = 1191] = "update_coal";
        broadcast_ids[broadcast_ids["update_power"] = 1192] = "update_power";
        broadcast_ids[broadcast_ids["update_offline"] = 1193] = "update_offline";
        broadcast_ids[broadcast_ids["coal_lv_up"] = 1194] = "coal_lv_up";
        broadcast_ids[broadcast_ids["power_lv_up"] = 1195] = "power_lv_up";
        broadcast_ids[broadcast_ids["offline_lv_up"] = 1196] = "offline_lv_up";
        broadcast_ids[broadcast_ids["battle_prepare_complete"] = 1197] = "battle_prepare_complete";
        broadcast_ids[broadcast_ids["update_user_info"] = 1198] = "update_user_info";
        broadcast_ids[broadcast_ids["train_turn_over"] = 1199] = "train_turn_over";
        broadcast_ids[broadcast_ids["update_guide_state"] = 1200] = "update_guide_state";
        broadcast_ids[broadcast_ids["need_supply_gold"] = 1201] = "need_supply_gold";
        broadcast_ids[broadcast_ids["app_box_init_compelete"] = 1202] = "app_box_init_compelete";
        broadcast_ids[broadcast_ids["show_app_box"] = 1203] = "show_app_box";
        broadcast_ids[broadcast_ids["share_inner_video_compelete"] = 1204] = "share_inner_video_compelete";
    })(broadcast_ids || (broadcast_ids = {}));
    window["phone_ids"] = broadcast_ids;
    class ui_sound extends Laya.Sprite {
        constructor() {
            super();
            this.cur_sound_id = sound_id.btn.toString();
        }
        set owner(value) {
            this.this_sprite = value;
            igc.igc_timer.frameOnce(1, this, this.set_sound);
        }
        get owner() {
            return this.this_sprite;
        }
        set_sound() {
            if (this.cur_sound_id) {
                this.this_sprite.on(Laya.Event.CLICK, this, () => {
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.play_sound, {
                        id: "button"
                    });
                });
            }
        }
    }
    class GameConfig {
        constructor() {}
        static init() {
            var reg = Laya.ClassUtils.regClass;
            reg("script/ui/ui_animation/ui_button_scale.ts", ui_button_scale);
            reg("script/ui/ui_more_games.ts", ui_more_games);
            reg("script/ui/ui_animation/ui_sound.ts", ui_sound);
        }
    }
    GameConfig.width = 1080;
    GameConfig.height = 1920;
    GameConfig.scaleMode = "fixedheight";
    GameConfig.screenMode = "none";
    GameConfig.alignV = "middle";
    GameConfig.alignH = "center";
    GameConfig.startScene = "scenes/chapter_info.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;
    GameConfig.init();
    var phone_ids;
    (function(phone_ids) {
        phone_ids[phone_ids["create_workflow"] = 0] = "create_workflow";
        phone_ids[phone_ids["create_workflow_domain"] = 1] = "create_workflow_domain";
        phone_ids[phone_ids["show_ui"] = 1e3] = "show_ui";
        phone_ids[phone_ids["hide_ui"] = 1001] = "hide_ui";
        phone_ids[phone_ids["show_tips"] = 1002] = "show_tips";
        phone_ids[phone_ids["get_ui"] = 1003] = "get_ui";
        phone_ids[phone_ids["get_ui_by_name"] = 1004] = "get_ui_by_name";
        phone_ids[phone_ids["get_world_to_screen_position"] = 1005] = "get_world_to_screen_position";
        phone_ids[phone_ids["get_relative_game_elapsed_time"] = 1006] = "get_relative_game_elapsed_time";
        phone_ids[phone_ids["get_absolutely_game_elapsed_time"] = 1007] = "get_absolutely_game_elapsed_time";
        phone_ids[phone_ids["get_all_attackable_targets"] = 1008] = "get_all_attackable_targets";
        phone_ids[phone_ids["get_all_opponent_targets"] = 1009] = "get_all_opponent_targets";
        phone_ids[phone_ids["get_player_movable_coordinate"] = 1010] = "get_player_movable_coordinate";
        phone_ids[phone_ids["get_obstalces"] = 1011] = "get_obstalces";
        phone_ids[phone_ids["get_character_position"] = 1012] = "get_character_position";
        phone_ids[phone_ids["is_character_in_attack_cd"] = 1013] = "is_character_in_attack_cd";
        phone_ids[phone_ids["is_character_running"] = 1014] = "is_character_running";
        phone_ids[phone_ids["is_character_ready_to_attack"] = 1015] = "is_character_ready_to_attack";
        phone_ids[phone_ids["is_character_ready_to_move"] = 1016] = "is_character_ready_to_move";
        phone_ids[phone_ids["get_active_scene"] = 1017] = "get_active_scene";
        phone_ids[phone_ids["get_active_camera"] = 1018] = "get_active_camera";
        phone_ids[phone_ids["get_active_qidian"] = 1019] = "get_active_qidian";
        phone_ids[phone_ids["get_active_plane"] = 1020] = "get_active_plane";
        phone_ids[phone_ids["get_active_effect"] = 1021] = "get_active_effect";
        phone_ids[phone_ids["can_position_place_army"] = 1022] = "can_position_place_army";
        phone_ids[phone_ids["get_character"] = 1023] = "get_character";
        phone_ids[phone_ids["get_all_players"] = 1024] = "get_all_players";
        phone_ids[phone_ids["get_all_enemies"] = 1025] = "get_all_enemies";
        phone_ids[phone_ids["get_battle_scene_enemies"] = 1026] = "get_battle_scene_enemies";
        phone_ids[phone_ids["get_attackable_main_targets"] = 1027] = "get_attackable_main_targets";
        phone_ids[phone_ids["get_attackable_secondary_targets"] = 1028] = "get_attackable_secondary_targets";
        phone_ids[phone_ids["get_main_target_movable_cell"] = 1029] = "get_main_target_movable_cell";
        phone_ids[phone_ids["get_secondary_target_movable_cell"] = 1030] = "get_secondary_target_movable_cell";
        phone_ids[phone_ids["show_effect"] = 1031] = "show_effect";
        phone_ids[phone_ids["get_effect"] = 1032] = "get_effect";
        phone_ids[phone_ids["show_bullet"] = 1033] = "show_bullet";
        phone_ids[phone_ids["get_bullet"] = 1034] = "get_bullet";
        phone_ids[phone_ids["add_item"] = 1035] = "add_item";
        phone_ids[phone_ids["use_item"] = 1036] = "use_item";
        phone_ids[phone_ids["get_item_amount"] = 1037] = "get_item_amount";
        phone_ids[phone_ids["get_cur_battle_data"] = 1038] = "get_cur_battle_data";
        phone_ids[phone_ids["get_pre_battle_data"] = 1039] = "get_pre_battle_data";
        phone_ids[phone_ids["call_exit_battle"] = 1040] = "call_exit_battle";
        phone_ids[phone_ids["check_can_end_pro"] = 1041] = "check_can_end_pro";
        phone_ids[phone_ids["get_cur_chapter_id"] = 1042] = "get_cur_chapter_id";
        phone_ids[phone_ids["get_cur_battle_gold_reward"] = 1043] = "get_cur_battle_gold_reward";
        phone_ids[phone_ids["get_cur_battle_diamond_reward"] = 1044] = "get_cur_battle_diamond_reward";
        phone_ids[phone_ids["check_battle_end_show"] = 1045] = "check_battle_end_show";
        phone_ids[phone_ids["get_battle_formation"] = 1046] = "get_battle_formation";
        phone_ids[phone_ids["set_cur_select_id"] = 1047] = "set_cur_select_id";
        phone_ids[phone_ids["set_cur_wait_select_id"] = 1048] = "set_cur_wait_select_id";
        phone_ids[phone_ids["get_all_unlock_players"] = 1049] = "get_all_unlock_players";
        phone_ids[phone_ids["get_suggest_soldier"] = 1050] = "get_suggest_soldier";
        phone_ids[phone_ids["get_max_level"] = 1051] = "get_max_level";
        phone_ids[phone_ids["get_max_unlock_level"] = 1052] = "get_max_unlock_level";
        phone_ids[phone_ids["get_compose_soldier_list"] = 1053] = "get_compose_soldier_list";
        phone_ids[phone_ids["get_cur_unlock_soldier"] = 1054] = "get_cur_unlock_soldier";
        phone_ids[phone_ids["get_production_per_second"] = 1055] = "get_production_per_second";
        phone_ids[phone_ids["get_shop_soldier_list"] = 1056] = "get_shop_soldier_list";
        phone_ids[phone_ids["check_purchase_lock_status"] = 1057] = "check_purchase_lock_status";
        phone_ids[phone_ids["soldier_purchase"] = 1058] = "soldier_purchase";
        phone_ids[phone_ids["req_compose"] = 1059] = "req_compose";
        phone_ids[phone_ids["req_production_speed_up"] = 1060] = "req_production_speed_up";
        phone_ids[phone_ids["get_can_use_soldiers"] = 1061] = "get_can_use_soldiers";
        phone_ids[phone_ids["get_cur_sign_day"] = 1062] = "get_cur_sign_day";
        phone_ids[phone_ids["req_sign"] = 1063] = "req_sign";
        phone_ids[phone_ids["get_sign_award"] = 1064] = "get_sign_award";
        phone_ids[phone_ids["ref_sign_win"] = 1065] = "ref_sign_win";
        phone_ids[phone_ids["get_chapter_side"] = 1066] = "get_chapter_side";
        phone_ids[phone_ids["get_chapter_id"] = 1067] = "get_chapter_id";
        phone_ids[phone_ids["get_chapter_config"] = 1068] = "get_chapter_config";
        phone_ids[phone_ids["get_vol"] = 1069] = "get_vol";
        phone_ids[phone_ids["get_shake"] = 1070] = "get_shake";
        phone_ids[phone_ids["get_chapter_distance"] = 1071] = "get_chapter_distance";
        phone_ids[phone_ids["get_chapter_progress"] = 1072] = "get_chapter_progress";
        phone_ids[phone_ids["get_blackhole_obj"] = 1073] = "get_blackhole_obj";
        phone_ids[phone_ids["create_character"] = 1074] = "create_character";
        phone_ids[phone_ids["get_player_obj"] = 1075] = "get_player_obj";
        phone_ids[phone_ids["get_close_collider_area_vertice"] = 1076] = "get_close_collider_area_vertice";
        phone_ids[phone_ids["get_player_pos"] = 1077] = "get_player_pos";
        phone_ids[phone_ids["get_ball_out_side"] = 1078] = "get_ball_out_side";
        phone_ids[phone_ids["get_player_out_side"] = 1079] = "get_player_out_side";
        phone_ids[phone_ids["get_close_collider_side"] = 1080] = "get_close_collider_side";
        phone_ids[phone_ids["get_enemy_ball"] = 1081] = "get_enemy_ball";
        phone_ids[phone_ids["get_obstalce_model"] = 1082] = "get_obstalce_model";
        phone_ids[phone_ids["remove_obstacle_model"] = 1083] = "remove_obstacle_model";
        phone_ids[phone_ids["get_chapter_diamond"] = 1084] = "get_chapter_diamond";
        phone_ids[phone_ids["get_diamond"] = 1085] = "get_diamond";
        phone_ids[phone_ids["get_next_unlock_skin"] = 1086] = "get_next_unlock_skin";
        phone_ids[phone_ids["get_skin_data_list"] = 1087] = "get_skin_data_list";
        phone_ids[phone_ids["get_skin_try_data_list"] = 1088] = "get_skin_try_data_list";
        phone_ids[phone_ids["get_skin_video_data_list"] = 1089] = "get_skin_video_data_list";
        phone_ids[phone_ids["get_player_play"] = 1090] = "get_player_play";
        phone_ids[phone_ids["get_player_begin"] = 1091] = "get_player_begin";
        phone_ids[phone_ids["get_jump_length"] = 1092] = "get_jump_length";
        phone_ids[phone_ids["get_energy"] = 1093] = "get_energy";
        phone_ids[phone_ids["get_max_energy"] = 1094] = "get_max_energy";
        phone_ids[phone_ids["cost_energy"] = 1095] = "cost_energy";
        phone_ids[phone_ids["get_energy_resume_left_time"] = 1096] = "get_energy_resume_left_time";
        phone_ids[phone_ids["get_energy_resume_value"] = 1097] = "get_energy_resume_value";
        phone_ids[phone_ids["get_default_model"] = 1098] = "get_default_model";
        phone_ids[phone_ids["get_skin_id"] = 1099] = "get_skin_id";
        phone_ids[phone_ids["get_need_show_reddot"] = 1100] = "get_need_show_reddot";
        phone_ids[phone_ids["get_plane_mat"] = 1101] = "get_plane_mat";
        phone_ids[phone_ids["get_side_mat"] = 1102] = "get_side_mat";
        phone_ids[phone_ids["check_record_skin_win"] = 1103] = "check_record_skin_win";
        phone_ids[phone_ids["get_level_config"] = 1104] = "get_level_config";
        phone_ids[phone_ids["get_active_game_scene"] = 1105] = "get_active_game_scene";
        phone_ids[phone_ids["get_top_view"] = 1106] = "get_top_view";
        phone_ids[phone_ids["get_top_view_name"] = 1107] = "get_top_view_name";
        phone_ids[phone_ids["check_view_exist"] = 1108] = "check_view_exist";
        phone_ids[phone_ids["get_log_config"] = 1109] = "get_log_config";
        phone_ids[phone_ids["camera_scale_tween"] = 1110] = "camera_scale_tween";
        phone_ids[phone_ids["get_decoration_datas"] = 1111] = "get_decoration_datas";
        phone_ids[phone_ids["get_last_online_time"] = 1112] = "get_last_online_time";
        phone_ids[phone_ids["get_effect_template"] = 1113] = "get_effect_template";
        phone_ids[phone_ids["show_ui_effect"] = 1114] = "show_ui_effect";
        phone_ids[phone_ids["create_animation"] = 1115] = "create_animation";
        phone_ids[phone_ids["use_energy"] = 1116] = "use_energy";
        phone_ids[phone_ids["get_role_data"] = 1117] = "get_role_data";
        phone_ids[phone_ids["send_user_point_event"] = 1118] = "send_user_point_event";
        phone_ids[phone_ids["get_offline_time"] = 1119] = "get_offline_time";
        phone_ids[phone_ids["check_is_new_player"] = 1120] = "check_is_new_player";
        phone_ids[phone_ids["shake_camera"] = 1121] = "shake_camera";
        phone_ids[phone_ids["get_road_data"] = 1122] = "get_road_data";
        phone_ids[phone_ids["get_model"] = 1123] = "get_model";
        phone_ids[phone_ids["recycle_model"] = 1124] = "recycle_model";
        phone_ids[phone_ids["get_scene_level"] = 1125] = "get_scene_level";
        phone_ids[phone_ids["get_fix"] = 1126] = "get_fix";
        phone_ids[phone_ids["get_mat"] = 1127] = "get_mat";
        phone_ids[phone_ids["get_track_mat"] = 1128] = "get_track_mat";
        phone_ids[phone_ids["check_adv_state"] = 1129] = "check_adv_state";
        phone_ids[phone_ids["get_env_type"] = 1130] = "get_env_type";
        phone_ids[phone_ids["get_share_env_id"] = 1131] = "get_share_env_id";
        phone_ids[phone_ids["get_game_state"] = 1132] = "get_game_state";
        phone_ids[phone_ids["get_sky_box"] = 1133] = "get_sky_box";
        phone_ids[phone_ids["get_gift_limit"] = 1134] = "get_gift_limit";
        phone_ids[phone_ids["get_is_play"] = 1135] = "get_is_play";
        phone_ids[phone_ids["check_ad_is_show"] = 1136] = "check_ad_is_show";
        phone_ids[phone_ids["get_track_total_length"] = 1137] = "get_track_total_length";
        phone_ids[phone_ids["get_track_point_by_length"] = 1138] = "get_track_point_by_length";
        phone_ids[phone_ids["get_segment_info_by_length"] = 1139] = "get_segment_info_by_length";
        phone_ids[phone_ids["get_reborn_state"] = 1140] = "get_reborn_state";
        phone_ids[phone_ids["get_is_init_app_box"] = 1141] = "get_is_init_app_box";
        phone_ids[phone_ids["dnsdk_init_compelete"] = 1142] = "dnsdk_init_compelete";
        phone_ids[phone_ids["get_is_hall"] = 1143] = "get_is_hall";
    })(phone_ids || (phone_ids = {}));
    window["phone_ids"] = phone_ids;
    var REG = Laya.ClassUtils.regClass;
    var ui;
    (function(ui) {
        var scenes;
        (function(scenes) {
            class chapter_infoUI extends Laya.Scene {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(chapter_infoUI.uiView);
                }
            }
            chapter_infoUI.uiView = {
                "x": 0,
                "type": "Scene",
                "selectedBox": 2,
                "selecteID": 40,
                "searchKey": "Scene",
                "props": {
                    "width": 1080,
                    "mouseThrough": true,
                    "height": 1920
                },
                "nodeParent": -1,
                "maxID": 52,
                "loadList3D": [],
                "loadList": [
                    "battle/bar_battle_04.png",
                    "battle/bar_battle_03.png",
                    "battle/om_battle_zd.png",
                    "nub/nub_2_0.png",
                    "city/txt_city_gq.png",
                    "city/om_city_xian.png",
                    "battle/bar_battle_02.png",
                    "battle/icon_battle_yl.png",
                    "battle/bar_battle_01.png",
                    "battle/txt_battle_rlbz.png",
                    "battle/txt_battle_rlyj.png",
                    "battle/txt_battle_sdtk.png"
                ],
                "label": "Scene",
                "isOpen": true,
                "isDirectory": true,
                "isAniNode": true,
                "hasChild": true,
                "compId": 2,
                "child": [{
                    "x": 15,
                    "type": "Box",
                    "searchKey": "Box,top",
                    "props": {
                        "centerX": 0,
                        "width": 1079,
                        "top": 50,
                        "name": "top",
                        "height": 281
                    },
                    "nodeParent": 2,
                    "label": "top",
                    "isOpen": true,
                    "isDirectory": true,
                    "isAniNode": true,
                    "hasChild": true,
                    "compId": 25,
                    "child": [{
                            "x": 30,
                            "type": "Image",
                            "searchKey": "Image",
                            "props": {
                                "y": 210,
                                "width": 850,
                                "skin": "battle/bar_battle_04.png",
                                "sizeGrid": "0,62,0,69",
                                "height": 65,
                                "centerX": 0
                            },
                            "nodeParent": 25,
                            "label": "Image",
                            "isOpen": true,
                            "isDirectory": true,
                            "isAniNode": true,
                            "hasChild": true,
                            "compId": 31,
                            "child": [{
                                    "x": 45,
                                    "type": "Image",
                                    "searchKey": "Image,progress_bar",
                                    "props": {
                                        "y": 7,
                                        "x": 10,
                                        "width": 850,
                                        "var": "progress_bar",
                                        "skin": "battle/bar_battle_03.png",
                                        "sizeGrid": "0,47,0,45",
                                        "pivotX": 0,
                                        "height": 40
                                    },
                                    "nodeParent": 31,
                                    "label": "progress_bar",
                                    "isDirectory": false,
                                    "isAniNode": true,
                                    "hasChild": false,
                                    "compId": 32,
                                    "child": []
                                },
                                {
                                    "x": 45,
                                    "type": "Image",
                                    "searchKey": "Image,qi",
                                    "props": {
                                        "y": 3.5,
                                        "x": 833,
                                        "width": 38,
                                        "skin": "battle/om_battle_zd.png",
                                        "scaleY": 1,
                                        "scaleX": 1,
                                        "pivotY": 32,
                                        "pivotX": 19,
                                        "name": "qi",
                                        "height": 64
                                    },
                                    "nodeParent": 31,
                                    "label": "qi",
                                    "isDirectory": false,
                                    "isAniNode": true,
                                    "hasChild": false,
                                    "compId": 6,
                                    "child": []
                                }
                            ]
                        },
                        {
                            "x": 30,
                            "type": "Box",
                            "searchKey": "Box",
                            "props": {
                                "y": 68,
                                "width": 1080,
                                "height": 100,
                                "centerX": 0
                            },
                            "nodeParent": 25,
                            "label": "Box",
                            "isOpen": true,
                            "isDirectory": true,
                            "isAniNode": true,
                            "hasChild": true,
                            "compId": 40,
                            "child": [{
                                    "x": 45,
                                    "type": "FontClip",
                                    "searchKey": "FontClip,text_chaper,text_chaper",
                                    "props": {
                                        "x": 625,
                                        "width": 72,
                                        "var": "text_chaper",
                                        "value": "12",
                                        "skin": "nub/nub_2_0.png",
                                        "sheet": "0123456789",
                                        "name": "text_chaper",
                                        "height": 63,
                                        "centerY": -20,
                                        "align": "center"
                                    },
                                    "nodeParent": 40,
                                    "label": "text_chaper",
                                    "isDirectory": false,
                                    "isAniNode": true,
                                    "hasChild": false,
                                    "compId": 7,
                                    "child": []
                                },
                                {
                                    "x": 45,
                                    "type": "Image",
                                    "searchKey": "Image",
                                    "props": {
                                        "x": 398,
                                        "skin": "city/txt_city_gq.png",
                                        "centerY": 0
                                    },
                                    "nodeParent": 40,
                                    "label": "Image",
                                    "isDirectory": false,
                                    "isAniNode": true,
                                    "hasChild": false,
                                    "compId": 39,
                                    "child": []
                                },
                                {
                                    "x": 45,
                                    "type": "Image",
                                    "searchKey": "Image",
                                    "props": {
                                        "x": 234,
                                        "skin": "city/om_city_xian.png",
                                        "centerY": -3
                                    },
                                    "nodeParent": 40,
                                    "label": "Image",
                                    "isDirectory": false,
                                    "isAniNode": true,
                                    "hasChild": false,
                                    "compId": 41,
                                    "child": []
                                },
                                {
                                    "x": 45,
                                    "type": "Image",
                                    "searchKey": "Image",
                                    "props": {
                                        "x": 887,
                                        "skin": "city/om_city_xian.png",
                                        "scaleX": -1,
                                        "centerY": -3
                                    },
                                    "nodeParent": 40,
                                    "label": "Image",
                                    "isDirectory": false,
                                    "isAniNode": true,
                                    "hasChild": false,
                                    "compId": 42,
                                    "child": []
                                }
                            ]
                        },
                        {
                            "x": 30,
                            "type": "Image",
                            "searchKey": "Image,coal_container",
                            "props": {
                                "y": 863,
                                "var": "coal_container",
                                "skin": "battle/bar_battle_02.png",
                                "sizeGrid": "0,45,0,45",
                                "centerX": -38
                            },
                            "nodeParent": 25,
                            "label": "coal_container",
                            "isOpen": null,
                            "isDirectory": true,
                            "isAniNode": true,
                            "hasChild": true,
                            "compId": 43,
                            "child": [{
                                    "type": "Image",
                                    "searchKey": "Image,coal_icon",
                                    "props": {
                                        "y": 39,
                                        "x": 45,
                                        "var": "coal_icon",
                                        "skin": "battle/icon_battle_yl.png",
                                        "centerY": 0,
                                        "centerX": 0
                                    },
                                    "nodeParent": 43,
                                    "label": "coal_icon",
                                    "isDirectory": false,
                                    "isAniNode": true,
                                    "hasChild": false,
                                    "compId": 45,
                                    "child": []
                                },
                                {
                                    "type": "Image",
                                    "searchKey": "Image,coal",
                                    "props": {
                                        "var": "coal",
                                        "skin": "battle/bar_battle_01.png",
                                        "sizeGrid": "0,47,0,46"
                                    },
                                    "nodeParent": 43,
                                    "label": "coal",
                                    "isDirectory": true,
                                    "isAniNode": true,
                                    "hasChild": true,
                                    "compId": 44,
                                    "child": [{
                                        "type": "Sprite",
                                        "searchKey": "Sprite,coal_progress",
                                        "props": {
                                            "y": 0,
                                            "x": 0,
                                            "width": 150,
                                            "var": "coal_progress",
                                            "rotation": 0,
                                            "renderType": "mask",
                                            "height": 150
                                        },
                                        "nodeParent": 44,
                                        "label": "coal_progress",
                                        "isDirectory": true,
                                        "isAniNode": true,
                                        "hasChild": true,
                                        "compId": 47,
                                        "child": [{
                                            "type": "Pie",
                                            "searchKey": "Pie,pie",
                                            "props": {
                                                "y": 75,
                                                "x": 75,
                                                "startAngle": -80,
                                                "rotation": 0,
                                                "radius": 75,
                                                "name": "pie",
                                                "lineWidth": 1,
                                                "fillColor": "#ff0000",
                                                "endAngle": 270
                                            },
                                            "nodeParent": 47,
                                            "label": "pie",
                                            "isDirectory": false,
                                            "isAniNode": true,
                                            "hasChild": false,
                                            "compId": 48,
                                            "child": []
                                        }]
                                    }]
                                },
                                {
                                    "type": "Image",
                                    "searchKey": "Image,tip_not_full",
                                    "props": {
                                        "y": -60,
                                        "var": "tip_not_full",
                                        "skin": "battle/txt_battle_rlbz.png",
                                        "centerX": 0
                                    },
                                    "nodeParent": 43,
                                    "label": "tip_not_full",
                                    "isDirectory": false,
                                    "isAniNode": true,
                                    "hasChild": false,
                                    "compId": 49,
                                    "child": []
                                }
                            ]
                        },
                        {
                            "x": 30,
                            "type": "Image",
                            "searchKey": "Image,tip_coal_empty",
                            "props": {
                                "y": 356,
                                "var": "tip_coal_empty",
                                "skin": "battle/txt_battle_rlyj.png",
                                "centerX": 0
                            },
                            "nodeParent": 25,
                            "label": "tip_coal_empty",
                            "isDirectory": false,
                            "isAniNode": true,
                            "hasChild": false,
                            "compId": 50,
                            "child": []
                        },
                        {
                            "x": 30,
                            "type": "Image",
                            "searchKey": "Image,tip_speed_out",
                            "props": {
                                "y": 353,
                                "var": "tip_speed_out",
                                "skin": "battle/txt_battle_sdtk.png",
                                "centerX": 0
                            },
                            "nodeParent": 25,
                            "label": "tip_speed_out",
                            "isDirectory": false,
                            "isAniNode": true,
                            "hasChild": false,
                            "compId": 51,
                            "child": []
                        }
                    ]
                }],
                "animations": [{
                        "nodes": [{
                            "target": 12,
                            "keyframes": {
                                "y": [{
                                        "value": 0,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "y",
                                        "index": 0
                                    },
                                    {
                                        "value": -100,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "y",
                                        "index": 10
                                    }
                                ],
                                "scaleY": [{
                                        "value": 0,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleY",
                                        "index": 0
                                    },
                                    {
                                        "value": 1.5,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleY",
                                        "index": 10
                                    },
                                    {
                                        "value": 1,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleY",
                                        "index": 15
                                    },
                                    {
                                        "value": 1,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleY",
                                        "index": 40
                                    },
                                    {
                                        "value": 0,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleY",
                                        "index": 45
                                    }
                                ],
                                "scaleX": [{
                                        "value": 0,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleX",
                                        "index": 0
                                    },
                                    {
                                        "value": 1.5,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleX",
                                        "index": 10
                                    },
                                    {
                                        "value": 1,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleX",
                                        "index": 15
                                    },
                                    {
                                        "value": 1,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleX",
                                        "index": 40
                                    },
                                    {
                                        "value": 0,
                                        "tweenMethod": "linearNone",
                                        "tween": true,
                                        "target": 12,
                                        "key": "scaleX",
                                        "index": 45
                                    }
                                ]
                            }
                        }],
                        "name": "show_add",
                        "id": 1,
                        "frameRate": 24,
                        "action": 0
                    },
                    {
                        "nodes": [],
                        "name": "ani2",
                        "id": 2,
                        "frameRate": 24,
                        "action": 0
                    }
                ]
            };
            scenes.chapter_infoUI = chapter_infoUI;
            REG("ui.scenes.chapter_infoUI", chapter_infoUI);
            class ContainerViewUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ContainerViewUI.uiView);
                }
            }
            ContainerViewUI.uiView = {
                type: "View",
                props: {
                    top: 0,
                    right: 0,
                    left: 0,
                    bottom: 0
                },
                compId: 2,
                loadList: [],
                loadList3D: []
            };
            scenes.ContainerViewUI = ContainerViewUI;
            REG("ui.scenes.ContainerViewUI", ContainerViewUI);
            class dnsdkUI extends Laya.Scene {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(dnsdkUI.uiView);
                }
            }
            dnsdkUI.uiView = {
                type: "Scene",
                props: {
                    width: 1080,
                    height: 1920
                },
                compId: 2,
                loadList: [],
                loadList3D: []
            };
            scenes.dnsdkUI = dnsdkUI;
            REG("ui.scenes.dnsdkUI", dnsdkUI);
            class GameShareDialogUI extends Laya.Dialog {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(GameShareDialogUI.uiView);
                }
            }
            GameShareDialogUI.uiView = {
                type: "Dialog",
                props: {
                    width: 1080,
                    height: 1920
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        width: 1500,
                        skin: "multual_push/common_zhezhao.png",
                        sizeGrid: "41,54,57,53",
                        scaleY: 1,
                        scaleX: 1,
                        name: "zhezhao",
                        height: 3e3,
                        centerY: 0,
                        centerX: 0,
                        alpha: 1
                    },
                    compId: 31
                }, {
                    type: "Button",
                    props: {
                        x: 28,
                        width: 40,
                        var: "btn_close",
                        top: 60,
                        stateNum: 1,
                        skin: "ui/btn_fh.png",
                        scaleY: 3,
                        scaleX: 3,
                        labelSize: 32,
                        labelColors: "#fff,#fff,#fff,#fff",
                        height: 36
                    },
                    compId: 24
                }, {
                    type: "Image",
                    props: {
                        x: 22,
                        var: "img_play",
                        top: 220,
                        skin: "dev/hyzw.png",
                        scaleY: 3,
                        scaleX: 3
                    },
                    compId: 21
                }, {
                    type: "Box",
                    props: {
                        x: 0,
                        width: 726,
                        top: 350,
                        scaleY: 2,
                        scaleX: 2,
                        height: 88
                    },
                    compId: 3,
                    child: [{
                        type: "Image",
                        props: {
                            y: -6,
                            x: -131,
                            width: 1067,
                            skin: "dev/black.png",
                            sizeGrid: "9,10,10,9",
                            height: 102
                        },
                        compId: 28
                    }, {
                        type: "List",
                        props: {
                            y: 5,
                            x: 0,
                            width: 640,
                            var: "list_dev_pick",
                            spaceX: 16,
                            repeatY: 1,
                            repeatX: 10,
                            height: 83
                        },
                        compId: 18,
                        child: [{
                            type: "Box",
                            props: {
                                renderType: "render"
                            },
                            compId: 19,
                            child: [{
                                type: "Image",
                                props: {
                                    width: 80,
                                    skin: "dev/ui_jgg.png",
                                    name: "icon",
                                    height: 80
                                },
                                compId: 20
                            }]
                        }]
                    }]
                }, {
                    type: "Image",
                    props: {
                        x: 24,
                        var: "img_recm",
                        top: 580,
                        skin: "dev/rmtj.png",
                        scaleY: 3,
                        scaleX: 3
                    },
                    compId: 22
                }, {
                    type: "Box",
                    props: {
                        width: 429,
                        var: "box_dev_box",
                        top: 700,
                        scaleY: 2.2,
                        scaleX: 2.2,
                        height: 642,
                        centerX: 0
                    },
                    compId: 2,
                    child: [{
                        type: "List",
                        props: {
                            y: 0,
                            x: 6,
                            width: 418,
                            var: "list_dev_box",
                            spaceY: 4,
                            spaceX: 2,
                            repeatY: 10,
                            repeatX: 2,
                            name: "list",
                            height: 632
                        },
                        compId: 8,
                        child: [{
                            type: "Box",
                            props: {
                                y: 0,
                                x: 0,
                                width: 208,
                                renderType: "render",
                                height: 140
                            },
                            compId: 9,
                            child: [{
                                type: "Image",
                                props: {
                                    y: 0,
                                    x: 0,
                                    width: 207,
                                    skin: "dev/ui_tj_01.png",
                                    name: "icon",
                                    height: 112
                                },
                                compId: 11
                            }, {
                                type: "Image",
                                props: {
                                    y: 113,
                                    x: 0,
                                    width: 207,
                                    skin: "dev/ui_tj_02.png",
                                    height: 26
                                },
                                compId: 25
                            }, {
                                type: "Label",
                                props: {
                                    y: 114,
                                    x: 5,
                                    width: 141,
                                    text: "xxxxx",
                                    strokeColor: "#000000",
                                    stroke: 1,
                                    name: "label",
                                    height: 22,
                                    fontSize: 22,
                                    color: "#ffffff"
                                },
                                compId: 26
                            }]
                        }]
                    }]
                }],
                loadList: ["multual_push/common_zhezhao.png", "ui/btn_fh.png", "dev/hyzw.png", "dev/black.png", "dev/ui_jgg.png", "dev/rmtj.png", "dev/ui_tj_01.png", "dev/ui_tj_02.png"],
                loadList3D: []
            };
            scenes.GameShareDialogUI = GameShareDialogUI;
            REG("ui.scenes.GameShareDialogUI", GameShareDialogUI);
            class guess_likeUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(guess_likeUI.uiView);
                }
            }
            guess_likeUI.uiView = {
                type: "View",
                props: {
                    y: 0,
                    width: 1080,
                    top: 0,
                    right: 0,
                    mouseThrough: true,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Box",
                    props: {
                        var: "gifRoot",
                        styleSkin: "multual_push/box_room_gengduoyouxi.png",
                        right: 10,
                        name: "gifRoot",
                        mouseEnabled: true,
                        centerY: 188
                    },
                    compId: 51,
                    child: [{
                        type: "Image",
                        props: {
                            y: 0,
                            x: 0,
                            skin: "multual_push/box_gif.png",
                            name: ""
                        },
                        compId: 52
                    }, {
                        type: "Image",
                        props: {
                            y: 17,
                            x: 17,
                            width: 256,
                            var: "update_icon",
                            name: "",
                            height: 256
                        },
                        compId: 53
                    }, {
                        type: "Button",
                        props: {
                            y: 0,
                            x: 0,
                            width: 297,
                            var: "update_icon_btn",
                            name: "",
                            height: 376
                        },
                        compId: 54
                    }]
                }, {
                    type: "Box",
                    props: {
                        width: 400,
                        var: "vGuessLikeRoot",
                        top: 214,
                        scaleY: 1,
                        scaleX: 1,
                        name: "vGuessLikeRoot",
                        mouseThrough: false,
                        mouseEnabled: true,
                        left: -400,
                        height: 1164
                    },
                    compId: 49,
                    child: [{
                        type: "Image",
                        props: {
                            y: 47,
                            x: 528,
                            width: 109,
                            var: "hide_btn",
                            skin: "multual_push/bt_room_zhankai.png",
                            scaleY: 1.2,
                            scaleX: -1.2,
                            height: 110
                        },
                        compId: 11
                    }, {
                        type: "Image",
                        props: {
                            y: 47,
                            x: 528,
                            width: 130,
                            var: "show_btn",
                            skin: "multual_push/bt_room_hebi.png",
                            sizeGrid: "0,5,0,98",
                            scaleY: 1.2,
                            scaleX: -1.2,
                            height: 110
                        },
                        compId: 4,
                        child: [{
                            type: "Image",
                            props: {
                                y: -5,
                                x: 0,
                                skin: "multual_push/om_liuzhuan_hongdian.png"
                            },
                            compId: 10
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: 545,
                            x: 198,
                            width: 400,
                            scaleY: 1,
                            scaleX: 1,
                            mouseThrough: true,
                            height: 1080,
                            anchorY: .5,
                            anchorX: .5
                        },
                        compId: 9,
                        child: [{
                            type: "Image",
                            props: {
                                y: 0,
                                x: 400,
                                width: 400,
                                var: "bg",
                                skin: "multual_push/box_room_di1.png",
                                sizeGrid: "159,93,109,149",
                                scaleX: -1,
                                mouseThrough: false,
                                height: 1700
                            },
                            compId: 55
                        }, {
                            type: "Image",
                            props: {
                                y: 16,
                                x: 123,
                                skin: "multual_push/tex_01.png"
                            },
                            compId: 12
                        }, {
                            type: "Panel",
                            props: {
                                y: 90,
                                x: 95,
                                width: 280,
                                var: "vGuessLikePanel",
                                name: "vGuessLikePanel",
                                height: 1600
                            },
                            compId: 103,
                            child: [{
                                type: "VBox",
                                props: {
                                    y: 0,
                                    x: 0,
                                    space: 0,
                                    align: "center"
                                },
                                compId: 104,
                                child: [{
                                    type: "Box",
                                    props: {
                                        y: 0,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game1",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 18,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 13,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                var: "icon_mask",
                                                renderType: "mask"
                                            },
                                            compId: 16,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 17
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 14
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 28
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 320,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game2",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 105,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 106,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                renderType: "mask"
                                            },
                                            compId: 107,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 108
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 109
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 110
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 640,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game3",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 117,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 118,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                renderType: "mask"
                                            },
                                            compId: 119,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 120
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 121
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 122
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 960,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game4",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 123,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 124,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                renderType: "mask"
                                            },
                                            compId: 125,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 126
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 127
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 128
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 1280,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game5",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 129,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 130,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                renderType: "mask"
                                            },
                                            compId: 131,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 132
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 133
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 134
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 1662,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game6",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 135,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 136,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                renderType: "mask"
                                            },
                                            compId: 137,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 138
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 139
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 140
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 1768,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game7",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 141,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 142,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                renderType: "mask"
                                            },
                                            compId: 143,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 144
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 145
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 146
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 1841,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game8",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 147,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 148,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                renderType: "mask"
                                            },
                                            compId: 149,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 150
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 151
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 152
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 1930,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game9",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 153,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 154,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                renderType: "mask"
                                            },
                                            compId: 155,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 156
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 157
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 158
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 2024,
                                        x: 12,
                                        width: 250,
                                        scaleY: 1,
                                        scaleX: 1,
                                        name: "game10",
                                        mouseEnabled: true,
                                        height: 320,
                                        anchorY: 0,
                                        anchorX: 0
                                    },
                                    compId: 159,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            y: 12,
                                            x: -3,
                                            width: 250,
                                            skin: "multual_push/common_zhezhao.png",
                                            name: "app_icon",
                                            height: 250
                                        },
                                        compId: 160,
                                        child: [{
                                            type: "Sprite",
                                            props: {
                                                y: 0,
                                                x: 0,
                                                renderType: "mask"
                                            },
                                            compId: 161,
                                            child: [{
                                                type: "Texture",
                                                props: {
                                                    y: 0,
                                                    x: 0,
                                                    width: 250,
                                                    skin: "multual_push/common_zhezhao.png",
                                                    height: 250
                                                },
                                                compId: 162
                                            }]
                                        }]
                                    }, {
                                        type: "Image",
                                        props: {
                                            y: 8,
                                            x: 184,
                                            skin: "multual_push/om_room_remen.png",
                                            name: "app_tag"
                                        },
                                        compId: 163
                                    }, {
                                        type: "Label",
                                        props: {
                                            y: 284,
                                            x: 125,
                                            text: "小镇飞车",
                                            name: "app_name",
                                            fontSize: 40,
                                            color: "#ffffff",
                                            anchorY: .5,
                                            anchorX: .5
                                        },
                                        compId: 164
                                    }]
                                }]
                            }]
                        }]
                    }]
                }, {
                    type: "Box",
                    props: {
                        var: "hGuessLikeRoot",
                        name: "hGuessLikeRoot",
                        centerY: -77,
                        centerX: 0
                    },
                    compId: 57,
                    child: [{
                        type: "Image",
                        props: {
                            width: 998,
                            skin: "multual_push/box_hutui_01.png",
                            sizeGrid: "22,70,26,107",
                            name: "bg",
                            height: 308
                        },
                        compId: 56,
                        child: [{
                            type: "Sprite",
                            props: {
                                y: 61.5,
                                x: 27,
                                texture: "multual_push/txt_hutui_cnxh.png",
                                name: "title"
                            },
                            compId: 58
                        }, {
                            type: "Panel",
                            props: {
                                y: 12,
                                x: 105,
                                width: 836,
                                var: "hGuessLikePanel",
                                name: "hGuessLikePanel",
                                height: 291
                            },
                            compId: 59,
                            child: [{
                                type: "HBox",
                                props: {
                                    y: 0,
                                    x: 0,
                                    space: 20,
                                    align: "middle"
                                },
                                compId: 78,
                                child: [{
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 0,
                                        name: "game1"
                                    },
                                    compId: 65,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 66,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 67
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高1",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 68
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 226,
                                        name: "game2"
                                    },
                                    compId: 69,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 70,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 71
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高2",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 72
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 441,
                                        name: "game3"
                                    },
                                    compId: 73,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 74,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 75
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高3",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 76
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 654,
                                        name: "game4"
                                    },
                                    compId: 79,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 80,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 81
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高4",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 82
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 869,
                                        name: "game5"
                                    },
                                    compId: 64,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 61,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 62
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 63
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 971,
                                        name: "game6"
                                    },
                                    compId: 83,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 84,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 85
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 86
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 5,
                                        x: 1080,
                                        name: "game7"
                                    },
                                    compId: 87,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 88,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 89
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 90
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 5,
                                        x: 1226,
                                        name: "game8"
                                    },
                                    compId: 91,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 92,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 93
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 94
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 17,
                                        x: 1380,
                                        name: "game9"
                                    },
                                    compId: 95,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 96,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 97
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 98
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 17,
                                        x: 1532,
                                        name: "game10"
                                    },
                                    compId: 99,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 100,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 101
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 102
                                        }]
                                    }]
                                }]
                            }]
                        }]
                    }]
                }, {
                    type: "Box",
                    props: {
                        var: "mostPopularRoot",
                        name: "mostPopularRoot",
                        centerY: -150,
                        centerX: 0
                    },
                    compId: 165,
                    child: [{
                        type: "Sprite",
                        props: {
                            y: -60,
                            x: 213,
                            texture: "multual_push/txt_hutui_tj.png",
                            name: "title"
                        },
                        compId: 210
                    }, {
                        type: "Image",
                        props: {
                            y: 0,
                            x: 0,
                            width: 938,
                            skin: "multual_push/box_hutui_02.png",
                            sizeGrid: "53,108,65,105",
                            name: "bg",
                            height: 596
                        },
                        compId: 166
                    }, {
                        type: "Box",
                        props: {
                            y: 17,
                            x: 10,
                            name: "box"
                        },
                        compId: 211,
                        child: [{
                            type: "Box",
                            props: {
                                name: "game1"
                            },
                            compId: 170,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "multual_push/box_hutui_03.png",
                                    name: "bg"
                                },
                                compId: 171,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 24,
                                        x: 20.5,
                                        width: 163,
                                        name: "gameIcon",
                                        height: 163
                                    },
                                    compId: 172,
                                    child: [{
                                        type: "Sprite",
                                        props: {
                                            y: 0,
                                            x: 0,
                                            renderType: "mask"
                                        },
                                        compId: 218,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                width: 163,
                                                skin: "multual_push/common_zhezhao.png",
                                                height: 163
                                            },
                                            compId: 219
                                        }]
                                    }]
                                }, {
                                    type: "Label",
                                    props: {
                                        y: 223,
                                        x: 102,
                                        text: "明星篮球高1",
                                        name: "name",
                                        fontSize: 32,
                                        color: "#ffffff",
                                        anchorY: .5,
                                        anchorX: .5,
                                        align: "center"
                                    },
                                    compId: 173
                                }]
                            }]
                        }, {
                            type: "Box",
                            props: {
                                x: 235,
                                name: "game2"
                            },
                            compId: 174,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "multual_push/box_hutui_04.png",
                                    name: "bg"
                                },
                                compId: 175,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 24,
                                        x: 20.5,
                                        width: 163,
                                        name: "gameIcon",
                                        height: 163
                                    },
                                    compId: 176,
                                    child: [{
                                        type: "Sprite",
                                        props: {
                                            renderType: "mask"
                                        },
                                        compId: 216,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                width: 163,
                                                skin: "multual_push/common_zhezhao.png",
                                                height: 163
                                            },
                                            compId: 217
                                        }]
                                    }]
                                }, {
                                    type: "Label",
                                    props: {
                                        y: 223,
                                        x: 102,
                                        text: "明星篮球高2",
                                        name: "name",
                                        fontSize: 32,
                                        color: "#ffffff",
                                        anchorY: .5,
                                        anchorX: .5,
                                        align: "center"
                                    },
                                    compId: 177
                                }]
                            }]
                        }, {
                            type: "Box",
                            props: {
                                x: 471,
                                name: "game3"
                            },
                            compId: 178,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "multual_push/box_hutui_03.png",
                                    name: "bg"
                                },
                                compId: 179,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 24,
                                        x: 20.5,
                                        width: 163,
                                        name: "gameIcon",
                                        height: 163
                                    },
                                    compId: 180,
                                    child: [{
                                        type: "Sprite",
                                        props: {
                                            y: 0,
                                            x: 0,
                                            renderType: "mask"
                                        },
                                        compId: 220,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                width: 163,
                                                skin: "multual_push/common_zhezhao.png",
                                                height: 163
                                            },
                                            compId: 221
                                        }]
                                    }]
                                }, {
                                    type: "Label",
                                    props: {
                                        y: 223,
                                        x: 102,
                                        text: "明星篮球高3",
                                        name: "name",
                                        fontSize: 32,
                                        color: "#ffffff",
                                        anchorY: .5,
                                        anchorX: .5,
                                        align: "center"
                                    },
                                    compId: 181
                                }]
                            }]
                        }, {
                            type: "Box",
                            props: {
                                x: 706,
                                name: "game4"
                            },
                            compId: 182,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "multual_push/box_hutui_04.png",
                                    name: "bg"
                                },
                                compId: 183,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 24,
                                        x: 20.5,
                                        width: 163,
                                        name: "gameIcon",
                                        height: 163
                                    },
                                    compId: 184,
                                    child: [{
                                        type: "Sprite",
                                        props: {
                                            y: 0,
                                            x: 0,
                                            renderType: "mask"
                                        },
                                        compId: 222,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                width: 163,
                                                skin: "multual_push/common_zhezhao.png",
                                                height: 163
                                            },
                                            compId: 223
                                        }]
                                    }]
                                }, {
                                    type: "Label",
                                    props: {
                                        y: 223,
                                        x: 102,
                                        text: "明星篮球高4",
                                        name: "name",
                                        fontSize: 32,
                                        color: "#ffffff",
                                        anchorY: .5,
                                        anchorX: .5,
                                        align: "center"
                                    },
                                    compId: 185
                                }]
                            }]
                        }, {
                            type: "Box",
                            props: {
                                y: 290,
                                x: 5,
                                name: "game5"
                            },
                            compId: 186,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "multual_push/box_hutui_04.png",
                                    name: "bg"
                                },
                                compId: 187,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 24,
                                        x: 20.5,
                                        width: 163,
                                        name: "gameIcon",
                                        height: 163
                                    },
                                    compId: 188,
                                    child: [{
                                        type: "Sprite",
                                        props: {
                                            y: 0,
                                            x: 0,
                                            renderType: "mask"
                                        },
                                        compId: 224,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                width: 163,
                                                skin: "multual_push/common_zhezhao.png",
                                                height: 163
                                            },
                                            compId: 225
                                        }]
                                    }]
                                }, {
                                    type: "Label",
                                    props: {
                                        y: 223,
                                        x: 102,
                                        text: "明星篮球高5",
                                        name: "name",
                                        fontSize: 32,
                                        color: "#ffffff",
                                        anchorY: .5,
                                        anchorX: .5,
                                        align: "center"
                                    },
                                    compId: 189
                                }]
                            }]
                        }, {
                            type: "Box",
                            props: {
                                y: 290,
                                x: 239,
                                name: "game6"
                            },
                            compId: 190,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "multual_push/box_hutui_03.png",
                                    name: "bg"
                                },
                                compId: 191,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 24,
                                        x: 20.5,
                                        width: 163,
                                        name: "gameIcon",
                                        height: 163
                                    },
                                    compId: 192,
                                    child: [{
                                        type: "Sprite",
                                        props: {
                                            y: 0,
                                            x: 0,
                                            renderType: "mask"
                                        },
                                        compId: 226,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                width: 163,
                                                skin: "multual_push/common_zhezhao.png",
                                                height: 163
                                            },
                                            compId: 227
                                        }]
                                    }]
                                }, {
                                    type: "Label",
                                    props: {
                                        y: 223,
                                        x: 102,
                                        text: "明星篮球高5",
                                        name: "name",
                                        fontSize: 32,
                                        color: "#ffffff",
                                        anchorY: .5,
                                        anchorX: .5,
                                        align: "center"
                                    },
                                    compId: 193
                                }]
                            }]
                        }, {
                            type: "Box",
                            props: {
                                y: 290,
                                x: 474,
                                name: "game7"
                            },
                            compId: 194,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "multual_push/box_hutui_04.png",
                                    name: "bg"
                                },
                                compId: 195,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 24,
                                        x: 20.5,
                                        width: 163,
                                        name: "gameIcon",
                                        height: 163
                                    },
                                    compId: 196,
                                    child: [{
                                        type: "Sprite",
                                        props: {
                                            y: 0,
                                            x: 0,
                                            renderType: "mask"
                                        },
                                        compId: 228,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                width: 163,
                                                skin: "multual_push/common_zhezhao.png",
                                                height: 163
                                            },
                                            compId: 229
                                        }]
                                    }]
                                }, {
                                    type: "Label",
                                    props: {
                                        y: 223,
                                        x: 102,
                                        text: "明星篮球高5",
                                        name: "name",
                                        fontSize: 32,
                                        color: "#ffffff",
                                        anchorY: .5,
                                        anchorX: .5,
                                        align: "center"
                                    },
                                    compId: 197
                                }]
                            }]
                        }, {
                            type: "Box",
                            props: {
                                y: 290,
                                x: 708,
                                name: "game8"
                            },
                            compId: 198,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "multual_push/box_hutui_03.png",
                                    name: "bg"
                                },
                                compId: 199,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 24,
                                        x: 20.5,
                                        width: 163,
                                        name: "gameIcon",
                                        height: 163
                                    },
                                    compId: 200,
                                    child: [{
                                        type: "Sprite",
                                        props: {
                                            y: 0,
                                            x: 0,
                                            renderType: "mask"
                                        },
                                        compId: 230,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                width: 163,
                                                skin: "multual_push/common_zhezhao.png",
                                                height: 163
                                            },
                                            compId: 231
                                        }]
                                    }]
                                }, {
                                    type: "Label",
                                    props: {
                                        y: 223,
                                        x: 102,
                                        text: "明星篮球高5",
                                        name: "name",
                                        fontSize: 32,
                                        color: "#ffffff",
                                        anchorY: .5,
                                        anchorX: .5,
                                        align: "center"
                                    },
                                    compId: 201
                                }]
                            }]
                        }]
                    }]
                }],
                animations: [{
                    nodes: [{
                        target: 4,
                        keyframes: {
                            x: [{
                                value: 528,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 4,
                                key: "x",
                                index: 0
                            }, {
                                value: 538,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 4,
                                key: "x",
                                index: 10
                            }, {
                                value: 528,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 4,
                                key: "x",
                                index: 20
                            }]
                        }
                    }],
                    name: "ani4",
                    id: 4,
                    frameRate: 24,
                    action: 2
                }],
                loadList: ["multual_push/box_room_gengduoyouxi.png", "multual_push/box_gif.png", "multual_push/bt_room_zhankai.png", "multual_push/bt_room_hebi.png", "multual_push/om_liuzhuan_hongdian.png", "multual_push/box_room_di1.png", "multual_push/tex_01.png", "multual_push/common_zhezhao.png", "multual_push/om_room_remen.png", "multual_push/box_hutui_01.png", "multual_push/txt_hutui_cnxh.png", "multual_push/box_hutui_03.png", "multual_push/box_hutui_04.png", "multual_push/txt_hutui_tj.png", "multual_push/box_hutui_02.png"],
                loadList3D: []
            };
            scenes.guess_likeUI = guess_likeUI;
            REG("ui.scenes.guess_likeUI", guess_likeUI);
            class HallSplashListUI extends Laya.Dialog {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(HallSplashListUI.uiView);
                }
            }
            HallSplashListUI.uiView = {
                type: "Dialog",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        y: 0,
                        x: 0,
                        top: 0,
                        skin: "common/om_common_zz.png",
                        scaleY: 1,
                        scaleX: 1,
                        right: 0,
                        name: "zhezhao",
                        left: 0,
                        bottom: 0,
                        sizeGrid: "21,20,12,18"
                    },
                    compId: 26
                }, {
                    type: "Image",
                    props: {
                        width: 314,
                        skin: "ui/ui_2.png",
                        scaleY: 2.5,
                        scaleX: 2.5,
                        height: 415,
                        centerY: 0,
                        centerX: 0,
                        anchorY: .5,
                        anchorX: .5
                    },
                    compId: 16,
                    child: [{
                        type: "Image",
                        props: {
                            y: -1,
                            x: -1,
                            width: 315,
                            skin: "ui/ui_lan.png",
                            height: 34
                        },
                        compId: 18,
                        child: [{
                            type: "Label",
                            props: {
                                y: 23,
                                x: 170,
                                width: 225,
                                text: "好友都在玩的爆款游戏",
                                height: 33,
                                fontSize: 20,
                                color: "#f4e210",
                                bold: true,
                                anchorY: .5,
                                anchorX: .5,
                                align: "center"
                            },
                            compId: 19
                        }, {
                            type: "Button",
                            props: {
                                y: 3,
                                x: 9,
                                var: "btn_close",
                                stateNum: 1,
                                skin: "ui/btn_fh.png",
                                scaleY: .8,
                                scaleX: .8
                            },
                            compId: 25
                        }, {
                            type: "List",
                            props: {
                                y: 35,
                                x: 10,
                                width: 295,
                                var: "list_dev_box",
                                spaceY: 10,
                                spaceX: 10,
                                repeatY: 3,
                                repeatX: 3,
                                name: "list",
                                height: 375
                            },
                            compId: 8,
                            child: [{
                                type: "Box",
                                props: {
                                    y: 0,
                                    x: 0,
                                    width: 92,
                                    renderType: "render",
                                    height: 116
                                },
                                compId: 9,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 10,
                                        x: 0,
                                        width: 90,
                                        skin: "dev/ui_jgg.png",
                                        sizeGrid: "13,11,14,12",
                                        height: 94
                                    },
                                    compId: 10
                                }, {
                                    type: "Image",
                                    props: {
                                        y: 8,
                                        x: 0,
                                        width: 90,
                                        skin: "ui/ui_xiaokuang.png",
                                        name: "icon",
                                        height: 95
                                    },
                                    compId: 11
                                }, {
                                    type: "Image",
                                    props: {
                                        y: 103,
                                        x: 0,
                                        width: 150,
                                        skin: "ui/ui_lan.png",
                                        scaleY: .6,
                                        scaleX: .6,
                                        height: 32
                                    },
                                    compId: 15
                                }, {
                                    type: "Label",
                                    props: {
                                        y: 105,
                                        x: 12,
                                        width: 70,
                                        text: "label",
                                        name: "label",
                                        height: 16,
                                        fontSize: 14,
                                        color: "#ffffff",
                                        align: "center"
                                    },
                                    compId: 13
                                }]
                            }]
                        }]
                    }]
                }],
                loadList: ["common/om_common_zz.png", "ui/ui_2.png", "ui/ui_lan.png", "ui/btn_fh.png", "dev/ui_jgg.png", "ui/ui_xiaokuang.png"],
                loadList3D: []
            };
            scenes.HallSplashListUI = HallSplashListUI;
            REG("ui.scenes.HallSplashListUI", HallSplashListUI);
            class PushViewUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(PushViewUI.uiView);
                }
            }
            PushViewUI.uiView = {
                type: "View",
                props: {
                    y: 0,
                    x: 0,
                    width: 1080,
                    top: 0,
                    right: 0,
                    mouseThrough: true,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        width: 0,
                        var: "img_dev_share1",
                        top: 410,
                        name: "rect",
                        left: 50,
                        height: 0,
                        anchorY: .5,
                        anchorX: .5
                    },
                    compId: 63
                }, {
                    type: "Image",
                    props: {
                        width: 0,
                        var: "img_dev_share2",
                        top: 410,
                        right: 250,
                        name: "rect",
                        height: 0,
                        anchorY: .5,
                        anchorX: .5
                    },
                    compId: 58
                }, {
                    type: "Box",
                    props: {
                        x: 0,
                        width: 250,
                        var: "box_dev_box",
                        scaleY: 2,
                        scaleX: 2,
                        height: 470,
                        centerY: -200
                    },
                    compId: 34,
                    child: [{
                        type: "Image",
                        props: {
                            y: 0,
                            x: 0,
                            width: 250,
                            skin: "dev/ui_lan1.png",
                            sizeGrid: "10,10,13,11",
                            height: 470
                        },
                        compId: 50
                    }, {
                        type: "Text",
                        props: {
                            y: 5,
                            x: 81,
                            text: "更多好玩",
                            fontSize: 22,
                            color: "#ffffff",
                            runtime: "laya.display.Text"
                        },
                        compId: 69
                    }, {
                        type: "List",
                        props: {
                            y: 38,
                            x: 10,
                            width: 240,
                            var: "list_dev_box",
                            repeatY: 4,
                            repeatX: 3,
                            name: "list",
                            height: 420
                        },
                        compId: 36,
                        child: [{
                            type: "Box",
                            props: {
                                y: 0,
                                x: 0,
                                width: 80,
                                renderType: "render",
                                height: 95
                            },
                            compId: 43,
                            child: [{
                                type: "Image",
                                props: {
                                    y: 10,
                                    x: 0,
                                    width: 68,
                                    skin: "dev/ui_jgg.png",
                                    sizeGrid: "13,11,14,12",
                                    height: 68
                                },
                                compId: 41
                            }, {
                                type: "Image",
                                props: {
                                    y: 12,
                                    x: 2,
                                    width: 64,
                                    skin: "dev/ui_rank.png",
                                    name: "icon",
                                    height: 64
                                },
                                compId: 40
                            }, {
                                type: "Image",
                                props: {
                                    y: 1,
                                    x: 52,
                                    skin: "dev/hd.png",
                                    name: "new"
                                },
                                compId: 42
                            }, {
                                type: "Label",
                                props: {
                                    y: 81,
                                    x: 0,
                                    width: 70,
                                    text: "label",
                                    name: "label",
                                    height: 16,
                                    fontSize: 14,
                                    color: "#ffffff",
                                    align: "center"
                                },
                                compId: 51
                            }, {
                                type: "Label",
                                props: {
                                    y: 96,
                                    x: 0,
                                    width: 69,
                                    visible: false,
                                    text: "label",
                                    name: "desc",
                                    height: 17,
                                    fontSize: 12,
                                    color: "#ffffff",
                                    align: "center"
                                },
                                compId: 52
                            }]
                        }]
                    }, {
                        type: "CheckBox",
                        props: {
                            y: 49,
                            x: 250,
                            width: 59,
                            var: "chk_dev_box",
                            stateNum: 2,
                            skin: "dev/tb_sq.png",
                            height: 62,
                            disabled: false
                        },
                        compId: 35
                    }, {
                        type: "Image",
                        props: {
                            y: 41,
                            x: 279.5,
                            skin: "dev/hd.png"
                        },
                        compId: 49
                    }]
                }, {
                    type: "Box",
                    props: {
                        x: 0,
                        var: "box_dev_pick",
                        scaleY: 2.2,
                        scaleX: 2.2,
                        bottom: 50
                    },
                    compId: 57,
                    child: [{
                        type: "Image",
                        props: {
                            y: 0,
                            x: 0,
                            width: 795,
                            skin: "dev/black.png",
                            sizeGrid: "11,10,11,10",
                            height: 110
                        },
                        compId: 56
                    }, {
                        type: "List",
                        props: {
                            y: 4,
                            x: 0,
                            width: 640,
                            var: "list_dev_pick",
                            spaceX: 4,
                            repeatY: 1,
                            repeatX: 10,
                            height: 101
                        },
                        compId: 53,
                        child: [{
                            type: "Box",
                            props: {
                                y: 1,
                                x: 0,
                                renderType: "render"
                            },
                            compId: 55,
                            child: [{
                                type: "Image",
                                props: {
                                    width: 100,
                                    skin: "dev/ui_jgg.png",
                                    name: "icon",
                                    height: 100
                                },
                                compId: 54
                            }]
                        }]
                    }]
                }, {
                    type: "Image",
                    props: {
                        width: 1620,
                        visible: false,
                        var: "banner",
                        skin: "ui/ui_2.png",
                        scaleY: .5,
                        scaleX: .5,
                        height: 564,
                        centerX: 0,
                        bottom: 50,
                        anchorY: .5,
                        anchorX: .5
                    },
                    compId: 68
                }],
                loadList: ["dev/ui_lan1.png", "dev/ui_jgg.png", "dev/ui_rank.png", "dev/hd.png", "dev/tb_sq.png", "dev/black.png", "ui/ui_2.png"],
                loadList3D: []
            };
            scenes.PushViewUI = PushViewUI;
            REG("ui.scenes.PushViewUI", PushViewUI);
            class SplashListDialogUI extends Laya.Dialog {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(SplashListDialogUI.uiView);
                }
            }
            SplashListDialogUI.uiView = {
                type: "Dialog",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    mouseThrough: true,
                    mouseEnabled: true,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        width: 950,
                        visible: true,
                        scaleY: 1,
                        scaleX: 1,
                        height: 700,
                        centerY: -130,
                        centerX: 0,
                        anchorY: .5,
                        anchorX: .5
                    },
                    compId: 16,
                    child: [{
                        type: "Button",
                        props: {
                            y: 3,
                            x: 0,
                            visible: false,
                            var: "btn_close",
                            stateNum: 1,
                            skin: "ui/btn_fh.png",
                            scaleY: .8,
                            scaleX: .8
                        },
                        compId: 25
                    }, {
                        type: "List",
                        props: {
                            y: 24,
                            x: 32,
                            width: 900,
                            var: "list_dev_box",
                            spaceY: 10,
                            spaceX: 18,
                            repeatY: 2,
                            repeatX: 3,
                            name: "list",
                            height: 650
                        },
                        compId: 8,
                        child: [{
                            type: "Box",
                            props: {
                                y: 0,
                                x: 0,
                                width: 275,
                                renderType: "render",
                                height: 320
                            },
                            compId: 9,
                            child: [{
                                type: "Image",
                                props: {
                                    y: 8,
                                    x: 10,
                                    width: 280,
                                    skin: "ui/ui_xiaokuang.png",
                                    name: "icon",
                                    height: 250
                                },
                                compId: 11
                            }, {
                                type: "Image",
                                props: {
                                    y: 258,
                                    x: 10,
                                    width: 280,
                                    skin: "dev/ui_cheng.png",
                                    name: "name_bg",
                                    height: 50
                                },
                                compId: 15
                            }, {
                                type: "Label",
                                props: {
                                    y: 263,
                                    x: 10,
                                    width: 280,
                                    text: "label",
                                    name: "label",
                                    height: 40,
                                    fontSize: 40,
                                    color: "#ffffff",
                                    align: "center"
                                },
                                compId: 13
                            }]
                        }]
                    }]
                }],
                loadList: ["ui/btn_fh.png", "ui/ui_xiaokuang.png", "dev/ui_cheng.png"],
                loadList3D: []
            };
            scenes.SplashListDialogUI = SplashListDialogUI;
            REG("ui.scenes.SplashListDialogUI", SplashListDialogUI);
            class SplashSingleDialogUI extends Laya.Dialog {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(SplashSingleDialogUI.uiView);
                }
            }
            SplashSingleDialogUI.uiView = {
                type: "Dialog",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        top: 0,
                        skin: "common/om_common_zz.png",
                        scaleY: 1,
                        scaleX: 1,
                        right: 0,
                        name: "zhezhao",
                        left: 0,
                        bottom: 0,
                        sizeGrid: "21,20,12,18"
                    },
                    compId: 8
                }, {
                    type: "Button",
                    props: {
                        var: "btn_close",
                        stateNum: 1,
                        skin: "dev/btn_jj.png",
                        scaleY: 1.8,
                        scaleX: 1.8,
                        centerY: 300,
                        centerX: 0
                    },
                    compId: 3
                }, {
                    type: "Image",
                    props: {
                        var: "bg",
                        skin: "dev/ui_1.png",
                        scaleY: 1.8,
                        scaleX: 1.8,
                        centerY: -300,
                        centerX: 0
                    },
                    compId: 9,
                    child: [{
                        type: "Image",
                        props: {
                            y: 51,
                            x: 256,
                            width: 106,
                            var: "friend_icon",
                            skin: "dev/tb_tx.png",
                            height: 106
                        },
                        compId: 12,
                        child: [{
                            type: "Image",
                            props: {
                                y: 53,
                                x: 53,
                                skin: "dev/tb_tx.png",
                                renderType: "mask",
                                centerY: 0,
                                centerX: 0,
                                anchorY: .5,
                                anchorX: .5
                            },
                            compId: 20
                        }]
                    }, {
                        type: "Text",
                        props: {
                            y: 86,
                            x: 63,
                            text: "您的好友",
                            fontSize: 36,
                            color: "#877d36",
                            bold: true,
                            runtime: "laya.display.Text"
                        },
                        compId: 13
                    }, {
                        type: "Text",
                        props: {
                            y: 183,
                            x: 92,
                            text: "邀请您体验",
                            fontSize: 48,
                            color: "#ffffff",
                            bold: true,
                            runtime: "laya.display.Text"
                        },
                        compId: 14
                    }, {
                        type: "Image",
                        props: {
                            y: 251,
                            width: 162,
                            var: "game_icon",
                            skin: "dev/icon.png",
                            height: 162,
                            centerX: 0
                        },
                        compId: 15,
                        child: [{
                            type: "Image",
                            props: {
                                y: 81,
                                x: 81,
                                skin: "dev/icon.png",
                                renderType: "mask",
                                centerY: 0,
                                centerX: 0,
                                anchorY: .5,
                                anchorX: .5
                            },
                            compId: 19
                        }]
                    }, {
                        type: "Text",
                        props: {
                            y: 431,
                            x: 114.34375,
                            width: 200,
                            var: "game_name",
                            text: "春节小火车3D",
                            scaleY: 1,
                            scaleX: 1,
                            fontSize: 30,
                            color: "#ffffff",
                            bold: true,
                            align: "center",
                            runtime: "laya.display.Text"
                        },
                        compId: 17
                    }]
                }, {
                    type: "Image",
                    props: {
                        var: "btn_accept",
                        skin: "dev/btn_js.png",
                        scaleY: 1.8,
                        scaleX: 1.8,
                        centerY: 510,
                        centerX: 0
                    },
                    compId: 10
                }],
                loadList: ["common/om_common_zz.png", "dev/btn_jj.png", "dev/ui_1.png", "dev/tb_tx.png", "dev/icon.png", "dev/btn_js.png"],
                loadList3D: []
            };
            scenes.SplashSingleDialogUI = SplashSingleDialogUI;
            REG("ui.scenes.SplashSingleDialogUI", SplashSingleDialogUI);
            class ui_advUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_advUI.uiView);
                }
            }
            ui_advUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    mouseThrough: true,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 2,
                child: [{
                    type: "Image",
                    props: {
                        x: 98,
                        width: 885,
                        skin: "yuansheng/settlement_ysgg.png",
                        sizeGrid: "202,50,38,62",
                        height: 800,
                        centerX: 0,
                        bottom: 900
                    },
                    compId: 34,
                    child: [{
                        type: "Text",
                        props: {
                            y: 34,
                            x: 290,
                            text: "视频APP",
                            fontSize: 80,
                            color: "#ffffff",
                            runtime: "laya.display.Text"
                        },
                        compId: 35
                    }, {
                        type: "Image",
                        props: {
                            width: 56,
                            var: "btn_click_close",
                            top: 14,
                            skin: "yuansheng/bt_ys_guanbi.png",
                            scaleY: 1.5,
                            scaleX: 1.5,
                            right: 26,
                            height: 56
                        },
                        compId: 36
                    }, {
                        type: "Text",
                        props: {
                            y: 703,
                            x: 43,
                            width: 800,
                            var: "text_desc",
                            text: "text_desc",
                            fontSize: 45,
                            color: "#000000",
                            bold: true,
                            align: "center",
                            runtime: "laya.display.Text"
                        },
                        compId: 37
                    }, {
                        type: "Image",
                        props: {
                            y: 172,
                            width: 840,
                            var: "icon_video",
                            height: 478,
                            centerX: 0
                        },
                        compId: 38
                    }]
                }, {
                    type: "Image",
                    props: {
                        var: "btn_click_button",
                        skin: "common/bt_common_03.png",
                        centerX: 0,
                        bottom: 600
                    },
                    compId: 10,
                    child: [{
                        type: "Text",
                        props: {
                            y: 39,
                            x: 66,
                            text: "查看广告",
                            strokeColor: "#000000",
                            stroke: 7,
                            fontSize: 100,
                            color: "#ffffff",
                            runtime: "laya.display.Text"
                        },
                        compId: 39
                    }]
                }],
                loadList: ["yuansheng/settlement_ysgg.png", "yuansheng/bt_ys_guanbi.png", "common/bt_common_03.png"],
                loadList3D: []
            };
            scenes.ui_advUI = ui_advUI;
            REG("ui.scenes.ui_advUI", ui_advUI);
            class ui_exit_gameUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_exit_gameUI.uiView);
                }
            }
            ui_exit_gameUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    mouseThrough: false,
                    mouseEnabled: true,
                    height: 1920
                },
                compId: 2,
                child: [{
                    type: "Image",
                    props: {
                        width: 830,
                        skin: "common/conmon_bg_01_01.png",
                        sizeGrid: "101,116,105,114",
                        height: 534,
                        centerY: 0,
                        centerX: 0
                    },
                    compId: 3,
                    child: [{
                        type: "Image",
                        props: {
                            y: 164,
                            x: 232,
                            skin: "common/tet_zanting_03.png"
                        },
                        compId: 9
                    }, {
                        type: "Image",
                        props: {
                            y: -58,
                            x: 142,
                            skin: "jiesuan/common_caidai_01.png"
                        },
                        compId: 11,
                        child: [{
                            type: "Image",
                            props: {
                                y: 34.5,
                                x: 120,
                                skin: "common/tet_zanting_04.png"
                            },
                            compId: 12
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: 313,
                            var: "mp_btn_confirm",
                            skin: "common/btn_zanting_01.png",
                            left: 40
                        },
                        compId: 4,
                        child: [{
                            type: "Image",
                            props: {
                                y: 53,
                                x: 121,
                                skin: "common/tet_zanting_02.png"
                            },
                            compId: 7
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: 313,
                            var: "mp_btn_cancel",
                            skin: "common/btn_zanting_01.png",
                            right: 40
                        },
                        compId: 5,
                        child: [{
                            type: "Image",
                            props: {
                                y: 53,
                                x: 122,
                                skin: "common/tet_zanting_01.png"
                            },
                            compId: 8
                        }]
                    }]
                }],
                loadList: ["common/conmon_bg_01_01.png", "common/tet_zanting_03.png", "jiesuan/common_caidai_01.png", "common/tet_zanting_04.png", "common/btn_zanting_01.png", "common/tet_zanting_02.png", "common/tet_zanting_01.png"],
                loadList3D: []
            };
            scenes.ui_exit_gameUI = ui_exit_gameUI;
            REG("ui.scenes.ui_exit_gameUI", ui_exit_gameUI);
            class ui_failUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_failUI.uiView);
                }
            }
            ui_failUI.uiView = {
                "x": 0,
                "type": "View",
                "selectedBox": 1,
                "selecteID": 342,
                "searchKey": "View",
                "props": {
                    "width": 1080,
                    "visible": true,
                    "top": 0,
                    "right": 0,
                    "renderType": "mask",
                    "left": 0,
                    "height": 1920,
                    "bottom": 0
                },
                "nodeParent": -1,
                "maxID": 345,
                "loadList3D": [],
                "loadList": [
                    "common/om_common_zz.png",
                    "settlement/txt_settlement_cgl.png",
                    "settlement/txt_settlement_rlyj.png",
                    "common/txt_common_nhdl.png",
                    "city/icon_city_jb.png",
                    "nub/nub_2_0.png",
                    "common/bt_common_01.png",
                    "common/txt_common_sb.png",
                    "common/om_common_sb.png",
                    "settlement/txt_settlement_fhmc.png",
                    "common/bt_common_dbsj.png",
                    "settlement/bt_settlement_ctks.png"
                ],
                "label": "View",
                "isOpen": true,
                "isDirectory": true,
                "isAniNode": true,
                "hasChild": true,
                "compId": 1,
                "child": [{
                        "x": 15,
                        "type": "Image",
                        "searchKey": "Image,zhezhao",
                        "props": {
                            "top": -1001,
                            "skin": "common/om_common_zz.png",
                            "sizeGrid": "21,20,12,18",
                            "right": -1000,
                            "name": "zhezhao",
                            "left": -1000,
                            "bottom": -1000
                        },
                        "nodeParent": 1,
                        "label": "zhezhao",
                        "isDirectory": false,
                        "isAniNode": true,
                        "hasChild": false,
                        "compId": 3,
                        "child": []
                    },
                    {
                        "x": 15,
                        "type": "Box",
                        "searchKey": "Box,fail",
                        "props": {
                            "y": 307,
                            "width": 1080,
                            "var": "fail",
                            "height": 200,
                            "centerX": 0
                        },
                        "nodeParent": 1,
                        "label": "fail",
                        "isOpen": true,
                        "isDirectory": true,
                        "isAniNode": true,
                        "hasChild": true,
                        "compId": 213,
                        "child": [{
                                "x": 30,
                                "type": "Image",
                                "searchKey": "Image,turn_over",
                                "props": {
                                    "var": "turn_over",
                                    "skin": "settlement/txt_settlement_cgl.png",
                                    "centerY": 0,
                                    "centerX": 0
                                },
                                "nodeParent": 213,
                                "label": "turn_over",
                                "isDirectory": false,
                                "isAniNode": true,
                                "hasChild": false,
                                "compId": 214,
                                "child": []
                            },
                            {
                                "x": 30,
                                "type": "Image",
                                "searchKey": "Image,no_coal",
                                "props": {
                                    "var": "no_coal",
                                    "skin": "settlement/txt_settlement_rlyj.png",
                                    "centerY": 0,
                                    "centerX": 0
                                },
                                "nodeParent": 213,
                                "label": "no_coal",
                                "isDirectory": false,
                                "isAniNode": true,
                                "hasChild": false,
                                "compId": 215,
                                "child": []
                            }
                        ]
                    },
                    {
                        "x": 15,
                        "type": "Image",
                        "searchKey": "Image,multual_push_layout",
                        "props": {
                            "var": "multual_push_layout",
                            "top": 0,
                            "right": 0,
                            "left": 0,
                            "bottom": 0
                        },
                        "nodeParent": 1,
                        "label": "multual_push_layout",
                        "isDirectory": false,
                        "isAniNode": true,
                        "hasChild": false,
                        "compId": 232,
                        "child": []
                    },
                    {
                        "x": 15,
                        "type": "Image",
                        "searchKey": "Image,dnsdk_layout",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "var": "dnsdk_layout",
                            "top": 0,
                            "right": 0,
                            "left": 0,
                            "bottom": 0
                        },
                        "nodeParent": 1,
                        "label": "dnsdk_layout",
                        "isDirectory": false,
                        "isAniNode": true,
                        "hasChild": false,
                        "compId": 341,
                        "child": []
                    },
                    {
                        "x": 15,
                        "type": "Box",
                        "searchKey": "Box,buttom",
                        "props": {
                            "width": 1080,
                            "var": "buttom",
                            "height": 418,
                            "centerX": 0,
                            "bottom": 391
                        },
                        "nodeParent": 1,
                        "label": "buttom",
                        "isOpen": null,
                        "isDirectory": true,
                        "isAniNode": true,
                        "hasChild": true,
                        "compId": 216,
                        "child": [{
                                "type": "Image",
                                "searchKey": "Image",
                                "props": {
                                    "y": 65.5,
                                    "skin": "common/txt_common_nhdl.png",
                                    "centerX": -156
                                },
                                "nodeParent": 216,
                                "label": "Image",
                                "isDirectory": false,
                                "isAniNode": true,
                                "hasChild": false,
                                "compId": 218,
                                "child": []
                            },
                            {
                                "type": "Image",
                                "searchKey": "Image",
                                "props": {
                                    "y": 47,
                                    "x": 521,
                                    "skin": "city/icon_city_jb.png"
                                },
                                "nodeParent": 216,
                                "label": "Image",
                                "isDirectory": false,
                                "isAniNode": true,
                                "hasChild": false,
                                "compId": 219,
                                "child": []
                            },
                            {
                                "type": "FontClip",
                                "searchKey": "FontClip,lb_reward",
                                "props": {
                                    "y": 53,
                                    "x": 629,
                                    "var": "lb_reward",
                                    "value": "66951",
                                    "skin": "nub/nub_2_0.png",
                                    "sheet": "0123456789"
                                },
                                "nodeParent": 216,
                                "label": "lb_reward",
                                "isDirectory": false,
                                "isAniNode": true,
                                "hasChild": false,
                                "compId": 220,
                                "child": []
                            },
                            {
                                "type": "Image",
                                "searchKey": "Image,btn_double",
                                "props": {
                                    "y": 152,
                                    "var": "btn_double",
                                    "skin": "common/bt_common_01.png",
                                    "centerX": 0
                                },
                                "nodeParent": 216,
                                "label": "btn_double",
                                "isDirectory": true,
                                "isAniNode": true,
                                "hasChild": true,
                                "compId": 221,
                                "child": [{
                                        "type": "Image",
                                        "searchKey": "Image",
                                        "props": {
                                            "y": 45,
                                            "x": 242,
                                            "skin": "common/txt_common_sb.png"
                                        },
                                        "nodeParent": 221,
                                        "label": "Image",
                                        "isDirectory": false,
                                        "isAniNode": true,
                                        "hasChild": false,
                                        "compId": 229,
                                        "child": []
                                    },
                                    {
                                        "type": "Image",
                                        "searchKey": "Image",
                                        "props": {
                                            "y": 0,
                                            "x": 445,
                                            "skin": "common/om_common_sb.png"
                                        },
                                        "nodeParent": 221,
                                        "label": "Image",
                                        "isDirectory": false,
                                        "isAniNode": true,
                                        "hasChild": false,
                                        "compId": 231,
                                        "child": []
                                    }
                                ]
                            },
                            {
                                "type": "Image",
                                "searchKey": "Image,btn_reborn",
                                "props": {
                                    "y": 0,
                                    "var": "btn_reborn",
                                    "skin": "common/bt_common_01.png",
                                    "centerX": 0
                                },
                                "nodeParent": 216,
                                "label": "btn_reborn",
                                "isDirectory": true,
                                "isAniNode": true,
                                "hasChild": true,
                                "compId": 227,
                                "child": [{
                                    "type": "Image",
                                    "searchKey": "Image",
                                    "props": {
                                        "y": 48,
                                        "x": 228,
                                        "skin": "settlement/txt_settlement_fhmc.png"
                                    },
                                    "nodeParent": 227,
                                    "label": "Image",
                                    "isDirectory": false,
                                    "isAniNode": true,
                                    "hasChild": false,
                                    "compId": 228,
                                    "child": []
                                }]
                            }
                        ]
                    },
                    {
                        "x": 15,
                        "type": "Image",
                        "searchKey": "Image,btn_once",
                        "props": {
                            "y": 1392,
                            "x": 452,
                            "var": "btn_once",
                            "skin": "common/bt_common_dbsj.png",
                            "scaleY": 1.3,
                            "scaleX": 1.3,
                            "centerX": 0,
                            "bottom": 300
                        },
                        "nodeParent": 1,
                        "label": "btn_once",
                        "isDirectory": false,
                        "isAniNode": true,
                        "hasChild": false,
                        "compId": 224,
                        "child": []
                    },
                    {
                        "x": 15,
                        "type": "Image",
                        "searchKey": "Image,btn_restart",
                        "props": {
                            "y": 1394,
                            "x": 452,
                            "var": "btn_restart",
                            "skin": "settlement/bt_settlement_ctks.png",
                            "scaleY": 1.3,
                            "scaleX": 1.3,
                            "centerX": 0,
                            "bottom": 500
                        },
                        "nodeParent": 1,
                        "label": "btn_restart",
                        "isDirectory": false,
                        "isAniNode": true,
                        "hasChild": false,
                        "compId": 226,
                        "child": []
                    },
                    {
                        "x": 15,
                        "type": "List",
                        "searchKey": "List,list_showA",
                        "props": {
                            "y": 527,
                            "x": 90,
                            "width": 899,
                            "var": "list_showA",
                            "height": 600
                        },
                        "nodeParent": 1,
                        "label": "list_showA",
                        "isOpen": true,
                        "isDirectory": true,
                        "isAniNode": true,
                        "hasChild": true,
                        "compId": 342,
                        "child": [{
                            "x": 30,
                            "type": "Box",
                            "searchKey": "Box",
                            "props": {
                                "renderType": "render"
                            },
                            "nodeParent": 342,
                            "label": "Box",
                            "isOpen": true,
                            "isDirectory": true,
                            "isAniNode": false,
                            "hasChild": true,
                            "compId": 343,
                            "child": [{
                                "x": 45,
                                "type": "Image",
                                "searchKey": "Image,thumb",
                                "props": {
                                    "width": 300,
                                    "name": "thumb",
                                    "height": 200
                                },
                                "nodeParent": 343,
                                "label": "thumb",
                                "isDirectory": false,
                                "isAniNode": false,
                                "hasChild": false,
                                "compId": 344,
                                "child": []
                            }]
                        }]
                    }
                ],
                "animations": [{
                    "nodes": [],
                    "name": "ani1",
                    "id": 1,
                    "frameRate": 24,
                    "action": 0
                }]
            };
            scenes.ui_failUI = ui_failUI;
            REG("ui.scenes.ui_failUI", ui_failUI);
            class ui_get_rewardUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_get_rewardUI.uiView);
                }
            }
            ui_get_rewardUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        var: "zhezhao",
                        top: -200,
                        skin: "common/om_common_zz.png",
                        scaleY: 1,
                        scaleX: 1,
                        right: -200,
                        pivotY: 960,
                        pivotX: 540,
                        name: "zhezhao",
                        left: -200,
                        bottom: -200,
                        sizeGrid: "21,20,12,18"
                    },
                    compId: 3
                }, {
                    type: "Box",
                    props: {
                        width: 1080,
                        height: 500,
                        centerY: -50,
                        centerX: 0
                    },
                    compId: 144,
                    child: [{
                        type: "Image",
                        props: {
                            y: 250,
                            x: 540,
                            var: "guang",
                            skin: "common/om_common_guang01.png",
                            rotation: 360,
                            centerY: 0,
                            centerX: 0,
                            anchorY: .5,
                            anchorX: .5
                        },
                        compId: 147
                    }, {
                        type: "Image",
                        props: {
                            skin: "common/om_common_guang02.png",
                            centerY: 53,
                            centerX: 24
                        },
                        compId: 148
                    }, {
                        type: "Image",
                        props: {
                            y: -215,
                            x: 205,
                            var: "gole_title",
                            skin: "settlement/om_settlement_gxhd.png",
                            centerX: 0
                        },
                        compId: 150,
                        child: [{
                            type: "Image",
                            props: {
                                y: 190,
                                x: 83,
                                var: "gold_icon",
                                skin: "offline/om_offline_jb.png"
                            },
                            compId: 149
                        }, {
                            type: "Image",
                            props: {
                                y: 744,
                                var: "gold",
                                skin: "common/txt_common_nhdl.png",
                                centerX: 0
                            },
                            compId: 140,
                            child: [{
                                type: "FontClip",
                                props: {
                                    y: 79,
                                    x: 68,
                                    var: "lb_reward",
                                    value: "500",
                                    skin: "nub/nub_2_0.png",
                                    sheet: "0123456789"
                                },
                                compId: 142
                            }, {
                                type: "Image",
                                props: {
                                    y: 80,
                                    x: -40,
                                    skin: "city/icon_city_jb.png"
                                },
                                compId: 141
                            }]
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: -215,
                            x: 205,
                            var: "env_title",
                            skin: "settlement/om_settlement_gxjs.png",
                            centerX: 0
                        },
                        compId: 153,
                        child: [{
                            type: "Image",
                            props: {
                                y: 279,
                                x: 56,
                                var: "icon_sand",
                                skin: "settlement/bg_skin_01.png",
                                scaleY: .7,
                                scaleX: .7,
                                centerX: 0
                            },
                            compId: 154
                        }, {
                            type: "Image",
                            props: {
                                y: 279,
                                x: 56,
                                var: "icon_snow",
                                skin: "settlement/bg_skin_02.png",
                                scaleY: .7,
                                scaleX: .7,
                                centerX: 0
                            },
                            compId: 158
                        }, {
                            type: "Image",
                            props: {
                                y: 816,
                                x: 221,
                                var: "txt_sand",
                                skin: "city/txt_city_smlc.png",
                                centerX: 0
                            },
                            compId: 156
                        }, {
                            type: "Image",
                            props: {
                                y: 816,
                                x: 221,
                                var: "txt_snow",
                                skin: "city/txt_city_xglc.png",
                                centerX: 0
                            },
                            compId: 157
                        }]
                    }]
                }],
                animations: [{
                    nodes: [{
                        target: 102,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 45
                            }],
                            x: [{
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "x",
                                index: 0
                            }, {
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 45
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 45
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 46
                            }]
                        }
                    }, {
                        target: 96,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 0
                            }, {
                                value: 50.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 19
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "y",
                                index: 48
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "x",
                                index: 0
                            }, {
                                value: -67,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 19
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 48
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 19
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 48
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 49
                            }]
                        }
                    }, {
                        target: 112,
                        keyframes: {
                            y: [{
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "y",
                                index: 0
                            }, {
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 22
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 51
                            }],
                            x: [{
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "x",
                                index: 0
                            }, {
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 22
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 51
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 22
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 51
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 52
                            }]
                        }
                    }, {
                        target: 106,
                        keyframes: {
                            y: [{
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "y",
                                index: 0
                            }, {
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 41
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 41
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 41
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 42
                            }]
                        }
                    }, {
                        target: 105,
                        keyframes: {
                            y: [{
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 38
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 38
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 38
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 39
                            }]
                        }
                    }, {
                        target: 111,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 36
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 36
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 36
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 37
                            }]
                        }
                    }, {
                        target: 104,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 5
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 21
                            }],
                            x: [{
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "x",
                                index: 0
                            }, {
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 5
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 21
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 21
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 22
                            }]
                        }
                    }, {
                        target: 110,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 28
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 28
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 28
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 29
                            }]
                        }
                    }, {
                        target: 103,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 12
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "y",
                                index: 32
                            }],
                            x: [{
                                value: -106,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 12
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 32
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 12
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 32
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 33
                            }]
                        }
                    }, {
                        target: 109,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 34
                            }],
                            x: [{
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "x",
                                index: 0
                            }, {
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 34
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 34
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 35
                            }]
                        }
                    }, {
                        target: 101,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 7
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 23
                            }],
                            x: [{
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 7
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 23
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 7
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 23
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 24
                            }]
                        }
                    }, {
                        target: 108,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 13
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 33
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "x",
                                index: 0
                            }, {
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 13
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 33
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 13
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 33
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 34
                            }]
                        }
                    }, {
                        target: 107,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "y",
                                index: 10
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 24
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "x",
                                index: 10
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 24
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 10
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 24
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 25
                            }]
                        }
                    }],
                    name: "diamondAni",
                    id: 1,
                    frameRate: 30,
                    action: 0
                }, {
                    nodes: [{
                        target: 86,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 87,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni1",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 70,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 71,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni2",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 76,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 77,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni3",
                    id: 3,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 79,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 80,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni4",
                    id: 4,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [],
                    name: "doubleRewardAni",
                    id: 5,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [],
                    name: "quan",
                    id: 6,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [{
                        target: 147,
                        keyframes: {
                            rotation: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 0
                            }, {
                                value: 360,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 100
                            }],
                            centerX: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "centerX",
                                index: 100
                            }]
                        }
                    }],
                    name: "guang_rot",
                    id: 7,
                    frameRate: 10,
                    action: 2
                }],
                loadList: ["common/om_common_zz.png", "common/om_common_guang01.png", "common/om_common_guang02.png", "settlement/om_settlement_gxhd.png", "offline/om_offline_jb.png", "common/txt_common_nhdl.png", "nub/nub_2_0.png", "city/icon_city_jb.png", "settlement/om_settlement_gxjs.png", "settlement/bg_skin_01.png", "settlement/bg_skin_02.png", "city/txt_city_smlc.png", "city/txt_city_xglc.png"],
                loadList3D: []
            };
            scenes.ui_get_rewardUI = ui_get_rewardUI;
            REG("ui.scenes.ui_get_rewardUI", ui_get_rewardUI);
            class ui_guideUI extends Laya.Scene {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_guideUI.uiView);
                }
            }
            ui_guideUI.uiView = {
                type: "Scene",
                props: {
                    width: 1080,
                    mouseThrough: true,
                    height: 1920
                },
                compId: 2,
                child: [{
                    type: "Box",
                    props: {
                        y: 548,
                        centerX: 0,
                        width: 1080,
                        var: "guide_1",
                        height: 300
                    },
                    compId: 52,
                    child: [{
                        type: "Image",
                        props: {
                            skin: "battle/om_battle_ydwz01.png",
                            centerX: 0
                        },
                        compId: 53
                    }, {
                        type: "Box",
                        props: {
                            width: 100,
                            name: "finger",
                            height: 100,
                            centerY: 473,
                            centerX: 338
                        },
                        compId: 70,
                        child: [{
                            type: "Image",
                            props: {
                                y: 38,
                                x: 9,
                                width: 164,
                                skin: "battle/om_battle_ydgq.png",
                                scaleY: 1,
                                scaleX: 1,
                                pivotY: 82,
                                pivotX: 82,
                                name: "quan",
                                height: 164,
                                alpha: 0
                            },
                            compId: 55
                        }, {
                            type: "Image",
                            props: {
                                y: 0,
                                x: 0,
                                skin: "battle/om_battle_shou1.png",
                                name: "finger_1",
                                alpha: 0
                            },
                            compId: 54
                        }, {
                            type: "Image",
                            props: {
                                y: 0,
                                x: 0,
                                skin: "battle/om_battle_shou2.png",
                                name: "finger_2",
                                alpha: 1
                            },
                            compId: 56
                        }, {
                            type: "Image",
                            props: {
                                y: 38,
                                x: 9,
                                width: 164,
                                skin: "battle/om_battle_ydgq.png",
                                scaleY: .7894736842105263,
                                scaleX: .7894736842105263,
                                pivotY: 82,
                                pivotX: 82,
                                name: "quan_2",
                                height: 164,
                                alpha: .26315789473684215
                            },
                            compId: 86
                        }]
                    }]
                }, {
                    type: "Box",
                    props: {
                        y: 504,
                        centerX: 0,
                        width: 1080,
                        var: "guide_2",
                        height: 300
                    },
                    compId: 60,
                    child: [{
                        type: "Image",
                        props: {
                            x: -1e4,
                            var: "bg_mask",
                            top: -2e4,
                            skin: "battle/om_battle_ydzz.png",
                            right: -1e4,
                            left: -1e4,
                            bottom: -2e4
                        },
                        compId: 90
                    }, {
                        type: "Box",
                        props: {
                            y: 0,
                            x: 0,
                            width: 1080,
                            var: "up",
                            height: 300
                        },
                        compId: 61,
                        child: [{
                            type: "Image",
                            props: {
                                skin: "battle/om_battle_ydwz02.png",
                                centerX: 0
                            },
                            compId: 62
                        }, {
                            type: "Image",
                            props: {
                                y: 0,
                                x: 252,
                                skin: "battle/om_battle_ydwz03.png",
                                centerX: 0,
                                alpha: 1
                            },
                            compId: 74
                        }, {
                            type: "Image",
                            props: {
                                y: 190,
                                width: 700,
                                var: "guide_bg",
                                skin: "battle/box_battle_yddk.png",
                                height: 600,
                                centerX: 0,
                                sizeGrid: "39,44,39,39"
                            },
                            compId: 64,
                            child: [{
                                type: "Box",
                                props: {
                                    y: 300,
                                    x: 350,
                                    width: 700,
                                    rotation: 42,
                                    height: 600,
                                    anchorY: .5,
                                    anchorX: .5
                                },
                                compId: 87,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 158,
                                        x: 103,
                                        skin: "battle/om_battle_yddh03.png"
                                    },
                                    compId: 65
                                }, {
                                    type: "Image",
                                    props: {
                                        y: 94,
                                        x: 468,
                                        skin: "battle/om_battle_yddh02.png"
                                    },
                                    compId: 69
                                }, {
                                    type: "Image",
                                    props: {
                                        y: 112,
                                        x: 220,
                                        skin: "battle/om_battle_yddh01.png"
                                    },
                                    compId: 68
                                }, {
                                    type: "Image",
                                    props: {
                                        y: 273,
                                        x: 238,
                                        width: 158,
                                        skin: "battle/om_battle_yddh04.png",
                                        scaleX: .1,
                                        rotation: -30,
                                        pivotY: 64,
                                        pivotX: 158,
                                        height: 128,
                                        alpha: 0
                                    },
                                    compId: 89
                                }]
                            }, {
                                type: "Box",
                                props: {
                                    width: 100,
                                    name: "finger",
                                    height: 100,
                                    centerY: 168,
                                    centerX: 70
                                },
                                compId: 81,
                                child: [{
                                    type: "Image",
                                    props: {
                                        y: 82,
                                        x: 82,
                                        width: 164,
                                        skin: "battle/om_battle_ydgq.png",
                                        scaleY: 1,
                                        scaleX: 1,
                                        pivotY: 82,
                                        pivotX: 82,
                                        name: "quan",
                                        height: 164,
                                        alpha: 0
                                    },
                                    compId: 82
                                }, {
                                    type: "Image",
                                    props: {
                                        y: 82,
                                        x: 82,
                                        width: 164,
                                        skin: "battle/om_battle_ydgq.png",
                                        scaleY: 1,
                                        scaleX: 1,
                                        pivotY: 82,
                                        pivotX: 82,
                                        name: "quan_2",
                                        height: 164,
                                        alpha: 0
                                    },
                                    compId: 88
                                }, {
                                    type: "Image",
                                    props: {
                                        y: 50,
                                        x: 70,
                                        skin: "battle/om_battle_shou1.png",
                                        name: "finger_1",
                                        alpha: 1.1
                                    },
                                    compId: 83
                                }, {
                                    type: "Image",
                                    props: {
                                        y: 50,
                                        x: 70,
                                        skin: "battle/om_battle_shou2.png",
                                        name: "finger_2",
                                        alpha: 0
                                    },
                                    compId: 84
                                }]
                            }, {
                                type: "Sprite",
                                props: {
                                    y: 36,
                                    x: -48,
                                    texture: "battle/om_battle_zgj.png"
                                },
                                compId: 91
                            }, {
                                type: "Sprite",
                                props: {
                                    y: 36,
                                    x: 749,
                                    texture: "battle/om_battle_zgj.png",
                                    scaleX: -1
                                },
                                compId: 92
                            }]
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: 924,
                            x: 323,
                            var: "btn_continue",
                            skin: "battle/bt_battle_jx.png",
                            centerX: 0
                        },
                        compId: 71,
                        child: [{
                            type: "Script",
                            props: {
                                runtime: "script/ui/ui_animation/ui_button_scale.ts"
                            },
                            compId: 72
                        }]
                    }]
                }],
                animations: [{
                    nodes: [{
                        target: 12,
                        keyframes: {
                            y: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "y",
                                index: 0
                            }, {
                                value: -100,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "y",
                                index: 10
                            }],
                            scaleY: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleY",
                                index: 10
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleY",
                                index: 40
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleY",
                                index: 45
                            }],
                            scaleX: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleX",
                                index: 10
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleX",
                                index: 40
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 12,
                                key: "scaleX",
                                index: 45
                            }]
                        }
                    }],
                    name: "show_add",
                    id: 1,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [],
                    name: "ani2",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 55,
                        keyframes: {
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "scaleY",
                                index: 13
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "scaleY",
                                index: 31
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                label: null,
                                key: "scaleY",
                                index: 32
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                label: null,
                                key: "scaleY",
                                index: 48
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "scaleX",
                                index: 13
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "scaleX",
                                index: 31
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                label: null,
                                key: "scaleX",
                                index: 32
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                label: null,
                                key: "scaleX",
                                index: 48
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "alpha",
                                index: 12
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "alpha",
                                index: 13
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                key: "alpha",
                                index: 31
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                label: null,
                                key: "alpha",
                                index: 32
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 55,
                                label: null,
                                key: "alpha",
                                index: 48
                            }]
                        }
                    }, {
                        target: 54,
                        keyframes: {
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 54,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 54,
                                key: "alpha",
                                index: 12
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 54,
                                key: "alpha",
                                index: 13
                            }]
                        }
                    }, {
                        target: 56,
                        keyframes: {
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 56,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 56,
                                key: "alpha",
                                index: 12
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 56,
                                key: "alpha",
                                index: 13
                            }]
                        }
                    }, {
                        target: 86,
                        keyframes: {
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "scaleY",
                                index: 22
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "scaleY",
                                index: 38
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "scaleY",
                                index: 39
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "scaleY",
                                index: 58
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "scaleX",
                                index: 22
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "scaleX",
                                index: 38
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "scaleX",
                                index: 39
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "scaleX",
                                index: 58
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "alpha",
                                index: 21
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "alpha",
                                index: 22
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "alpha",
                                index: 38
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "alpha",
                                index: 39
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                label: null,
                                key: "alpha",
                                index: 58
                            }]
                        }
                    }],
                    name: "shou01",
                    id: 3,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [{
                        target: 83,
                        keyframes: {
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 83,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 83,
                                key: "alpha",
                                index: 5
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 83,
                                key: "alpha",
                                index: 6
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 83,
                                key: "alpha",
                                index: 42
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 83,
                                key: "alpha",
                                index: 43
                            }, {
                                value: 1.1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 83,
                                key: "alpha",
                                index: 80
                            }]
                        }
                    }, {
                        target: 84,
                        keyframes: {
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 84,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 84,
                                key: "alpha",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 84,
                                key: "alpha",
                                index: 6
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 84,
                                key: "alpha",
                                index: 42
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 84,
                                key: "alpha",
                                index: 43
                            }]
                        }
                    }, {
                        target: 82,
                        keyframes: {
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "scaleY",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "scaleY",
                                index: 24
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "scaleY",
                                index: 25
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                label: null,
                                key: "scaleY",
                                index: 45
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "scaleX",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "scaleX",
                                index: 24
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "scaleX",
                                index: 25
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                label: null,
                                key: "scaleX",
                                index: 45
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "alpha",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "alpha",
                                index: 6
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                key: "alpha",
                                index: 24
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                label: null,
                                key: "alpha",
                                index: 25
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 82,
                                label: null,
                                key: "alpha",
                                index: 45
                            }]
                        }
                    }, {
                        target: 88,
                        keyframes: {
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                key: "scaleY",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                label: null,
                                key: "scaleY",
                                index: 35
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                key: "scaleX",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                label: null,
                                key: "scaleX",
                                index: 35
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                key: "alpha",
                                index: 16
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                label: null,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 88,
                                label: null,
                                key: "alpha",
                                index: 35
                            }]
                        }
                    }, {
                        target: 89,
                        keyframes: {
                            scaleX: [{
                                value: .1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "scaleX",
                                index: 16
                            }, {
                                value: .8,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "scaleX",
                                index: 20
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "scaleX",
                                index: 26
                            }, {
                                value: .8,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                label: null,
                                key: "scaleX",
                                index: 30
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                label: null,
                                key: "scaleX",
                                index: 36
                            }, {
                                value: .8,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                label: null,
                                key: "scaleX",
                                index: 40
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                label: null,
                                key: "scaleX",
                                index: 45
                            }, {
                                value: .1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "scaleX",
                                index: 60
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "alpha",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "alpha",
                                index: 6
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "alpha",
                                index: 60
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 89,
                                key: "alpha",
                                index: 62
                            }]
                        }
                    }, {
                        target: 87,
                        keyframes: {
                            rotation: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "rotation",
                                index: 0
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "rotation",
                                index: 44
                            }, {
                                value: 60,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "rotation",
                                index: 55
                            }, {
                                value: 60,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "rotation",
                                index: 80
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "rotation",
                                index: 90
                            }]
                        }
                    }, {
                        target: 74,
                        keyframes: {
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 74,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 74,
                                key: "alpha",
                                index: 31
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 74,
                                key: "alpha",
                                index: 48
                            }]
                        }
                    }],
                    name: "shou_02",
                    id: 4,
                    frameRate: 24,
                    action: 2
                }],
                loadList: ["battle/om_battle_ydwz01.png", "battle/om_battle_ydgq.png", "battle/om_battle_shou1.png", "battle/om_battle_shou2.png", "battle/om_battle_ydzz.png", "battle/om_battle_ydwz02.png", "battle/om_battle_ydwz03.png", "battle/box_battle_yddk.png", "battle/om_battle_yddh03.png", "battle/om_battle_yddh02.png", "battle/om_battle_yddh01.png", "battle/om_battle_yddh04.png", "battle/om_battle_zgj.png", "battle/bt_battle_jx.png"],
                loadList3D: []
            };
            scenes.ui_guideUI = ui_guideUI;
            REG("ui.scenes.ui_guideUI", ui_guideUI);
            class ui_loadingUI extends Laya.Scene {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_loadingUI.uiView);
                }
            }
            ui_loadingUI.uiView = {
                type: "Scene",
                props: {
                    width: 1080,
                    mouseThrough: true,
                    mouseEnabled: true,
                    height: 1920
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        y: 960,
                        x: 540,
                        var: "bg",
                        top: -250,
                        skin: "loading/bg_01.png",
                        scaleY: 1,
                        scaleX: 1,
                        right: -250,
                        name: "bg",
                        left: -250,
                        bottom: -250,
                        anchorY: .5,
                        anchorX: .5
                    },
                    compId: 3
                }, {
                    type: "Image",
                    props: {
                        y: 960,
                        x: 540,
                        var: "loading",
                        skin: "city/om_city_jiazai.png",
                        centerY: 0,
                        centerX: 0,
                        anchorY: .5,
                        anchorX: .5
                    },
                    compId: 495
                }],
                animations: [{
                    nodes: [{
                        target: 495,
                        keyframes: {
                            rotation: [{
                                value: 360,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 495,
                                key: "rotation",
                                index: 0
                            }, {
                                value: 360,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 495,
                                key: "rotation",
                                index: 15
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 495,
                                key: "rotation",
                                index: 48
                            }]
                        }
                    }],
                    name: "rotateAni",
                    id: 1,
                    frameRate: 24,
                    action: 0
                }],
                loadList: ["loading/bg_01.png", "city/om_city_jiazai.png"],
                loadList3D: []
            };
            scenes.ui_loadingUI = ui_loadingUI;
            REG("ui.scenes.ui_loadingUI", ui_loadingUI);
            class ui_load_resUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_load_resUI.uiView);
                }
            }
            ui_load_resUI.uiView = {
                "x": 0,
                "type": "View",
                "selectedBox": 2,
                "selecteID": 5,
                "searchKey": "View",
                "props": {
                    "width": 1080,
                    "top": 0,
                    "right": 0,
                    "mouseThrough": false,
                    "mouseEnabled": true,
                    "left": 0,
                    "height": 1920,
                    "bottom": 0
                },
                "nodeParent": -1,
                "maxID": 6,
                "loadList3D": [],
                "loadList": [
                    "common/zhezhao_bg_white.png",
                    "common/bg_02.png"
                ],
                "label": "View",
                "isOpen": true,
                "isDirectory": true,
                "isAniNode": true,
                "hasChild": true,
                "compId": 2,
                "child": [{
                        "x": 15,
                        "type": "Image",
                        "searchKey": "Image,bg",
                        "props": {
                            "var": "bg",
                            "top": 0,
                            "skin": "common/zhezhao_bg_white.png",
                            "sizeGrid": "8,8,7,8",
                            "right": 0,
                            "mouseThrough": false,
                            "mouseEnabled": true,
                            "left": 0,
                            "bottom": 0,
                            "alpha": 0
                        },
                        "nodeParent": 2,
                        "label": "bg",
                        "isDirectory": false,
                        "isAniNode": true,
                        "hasChild": false,
                        "compId": 3,
                        "child": []
                    },
                    {
                        "x": 15,
                        "type": "Image",
                        "searchKey": "Image,mp_img_load",
                        "props": {
                            "y": 921,
                            "x": 540,
                            "var": "mp_img_load",
                            "skin": "common/bg_02.png",
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "alpha": 1
                        },
                        "nodeParent": 2,
                        "label": "mp_img_load",
                        "isDirectory": false,
                        "isAniNode": true,
                        "hasChild": false,
                        "compId": 4,
                        "child": []
                    },
                    {
                        "x": 15,
                        "type": "Label",
                        "searchKey": "Label,mp_label",
                        "props": {
                            "y": 997,
                            "x": 449,
                            "var": "mp_label",
                            "text": "LoadIng",
                            "fontSize": 50,
                            "color": "#e7ac15"
                        },
                        "nodeParent": 2,
                        "label": "mp_label",
                        "isDirectory": false,
                        "isAniNode": true,
                        "hasChild": false,
                        "compId": 5,
                        "child": []
                    }
                ],
                "animations": [{
                    "nodes": [],
                    "name": "ani1",
                    "id": 1,
                    "frameRate": 24,
                    "action": 0
                }]
            };
            scenes.ui_load_resUI = ui_load_resUI;
            REG("ui.scenes.ui_load_resUI", ui_load_resUI);
            class ui_loginUI extends Laya.Scene {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_loginUI.uiView);
                }
            }
            ui_loginUI.uiView = {
                type: "Scene",
                props: {
                    width: 1080,
                    height: 1920
                },
                compId: 2,
                child: [{
                    type: "Image",
                    props: {
                        top: -2e3,
                        skin: "denglu/white_bg_01.png",
                        sizeGrid: "5,5,5,5",
                        right: -1e3,
                        name: "bg",
                        left: -1e3,
                        bottom: -2e3
                    },
                    compId: 7
                }, {
                    type: "Image",
                    props: {
                        y: 190,
                        skin: "denglu/om_city_logo.png",
                        scaleY: 1.5,
                        scaleX: 1.5,
                        centerX: 0
                    },
                    compId: 20
                }, {
                    type: "Image",
                    props: {
                        y: 1431,
                        width: 600,
                        skin: "denglu/bar_city_01.png",
                        sizeGrid: "0,27,0,26",
                        height: 60,
                        centerX: -18
                    },
                    compId: 10
                }, {
                    type: "Image",
                    props: {
                        y: 1436,
                        width: 590,
                        var: "img_progress",
                        skin: "denglu/bar_city_02.png",
                        sizeGrid: "11,29,14,27",
                        height: 50,
                        centerX: -18
                    },
                    compId: 11,
                    child: [{
                        type: "Sprite",
                        props: {
                            y: -35,
                            x: 0,
                            var: "progress_mask",
                            renderType: "mask"
                        },
                        compId: 12,
                        child: [{
                            type: "Rect",
                            props: {
                                width: 600,
                                lineWidth: 1,
                                height: 100,
                                fillColor: "#ff0000"
                            },
                            compId: 14
                        }]
                    }]
                }],
                loadList: ["denglu/white_bg_01.png", "denglu/om_city_logo.png", "denglu/bar_city_01.png", "denglu/bar_city_02.png"],
                loadList3D: []
            };
            scenes.ui_loginUI = ui_loginUI;
            REG("ui.scenes.ui_loginUI", ui_loginUI);
            class ui_mainUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_mainUI.uiView);
                }
            }
            ui_mainUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        var: "startGameBtn",
                        top: 1,
                        right: 0,
                        name: "startGameBtn",
                        left: 1,
                        bottom: 0
                    },
                    compId: 45
                }, {
                    type: "Image",
                    props: {
                        centerX: 0,
                        width: 274,
                        top: 164,
                        skin: "city/box_city_jb.png",
                        scaleY: 1,
                        scaleX: 1,
                        pivotY: 39,
                        pivotX: 114,
                        name: "gold",
                        height: 83,
                        sizeGrid: "0,40,0,39"
                    },
                    compId: 16,
                    child: [{
                        type: "Image",
                        props: {
                            y: 21,
                            x: 20,
                            width: 81,
                            skin: "city/icon_city_jb.png",
                            scaleY: 1,
                            scaleX: 1,
                            pivotY: 29.5,
                            pivotX: 33.5,
                            name: "icon",
                            height: 93
                        },
                        compId: 17,
                        child: [{
                            type: "FontClip",
                            props: {
                                y: 29,
                                x: 94,
                                var: "goldNum",
                                value: "200",
                                skin: "nub/nub_3_0.png",
                                sheet: "0123456789"
                            },
                            compId: 66
                        }]
                    }]
                }, {
                    type: "Box",
                    props: {
                        y: 132.5,
                        width: 871,
                        var: "chapter_ding",
                        name: "chapter_ding",
                        height: 306,
                        centerX: 0
                    },
                    compId: 60,
                    child: [{
                        type: "Image",
                        props: {
                            y: 167,
                            width: 177,
                            skin: "city/txt_city_gq.png",
                            scaleY: 1,
                            scaleX: 1,
                            pivotY: 30,
                            pivotX: 66.5,
                            name: "guanqia",
                            height: 106,
                            centerX: -80
                        },
                        compId: 14,
                        child: [{
                            type: "FontClip",
                            props: {
                                y: 9,
                                x: 199,
                                width: 80,
                                var: "chaper_id",
                                value: "50",
                                spaceX: 0,
                                skin: "nub/nub_2_0.png",
                                sheet: "0123456789",
                                height: 59,
                                centerY: -15,
                                centerX: 150
                            },
                            compId: 65
                        }]
                    }, {
                        type: "Sprite",
                        props: {
                            y: 163,
                            x: 78,
                            texture: "city/om_city_xian.png",
                            height: 0
                        },
                        compId: 134
                    }, {
                        type: "Sprite",
                        props: {
                            y: 163,
                            x: 776,
                            texture: "city/om_city_xian.png",
                            scaleX: -1,
                            rotation: 0,
                            height: 0
                        },
                        compId: 135
                    }]
                }, {
                    type: "Box",
                    props: {
                        y: 381,
                        width: 126,
                        height: 380,
                        right: 0,
                        name: "setting"
                    },
                    compId: 61,
                    child: [{
                        type: "Image",
                        props: {
                            y: 56,
                            x: 56,
                            width: 112,
                            var: "soundBtn",
                            skin: "city/bt_city_sy1.png",
                            scaleY: 1,
                            scaleX: 1,
                            pivotY: 56,
                            pivotX: 56,
                            height: 112
                        },
                        compId: 19
                    }, {
                        type: "Image",
                        props: {
                            y: 828,
                            x: 268,
                            width: 112,
                            var: "shakeBtn",
                            skin: "city/bt_city_zd1.png",
                            scaleY: 1,
                            scaleX: 1,
                            pivotY: 56,
                            pivotX: 56,
                            height: 112
                        },
                        compId: 20
                    }]
                }, {
                    type: "Image",
                    props: {
                        centerX: 0,
                        var: "btn_more_game",
                        skin: "city/om_yhz.png",
                        left: 30,
                        bottom: 1100,
                        anchorY: .5,
                        anchorX: .5
                    },
                    compId: 175,
                    child: [{
                        type: "Script",
                        props: {
                            runtime: "script/ui/ui_more_games.ts"
                        },
                        compId: 176
                    }, {
                        type: "Script",
                        props: {
                            runtime: "script/ui/ui_animation/ui_sound.ts"
                        },
                        compId: 177
                    }]
                }, {
                    type: "Box",
                    props: {
                        centerX: 0,
                        width: 1080,
                        var: "upgrade_box",
                        height: 600,
                        bottom: 160
                    },
                    compId: 136,
                    child: [{
                        type: "Image",
                        props: {
                            y: 315,
                            x: 186,
                            var: "coal_bg",
                            skin: "city/icon_city_rl.png",
                            mouseThrough: false,
                            anchorY: .5,
                            anchorX: .5
                        },
                        compId: 139,
                        child: [{
                            type: "Image",
                            props: {
                                y: 292,
                                x: 100,
                                skin: "city/txt_city_dj.png"
                            },
                            compId: 141,
                            child: [{
                                type: "FontClip",
                                props: {
                                    y: 0,
                                    x: 98,
                                    var: "coal_level",
                                    value: "12",
                                    skin: "nub/nub_4_0.png",
                                    sheet: "0123456789"
                                },
                                compId: 158
                            }]
                        }, {
                            type: "Image",
                            props: {
                                y: 338,
                                x: 86,
                                skin: "city/icon_city_jb.png",
                                scaleY: .6,
                                scaleX: .6
                            },
                            compId: 142,
                            child: [{
                                type: "Label",
                                props: {
                                    y: 14.5,
                                    x: 91,
                                    width: 198,
                                    var: "coal_cost",
                                    text: "123456",
                                    height: 32,
                                    fontSize: 60,
                                    color: "#fd1d19",
                                    bold: true
                                },
                                compId: 143
                            }]
                        }, {
                            type: "Sprite",
                            props: {
                                y: -102,
                                x: 65,
                                var: "coal_lv_up_tip",
                                texture: "city/om_city_sj.png"
                            },
                            compId: 145
                        }, {
                            type: "Sprite",
                            props: {
                                var: "coal_mask",
                                texture: "city/om_city_zz.png"
                            },
                            compId: 161
                        }, {
                            type: "Script",
                            props: {
                                runtime: "script/ui/ui_animation/ui_button_scale.ts"
                            },
                            compId: 169
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: 315,
                            x: 540,
                            var: "power_bg",
                            skin: "city/icon_city_dl.png",
                            mouseThrough: false,
                            centerX: 0,
                            anchorY: .5,
                            anchorX: .5
                        },
                        compId: 146,
                        child: [{
                            type: "Image",
                            props: {
                                y: 292,
                                x: 100,
                                skin: "city/txt_city_dj.png"
                            },
                            compId: 147,
                            child: [{
                                type: "FontClip",
                                props: {
                                    y: 0,
                                    x: 98,
                                    var: "power_level",
                                    value: "13",
                                    skin: "nub/nub_4_0.png",
                                    sheet: "0123456789"
                                },
                                compId: 159
                            }]
                        }, {
                            type: "Image",
                            props: {
                                y: 338,
                                x: 86,
                                skin: "city/icon_city_jb.png",
                                scaleY: .6,
                                scaleX: .6
                            },
                            compId: 149,
                            child: [{
                                type: "Label",
                                props: {
                                    y: 14.5,
                                    x: 91,
                                    width: 198,
                                    var: "power_cost",
                                    text: "123456",
                                    height: 32,
                                    fontSize: 60,
                                    color: "#1898ca",
                                    bold: true
                                },
                                compId: 150
                            }]
                        }, {
                            type: "Sprite",
                            props: {
                                y: -102,
                                x: 65,
                                var: "power_lv_up_tip",
                                texture: "city/om_city_sj.png"
                            },
                            compId: 151
                        }, {
                            type: "Sprite",
                            props: {
                                var: "power_mask",
                                texture: "city/om_city_zz.png"
                            },
                            compId: 162
                        }, {
                            type: "Script",
                            props: {
                                runtime: "script/ui/ui_animation/ui_button_scale.ts"
                            },
                            compId: 170
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: 315,
                            x: 894,
                            var: "offline_bg",
                            skin: "city/icon_city_lxsy.png",
                            mouseThrough: false,
                            anchorY: .5,
                            anchorX: .5
                        },
                        compId: 152,
                        child: [{
                            type: "Image",
                            props: {
                                y: 292,
                                x: 100,
                                skin: "city/txt_city_dj.png"
                            },
                            compId: 153,
                            child: [{
                                type: "FontClip",
                                props: {
                                    y: 0,
                                    x: 98,
                                    var: "offline_level",
                                    value: "12",
                                    skin: "nub/nub_4_0.png",
                                    sheet: "0123456789"
                                },
                                compId: 160
                            }]
                        }, {
                            type: "Image",
                            props: {
                                y: 338,
                                x: 86,
                                skin: "city/icon_city_jb.png",
                                scaleY: .6,
                                scaleX: .6
                            },
                            compId: 155,
                            child: [{
                                type: "Label",
                                props: {
                                    y: 14.5,
                                    x: 91,
                                    width: 198,
                                    var: "offline_cost",
                                    text: "123456",
                                    height: 32,
                                    fontSize: 60,
                                    color: "#ad4745",
                                    bold: true
                                },
                                compId: 156
                            }]
                        }, {
                            type: "Sprite",
                            props: {
                                y: -102,
                                x: 65,
                                var: "offline_lv_up_tip",
                                texture: "city/om_city_sj.png"
                            },
                            compId: 157
                        }, {
                            type: "Sprite",
                            props: {
                                var: "offline_mask",
                                texture: "city/om_city_zz.png"
                            },
                            compId: 163
                        }, {
                            type: "Script",
                            props: {
                                runtime: "script/ui/ui_animation/ui_button_scale.ts"
                            },
                            compId: 171
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: -100,
                            width: 339,
                            var: "startTips",
                            skin: "city/txt_city_djksyx.png",
                            scaleY: 1,
                            scaleX: 1,
                            pivotY: 20,
                            pivotX: 338,
                            name: "startTips",
                            height: 60,
                            centerX: 0
                        },
                        compId: 23
                    }, {
                        type: "Box",
                        props: {
                            y: -227,
                            x: 25,
                            width: 1080,
                            var: "luck_tips",
                            height: 62
                        },
                        compId: 178,
                        child: [{
                            type: "Image",
                            props: {
                                y: 0,
                                x: 310,
                                skin: "city/txt_city_jszt.png"
                            },
                            compId: 179
                        }, {
                            type: "Image",
                            props: {
                                y: -10,
                                x: 585,
                                var: "img_sand",
                                skin: "city/txt_city_smlc.png"
                            },
                            compId: 180
                        }, {
                            type: "FontClip",
                            props: {
                                y: -14.5,
                                var: "luck_level",
                                value: "20",
                                skin: "nub/nub_2_0.png",
                                sheet: "0123456789",
                                scaleY: .9,
                                scaleX: .9,
                                right: 774
                            },
                            compId: 182
                        }, {
                            type: "Image",
                            props: {
                                y: -4.5,
                                x: 586,
                                var: "img_snow",
                                skin: "city/txt_city_xglc.png"
                            },
                            compId: 183
                        }]
                    }]
                }, {
                    type: "Image",
                    props: {
                        y: 68,
                        width: 195,
                        var: "btn_clear",
                        skin: "city/box_city_jb.png",
                        right: 30,
                        height: 83,
                        sizeGrid: "0,40,0,39"
                    },
                    compId: 165,
                    child: [{
                        type: "Label",
                        props: {
                            y: 0,
                            x: 37.5,
                            text: "清理",
                            fontSize: 60
                        },
                        compId: 166
                    }]
                }],
                animations: [{
                    nodes: [{
                        target: 145,
                        keyframes: {
                            y: [{
                                value: -100,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 145,
                                key: "y",
                                index: 0
                            }, {
                                value: -118,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 145,
                                key: "y",
                                index: 10
                            }, {
                                value: -100,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 145,
                                label: null,
                                key: "y",
                                index: 20
                            }]
                        }
                    }],
                    name: "tip_ani",
                    id: 1,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [{
                        target: 151,
                        keyframes: {
                            y: [{
                                value: -102,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 151,
                                key: "y",
                                index: 0
                            }, {
                                value: -118,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 151,
                                key: "y",
                                index: 10
                            }, {
                                value: -102,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 151,
                                key: "y",
                                index: 20
                            }]
                        }
                    }],
                    name: "tip_ani_power",
                    id: 2,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [{
                        target: 157,
                        keyframes: {
                            y: [{
                                value: -102,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 157,
                                key: "y",
                                index: 0
                            }, {
                                value: -118,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 157,
                                key: "y",
                                index: 10
                            }, {
                                value: -102,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 157,
                                key: "y",
                                index: 20
                            }]
                        }
                    }],
                    name: "tip_ani_offline",
                    id: 3,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [{
                        target: 175,
                        keyframes: {
                            rotation: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 175,
                                key: "rotation",
                                index: 0
                            }, {
                                value: 30,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 175,
                                key: "rotation",
                                index: 15
                            }, {
                                value: -30,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 175,
                                key: "rotation",
                                index: 30
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 175,
                                key: "rotation",
                                index: 40
                            }]
                        }
                    }],
                    name: "ani4",
                    id: 4,
                    frameRate: 24,
                    action: 2
                }],
                loadList: ["city/box_city_jb.png", "city/icon_city_jb.png", "nub/nub_3_0.png", "city/txt_city_gq.png", "nub/nub_2_0.png", "city/om_city_xian.png", "denglu/om_city_logo.png", "city/bt_city_sy1.png", "city/bt_city_zd1.png", "city/om_yhz.png", "city/icon_city_rl.png", "city/txt_city_dj.png", "nub/nub_4_0.png", "city/om_city_sj.png", "city/om_city_zz.png", "city/icon_city_dl.png", "city/icon_city_lxsy.png", "city/txt_city_djksyx.png", "city/txt_city_jszt.png", "city/txt_city_smlc.png", "city/txt_city_xglc.png"],
                loadList3D: []
            };
            scenes.ui_mainUI = ui_mainUI;
            REG("ui.scenes.ui_mainUI", ui_mainUI);
            class ui_offlineUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_offlineUI.uiView);
                }
            }
            ui_offlineUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        top: -200,
                        skin: "common/om_common_zz.png",
                        scaleY: 1,
                        scaleX: 1,
                        right: -200,
                        pivotY: 960,
                        pivotX: 540,
                        name: "zhezhao",
                        left: -200,
                        bottom: -200,
                        sizeGrid: "21,20,12,18"
                    },
                    compId: 3
                }, {
                    type: "Box",
                    props: {
                        y: 342,
                        x: 0,
                        width: 1080,
                        height: 500,
                        centerX: 0
                    },
                    compId: 144,
                    child: [{
                        type: "Image",
                        props: {
                            y: 250,
                            x: 540,
                            var: "guang",
                            skin: "common/om_common_guang01.png",
                            rotation: 360,
                            centerY: 0,
                            centerX: 0,
                            anchorY: .5,
                            anchorX: .5
                        },
                        compId: 147
                    }, {
                        type: "Image",
                        props: {
                            skin: "common/om_common_guang02.png",
                            centerY: 53,
                            centerX: 24
                        },
                        compId: 148
                    }, {
                        type: "Image",
                        props: {
                            y: -25,
                            x: 287.5,
                            skin: "offline/om_offline_jb.png"
                        },
                        compId: 149
                    }, {
                        type: "Image",
                        props: {
                            y: -215,
                            skin: "offline/om_offline_bt.png",
                            centerX: 0
                        },
                        compId: 150
                    }]
                }, {
                    type: "Box",
                    props: {
                        width: 1080,
                        var: "buttom",
                        centerX: 0,
                        bottom: 420
                    },
                    compId: 138,
                    child: [{
                        type: "Image",
                        props: {
                            skin: "common/txt_common_nhdl.png",
                            centerX: 0
                        },
                        compId: 140
                    }, {
                        type: "Image",
                        props: {
                            y: 79,
                            x: 387.5,
                            skin: "city/icon_city_jb.png"
                        },
                        compId: 141
                    }, {
                        type: "FontClip",
                        props: {
                            y: 79,
                            x: 496,
                            var: "lb_reward",
                            value: "100",
                            skin: "nub/nub_2_0.png",
                            sheet: "0123456789"
                        },
                        compId: 142
                    }, {
                        type: "Image",
                        props: {
                            y: 350,
                            width: 574,
                            var: "btn_double",
                            skin: "common/bt_common_01.png",
                            scaleY: 1,
                            scaleX: 1,
                            height: 229,
                            centerX: 0,
                            anchorY: .5,
                            anchorX: .5
                        },
                        compId: 25,
                        child: [{
                            type: "Script",
                            props: {
                                runtime: "script/ui/ui_animation/ui_button_scale.ts"
                            },
                            compId: 133
                        }, {
                            type: "Script",
                            props: {
                                cur_sound_id: "9",
                                runtime: "script/ui/ui_animation/ui_sound.ts"
                            },
                            compId: 134
                        }, {
                            type: "Sprite",
                            props: {
                                y: 45,
                                x: 227,
                                texture: "common/txt_common_sb.png"
                            },
                            compId: 136
                        }, {
                            type: "Sprite",
                            props: {
                                y: 0,
                                x: 432,
                                texture: "common/om_common_sb.png"
                            },
                            compId: 143
                        }]
                    }]
                }, {
                    type: "Image",
                    props: {
                        x: 452,
                        var: "btn_one",
                        skin: "common/bt_common_dbsj.png",
                        scaleY: 1.3,
                        scaleX: 1.3,
                        centerX: 0,
                        bottom: 420
                    },
                    compId: 137
                }],
                animations: [{
                    nodes: [{
                        target: 102,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 45
                            }],
                            x: [{
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "x",
                                index: 0
                            }, {
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 45
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 45
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 46
                            }]
                        }
                    }, {
                        target: 96,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 0
                            }, {
                                value: 50.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 19
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "y",
                                index: 48
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "x",
                                index: 0
                            }, {
                                value: -67,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 19
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 48
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 19
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 48
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 49
                            }]
                        }
                    }, {
                        target: 112,
                        keyframes: {
                            y: [{
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "y",
                                index: 0
                            }, {
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 22
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 51
                            }],
                            x: [{
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "x",
                                index: 0
                            }, {
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 22
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 51
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 22
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 51
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 52
                            }]
                        }
                    }, {
                        target: 106,
                        keyframes: {
                            y: [{
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "y",
                                index: 0
                            }, {
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 41
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 41
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 41
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 42
                            }]
                        }
                    }, {
                        target: 105,
                        keyframes: {
                            y: [{
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 38
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 38
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 38
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 39
                            }]
                        }
                    }, {
                        target: 111,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 36
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 36
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 36
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 37
                            }]
                        }
                    }, {
                        target: 104,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 5
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 21
                            }],
                            x: [{
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "x",
                                index: 0
                            }, {
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 5
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 21
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 21
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 22
                            }]
                        }
                    }, {
                        target: 110,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 28
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 28
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 28
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 29
                            }]
                        }
                    }, {
                        target: 103,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 12
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "y",
                                index: 32
                            }],
                            x: [{
                                value: -106,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 12
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 32
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 12
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 32
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 33
                            }]
                        }
                    }, {
                        target: 109,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 34
                            }],
                            x: [{
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "x",
                                index: 0
                            }, {
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 34
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 34
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 35
                            }]
                        }
                    }, {
                        target: 101,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 7
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 23
                            }],
                            x: [{
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 7
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 23
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 7
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 23
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 24
                            }]
                        }
                    }, {
                        target: 108,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 13
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 33
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "x",
                                index: 0
                            }, {
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 13
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 33
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 13
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 33
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 34
                            }]
                        }
                    }, {
                        target: 107,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "y",
                                index: 10
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 24
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "x",
                                index: 10
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 24
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 10
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 24
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 25
                            }]
                        }
                    }],
                    name: "diamondAni",
                    id: 1,
                    frameRate: 30,
                    action: 0
                }, {
                    nodes: [{
                        target: 86,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 87,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni1",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 70,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 71,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni2",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 76,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 77,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni3",
                    id: 3,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 79,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 80,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni4",
                    id: 4,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [],
                    name: "doubleRewardAni",
                    id: 5,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [],
                    name: "quan",
                    id: 6,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [{
                        target: 147,
                        keyframes: {
                            rotation: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 0
                            }, {
                                value: 360,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 100
                            }],
                            centerX: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "centerX",
                                index: 100
                            }]
                        }
                    }],
                    name: "guang_rot",
                    id: 7,
                    frameRate: 10,
                    action: 2
                }],
                loadList: ["common/om_common_zz.png", "common/om_common_guang01.png", "common/om_common_guang02.png", "offline/om_offline_jb.png", "offline/om_offline_bt.png", "common/txt_common_nhdl.png", "city/icon_city_jb.png", "nub/nub_2_0.png", "common/bt_common_01.png", "common/txt_common_sb.png", "common/om_common_sb.png", "common/bt_common_dbsj.png"],
                loadList3D: []
            };
            scenes.ui_offlineUI = ui_offlineUI;
            REG("ui.scenes.ui_offlineUI", ui_offlineUI);
            class ui_private_viewUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_private_viewUI.uiView);
                }
            }
            ui_private_viewUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    mouseThrough: false,
                    mouseEnabled: true,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 2,
                child: [{
                    type: "Image",
                    props: {
                        y: 0,
                        x: 0,
                        top: 0,
                        skin: "common/zhezhao_bg_white.png",
                        sizeGrid: "10,6,6,8",
                        right: 0,
                        left: 0,
                        bottom: 0
                    },
                    compId: 7
                }, {
                    type: "Panel",
                    props: {
                        var: "mp_scroll_panel",
                        top: 40,
                        right: 40,
                        left: 40,
                        elasticEnabled: true,
                        bottom: 40
                    },
                    compId: 3,
                    child: [{
                        type: "Box",
                        props: {
                            width: 1080,
                            height: 3e3
                        },
                        compId: 4,
                        child: [{
                            type: "Label",
                            props: {
                                wordWrap: true,
                                width: 1e3,
                                top: 100,
                                text: "",
                                left: 0,
                                height: 3e3,
                                fontSize: 30
                            },
                            compId: 5
                        }, {
                            type: "Image",
                            props: {
                                y: 0,
                                x: 914,
                                var: "mp_btn_close",
                                skin: "city/bt_city_gb.png"
                            },
                            compId: 6
                        }]
                    }]
                }],
                loadList: ["common/zhezhao_bg_white.png", "city/bt_city_gb.png"],
                loadList3D: []
            };
            scenes.ui_private_viewUI = ui_private_viewUI;
            REG("ui.scenes.ui_private_viewUI", ui_private_viewUI);
            class ui_share_videoUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_share_videoUI.uiView);
                }
            }
            ui_share_videoUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        top: -200,
                        skin: "common/om_common_zz.png",
                        scaleY: 1,
                        scaleX: 1,
                        right: -200,
                        pivotY: 960,
                        pivotX: 540,
                        name: "zhezhao",
                        left: -200,
                        bottom: -200,
                        sizeGrid: "21,20,12,18"
                    },
                    compId: 3
                }, {
                    type: "Box",
                    props: {
                        width: 800,
                        height: 900,
                        centerY: 0,
                        centerX: 0
                    },
                    compId: 202,
                    child: [{
                        type: "Image",
                        props: {
                            width: 900,
                            var: "gold_box",
                            skin: "settlement/box_settlement_dk1.png",
                            sizeGrid: "68,78,148,91",
                            height: 1150,
                            centerY: -64,
                            centerX: 0
                        },
                        compId: 201,
                        child: [{
                            type: "Image",
                            props: {
                                y: -185,
                                x: 39,
                                var: "gold_title",
                                skin: "settlement/om_settlement_bt.png"
                            },
                            compId: 206,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "gold/txt_settlement_cjfl.png",
                                    centerY: 35,
                                    centerX: -26
                                },
                                compId: 207
                            }, {
                                type: "Image",
                                props: {
                                    y: 933,
                                    x: 197,
                                    var: "gold_desc",
                                    skin: "settlement/txt_settlement_tips.png",
                                    centerX: 0
                                },
                                compId: 215
                            }]
                        }, {
                            type: "Image",
                            props: {
                                y: 102,
                                x: 234,
                                var: "gold",
                                skin: "settlement/om_settlement_hb.png",
                                centerX: 0
                            },
                            compId: 204,
                            child: [{
                                type: "Image",
                                props: {
                                    y: 39,
                                    x: -148,
                                    skin: "settlement/om_settlement_fcjb.png",
                                    centerX: -300
                                },
                                compId: 212
                            }, {
                                type: "Image",
                                props: {
                                    y: 39,
                                    x: 581,
                                    skin: "settlement/om_settlement_fcjb.png",
                                    scaleX: -1,
                                    centerX: 300
                                },
                                compId: 213
                            }]
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: -189,
                            x: -50,
                            width: 900,
                            var: "env_box",
                            skin: "settlement/box_skin_01.png",
                            sizeGrid: "68,78,148,91",
                            height: 1150,
                            centerY: -64,
                            centerX: 0
                        },
                        compId: 222,
                        child: [{
                            type: "Image",
                            props: {
                                y: -70,
                                x: 137,
                                var: "env_title",
                                skin: "settlement/om_skin_xdlc.png"
                            },
                            compId: 220
                        }, {
                            type: "Image",
                            props: {
                                y: 144,
                                x: 51,
                                var: "icon_snow",
                                skin: "settlement/bg_skin_02.png"
                            },
                            compId: 216
                        }, {
                            type: "Image",
                            props: {
                                y: 144,
                                x: 51,
                                var: "icon_sand",
                                skin: "settlement/bg_skin_01.png"
                            },
                            compId: 223
                        }, {
                            type: "Image",
                            props: {
                                y: 745,
                                x: 240,
                                var: "env_desc",
                                skin: "settlement/txt_skin_jszt.png"
                            },
                            compId: 217,
                            child: [{
                                type: "Image",
                                props: {
                                    y: -5,
                                    x: 195,
                                    var: "txt_sand",
                                    skin: "city/txt_city_smlc.png"
                                },
                                compId: 218
                            }, {
                                type: "Image",
                                props: {
                                    y: -5,
                                    x: 195,
                                    var: "txt_snow",
                                    skin: "city/txt_city_xglc.png"
                                },
                                compId: 219
                            }]
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: 645,
                            var: "btn_video",
                            skin: "settlement/bt_settlement_fxlp2.png",
                            centerX: 0
                        },
                        compId: 208,
                        child: [{
                            type: "Image",
                            props: {
                                x: 223,
                                skin: "settlement/txt_settlement_fblp.png",
                                centerY: -16
                            },
                            compId: 211
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: -155,
                            x: 752,
                            var: "btn_close",
                            skin: "settlement/bt_settlement_gb.png"
                        },
                        compId: 214
                    }]
                }],
                animations: [{
                    nodes: [{
                        target: 102,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 45
                            }],
                            x: [{
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "x",
                                index: 0
                            }, {
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 45
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 45
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 46
                            }]
                        }
                    }, {
                        target: 96,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 0
                            }, {
                                value: 50.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 19
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "y",
                                index: 48
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "x",
                                index: 0
                            }, {
                                value: -67,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 19
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 48
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 19
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 48
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 49
                            }]
                        }
                    }, {
                        target: 112,
                        keyframes: {
                            y: [{
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "y",
                                index: 0
                            }, {
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 22
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 51
                            }],
                            x: [{
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "x",
                                index: 0
                            }, {
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 22
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 51
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 22
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 51
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 52
                            }]
                        }
                    }, {
                        target: 106,
                        keyframes: {
                            y: [{
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "y",
                                index: 0
                            }, {
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 41
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 41
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 41
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 42
                            }]
                        }
                    }, {
                        target: 105,
                        keyframes: {
                            y: [{
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 38
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 38
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 38
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 39
                            }]
                        }
                    }, {
                        target: 111,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 36
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 36
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 36
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 37
                            }]
                        }
                    }, {
                        target: 104,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 5
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 21
                            }],
                            x: [{
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "x",
                                index: 0
                            }, {
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 5
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 21
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 21
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 22
                            }]
                        }
                    }, {
                        target: 110,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 28
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 28
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 28
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 29
                            }]
                        }
                    }, {
                        target: 103,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 12
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "y",
                                index: 32
                            }],
                            x: [{
                                value: -106,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 12
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 32
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 12
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 32
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 33
                            }]
                        }
                    }, {
                        target: 109,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 34
                            }],
                            x: [{
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "x",
                                index: 0
                            }, {
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 34
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 34
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 35
                            }]
                        }
                    }, {
                        target: 101,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 7
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 23
                            }],
                            x: [{
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 7
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 23
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 7
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 23
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 24
                            }]
                        }
                    }, {
                        target: 108,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 13
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 33
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "x",
                                index: 0
                            }, {
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 13
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 33
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 13
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 33
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 34
                            }]
                        }
                    }, {
                        target: 107,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "y",
                                index: 10
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 24
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "x",
                                index: 10
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 24
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 10
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 24
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 25
                            }]
                        }
                    }],
                    name: "diamondAni",
                    id: 1,
                    frameRate: 30,
                    action: 0
                }, {
                    nodes: [{
                        target: 86,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 87,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni1",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 70,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 71,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni2",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 76,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 77,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni3",
                    id: 3,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 79,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 80,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni4",
                    id: 4,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [],
                    name: "doubleRewardAni",
                    id: 5,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [],
                    name: "quan",
                    id: 6,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [{
                        target: 147,
                        keyframes: {
                            rotation: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 0
                            }, {
                                value: 360,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 90
                            }]
                        }
                    }],
                    name: "guang_rot",
                    id: 7,
                    frameRate: 10,
                    action: 2
                }],
                loadList: ["common/om_common_zz.png", "settlement/box_settlement_dk1.png", "settlement/om_settlement_bt.png", "gold/txt_settlement_cjfl.png", "settlement/txt_settlement_tips.png", "settlement/om_settlement_hb.png", "settlement/om_settlement_fcjb.png", "settlement/box_skin_01.png", "settlement/om_skin_xdlc.png", "settlement/bg_skin_02.png", "settlement/bg_skin_01.png", "settlement/txt_skin_jszt.png", "city/txt_city_smlc.png", "city/txt_city_xglc.png", "settlement/bt_settlement_fxlp2.png", "settlement/txt_settlement_fblp.png", "settlement/bt_settlement_gb.png"],
                loadList3D: []
            };
            scenes.ui_share_videoUI = ui_share_videoUI;
            REG("ui.scenes.ui_share_videoUI", ui_share_videoUI);
            class ui_successUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_successUI.uiView);
                }
            }
            ui_successUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                        type: "Image",
                        props: {
                            top: -200,
                            skin: "common/om_common_zz.png",
                            scaleY: 1,
                            scaleX: 1,
                            right: -200,
                            pivotY: 960,
                            pivotX: 540,
                            name: "zhezhao",
                            left: -200,
                            bottom: -200,
                            sizeGrid: "21,20,12,18"
                        },
                        compId: 3
                    }, {
                        type: "Box",
                        props: {
                            centerX: 0,
                            width: 1080,
                            var: "top_view",
                            height: 500,
                            centerY: -400
                        },
                        compId: 144,
                        child: [{
                            type: "Image",
                            props: {
                                var: "guang",
                                skin: "common/om_common_guang01.png",
                                centerY: -47,
                                centerX: 0,
                                anchorY: .5,
                                anchorX: .5
                            },
                            compId: 147
                        }, {
                            type: "Image",
                            props: {
                                skin: "common/om_common_guang02.png",
                                centerY: 53,
                                centerX: 24
                            },
                            compId: 148
                        }, {
                            type: "Image",
                            props: {
                                x: 196,
                                skin: "settlement/om_settlement_gqwc.png",
                                centerY: 0,
                                centerX: 0
                            },
                            compId: 135
                        }]
                    }, {
                        type: "Image",
                        props: {
                            var: "multual_push_layout",
                            top: 0,
                            right: 0,
                            left: 0,
                            bottom: 0
                        },
                        compId: 201
                    }, {
                        type: "Image",
                        props: {
                            y: 0,
                            x: 0,
                            var: "dnsdk_layout",
                            top: 0,
                            right: 0,
                            left: 0,
                            bottom: 0
                        },
                        compId: 379
                    }, {
                        type: "Box",
                        props: {
                            centerX: 0,
                            width: 1080,
                            var: "buttom_view",
                            height: 600,
                            centerX: 0,
                            bottom: 330
                        },
                        compId: 138,
                        child: [{
                            type: "Image",
                            props: {
                                y: 105.5,
                                skin: "common/txt_common_nhdl.png",
                                centerX: -166
                            },
                            compId: 140
                        }, {
                            type: "Image",
                            props: {
                                y: 87,
                                x: 499.5,
                                skin: "city/icon_city_jb.png"
                            },
                            compId: 141
                        }, {
                            type: "FontClip",
                            props: {
                                y: 93,
                                x: 605,
                                var: "lb_reward",
                                value: "100",
                                skin: "nub/nub_2_0.png",
                                sheet: "0123456789"
                            },
                            compId: 142
                        }, {
                            type: "Image",
                            props: {
                                width: 574,
                                var: "btn_double",
                                skin: "common/bt_common_01.png",
                                scaleY: 1,
                                scaleX: 1,
                                height: 229,
                                centerY: 150,
                                centerX: 0,
                                anchorY: .5,
                                anchorX: .5
                            },
                            compId: 25,
                            child: [{
                                type: "Script",
                                props: {
                                    runtime: "script/ui/ui_animation/ui_button_scale.ts"
                                },
                                compId: 133
                            }, {
                                type: "Script",
                                props: {
                                    cur_sound_id: "9",
                                    runtime: "script/ui/ui_animation/ui_sound.ts"
                                },
                                compId: 134
                            }, {
                                type: "Sprite",
                                props: {
                                    y: 45,
                                    x: 227,
                                    texture: "common/txt_common_wb.png"
                                },
                                compId: 136
                            }, {
                                type: "Sprite",
                                props: {
                                    y: 0,
                                    x: 432,
                                    texture: "common/om_common_wb.png"
                                },
                                compId: 143
                            }]
                        }, {
                            type: "Image",
                            props: {
                                y: 245,
                                x: 859,
                                var: "btn_share_video",
                                skin: "settlement/bt_settlement_fxlp1.png"
                            },
                            compId: 202
                        }, {
                            type: "Image",
                            props: {
                                y: 220,
                                var: "btn_continue",
                                skin: "common/bt_common_03.png",
                                centerX: 0
                            },
                            compId: 204,
                            child: [{
                                type: "Image",
                                props: {
                                    skin: "yuansheng/txt_common_jxtz.png",
                                    centerY: 0,
                                    centerX: 0
                                },
                                compId: 205
                            }]
                        }]
                    }, {
                        type: "Image",
                        props: {
                            x: 452,
                            var: "btn_one",
                            skin: "common/bt_common_dbsj.png",
                            scaleY: 1.3,
                            scaleX: 1.3,
                            centerX: 0,
                            bottom: 300
                        },
                        compId: 137
                    },
                    {
                        "x": 15,
                        "type": "List",
                        "searchKey": "List,list_showA",
                        "props": {
                            "y": 1599,
                            "x": 90,
                            "width": 899,
                            "var": "list_showA",
                            "height": 198
                        },
                        "nodeParent": 1,
                        "label": "list_showA",
                        "isOpen": true,
                        "isDirectory": true,
                        "isAniNode": true,
                        "hasChild": true,
                        "compId": 380,
                        "child": [{
                            "x": 30,
                            "type": "Box",
                            "searchKey": "Box",
                            "props": {
                                "renderType": "render"
                            },
                            "nodeParent": 380,
                            "label": "Box",
                            "isOpen": true,
                            "isDirectory": true,
                            "isAniNode": false,
                            "hasChild": true,
                            "compId": 381,
                            "child": [{
                                "x": 45,
                                "type": "Image",
                                "searchKey": "Image,thumb",
                                "props": {
                                    "width": 300,
                                    "name": "thumb",
                                    "height": 200
                                },
                                "nodeParent": 381,
                                "label": "thumb",
                                "isDirectory": false,
                                "isAniNode": false,
                                "hasChild": false,
                                "compId": 382,
                                "child": []
                            }]
                        }]
                    }
                ],
                animations: [{
                    nodes: [{
                        target: 102,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 45
                            }],
                            x: [{
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "x",
                                index: 0
                            }, {
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 45
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 45
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 46
                            }]
                        }
                    }, {
                        target: 96,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 0
                            }, {
                                value: 50.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 19
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "y",
                                index: 48
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "x",
                                index: 0
                            }, {
                                value: -67,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 19
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 48
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 19
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 48
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 49
                            }]
                        }
                    }, {
                        target: 112,
                        keyframes: {
                            y: [{
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "y",
                                index: 0
                            }, {
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 22
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 51
                            }],
                            x: [{
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "x",
                                index: 0
                            }, {
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 22
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 51
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 22
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 51
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 52
                            }]
                        }
                    }, {
                        target: 106,
                        keyframes: {
                            y: [{
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "y",
                                index: 0
                            }, {
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 41
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 41
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 41
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 42
                            }]
                        }
                    }, {
                        target: 105,
                        keyframes: {
                            y: [{
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 38
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 38
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 38
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 39
                            }]
                        }
                    }, {
                        target: 111,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 36
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 36
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 36
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 37
                            }]
                        }
                    }, {
                        target: 104,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 5
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 21
                            }],
                            x: [{
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "x",
                                index: 0
                            }, {
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 5
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 21
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 21
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 22
                            }]
                        }
                    }, {
                        target: 110,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 28
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 28
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 28
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 29
                            }]
                        }
                    }, {
                        target: 103,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 12
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "y",
                                index: 32
                            }],
                            x: [{
                                value: -106,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 12
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 32
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 12
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 32
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 33
                            }]
                        }
                    }, {
                        target: 109,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 34
                            }],
                            x: [{
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "x",
                                index: 0
                            }, {
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 34
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 34
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 35
                            }]
                        }
                    }, {
                        target: 101,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 7
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 23
                            }],
                            x: [{
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 7
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 23
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 7
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 23
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 24
                            }]
                        }
                    }, {
                        target: 108,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 13
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 33
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "x",
                                index: 0
                            }, {
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 13
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 33
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 13
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 33
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 34
                            }]
                        }
                    }, {
                        target: 107,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "y",
                                index: 10
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 24
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "x",
                                index: 10
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 24
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 10
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 24
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 25
                            }]
                        }
                    }],
                    name: "diamondAni",
                    id: 1,
                    frameRate: 30,
                    action: 0
                }, {
                    nodes: [{
                        target: 86,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 87,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni1",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 70,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 71,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni2",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 76,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 77,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni3",
                    id: 3,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 79,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 80,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni4",
                    id: 4,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [],
                    name: "doubleRewardAni",
                    id: 5,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [],
                    name: "quan",
                    id: 6,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [{
                        target: 147,
                        keyframes: {
                            rotation: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 0
                            }, {
                                value: 360,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 90
                            }]
                        }
                    }],
                    name: "guang_rot",
                    id: 7,
                    frameRate: 10,
                    action: 2
                }],
                loadList: ["common/om_common_zz.png", "common/om_common_guang01.png", "common/om_common_guang02.png", "settlement/om_settlement_gqwc.png", "common/txt_common_nhdl.png", "city/icon_city_jb.png", "nub/nub_2_0.png", "common/bt_common_01.png", "common/txt_common_wb.png", "common/om_common_wb.png", "settlement/bt_settlement_fxlp1.png", "common/bt_common_03.png", "yuansheng/txt_common_jxtz.png", "common/bt_common_dbsj.png"],
                loadList3D: []
            };
            scenes.ui_successUI = ui_successUI;
            REG("ui.scenes.ui_successUI", ui_successUI);
            class ui_supplyUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_supplyUI.uiView);
                }
            }
            ui_supplyUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Image",
                    props: {
                        top: -200,
                        skin: "common/om_common_zz.png",
                        scaleY: 1,
                        scaleX: 1,
                        right: -200,
                        pivotY: 960,
                        pivotX: 540,
                        name: "zhezhao",
                        left: -200,
                        bottom: -200,
                        sizeGrid: "21,20,12,18"
                    },
                    compId: 3
                }, {
                    type: "Box",
                    props: {
                        width: 800,
                        height: 900,
                        centerY: -70,
                        centerX: 0
                    },
                    compId: 202,
                    child: [{
                        type: "Image",
                        props: {
                            width: 900,
                            skin: "settlement/box_settlement_dk1.png",
                            sizeGrid: "65,48,131,41",
                            height: 1150,
                            centerY: -64,
                            centerX: 0
                        },
                        compId: 201
                    }, {
                        type: "Image",
                        props: {
                            y: -310,
                            skin: "gold/om_gold_guang.png",
                            centerX: 0
                        },
                        compId: 203
                    }, {
                        type: "Image",
                        props: {
                            y: -87,
                            skin: "offline/om_offline_jb.png",
                            centerX: 0
                        },
                        compId: 204
                    }, {
                        type: "Image",
                        props: {
                            y: -374,
                            skin: "settlement/om_settlement_bt.png",
                            centerX: 0
                        },
                        compId: 206,
                        child: [{
                            type: "Image",
                            props: {
                                skin: "gold/txt_gold_bcjb.png",
                                centerY: 39,
                                centerX: -16
                            },
                            compId: 207
                        }]
                    }, {
                        type: "Image",
                        props: {
                            y: 605,
                            var: "btn_video",
                            skin: "gold/bt_gold_mflq.png",
                            centerX: 0
                        },
                        compId: 208
                    }, {
                        type: "FontClip",
                        props: {
                            y: 450,
                            var: "lb_gold",
                            value: "69541",
                            skin: "nub/nub_2_0.png",
                            sheet: "0123456789",
                            centerX: 0
                        },
                        compId: 210
                    }]
                }, {
                    type: "Image",
                    props: {
                        var: "btn_cancel",
                        skin: "gold/bt_gold_crjj.png",
                        scaleY: 1.3,
                        scaleX: 1.3,
                        centerX: 0,
                        bottom: 420
                    },
                    compId: 209
                }],
                animations: [{
                    nodes: [{
                        target: 102,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "y",
                                index: 45
                            }],
                            x: [{
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "x",
                                index: 0
                            }, {
                                value: -141,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                label: null,
                                key: "x",
                                index: 45
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 45
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 102,
                                key: "alpha",
                                index: 46
                            }]
                        }
                    }, {
                        target: 96,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 0
                            }, {
                                value: 50.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "y",
                                index: 19
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "y",
                                index: 48
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "x",
                                index: 0
                            }, {
                                value: -67,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 19
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                label: null,
                                key: "x",
                                index: 48
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 19
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 48
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 96,
                                key: "alpha",
                                index: 49
                            }]
                        }
                    }, {
                        target: 112,
                        keyframes: {
                            y: [{
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "y",
                                index: 0
                            }, {
                                value: 101,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 22
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "y",
                                index: 51
                            }],
                            x: [{
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "x",
                                index: 0
                            }, {
                                value: -153,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 22
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                label: null,
                                key: "x",
                                index: 51
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 22
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 51
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 112,
                                key: "alpha",
                                index: 52
                            }]
                        }
                    }, {
                        target: 106,
                        keyframes: {
                            y: [{
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "y",
                                index: 0
                            }, {
                                value: 116,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 17
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "y",
                                index: 41
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 17
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                label: null,
                                key: "x",
                                index: 41
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 17
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 41
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 106,
                                key: "alpha",
                                index: 42
                            }]
                        }
                    }, {
                        target: 105,
                        keyframes: {
                            y: [{
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "y",
                                index: 38
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                label: null,
                                key: "x",
                                index: 38
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 38
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 105,
                                key: "alpha",
                                index: 39
                            }]
                        }
                    }, {
                        target: 111,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "y",
                                index: 36
                            }],
                            x: [{
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "x",
                                index: 0
                            }, {
                                value: -94,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                label: null,
                                key: "x",
                                index: 36
                            }],
                            alpha: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 36
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 111,
                                key: "alpha",
                                index: 37
                            }]
                        }
                    }, {
                        target: 104,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 5
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "y",
                                index: 21
                            }],
                            x: [{
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "x",
                                index: 0
                            }, {
                                value: -79,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 5
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                label: null,
                                key: "x",
                                index: 21
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 5
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 21
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 104,
                                key: "alpha",
                                index: 22
                            }]
                        }
                    }, {
                        target: 110,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 11
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "y",
                                index: 28
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 11
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                label: null,
                                key: "x",
                                index: 28
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 11
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 28
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 110,
                                key: "alpha",
                                index: 29
                            }]
                        }
                    }, {
                        target: 103,
                        keyframes: {
                            y: [{
                                value: 83,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 0
                            }, {
                                value: 41.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "y",
                                index: 12
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "y",
                                index: 32
                            }],
                            x: [{
                                value: -106,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 12
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                label: null,
                                key: "x",
                                index: 32
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 12
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 32
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 103,
                                key: "alpha",
                                index: 33
                            }]
                        }
                    }, {
                        target: 109,
                        keyframes: {
                            y: [{
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "y",
                                index: 0
                            }, {
                                value: 74.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 14
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "y",
                                index: 34
                            }],
                            x: [{
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "x",
                                index: 0
                            }, {
                                value: -161,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 14
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                label: null,
                                key: "x",
                                index: 34
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 14
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 34
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 109,
                                key: "alpha",
                                index: 35
                            }]
                        }
                    }, {
                        target: 101,
                        keyframes: {
                            y: [{
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "y",
                                index: 0
                            }, {
                                value: 92,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 7
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "y",
                                index: 23
                            }],
                            x: [{
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "x",
                                index: 0
                            }, {
                                value: -126,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 7
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                label: null,
                                key: "x",
                                index: 23
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 7
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 23
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 101,
                                key: "alpha",
                                index: 24
                            }]
                        }
                    }, {
                        target: 108,
                        keyframes: {
                            y: [{
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "y",
                                index: 0
                            }, {
                                value: 33,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 13
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "y",
                                index: 33
                            }],
                            x: [{
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "x",
                                index: 0
                            }, {
                                value: -59,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 13
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                label: null,
                                key: "x",
                                index: 33
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 13
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 33
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 108,
                                key: "alpha",
                                index: 34
                            }]
                        }
                    }, {
                        target: 107,
                        keyframes: {
                            y: [{
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 0
                            }, {
                                value: 59.5,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "y",
                                index: 10
                            }, {
                                value: -1098,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "y",
                                index: 24
                            }],
                            x: [{
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 0
                            }, {
                                value: -114,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                label: null,
                                key: "x",
                                index: 10
                            }, {
                                value: -429,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "x",
                                index: 24
                            }],
                            alpha: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 10
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 24
                            }, {
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 107,
                                key: "alpha",
                                index: 25
                            }]
                        }
                    }],
                    name: "diamondAni",
                    id: 1,
                    frameRate: 30,
                    action: 0
                }, {
                    nodes: [{
                        target: 86,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 86,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 87,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 87,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 87,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni1",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 70,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 70,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 71,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 71,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 71,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni2",
                    id: 2,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 76,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 76,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 77,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 77,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 77,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni3",
                    id: 3,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [{
                        target: 79,
                        keyframes: {
                            scaleY: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleY",
                                index: 15
                            }],
                            scaleX: [{
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 79,
                                key: "scaleX",
                                index: 15
                            }]
                        }
                    }, {
                        target: 80,
                        keyframes: {
                            visible: [{
                                value: false,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 0
                            }, {
                                value: true,
                                tweenMethod: "linearNone",
                                tween: false,
                                target: 80,
                                key: "visible",
                                index: 15
                            }],
                            scaleY: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleY",
                                index: 30
                            }],
                            scaleX: [{
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 0
                            }, {
                                value: .2,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 15
                            }, {
                                value: 1,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 80,
                                key: "scaleX",
                                index: 30
                            }]
                        }
                    }],
                    name: "passAni4",
                    id: 4,
                    frameRate: 24,
                    action: 0
                }, {
                    nodes: [],
                    name: "doubleRewardAni",
                    id: 5,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [],
                    name: "quan",
                    id: 6,
                    frameRate: 24,
                    action: 2
                }, {
                    nodes: [{
                        target: 147,
                        keyframes: {
                            rotation: [{
                                value: 0,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 0
                            }, {
                                value: 360,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 147,
                                key: "rotation",
                                index: 90
                            }]
                        }
                    }],
                    name: "guang_rot",
                    id: 7,
                    frameRate: 10,
                    action: 2
                }],
                loadList: ["common/om_common_zz.png", "settlement/box_settlement_dk1.png", "gold/om_gold_guang.png", "offline/om_offline_jb.png", "settlement/om_settlement_bt.png", "gold/txt_gold_bcjb.png", "gold/bt_gold_mflq.png", "nub/nub_2_0.png", "gold/bt_gold_crjj.png"],
                loadList3D: []
            };
            scenes.ui_supplyUI = ui_supplyUI;
            REG("ui.scenes.ui_supplyUI", ui_supplyUI);
            class ui_toastUI extends Laya.Scene {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_toastUI.uiView);
                }
            }
            ui_toastUI.uiView = {
                type: "Scene",
                props: {
                    width: 1080,
                    height: 1920
                },
                compId: 2,
                child: [{
                    type: "Image",
                    props: {
                        y: 814,
                        x: 540,
                        width: 300,
                        var: "mp_img_bg",
                        skin: "common/toast.png",
                        sizeGrid: "40,113,43,124",
                        height: 120,
                        anchorY: .5,
                        anchorX: .5
                    },
                    compId: 3,
                    child: [{
                        type: "Label",
                        props: {
                            y: 60,
                            x: 150,
                            var: "mp_label_desc",
                            text: "label",
                            fontSize: 50,
                            color: "#ffffff",
                            anchorY: .5,
                            anchorX: .5
                        },
                        compId: 4
                    }]
                }],
                loadList: ["common/toast.png"],
                loadList3D: []
            };
            scenes.ui_toastUI = ui_toastUI;
            REG("ui.scenes.ui_toastUI", ui_toastUI);
            class ui_tt_guess_likeUI extends Laya.View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(ui_tt_guess_likeUI.uiView);
                }
            }
            ui_tt_guess_likeUI.uiView = {
                type: "View",
                props: {
                    width: 1080,
                    top: 0,
                    right: 0,
                    mouseThrough: true,
                    left: 0,
                    height: 1920,
                    bottom: 0
                },
                compId: 1,
                child: [{
                    type: "Box",
                    props: {
                        var: "hGuessLikeRoot",
                        top: 750,
                        name: "hGuessLikeRoot",
                        centerX: 0
                    },
                    compId: 57,
                    child: [{
                        type: "Image",
                        props: {
                            width: 998,
                            skin: "multual_push/box_hutui_01.png",
                            sizeGrid: "22,70,26,107",
                            name: "bg",
                            height: 308
                        },
                        compId: 56,
                        child: [{
                            type: "Sprite",
                            props: {
                                y: 61.5,
                                x: 27,
                                texture: "multual_push/txt_hutui_cnxh.png",
                                name: "title"
                            },
                            compId: 58
                        }, {
                            type: "Panel",
                            props: {
                                y: 12,
                                x: 105,
                                width: 836,
                                var: "hGuessLikePanel",
                                name: "hGuessLikePanel",
                                height: 291
                            },
                            compId: 59,
                            child: [{
                                type: "HBox",
                                props: {
                                    y: 0,
                                    x: 0,
                                    space: 20,
                                    align: "middle"
                                },
                                compId: 78,
                                child: [{
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 0,
                                        name: "game1"
                                    },
                                    compId: 65,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 66,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 67
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高1",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 68
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 226,
                                        name: "game2"
                                    },
                                    compId: 69,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 70,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 71
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高2",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 72
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 441,
                                        name: "game3"
                                    },
                                    compId: 73,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 74,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 75
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高3",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 76
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 654,
                                        name: "game4"
                                    },
                                    compId: 79,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 80,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 81
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高4",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 82
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 869,
                                        name: "game5"
                                    },
                                    compId: 64,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 61,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 62
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 63
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 10,
                                        x: 971,
                                        name: "game6"
                                    },
                                    compId: 83,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 84,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 85
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 86
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 5,
                                        x: 1080,
                                        name: "game7"
                                    },
                                    compId: 87,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 88,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 89
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 90
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 5,
                                        x: 1226,
                                        name: "game8"
                                    },
                                    compId: 91,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 92,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 93
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 94
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 17,
                                        x: 1380,
                                        name: "game9"
                                    },
                                    compId: 95,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_03.png",
                                            name: "bg"
                                        },
                                        compId: 96,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 97
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 98
                                        }]
                                    }]
                                }, {
                                    type: "Box",
                                    props: {
                                        y: 17,
                                        x: 1532,
                                        name: "game10"
                                    },
                                    compId: 99,
                                    child: [{
                                        type: "Image",
                                        props: {
                                            skin: "multual_push/box_hutui_04.png",
                                            name: "bg"
                                        },
                                        compId: 100,
                                        child: [{
                                            type: "Image",
                                            props: {
                                                y: 24,
                                                x: 20.5,
                                                width: 163,
                                                name: "gameIcon",
                                                height: 163
                                            },
                                            compId: 101
                                        }, {
                                            type: "Label",
                                            props: {
                                                y: 223,
                                                x: 102,
                                                text: "明星篮球高5",
                                                name: "name",
                                                fontSize: 32,
                                                color: "#ffffff",
                                                anchorY: .5,
                                                anchorX: .5,
                                                align: "center"
                                            },
                                            compId: 102
                                        }]
                                    }]
                                }]
                            }]
                        }]
                    }]
                }],
                animations: [{
                    nodes: [{
                        target: 4,
                        keyframes: {
                            x: [{
                                value: 528,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 4,
                                key: "x",
                                index: 0
                            }, {
                                value: 538,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 4,
                                key: "x",
                                index: 10
                            }, {
                                value: 528,
                                tweenMethod: "linearNone",
                                tween: true,
                                target: 4,
                                key: "x",
                                index: 20
                            }]
                        }
                    }],
                    name: "ani4",
                    id: 4,
                    frameRate: 24,
                    action: 2
                }],
                loadList: ["multual_push/box_hutui_01.png", "multual_push/txt_hutui_cnxh.png", "multual_push/box_hutui_03.png", "multual_push/box_hutui_04.png"],
                loadList3D: []
            };
            scenes.ui_tt_guess_likeUI = ui_tt_guess_likeUI;
            REG("ui.scenes.ui_tt_guess_likeUI", ui_tt_guess_likeUI);
        })(scenes = ui.scenes || (ui.scenes = {}));
    })(ui || (ui = {}));
    class ui_animation_base extends Laya.Script {
        constructor() {
            super();
            this.had_init_time_line = false;
        }
        set owner(value) {
            this.this_sprite = value;
            igc.igc_timer.frameOnce(1, this, this.init_anim);
        }
        get owner() {
            return {};
        }
        init_anim() {
            if (this.play_type != "during") this.loop = false;
            var node;
            node = this.this_sprite;
            let is_view = node instanceof Laya.View;
            while (!is_view) {
                if (node == undefined) return;
                node = node.parent;
                is_view = node instanceof Laya.View;
            }
            var type = ui_animation_type.open;
            switch (this.play_type) {
                case "open":
                    type = ui_animation_type.open;
                    break;

                case "close":
                    type = ui_animation_type.close;
                    break;

                case "during":
                    type = ui_animation_type.during;
                    this.this_sprite.on(ui_animation_base.ui_anim_event.play_during_anim, this, this.play_anim);
                    this.this_sprite.on(ui_animation_base.ui_anim_event.end_during_anim, this, this.end_anim);
                    this.this_sprite.on(ui_animation_base.ui_anim_event.reset_rotation_to_zero, this, this.reset_rotation_to_zero);
                    break;

                case "click":
                    type = ui_animation_type.click;
                    this.this_sprite.on(Laya.Event.CLICK, this, this.play_anim);
                    break;

                case "appear":
                    type = ui_animation_type.appear;
                    this.this_sprite.on(ui_animation_base.ui_anim_event.play_appear_anim, this, this.play_anim);
                    break;

                case "disappear":
                    type = ui_animation_type.disappear;
                    this.this_sprite.on(ui_animation_base.ui_anim_event.play_disappear_anim, this, () => {
                        this.this_sprite.event(ui_animation_base.ui_anim_event.end_during_anim);
                        this.this_sprite.visible = true;
                        this.play_anim();
                    });
                    break;

                case "code_control_1":
                    type = ui_animation_type.code_control1;
                    this.this_sprite.on(ui_animation_base.ui_anim_event.play_anim_1, this, this.play_anim);
                    break;

                case "code_control_2":
                    type = ui_animation_type.code_control2;
                    this.this_sprite.on(ui_animation_base.ui_anim_event.play_anim_2, this, this.play_anim);
                    break;

                default:
                    break;
            }
            igc.broadcast_manager.instance.broadcast(broadcast_ids.add_anim_node, {
                win_type: window_type.ui_main,
                type: type,
                animNode: this
            });
        }
        get playTime() {
            this.line_1_time = this.line_1_time ? this.line_1_time : 0;
            this.line_2_time = this.line_2_time ? this.line_2_time : 0;
            this.line_3_time = this.line_3_time ? this.line_3_time : 0;
            this.line_4_time = this.line_4_time ? this.line_4_time : 0;
            this.line_1_delay = this.line_1_delay ? this.line_1_delay : 0;
            this.line_2_delay = this.line_2_delay ? this.line_2_delay : 0;
            this.line_3_delay = this.line_3_delay ? this.line_3_delay : 0;
            this.line_4_delay = this.line_4_delay ? this.line_4_delay : 0;
            return this.line_1_time + this.line_2_time + this.line_3_time + this.line_4_time + this.line_1_delay + this.line_2_delay + this.line_3_delay + this.line_4_delay;
        }
        play_anim(type) {
            if (!this.had_init_time_line) {
                this.set_time_line();
                this.had_init_time_line = true;
            }
            if (this.time_line != undefined) {
                this.reset();
                if (this.play_type != "during" && this.play_type != "open" && this.play_type != "close") {
                    this.this_sprite.event(ui_animation_base.ui_anim_event.end_during_anim);
                }
                this.time_line.play(0, this.loop);
                if (this.play_type === "appear") {
                    this.time_line.once(Laya.Event.COMPLETE, this, () => {
                        this.this_sprite.event(ui_animation_base.ui_anim_event.play_during_anim);
                        this.this_sprite.event(ui_animation_base.ui_anim_event.appear_anim_complete);
                    });
                }
                if (this.play_type === "click") {
                    this.time_line.once(Laya.Event.COMPLETE, this, () => {
                        this.this_sprite.event(ui_animation_base.ui_anim_event.click_anim_complete);
                    });
                }
                if (this.play_type === "disappear") {
                    this.time_line.once(Laya.Event.COMPLETE, this, () => {
                        this.this_sprite.visible = false;
                        this.this_sprite.event(ui_animation_base.ui_anim_event.disappear_anim_complete);
                    });
                }
            }
        }
        end_anim() {
            if (this.time_line) this.time_line.pause();
        }
        resume_anim() {
            if (this.time_line) this.time_line.resume();
        }
        set_time_line() {}
        reset() {}
        reset_rotation_to_zero() {}
        destory() {
            if (this.time_line) this.time_line.destroy();
            this.had_init_time_line = false;
        }
    }
    ui_animation_base.ui_anim_event = {
        play_during_anim: "play_during_anim",
        end_during_anim: "end_during_anim",
        play_appear_anim: "play_appear_anim",
        play_disappear_anim: "play_disappear_anim",
        appear_anim_complete: "appear_anim_complete",
        disappear_anim_complete: "disappear_anim_complete",
        click_anim_complete: "click_anim_complete",
        play_anim_1: "play_anim_1",
        play_anim_2: "play_anim_2",
        reset_rotation_to_zero: "reset_rotation_to_zero"
    };
    class my_ease {
        constructor(type, param1) {
            this.type = type;
            this.param1 = param1;
            this.param1 = this.param1 ? this.param1 : 0;
        }
        ease(t, b, c, d) {
            switch (this.type) {
                case "linear":
                    return this.linearease(t, b, c, d);

                case "parabola":
                    return this.parabola(t, b, c, d);

                case "bethel":
                    return this.bethel(t, b, c, d);

                default:
                    return this.linearease(t, b, c, d);
            }
        }
        linearease(t, b, c, d) {
            return c * t / d + b;
        }
        parabola(t, b, c, d) {
            let v = (this.param1 + 5) / 5 * (c - b) / d;
            let a = (c - b - v * d) * 2 / (d * d);
            return v * t + .5 * a * t * t + b;
        }
        bethel(t, b, c, d) {
            let a = d - (this.param1 + 5) * d / 10;
            let x = t / d;
            return (1 - x) * (1 - x) * b + 2 * x * (1 - x) * ((b - c) * a / d + c) + x * x * c;
        }
    }
    class ui_animation_rotate extends ui_animation_base {
        constructor(parameters) {
            super();
        }
        set_time_line() {
            if (this.line_1_time > 0) {
                let ease1 = new my_ease(this.line_1_type, this.line_1_param_1);
                this.time_line = new Laya.TimeLine();
                this.time_line.addLabel("0", 0).to(this.this_sprite, {
                    rotation: this.line_1_end_1
                }, this.line_1_time, (t, b, c, d) => {
                    return ease1.ease(t, b, c, d);
                }, this.line_1_delay);
                if (this.line_2_time > 0) {
                    let ease2 = new my_ease(this.line_2_type, this.line_2_param_1);
                    this.time_line.addLabel("1", 0).to(this.this_sprite, {
                        rotation: this.line_2_end_1
                    }, this.line_2_time, (t, b, c, d) => {
                        return ease2.ease(t, b, c, d);
                    }, this.line_2_delay);
                    if (this.line_3_time > 0) {
                        let ease3 = new my_ease(this.line_3_type, this.line_3_param_1);
                        this.time_line.addLabel("2", 0).to(this.this_sprite, {
                            rotation: this.line_3_end_1
                        }, this.line_3_time, (t, b, c, d) => {
                            return ease3.ease(t, b, c, d);
                        }, this.line_3_delay);
                        if (this.line_4_time > 0) {
                            let ease4 = new my_ease(this.line_4_type, this.line_4_param_1);
                            this.time_line.addLabel("3", 0).to(this.this_sprite, {
                                rotation: this.line_4_end_1
                            }, this.line_4_time, (t, b, c, d) => {
                                return ease4.ease(t, b, c, d);
                            }, this.line_4_delay);
                            if (this.line_5_time > 0) {
                                let ease5 = new my_ease(this.line_5_type, this.line_5_param_1);
                                this.time_line.addLabel("4", 0).to(this.this_sprite, {
                                    rotation: this.line_5_end_1
                                }, this.line_5_time, (t, b, c, d) => {
                                    return ease5.ease(t, b, c, d);
                                }, this.line_5_delay);
                                if (this.line_6_time > 0) {
                                    let ease6 = new my_ease(this.line_6_type, this.line_6_param_1);
                                    this.time_line.addLabel("5", 0).to(this.this_sprite, {
                                        rotation: this.line_6_end_1
                                    }, this.line_6_time, (t, b, c, d) => {
                                        return ease6.ease(t, b, c, d);
                                    }, this.line_6_delay);
                                    if (this.line_7_time > 0) {
                                        let ease7 = new my_ease(this.line_7_type, this.line_7_param_1);
                                        this.time_line.addLabel("6", 0).to(this.this_sprite, {
                                            rotation: this.line_7_end_1
                                        }, this.line_7_time, (t, b, c, d) => {
                                            return ease7.ease(t, b, c, d);
                                        }, this.line_7_delay);
                                        if (this.line_8_time > 0) {
                                            let ease8 = new my_ease(this.line_8_type, this.line_8_param_1);
                                            this.time_line.addLabel("7", 0).to(this.this_sprite, {
                                                rotation: this.line_8_end_1
                                            }, this.line_8_time, (t, b, c, d) => {
                                                return ease8.ease(t, b, c, d);
                                            }, this.line_8_delay);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        reset() {
            if (this.begin_1) {
                this.this_sprite.rotation = this.begin_1;
            }
        }
        reset_rotation_to_zero() {
            this.this_sprite.rotation = 0;
        }
    }
    class ui_loading extends ui.scenes.ui_loadingUI {
        constructor() {
            super();
            this.zOrder = 45e3;
            this.bg.on(Laya.Event.CLICK, this, () => {});
        }
        on_enable(param) {
            this.rotateAni.play(0, true);
            this.bg.alpha = 0;
            let self = this;
            if (param && !param.b_first_game) {
                igc.utils_manager.tween(this, 0, 1, .2, function() {
                    if (self.bg) {
                        self.bg.alpha = Math.min(1, self.bg.alpha + 1 / 12);
                    }
                }, function() {
                    if (self.bg) {
                        self.bg.alpha = 1;
                    }
                }, false);
                this.loading.alpha = 0;
            } else {
                this.loading.alpha = 1;
            }
            igc.igc_timer.frameOnce(2, this, () => {
                this.loading.event(ui_animation_rotate.ui_anim_event.play_during_anim);
            });
        }
        on_disable() {
            this.loading.event(ui_animation_rotate.ui_anim_event.end_during_anim);
        }
    }
    class role_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this.max_level = 1;
            this.save_data = {
                coal_level: 1,
                power_level: 1,
                offline_level: 1,
                gold: 0,
                version: 1,
                record: []
            };
            this.add_listener();
        }
        static get instance() {
            return role_manager.get_instance();
        }
        init() {
            for (let idx = 1;; idx++) {
                if (this.configs[idx]) {
                    this.max_level = Math.max(idx, this.max_level);
                } else {
                    break;
                }
            }
            console.log("role_manager ---------------------------", this.max_level);
        }
        add_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.coal_lv_up, this, this.coal_lv_up);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.power_lv_up, this, this.power_lv_up);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.offline_lv_up, this, this.offline_lv_up);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.add_gold, this, this.add_gold);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.clear_data, this, this.clear_data);
        }
        get gold_num() {
            return Math.ceil(this.save_data["gold"]);
        }
        get configs() {
            return igc.igc_config_manager.instance.configs_data["role_config"];
        }
        get coal() {
            return this.configs[this.coal_level] && this.configs[this.coal_level]["coal"] || 1;
        }
        get coal_level() {
            return this.save_data["coal_level"];
        }
        get coal_cost() {
            return this.configs[this.coal_level] && this.configs[this.coal_level]["coal_cost"] || 1;
        }
        get coal_lv_up_enough() {
            return this.gold_num >= this.coal_cost;
        }
        get coal_level_max() {
            return this.coal_level >= this.max_level;
        }
        get coal_need_tip() {
            if (this.save_data["record"].length == 0 && igc.phone_manager.instance.call(phone_ids.get_chapter_id) > 1) {
                return true;
            } else {
                return this.save_data["record"].length > 2 && this.save_data["record"].indexOf(e_attr_type.coal) == -1;
            }
        }
        get power() {
            return this.configs[this.power_level] && this.configs[this.power_level]["power"] || 1;
        }
        get power_min() {
            return this.configs[this.power_level] && this.configs[this.power_level]["power_min"] || 1;
        }
        get power_duration() {
            return this.configs[this.power_level] && this.configs[this.power_level]["power_duration"] || 1;
        }
        get power_level() {
            return this.save_data["power_level"];
        }
        get power_level_max() {
            return this.power_level >= this.max_level;
        }
        get power_cost() {
            return this.configs[this.power_level] && this.configs[this.power_level]["power_cost"] || 1;
        }
        get speed_max() {
            return this.configs[this.power_level] && this.configs[this.power_level]["speed_max"] || 55;
        }
        get power_lv_up_enough() {
            return this.gold_num >= this.power_cost;
        }
        get power_need_tip() {
            if (this.save_data["record"].length == 0 && igc.phone_manager.instance.call(phone_ids.get_chapter_id) > 1) {
                return true;
            } else {
                return this.save_data["record"].length > 2 && this.save_data["record"].indexOf(e_attr_type.power) == -1;
            }
        }
        get offline() {
            return this.configs[this.offline_level] && this.configs[this.offline_level]["offline"] || 1;
        }
        get offline_level() {
            return this.save_data["offline_level"];
        }
        get offline_level_max() {
            return this.offline_level >= this.max_level;
        }
        get offline_cost() {
            return this.configs[this.offline_level] && this.configs[this.offline_level]["offline_cost"] || 1;
        }
        get offline_lv_up_enough() {
            return this.gold_num >= this.offline_cost;
        }
        get offline_need_tip() {
            if (this.save_data["record"].length == 0 && igc.phone_manager.instance.call(phone_ids.get_chapter_id) > 1) {
                return true;
            } else {
                return this.save_data["record"].length > 2 && this.save_data["record"].indexOf(e_attr_type.offline) == -1;
            }
        }
        do_record(attr_type) {
            this.save_data["record"].push(attr_type);
            if (this.save_data["record"].length > 3) {
                this.save_data["record"].splice(0, 1);
            }
        }
        power_lv_up() {
            if (this.power_lv_up_enough && !this.power_level_max) {
                this.cost_gold(this.power_cost);
                this.save_data["power_level"]++;
                this.do_record(e_attr_type.power);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_gold);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_power);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.send_dot, {
                    event_type: global.dot_type.power_level
                });
                this.save(true);
            }
        }
        coal_lv_up() {
            if (this.coal_lv_up_enough && !this.coal_level_max) {
                this.cost_gold(this.coal_cost);
                this.save_data["coal_level"]++;
                this.do_record(e_attr_type.coal);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_gold);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_coal);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.send_dot, {
                    event_type: global.dot_type.coal_level
                });
                this.save(true);
            }
        }
        offline_lv_up() {
            if (this.offline_lv_up_enough && !this.offline_level_max) {
                this.cost_gold(this.offline_cost);
                this.save_data["offline_level"]++;
                this.do_record(e_attr_type.offline);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_gold);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_offline);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.send_dot, {
                    event_type: global.dot_type.offline_level
                });
                this.save(true);
            }
        }
        cost_gold(value) {
            if (value && typeof value == "number") {
                if (this.save_data["gold"] >= Math.ceil(value)) {
                    this.save_data["gold"] -= Math.ceil(value);
                }
            }
        }
        add_gold(_, param) {
            console.log(param.reason, param.value);
            if (param.value && typeof param.value == "number") {
                this.save_data["gold"] += Math.ceil(param.value);
                this.save(true);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_gold);
            }
        }
        clear_data() {
            this.save_data = {
                coal_level: 1,
                power_level: 1,
                offline_level: 1,
                gold: 0,
                version: global.game.version,
                record: []
            };
            this.save(true);
        }
        on_load_save_begin() {
            if (this.save_data["version"] != global.game.version) {
                this.clear_data();
            }
        }
    }
    class game_config_manager extends igc.igc_singleton_manager_base {
        static get instance() {
            return game_config_manager.get_instance();
        }
        get_config(key) {
            if (igc.igc_config_manager.instance.configs_data["game_configs"][key]) {
                let value = igc.igc_config_manager.instance.configs_data["game_configs"][key].value || [undefined];
                return value[0];
            } else {
                return undefined;
            }
        }
        set_config(key, value) {
            igc.igc_config_manager.instance.configs_data["game_configs"][key] = {
                value: value
            };
        }
    }
    class utils_manager {
        static get_url(arg0) {
            throw new Error("Method not implemented.");
        }
        static GetComponentsInChildren(obj, component) {
            let results = [];
            if (obj) {
                let result = obj.getComponent(component);
                if (result) {
                    results.push(result);
                } else if (obj instanceof component) {
                    results.push(obj);
                }
                for (let i = 0; i < obj.numChildren; ++i) {
                    results = results.concat(utils_manager.GetComponentsInChildren(obj.getChildAt(i), component));
                }
            }
            return results;
        }
        static GetChildByName(obj, name) {
            if (obj) {
                let result = obj.getChildByName(name);
                if (result) {
                    return result;
                }
                for (let i = 0; i < obj.numChildren; ++i) {
                    let child = obj.getChildAt(i);
                    let result = utils_manager.GetChildByName(child, name);
                    if (result) {
                        return result;
                    }
                }
            }
            return undefined;
        }
        static formatTime(time) {
            if (time <= 0) {
                return "00:00:00";
            }
            var h = Math.floor(time / 3600 % 24);
            var m = Math.floor(time / 60 % 60);
            var s = Math.floor(time % 60);
            var hStr = h + "";
            var mStr = m + "";
            var sStr = s + "";
            if (h < 10) {
                hStr = "0" + h;
            }
            if (m < 10) {
                mStr = "0" + m;
            }
            if (s < 10) {
                sStr = "0" + s;
            }
            return hStr + ":" + mStr + ":" + sStr;
        }
        static get_length(datas) {
            let keys = Object.keys(datas);
            return keys.length;
        }
        static get_random_value(arr) {
            if (!arr) {
                console.error("utils_manager get_random_value error -> ", arr);
                return null;
            }
            let keys = Object.keys(arr);
            if (keys.length > 0) {
                let index = 0;
                index = Math.floor(Math.random() * this.get_length(keys));
                return arr[keys[index]];
            }
            return null;
        }
        static vector2_rectangle_distance(a, b) {
            return Math.abs(a.x - b.x) + Math.abs(a.y - b.y);
        }
        static vector2_distance_squared(a, b) {
            let x = a.x - b.x;
            let y = a.y - b.y;
            return x * x + y * y;
        }
        static vector2_distance(a, b) {
            return Math.sqrt(utils_manager.vector2_distance_squared(a, b));
        }
        static coordinate_position_distance_squared(coordinate, position) {
            utils_manager.position_to_coordinate(position, utils_manager.coordinate_position_distance_squared_coordinate);
            return this.vector2_distance_squared(coordinate, utils_manager.coordinate_position_distance_squared_coordinate);
        }
        static position_to_coordinate(position, coordinate) {
            coordinate.x = Math.floor(-position.x);
            coordinate.y = Math.floor(position.z);
        }
        static coordinate_to_position(coordinate, position) {
            position.x = -(coordinate.x + .5);
            position.z = coordinate.y + .5;
        }
        static same_coordinate(from, to) {
            return from.x === to.x && from.y === to.y;
        }
        static random_range(from, to) {
            return from + Math.random() * (to - from);
        }
        static effect_3d_to_2d(param) {
            if (!igc.igc_config_manager.instance.configs_data["effects"][param.effect_id]) {
                console.error("utils_manager effect_3d_to_2d error run -> ", param.effect_id);
                return;
            }
            let node = igc.phone_manager.instance.call(param.phone_id);
            let target_pos;
            if (node.bottom) {
                target_pos = new Laya.Vector3(node.x, node.y + node.height - (node.bottom ? node.bottom : 0) - (node.top ? node.top : 0), 1);
            } else {
                target_pos = new Laya.Vector3(node.x, node.y, 1);
            }
            let temp_position = igc.phone_manager.instance.call(phone_ids.get_world_to_screen_position, {
                position: param.scene_position
            });
            node.x = temp_position.x;
            node.y = temp_position.y;
            let effect_ins = igc.phone_manager.instance.call(phone_ids.show_ui_effect, {
                id: param.effect_id,
                ui_mount_point: node,
                scale: param.scale || 1
            });
            let start_pos = new Laya.Vector3(node.x, node.y, 1);
            igc.utils_manager.tween(node, start_pos, target_pos, param.duration, function(target, from, to, t) {
                Laya.Vector3.lerp(from, to, t, temp_position);
                target.x = temp_position.x;
                target.y = temp_position.y;
                effect_ins && effect_ins.scene && effect_ins.scene.move_to({
                    x: temp_position.x,
                    y: temp_position.y,
                    width: node.width,
                    height: node.height
                });
            }, function() {
                param.tween_finish_callback && param.tween_finish_callback();
                effect_ins && effect_ins.destroy();
                igc.igc_timer.once(param.delay_destroy, null, function() {
                    param.finish_callback && param.finish_callback();
                }, undefined, true);
            }, true);
        }
        static bounce_scale_tween(node, start_scale, bounce_scale, end_scale, up_time, down_time, finish_callback, ignore_x, ignore_y) {
            ignore_x = ignore_x || false;
            ignore_y = ignore_y || false;
            let self = this;
            node.visible = true;
            igc.utils_manager.tween(node, start_scale, bounce_scale, up_time, function(target, from, to, t) {
                if (!ignore_x) {
                    node.scaleX = from + t * (bounce_scale - start_scale);
                }
                if (!ignore_y) {
                    node.scaleY = from + t * (bounce_scale - start_scale);
                }
            }, function() {
                igc.utils_manager.tween(node, bounce_scale, end_scale, down_time, function(target, from, to, t) {
                    if (!ignore_x) {
                        node.scaleX = from + t * (end_scale - bounce_scale);
                    }
                    if (!ignore_y) {
                        node.scaleY = from + t * (end_scale - bounce_scale);
                    }
                }, function() {
                    finish_callback && finish_callback();
                }, true);
            }, true);
        }
        static scale_tween(node, start_scale, end_scale, time, finish_callback) {
            node.visible = true;
            return igc.utils_manager.tween(node, start_scale, end_scale, time, function(target, from, to, t) {
                node.scaleX = from + t * (end_scale - start_scale);
                node.scaleY = from + t * (end_scale - start_scale);
            }, function() {
                finish_callback && finish_callback();
            }, true);
        }
        static move_tween(node, origin_pos, target_pos, time, finish_callback) {
            let temp_pos = new Laya.Vector3(0, 0, 0);
            node.visible = true;
            return igc.utils_manager.tween(node, origin_pos, target_pos, time, function(target, from, to, t) {
                Laya.Vector3.lerp(origin_pos, target_pos, t, temp_pos);
                node.x = temp_pos.x;
                node.y = temp_pos.y;
            }, function() {
                finish_callback && finish_callback();
            }, true);
        }
        static alpha_tween(node, from, to, time, finish_callback) {
            node.visible = true;
            igc.utils_manager.tween(node, from, to, time, function(target, from, to, t) {
                node.alpha = from + t * (to - from);
            }, function() {
                finish_callback && finish_callback();
            }, true);
        }
        static get_player_arr_by_quality_with_equal(quality, equal, player_arr) {
            let players = player_arr || Object.keys(igc.igc_config_manager.instance.configs_data["players"]);
            let arr = [];
            for (let key in players) {
                let player_data = igc.igc_config_manager.instance.configs_data["players"][players[key]];
                let compare = player_data.quality - quality;
                compare = compare > 0 ? e_equal.large : compare === 0 ? e_equal.equal : e_equal.less;
                if (compare === equal && arr.indexOf(player_data.id) < 0 && player_data.ai > 0) {
                    arr.push(player_data.id);
                }
            }
            return arr;
        }
        static get_player_arr_by_level(min_level, max_level) {
            let players = igc.igc_config_manager.instance.configs_data["players"];
            let arr = [];
            for (let key in players) {
                let player_data = players[key];
                if (player_data.level >= min_level && player_data.level <= max_level && player_data.ai > 0) {
                    arr.push(player_data.id);
                }
            }
            return arr;
        }
        static get_player_arr_by_quality(min_quality, max_quality) {
            let players = igc.igc_config_manager.instance.configs_data["players"];
            let arr = [];
            for (let key in players) {
                let player_data = players[key];
                if (player_data.quality >= min_quality && player_data.quality <= max_quality && player_data.ai > 0) {
                    arr.push(player_data.id);
                }
            }
            return arr;
        }
        static filler_has_unlock(arr) {
            let unlock_max_level = igc.phone_manager.instance.call(phone_ids.get_max_unlock_level) || 1;
            for (let i = 0; i < arr.length; i++) {
                let player_data = igc.igc_config_manager.instance.configs_data["players"][arr[i]];
                if (unlock_max_level < player_data.level) {
                    arr.splice(i, 1);
                    i--;
                }
            }
        }
        static get_floor_player_map(quality_arr, random_count_arr, count_arr) {
            if (quality_arr.length === random_count_arr.length && random_count_arr.length === count_arr.length) {
                let map = {};
                let unlock_max_level = igc.phone_manager.instance.call(phone_ids.get_max_unlock_level) || 1;
                for (let i = 0; i < quality_arr.length; i++) {
                    let add_count = 0;
                    let quality = quality_arr[i];
                    let quality_players = this.get_player_arr_by_quality_with_equal(quality, e_equal.equal, undefined);
                    this.filler_has_unlock(quality_players);
                    if (quality_players.length > 0) {
                        while (add_count < random_count_arr[i]) {
                            let player_id = utils_manager.get_random_value(quality_players);
                            let player_data = igc.igc_config_manager.instance.configs_data["players"][player_id];
                            if (unlock_max_level >= player_data.level) {
                                if (map[player_id]) {
                                    add_count++;
                                    map[player_id].count = map[player_id].count + count_arr[i];
                                } else {
                                    add_count++;
                                    map[player_id] = {
                                        count: count_arr[i]
                                    };
                                }
                            }
                        }
                    }
                }
                return map;
            } else {
                console.error("utils_manager get_floor_player_arr error run quality_arr.length is not equal count_arr.length or random_count_arr.length", quality_arr, count_arr, random_count_arr);
                return [];
            }
        }
        static get_player_arr_by_level_quality_weight(level_arr, quality_arr, weight_arr, total_count, unlock_limit) {
            total_count = total_count || 1;
            unlock_limit = unlock_limit || 0;
            if (quality_arr.length !== weight_arr.length) {
                console.error("utils_manager get_player_arr_by_level_quality_weight error run quality_arr.length is not equal weight_arr.length", quality_arr, weight_arr);
                return [];
            }
            let max_level = level_arr[level_arr.length - 1];
            let unlock_max_level = igc.phone_manager.instance.call(phone_ids.get_max_unlock_level) || 1;
            let lock_levels = undefined;
            if (unlock_limit === 0) {
                max_level = unlock_max_level;
            } else {
                lock_levels = this.get_player_arr_by_level(Math.min(unlock_max_level + 1, max_level), max_level);
            }
            let select_player = this.get_player_arr_by_level(level_arr[0], max_level);
            let map = {};
            for (let i = 0; i < quality_arr.length; i++) {
                let quality = quality_arr[i];
                let quality_players = this.get_player_arr_by_quality_with_equal(quality, e_equal.equal, select_player);
                for (let j = 0; j < quality_players.length; j++) {
                    map[quality_players[j]] = parseFloat((weight_arr[i] / quality_players.length).toFixed(2));
                }
            }
            let arr = [];
            let get_lock_count = 0;
            for (let k = 0; k < total_count; k++) {
                let model_id = parseInt(igc.utils_manager.get_random_from_probability(map));
                if (lock_levels && lock_levels.indexOf(model_id) >= 0) {
                    get_lock_count++;
                }
                if (unlock_limit > 0 && get_lock_count >= unlock_limit) {
                    for (let kk = 0; kk < lock_levels.length; kk++) {
                        if (map[lock_levels[kk]]) {
                            map[lock_levels[kk]] = 0;
                        }
                    }
                    get_lock_count = -1;
                }
                arr.push(model_id);
            }
            return arr;
        }
        static get_star_show_by_data(data) {
            let total_star_count = 0;
            if (!data.chapter_datas || utils_manager.get_length(data.chapter_datas) === 0) {
                return total_star_count;
            }
            for (let key in data.chapter_datas) {
                total_star_count = data.get_star_count(data.chapter_datas[key].star_datas) >= 3 ? total_star_count + 1 : total_star_count;
            }
            let win_star_count_cfg = game_config_manager.instance.get_config("win_star_count");
            return total_star_count % win_star_count_cfg;
        }
        static get_hero_type_icon(id) {
            let cur_hero_data = igc.igc_config_manager.instance.configs_data["players"][id];
            if (cur_hero_data) {
                switch (cur_hero_data.player_action_type) {
                    case e_player_action_type.attack:
                        return "compose/hero/hero_icon_12.png";

                    case e_player_action_type.defend:
                        return "compose/hero/hero_icon_13.png";

                    case e_player_action_type.treat:
                        return "compose/hero/hero_icon_10.png";
                }
                return "";
            }
        }
        static screen_position_to_scene_position(screen_position, active_scene) {
            let scene = active_scene.scene;
            let camera = active_scene.camera;
            if (scene && camera) {
                camera.viewportPointToRay(screen_position, this.ray);
                let a = Laya.Vector3.dot(this.plane_normal, this.plane_point);
                let b = Laya.Vector3.dot(this.plane_normal, this.ray.origin);
                let c = Laya.Vector3.dot(this.plane_normal, this.ray.direction);
                let t = (a - b) / c;
                Laya.Vector3.scale(this.ray.direction, t, this.intersection);
                Laya.Vector3.add(this.ray.origin, this.intersection, this.intersection);
                return this.intersection;
            }
        }
        static is_in_boundary(from_coordinate, boundary) {
            if (boundary.x <= from_coordinate.x && from_coordinate.x <= boundary.y && boundary.z <= from_coordinate.y && from_coordinate.y <= boundary.w) {
                return true;
            } else {
                return false;
            }
        }
        static check_is_same_day(left_time, right_tiem) {
            let left_date = new Date(left_time);
            let right_date = new Date(right_tiem);
            if (left_date.getDay() != right_date.getDay() || left_date.getMonth() != right_date.getMonth() || left_date.getFullYear() != right_date.getFullYear()) {
                return false;
            }
            return true;
        }
        static get_notch_height() {
            if (Laya.Browser.onMobile) {
                if (window["qg"]) {
                    let info = window["qg"].getSystemInfoSync();
                    if (info) {
                        return info["notchHeight"];
                    }
                }
                return 120;
            }
            return 0;
        }
        static is_wall_id(id) {
            id = id + "";
            let config = igc.igc_config_manager.instance.configs_data["enemies"][id];
            if (config && config.enemy_type === e_enemy_type.building_wall) {
                return true;
            } else {
                return false;
            }
        }
    }
    utils_manager.players = {};
    utils_manager.format_big_num = function(gold) {
        if (!BigNumber.isBigNumber(gold)) {
            gold = new BigNumber(gold);
        }
        return this.int_format(gold.integerValue());
    };
    utils_manager.int_format = function(value) {
        if (!BigNumber.isBigNumber(value)) {
            value = Math.floor(value);
        }
        let param = value.toString();
        let gold_num = "";
        if (param.indexOf("e") == -1) {
            if (param.length <= 3) {
                gold_num = param;
            } else {
                let type_length = Math.floor(param.length / 3);
                let type_left = param.length % 3;
                gold_num += param[0];
                if (type_left == 0) {
                    type_length -= 1;
                }
                if (type_left == 1) {
                    gold_num += ".";
                }
                gold_num += param[1];
                if (type_left == 2) {
                    gold_num += ".";
                }
                gold_num += param[2];
                if (type_length < num_type.length) {
                    gold_num += num_type[type_length];
                } else {
                    gold_num += "超标";
                }
            }
        } else {
            let e_idx = param.indexOf("e");
            gold_num = param.substr(0, e_idx);
            let gold_length = param.substr(e_idx + 2);
            let type_length = Math.floor(gold_length / 3);
            let type_left = gold_length % 3;
            let big_temp = new BigNumber(gold_num);
            if (type_left == 0) {
                type_length -= 1;
            }
            if (type_left == 1) {
                big_temp = big_temp.multipliedBy(10);
            } else if (type_left == 2) {
                big_temp = big_temp.multipliedBy(100);
            }
            gold_num = big_temp.toString();
            gold_num = gold_num.substr(0, 4);
            if (gold_num.length == 1) {
                gold_num = gold_num + ".00";
            } else if (gold_num.length == 2) {
                gold_num = gold_num + ".0";
            }
            if (type_length < num_type.length) {
                gold_num += num_type[type_length];
            } else {
                gold_num += "超标";
            }
        }
        return gold_num;
    };
    utils_manager.coordinate_position_distance_squared_coordinate = new Laya.Vector2();
    utils_manager.plane_normal = new Laya.Vector3(0, 1, 0);
    utils_manager.plane_point = new Laya.Vector3();
    utils_manager.intersection = new Laya.Vector3();
    utils_manager.ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
    window["utils_manager"] = utils_manager;
    class atlas_animation_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this.needResEffect = [];
            this.preFix = igc.igc_resources_utils.get_url("ui/atlas/animation/");
            this.postFix = ".atlas";
            this.atlas_dic = {};
        }
        static get instance() {
            return atlas_animation_manager.get_instance();
        }
        init() {
            igc.phone_manager.instance.add_listener(phone_ids.create_animation, this, this.create_animation);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.end_animation, this, this.clear_loop_anim);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.end_all_animation, this, this.clear_all_loop_anim);
        }
        create_animation(broadcast_id, param) {
            let animation_param = param.ani_param;
            let callback = param.call_back;
            let atlasPath = this.preFix + animation_param.res_path + this.postFix;
            let ani = this.check_anim_child(animation_param.parent_node);
            if (ani == undefined) {
                ani = new Laya.Animation();
                animation_param.parent_node.addChild(ani);
                ani.blendMode = animation_param.blend_mode;
                ani.name = "ani";
            } else if (animation_param.is_bar) {
                return ani;
            }
            ani.clear();
            if (this.atlas_dic[animation_param.res_path] != undefined) {
                ani.source = this.atlas_dic[animation_param.res_path];
                this.init_ani(ani, animation_param, callback);
            } else {
                this.atlas_dic[animation_param.res_path] = atlasPath;
                ani.loadAtlas(atlasPath, Laya.Handler.create(this, () => {
                    this.init_ani(ani, animation_param, callback);
                }));
            }
            return ani;
        }
        init_ani(ani, animation_param, callback) {
            ani.interval = animation_param.interval;
            ani.index = 0;
            ani.scaleX = animation_param.scale[0];
            ani.scaleY = animation_param.scale[1];
            ani.pos(animation_param.position[0], animation_param.position[1]);
            ani.play();
            if (!animation_param.is_play_loop) {
                ani.once(Laya.Event.COMPLETE, this, () => {
                    this.remove_node(animation_param.parent_node);
                    if (callback) {
                        callback();
                    }
                });
            }
        }
        release_effect() {}
        remove_animation(res_path, parent_node) {
            this.remove_node(parent_node);
            this.release_res(res_path);
            if (res_path == "jindutiao") {
                parent_node.removeChildren();
            }
        }
        remove_node(parent_node) {
            let animNode = this.check_anim_child(parent_node);
            if (animNode) {
                animNode.clear();
            }
        }
        release_res(res_path) {
            let atlasPath = this.preFix + res_path + this.postFix;
            this.release_effect();
        }
        check_anim_child(parent_node) {
            return utils_manager.GetChildByName(parent_node, "ani");
        }
        check_ani_playing(parent_node) {
            let ani_node = utils_manager.GetChildByName(parent_node, "ani");
            return ani_node && ani_node.isPlaying;
        }
        clear_loop_anim(broadcast_id, param) {
            let animation_param = param.anim_param;
            if (animation_param) {
                this.remove_animation(animation_param.res_path, animation_param.parent_node);
            }
        }
        clear_all_loop_anim(broadcast_id, param) {
            let res_path = param.res_path;
            let node_list = param.parent_list || [];
            node_list.forEach(node => {
                this.remove_animation(res_path, node);
            });
        }
    }
    class animation_param {
        constructor(res_path, parent_node, interval, is_play_loop, position, scale, blend_mode = "", is_bar = false) {
            this.is_bar = false;
            this.res_path = res_path;
            this.parent_node = parent_node;
            this.interval = interval;
            this.is_play_loop = is_play_loop;
            this.position = position;
            this.scale = scale;
            this.blend_mode = blend_mode;
            this.is_bar = is_bar;
        }
    }
    class ui_main extends ui.scenes.ui_mainUI {
        constructor() {
            super(...arguments);
            this.b_relife = false;
            this.coal_lv_up_count = 0;
            this.power_lv_up_count = 0;
            this.offline_lv_up_count = 0;
            this.ui_open = false;
            this.is_show_dnsdk = false;
            this.is_in_hall = false;
        }
        awake() {
            this.show_dnsdk_view();
            this.btn_more_game.visible = global.game.channel_type == igc.e_channel_type.tt;
        }
        show_dnsdk_view() {
            let init_compelete = igc.phone_manager.instance.call(phone_ids.dnsdk_init_compelete);
            if (this.is_show_dnsdk || !init_compelete) {
                return;
            }
            this.is_show_dnsdk = true;
            igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_show_push_view, {
                isShow: true
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_show_splash_list, {
                isShow: true
            });
        }
        on_enable(param) {
            this.is_in_hall = true;
            this.ui_open = true;
            this.init_btn_event();
            this.register_listener();
            let wx_game_share_dialog = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                ui_name: "GameShareDialog"
            });
            if (!wx_game_share_dialog) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
                    type: global.ad_type.banner.normal
                });
            }
            let chapter = igc.phone_manager.instance.call(phone_ids.get_chapter_id) || 1;
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_show_update_icon, {
                isShow: true,
                uiPlaceType: igc.e_push_ui_place.main_city,
                position: {
                    centerX: -350,
                    centerY: -100
                },
                chapterId: chapter
            });
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_show_side_guess_like, {
                isShow: true,
                uiPlaceType: igc.e_push_ui_place.main_city,
                chapterId: chapter
            });
            this.b_relife = param.b_relife || false;
            this.cur_chapter = chapter;
            this.init_view();
        }
        on_disable() {
            this.is_in_hall = false;
            this.ui_open = false;
            this.release_btn_event();
            this.release_listener();
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_show_update_icon, {
                isShow: false
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_push_view_show_icon, {
                is_show_guess_like: true,
                is_show_icon: true,
                is_show_more_play: false,
                icon_position: 410
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.end_animation, {
                anim_param: this.coal_anim_param
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.end_animation, {
                anim_param: this.offline_anim_param
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.end_animation, {
                anim_param: this.power_anim_param
            });
        }
        init_view() {
            this.btn_clear.visible = global.game.editor;
            this.update_user_info();
            igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_push_view_show_icon, {
                is_show_guess_like: false,
                is_show_icon: true,
                is_show_more_play: true,
                icon_position: 750
            });
            if (global.game.channel_type == igc.e_channel_type.oppo_qg || global.game.channel_type == igc.e_channel_type.vivo_qg || global.game.channel_type == igc.e_channel_type.web) {
                this.luck_tips.visible = true;
                let chapter = igc.phone_manager.instance.call(phone_ids.get_chapter_id) || 1;
                this.luck_tips.visible = chapter < global.luck.sand;
                if (chapter < global.luck.snow) {
                    this.img_sand.visible = false;
                    this.img_snow.visible = true;
                    this.luck_level.value = global.luck.snow - chapter + "";
                } else if (chapter < global.luck.sand) {
                    this.img_sand.visible = true;
                    this.img_snow.visible = false;
                    this.luck_level.value = global.luck.sand - chapter + "";
                }
            } else {
                this.luck_tips.visible = false;
            }
            // this.updateSoundUI();
        }
        update_user_info() {
            this.updateChapterUI();
            this.updateGoldUI();
            this.updatePowerUI();
            this.updateOfflineUI();
            this.updateCoalUI();
            this.updateShakeUI();
            this.updateSoundUI();
            this.updateUpgradeUI();
        }
        updateUpgradeUI() {
            let channel_type = global.game.channel_type;
            if (channel_type == igc.e_channel_type.tt || channel_type == igc.e_channel_type.web) {
                this.upgrade_box.bottom = 150;
            } else if (channel_type == igc.e_channel_type.wx) {
                this.upgrade_box.bottom = 220;
            } else {
                this.upgrade_box.bottom = 20;
            }
        }
        on_btn_click_desktop() {
            igc.igc_main.instance.add_desktop({
                on_failed: function() {
                    igc.phone_manager.instance.call(phone_ids.show_tips, {
                        desc: "平台版本号过低"
                    });
                },
                has_create: function() {
                    igc.phone_manager.instance.call(phone_ids.show_tips, {
                        desc: "已经添加过桌面图标了"
                    });
                }
            });
        }
        register_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_user_info, this, this.update_user_info);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_coal, this, this.updateCoalUI);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_power, this, this.updatePowerUI);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_offline, this, this.updateOfflineUI);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_gold, this, this.updateGoldUI);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.banner_show, this, this.update_panel_position);
            igc.phone_manager.instance.add_listener(phone_ids.get_is_hall, this, this.get_is_hal);
        }
        release_listener() {
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.update_user_info, this, this.update_user_info);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.update_coal, this, this.updateCoalUI);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.update_power, this, this.updatePowerUI);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.update_offline, this, this.updateOfflineUI);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.update_gold, this, this.updateGoldUI);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.banner_show, this, this.update_panel_position);
        }
        get_is_hal() {
            return this.is_in_hall;
        }
        init_btn_event() {
            this.startGameBtn.on(Laya.Event.MOUSE_DOWN, this, this.on_click_start);
            this.shakeBtn.on(Laya.Event.CLICK, this, this.on_click_shake);
            this.soundBtn.on(Laya.Event.MOUSE_DOWN, this, this.on_click_sound);
            this.coal_bg.on(Laya.Event.MOUSE_DOWN, this, this.on_click_coal);
            this.power_bg.on(Laya.Event.MOUSE_DOWN, this, this.on_click_power);
            this.offline_bg.on(Laya.Event.MOUSE_DOWN, this, this.on_click_offline);
            this.btn_clear.on(Laya.Event.MOUSE_DOWN, this, this.on_click_clear);
            this.coal_anim_param = new animation_param("up_lv", this.coal_bg, 75, false, [20, -200], [2.5, 2.5], "");
            this.power_anim_param = new animation_param("up_lv", this.power_bg, 75, false, [15, -200], [2.5, 2.5], "");
            this.offline_anim_param = new animation_param("up_lv", this.offline_bg, 75, false, [10, -200], [2.5, 2.5], "");
        }
        release_btn_event() {
            this.startGameBtn.off(Laya.Event.MOUSE_DOWN, this, this.on_click_start);
            this.shakeBtn.off(Laya.Event.CLICK, this, this.on_click_shake);
            this.soundBtn.off(Laya.Event.MOUSE_DOWN, this, this.on_click_sound);
            this.coal_bg.off(Laya.Event.MOUSE_DOWN, this, this.on_click_coal);
            this.power_bg.off(Laya.Event.MOUSE_DOWN, this, this.on_click_power);
            this.offline_bg.off(Laya.Event.MOUSE_DOWN, this, this.on_click_offline);
            this.btn_clear.off(Laya.Event.MOUSE_DOWN, this, this.on_click_clear);
        }
        on_click_clear() {
            igc.broadcast_manager.instance.broadcast(broadcast_ids.clear_data);
        }
        on_click_coal() {
            if (role_manager.instance.coal_level_max) {
                igc.phone_manager.instance.call(phone_ids.show_tips, {
                    desc: "煤炭已达到最大级"
                });
            } else if (role_manager.instance.coal_lv_up_enough) {
                let self = this;
                if (self.coal_lv_up_count == 0) {
                    igc.phone_manager.instance.call(phone_ids.create_animation, {
                        ani_param: self.coal_anim_param,
                        call_back: () => {}
                    });
                }
                this.coal_lv_up_count++;
                Laya.timer.once(1e3, self, function() {
                    self.coal_lv_up_count--;
                });
                igc.broadcast_manager.instance.broadcast(broadcast_ids.coal_lv_up);
            } else {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.need_supply_gold, {
                    reward: role_manager.instance.coal_cost
                });
            }
        }
        on_click_power() {
            if (role_manager.instance.power_level_max) {
                igc.phone_manager.instance.call(phone_ids.show_tips, {
                    desc: "动力已达到最大级"
                });
            } else if (role_manager.instance.power_lv_up_enough) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.power_lv_up);
                let self = this;
                if (self.power_lv_up_count == 0) {
                    igc.phone_manager.instance.call(phone_ids.create_animation, {
                        ani_param: self.power_anim_param,
                        call_back: () => {}
                    });
                }
                this.power_lv_up_count++;
                Laya.timer.once(1e3, self, function() {
                    self.power_lv_up_count--;
                });
            } else {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.need_supply_gold, {
                    reward: role_manager.instance.power_cost
                });
            }
        }
        on_click_offline() {
            if (role_manager.instance.offline_level_max) {
                igc.phone_manager.instance.call(phone_ids.show_tips, {
                    desc: "离线收益已达到最大级"
                });
            } else if (role_manager.instance.offline_lv_up_enough) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.offline_lv_up);
                let self = this;
                if (self.offline_lv_up_count == 0) {
                    igc.phone_manager.instance.call(phone_ids.create_animation, {
                        ani_param: self.offline_anim_param,
                        call_back: () => {}
                    });
                }
                this.offline_lv_up_count++;
                Laya.timer.once(1e3, self, function() {
                    self.offline_lv_up_count--;
                });
            } else {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.need_supply_gold, {
                    reward: role_manager.instance.offline_cost
                });
            }
        }
        on_click_start() {
            let self = this;
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: self
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            // if (global.game.channel_type == igc.e_channel_type.qq) {
            //     igc.broadcast_manager.instance.broadcast(broadcast_ids.update_banner, {
            //         type: global.ad_type.banner.normal
            //     });
            // } else if (global.game.channel_type == igc.e_channel_type.tt || global.game.channel_type == igc.e_channel_type.wx) {
            //     igc.broadcast_manager.instance.broadcast(broadcast_ids.hide_banner);
            // } else {
            //     igc.broadcast_manager.instance.broadcast(broadcast_ids.set_can_show_banner);
            // }
            //platform.getInstance().showInterstitial(() => {
            igc.broadcast_manager.instance.broadcast(broadcast_ids.chapter_play);
            //})
        }
        on_click_shake() {
            let is_shake = igc.phone_manager.instance.call(phone_ids.get_shake) > 0;
            let new_shake = is_shake ? 0 : 1;
            igc.broadcast_manager.instance.broadcast(broadcast_ids.update_shake, {
                is_shake: new_shake
            });
            this.updateShakeUI();
        }
        on_click_sound() {
            let has_sound = JSON.parse(Laya.LocalStorage.getItem("Off-The-Rails-3D-Music"));
            // let newVol = has_sound ? 0 : 1;
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.update_vol, {
            //     vol: newVol
            // });
            if (has_sound) {
                Laya.LocalStorage.setItem("Off-The-Rails-3D-Music", "false");
            } else {
                Laya.LocalStorage.setItem("Off-The-Rails-3D-Music", "true");
            }
            this.updateSoundUI();
        }
        updateSoundUI() {
            let is_sound = JSON.parse(Laya.LocalStorage.getItem("Off-The-Rails-3D-Music"));
            this.soundBtn.skin = !is_sound ? "city/bt_city_sy2.png" : "city/bt_city_sy1.png";
            Laya.SoundManager.muted = is_sound;
        }
        updateShakeUI() {
            if (global.game.channel_type == igc.e_channel_type.tt) {
                this.shakeBtn.visible = false;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_shake, {
                    is_shake: 0
                });
            } else {
                let is_shake = igc.phone_manager.instance.call(phone_ids.get_shake) != 0;
                this.shakeBtn.skin = is_shake ? "city/bt_city_zd2.png" : "city/bt_city_zd1.png";
            }
        }
        update_lv_up_state() {
            this.coal_lv_up_tip.visible = role_manager.instance.coal_lv_up_enough && role_manager.instance.coal_need_tip;
            this.coal_mask.visible = false;
            this.power_lv_up_tip.visible = role_manager.instance.power_lv_up_enough && role_manager.instance.power_need_tip;
            this.power_mask.visible = false;
            this.offline_lv_up_tip.visible = role_manager.instance.offline_lv_up_enough && role_manager.instance.offline_need_tip;
            this.offline_mask.visible = false;
        }
        updateGoldUI() {
            this.goldNum.value = role_manager.instance.gold_num + "";
            this.update_lv_up_state();
        }
        updateCoalUI() {
            this.coal_level.value = role_manager.instance.coal_level;
            this.coal_cost.text = role_manager.instance.coal_cost;
        }
        updatePowerUI() {
            this.power_level.value = role_manager.instance.power_level;
            this.power_cost.text = role_manager.instance.power_cost;
        }
        updateOfflineUI() {
            this.offline_level.value = role_manager.instance.offline_level;
            this.offline_cost.text = role_manager.instance.offline_cost;
        }
        updateChapterUI() {
            let chapter = igc.phone_manager.instance.call(phone_ids.get_chapter_id) || 1;
            this.chaper_id.value = chapter;
        }
        updateEnergyLeftTime() {
            let resumeLeftTime = igc.phone_manager.instance.call(phone_ids.get_energy_resume_left_time);
        }
        update_panel_position() {}
    }
    class ui_tt_guess_like extends ui.scenes.ui_tt_guess_likeUI {
        constructor() {
            super();
            this.hGuessLikeCellList = [];
            this.hPreStageX = 0;
            this.bHGuessLikeAutoMoving = true;
            this.data_list = [{
                name: "",
                icon: ""
            }];
            this.initHGuessLike();
        }
        on_enable() {
            let self = this;
            igc.igc_timer.frameOnce(1, this, function() {
                self.addListener();
                self.showHGuessLikePanel(undefined, {
                    isShow: true
                });
            });
        }
        on_disable() {
            this.removeEventListener();
            this.showHGuessLikePanel(undefined, {
                isShow: false
            });
        }
        addListener() {
            this.hGuessLikePanel.on(Laya.Event.MOUSE_DOWN, this, this.onHGuessLikeMouseDown);
            this.hGuessLikePanel.on(Laya.Event.MOUSE_UP, this, this.onHGuessLikeMouseUp);
            this.hGuessLikePanel.on(Laya.Event.MOUSE_MOVE, this, this.onHGuessLikeMouseMove);
        }
        removeEventListener() {
            this.hGuessLikePanel.off(Laya.Event.MOUSE_DOWN, this, this.onHGuessLikeMouseDown);
            this.hGuessLikePanel.off(Laya.Event.MOUSE_UP, this, this.onHGuessLikeMouseUp);
            this.hGuessLikePanel.off(Laya.Event.MOUSE_MOVE, this, this.onHGuessLikeMouseMove);
        }
        initHGuessLike() {
            this.hGuessLikeRoot.visible = false;
            let hGuessLikeData = this.data_list;
            let hBox = this.hGuessLikePanel.content.getChildAt(0);
            for (let i = 0; i < hGuessLikeData.length; ++i) {
                if (i >= hBox.numChildren) break;
                let item = hBox.getChildAt(i);
                item.tag = i;
                let info = {};
                this.hGuessLikeCellList[i] = info;
                info.data = hGuessLikeData[i];
                info.gamePlace = i + 1;
                info.item = item;
                info.index = 0;
            }
            for (let j = hBox.numChildren - 1; j >= hGuessLikeData.length; --j) {
                hBox.removeChildAt(j);
            }
        }
        showHGuessLikePanel(id, args) {
            if (args.isShow) {
                let position = args.position;
                if (position) {
                    for (let key in position) {
                        this.hGuessLikeRoot[key] = position[key];
                    }
                }
                this.hGuessLikeRoot.visible = true;
                this.updateHGuessLikeGameList();
                this.frameLoop(1, this, this.hGuessLikeAutoMove, null, true);
            } else {
                this.hGuessLikeRoot.visible = false;
                this.clearTimer(this, this.hGuessLikeAutoMove);
            }
        }
        updateHGuessLikeGameList() {
            var r = this.hGuessLikePanel.content.scrollRect;
            r.x = 0;
            this.hGuessLikePanel.content.scrollRect = r;
            for (let i = 0; i < this.hGuessLikeCellList.length; ++i) {
                let info = this.hGuessLikeCellList[i];
                info.curGameData = info.data;
                console.log("xiejinhui tt guess_like item_data-----------\x3e", info.data);
                let item = info.item;
                let iconImage = item.getChildAt(0).getChildByName("gameIcon");
                iconImage.skin = info.curGameData.icon;
                let nameLabel = item.getChildAt(0).getChildByName("name");
                nameLabel.text = info.curGameData.name;
            }
        }
        onHGuessLikeMouseDown(e) {
            this.hPreStageX = e.stageX;
            this.bHGuessLikeAutoMoving = false;
        }
        onHGuessLikeMouseUp(e) {
            this.bHGuessLikeAutoMoving = true;
            if (global.game.is_support_tt_push) {
                console.log("xiejinhui 点击tt互推");
                igc.igc_main.instance.show_more_game_modal();
            } else {
                console.log("不支持tt互推 点击无效");
            }
        }
        onHGuessLikeMouseMove(e) {
            let delta = e.stageX - this.hPreStageX;
            this.hPreStageX = e.stageX;
            this.hGuessLikeOffset(delta);
        }
        hGuessLikeAutoMove() {
            if (this.bHGuessLikeAutoMoving) this.hGuessLikeOffset(-100 / 1e3 * Laya.timer.delta);
        }
        hGuessLikeOffset(delta) {
            var r = this.hGuessLikePanel.content.scrollRect;
            r.x -= delta;
            let box = this.hGuessLikePanel.content.getChildAt(0);
            if (delta > 0) {
                let lastItem = box.getChildAt(box.numChildren - 1);
                if (r.x + r.width < lastItem.x - box.space) {
                    lastItem.x = -1;
                    lastItem.parent.setChildIndex(lastItem, 0);
                    box.refresh();
                    r.x += lastItem.width + box.space;
                }
            } else {
                let firstItem = box.getChildAt(0);
                if (firstItem.x + firstItem.width + box.space < r.x) {
                    firstItem.removeSelf();
                    firstItem.x = box.width;
                    box.addChild(firstItem);
                    box.refresh();
                    r.x -= firstItem.width + box.space;
                }
            }
            this.hGuessLikePanel.content.scrollRect = r;
        }
    }
    class ListManager {
        constructor() {
            this.listRepeatCount = 1;
            this.isMouseDown = false;
            this.isMoveRight = false;
        }
        init(m_listRepeatCount, m_listArr = null) {
            this.listRepeatCount = m_listRepeatCount;
            this.listArr = m_listArr;
            Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
            Laya.stage.on(Laya.Event.MOUSE_UP, this, this.onMouseUp);
        }
        onMouseDown() {
            this.isMouseDown = true;
        }
        onMouseUp() {
            this.isMouseDown = false;
        }
        checkListMove() {
            // if (this.isMouseDown) {
            //     return;
            // }
            // for (var i = 0; i < this.listArr.length; i++) {
            //     let count = this.listArr[i].array.length - 1;
            //     if (Math.abs(this.listArr[i].scrollBar.value) < 10) {
            //         this.isMoveRight = true;
            //     }
            //     if (Math.abs(this.listArr[i].scrollBar.value - Math.abs(this.listArr[i].scrollBar.max)) < 100) {
            //         this.isMoveRight = false;
            //     }
            //     let speed = this.listRepeatCount;
            //     if (this.isMoveRight) {
            //         speed = 1 - Math.abs(this.listArr[i].scrollBar.value / this.listArr[i].scrollBar.max);
            //         this.listArr[i].tweenTo(count, 5e4 * speed);
            //     } else {
            //         speed = Math.abs(this.listArr[i].scrollBar.value / this.listArr[i].scrollBar.max);
            //         this.listArr[i].tweenTo(0, 5e4 * speed);
            //     }
            // }
        }
        getDataSource(listType, m_placement, m_eventid) {
            // let list;
            // switch (listType) {
            //     case "bottomList":
            //         list = Laya.Browser.window.dnsdk.data.pushData.bottomList;
            //         break;

            //     case "grouppageList":
            //         list = Laya.Browser.window.dnsdk.data.pushData.grouppageList;
            //         break;

            //     case "hotgameList":
            //         list = Laya.Browser.window.dnsdk.data.pushData.hotgameList;
            //         break;

            //     case "moregameList":
            //         list = Laya.Browser.window.dnsdk.data.pushData.moregameList;
            //         break;

            //     case "moregroupList":
            //         list = Laya.Browser.window.dnsdk.data.pushData.moregroupList;
            //         break;

            //     default:
            //         console.error("没有这个类型");
            //         break;
            // }
            // let length = list.length;
            // let dataSource = [];
            // for (let i = 0; i < length * 2 * this.listRepeatCount; i++) {
            //     let index = i % length;
            //     let item = list[index];
            //     let skin = item.icon;
            //     let data = {
            //         sharename: item.gameName,
            //         dnsdkid: item.id,
            //         openPath: item.openPath,
            //         shareid: item.pushAppID,
            //         icon: {
            //             skin: skin
            //         },
            //         label: {
            //             text: item.gameName
            //         },
            //         desc: {
            //             text: item.extra
            //         }
            //     };
            //     dataSource.push(data);
            //     if (Laya.Browser.window.dnsdk && i < length) {
            //         var tjData = {
            //             label: item.id,
            //             pushappid: item.pushAppID,
            //             placement: m_placement,
            //             eventid: m_placement
            //         };
            //         Laya.Browser.window.dnsdk.tjSendShowEvent(tjData);
            //     }
            // }
            // return dataSource;
        }
    }
    class XSecTimer {
        constructor(interval, reset = true) {
            this.last_time = 0;
            this.interval = interval;
            if (reset) {
                this.reset();
            }
        }
        reset() {
            this.last_time = Laya.timer.currTimer;
        }
        check() {
            let time = Laya.timer.currTimer;
            if (time - this.last_time > this.interval) {
                this.last_time = time;
                return true;
            }
            return false;
        }
        elapse() {
            let time = Laya.timer.currTimer;
            let e = time - this.last_time;
            e = Math.min(e, this.interval);
            return e / this.interval;
        }
    }
    class XWxad {
        constructor() {
            this.wx = null;
            this.adUnitId = "adunit-7b6edc46aa02b0b2";
            this.video_UnitId = "adunit-84c5ff260dc12f14";
            this.interstitialAd_UnitID = "adunit-0cf31b217d112226";
            this.videoTodayEnd = false;
            this.rewardedVideoAd = null;
            this.VideoAdOk = false;
            this.ad_heidht = 220;
            this.ad_hi = 200;
            this.ad_width = 300;
            this.resetEnd = false;
            this.ad_load_ok = false;
            this.bannerAd = null;
            this.interstitialAd = null;
            this.isShow = false;
        }
        static get Inst() {
            if (this._instance == null) {
                this._instance = new XWxad();
            }
            return this._instance;
        }
        init(wx) {
            this.wx = wx;
            this.ad_hi = Laya.Browser.clientHeight / Laya.stage.height * this.ad_hi;
            this.ad_width = Laya.Browser.clientWidth * .05;
        }
        CreateAd() {
            if (!this.wx) {
                return;
            }
            let top = 800;
            let wi = Laya.Browser.clientWidth - this.ad_width * 2;
            let example = {
                adUnitId: this.adUnitId,
                adIntervals: 30,
                style: {
                    top: top,
                    left: (Laya.Browser.clientWidth - wi) / 2,
                    width: wi * .8
                }
            };
            this.bannerAd = Laya.Browser.window.wx.createBannerAd(example);
            let self = this;
            this.bannerAd.onLoad(() => {
                console.log("广告加载完成", self.bannerAd);
                self.ad_load_ok = true;
                var phone = this.wx.getSystemInfoSync();
                console.log("phone info", phone);
                let hi = Laya.stage.width / Laya.Browser.clientWidth * self.bannerAd.style.realHeight;
                self.bannerAd.style.top = Laya.Browser.clientHeight - self.bannerAd.style.realHeight + .1;
                self.bannerAd.style.left = Laya.Browser.clientWidth / 2 - self.bannerAd.style.realWidth / 2;
                if (phone.model.search(/[iI][pP]hone\s*[xX]/) != -1) {
                    let hi = Laya.stage.width / Laya.Browser.clientWidth * (self.bannerAd.style.realHeight + 36);
                    self.bannerAd.style.top -= 36;
                    self.ad_heidht = 310;
                }
                if (self.ad_heidht < hi) {
                    self.ad_heidht = hi;
                }
                this.bannerAd.show();
                console.log("广告加载完成", self.bannerAd);
            });
            this.bannerAd.onError(err => {
                console.error("广告加载错误:" + err);
            });
        }
        ChangeAd() {
            if (!this.wx) {
                return;
            }
            this.bannerAd.destroy();
            this.CreateAd();
        }
        ShowBannerAd() {
            if (!this.wx) {
                return;
            }
            this.isShow = true;
            this.bannerAd.show();
            console.log("显示广告");
        }
        HideAd() {
            if (!this.wx) {
                return;
            }
            if (this.ad_load_ok) {
                this.isShow = false;
                this.bannerAd.hide();
            }
        }
        CreateVideo() {
            if (!this.wx) {
                return;
            }
            let example = {
                adUnitId: this.video_UnitId
            };
            let self = this;
            if (this.rewardedVideoAd == null) {
                console.log("创建视频");
                this.rewardedVideoAd = this.wx.createRewardedVideoAd(example);
                this.rewardedVideoAd.onLoad(() => {
                    self.VideoAdOk = true;
                    console.log("视频加载成功");
                });
                this.rewardedVideoAd.onError(function(res) {
                    console.log("视频加载错误");
                });
            }
        }
        ShowVideo(callback) {
            if (!this.wx) {
                callback && callback("local");
                return;
            }
            let self = this;
            if (this.VideoAdOk) {
                this.rewardedVideoAd.show();
                this.rewardedVideoAd.offClose();
                this.rewardedVideoAd.onClose(res => {
                    console.log("视频关闭");
                    let playstate = "break;";
                    if (res && res.isEnded || res === undefined) {
                        playstate = "finish";
                        self.wx.showToast({
                            title: "观看视频广告成功，获得奖励",
                            icon: "none"
                        });
                    } else {
                        self.wx.showToast({
                            title: "未看完视频广告，不能获得奖励",
                            icon: "none"
                        });
                    }
                    callback && callback(playstate);
                });
            } else {
                callback && callback("error");
            }
            this.rewardedVideoAd.onError(function(res) {
                if (res.errCode == 1004) {
                    self.wx.showToast({
                        title: "今日视频广告已看完",
                        icon: "none"
                    });
                    self.videoTodayEnd = true;
                    callback && callback("1004");
                } else {
                    self.wx.showToast({
                        title: "视频广告打开出错",
                        icon: "none"
                    });
                    callback && callback("error");
                    console.error("视频广告打开出错", res);
                }
            });
        }
        JumpGame(dnsdkid, placement, eventid, name, appId, path) {
            console.log("推荐游戏进入 " + name + " " + appId + "placement::" + placement + "eventid:::" + eventid);
            var tjData = {
                label: dnsdkid,
                pushappid: appId,
                placement: placement,
                eventid: eventid
            };
            if (Laya.Browser.window.dnsdk) {
                Laya.Browser.window.dnsdk.tjSendClickEvent(tjData);
            }
            console.log("发送统计" + JSON.stringify(tjData));
            if (this.wx == null) return;
            this.wx.navigateToMiniProgram({
                appId: appId,
                path: path,
                success: function() {
                    console.log("小程序跳转成功" + name + " " + appId);
                },
                fail: function() {
                    console.log("小程序跳转失败" + name + " " + appId);
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_show_game_share, {
                        isShow: true
                    });
                }
            });
        }
        create_interstitialAd() {
            if (Laya.Browser.window.wx && Laya.Browser.window.wx.createInterstitialAd) {
                this.interstitialAd = Laya.Browser.window.wx.createInterstitialAd({
                    adUnitId: this.interstitialAd_UnitID
                });
                console.log("创建插屏广告");
            }
        }
        show_interstitialAd(callback = null) {
            if (this.interstitialAd) {
                console.log("显示插屏广告");
                this.interstitialAd.show().catch(err => {
                    console.log("显示插屏广告错误");
                    callback && callback("error");
                    console.error(err);
                });
            }
        }
    }
    XWxad._instance = null;
    class SplashList_panel extends ui.scenes.SplashListDialogUI {
        constructor() {
            super();
            this.scroll_timer = null;
            this.is_show = true;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.listManager = new ListManager();
            this.listManager.init(1, [this.list_dev_box]);
            this.list_dev_box.vScrollBarSkin = "";
            this.list_dev_box.renderHandler = new Laya.Handler(this, this.list_dev_box_itemRenderHandler);
            this.list_dev_box_fill_list();
            this.scroll_timer = new XSecTimer(1500, false);
        }
        list_dev_box_fill_list() {
            // if (!Laya.Browser.window.dnsdk) return;
            // let dataSource = this.listManager.getDataSource("grouppageList", "pass", "grouppage");
            // if (!dataSource || dataSource && dataSource.length == 0) {
            //     console.error("dnsdk grouppageList is null！");
            //     return;
            // }
            // this.list_dev_box.dataSource = dataSource;
        }
        list_dev_box_itemRenderHandler(cell, index) {
            let data = cell.dataSource;
            let name_bg = cell.getChildByName("name_bg");
            if (index % 3 == 0) {
                name_bg.skin = "dev/ui_hong.png";
            } else if (index % 3 == 1) {
                name_bg.skin = "dev/ui_lv.png";
            } else {
                name_bg.skin = "dev/ui_cheng.png";
            }
            cell.offAll();
            cell.on("click", this, this.list_dev_box_itemClickHandler, [data]);
        }
        list_dev_box_itemClickHandler(data) {
            let self = this;
            XWxad.Inst.JumpGame(data.dnsdkid, "splash", "splash", data.sharename, data.shareid, data.openPath);
        }
        init_view() {
            this.is_show = true;
            Laya.timer.frameLoop(80, this, this.update_view);
        }
        hide() {
            console.log("xiejinhui 自动关闭结算互推界面");
            this.is_show = false;
            Laya.timer.clear(this, this.update_view);
        }
        update_view() {
            if (!this.parent || !this.is_show) {
                return;
            }
            if (this.scroll_timer.check()) {
                this.listManager.checkListMove();
            }
        }
    }
    class ui_fail extends ui.scenes.ui_failUI {
        constructor() {
            super(...arguments);
            this.curRewardNum = 0;
            this.b_show_video = false;
            this.tt_push_view = undefined;
            this.dnsdk_view = undefined;
            this.is_reborn = false;
        }
        awake() {
            this.btn_restart.on(Laya.Event.CLICK, this, this.on_click_restart);
            this.btn_reborn.on(Laya.Event.CLICK, this, this.on_click_reborn);
            this.btn_once.on(Laya.Event.CLICK, this, this.on_click_one);
            this.btn_double.on(Laya.Event.CLICK, this, this.on_click_double);
            this.register_listener();
        }
        on_enable(param) {
            this.chapter_id = param.chapter_id || 1;
            this.progress = igc.phone_manager.instance.call(phone_ids.get_chapter_progress) || 0;
            this.curRewardNum = Math.ceil(param.reward * this.progress);
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.add_game_number);
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_show_horizontal_guess_like, {
                isShow: true,
                uiPlaceType: igc.e_push_ui_place.fail,
                chapterId: this.chapter_id
            });
            nativeOpen("失败页",1)
            this.init_view();
            this.turn_over.visible = param.fail_reason == e_fail_reason.turn_over;
            this.no_coal.visible = param.fail_reason == e_fail_reason.no_coal;
            console.log("fail_reason", param.fail_reason);
            console.log("失敗獎勵", this.curRewardNum);
            this.init_tt_guess_like();
            this.init_dnsdk_view();
            platform.getInstance().initList(this.list_showA);
            // SetGamePromoVisible(true);
            setTimeout(function() {
                ShowInter();
            }, 500);
        }
        init_dnsdk_view() {
            igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_push_view_show_icon, {
                is_show_guess_like: false,
                is_show_icon: false
            });
            // if (global.game.channel_type == igc.e_channel_type.wx || global.game.channel_type == igc.e_channel_type.web) {
            //     if (!this.dnsdk_view) {
            //         this.dnsdk_view = new SplashList_panel();
            //         this.dnsdk_layout.addChild(this.dnsdk_view);
            //     }
            //     this.dnsdk_view && this.dnsdk_view.init_view();
            // }
        }
        init_tt_guess_like() {
            if (global.game.channel_type == igc.e_channel_type.tt) {
                if (global.game.is_support_tt_push) {
                    this.multual_push_layout.visible = true;
                    if (!this.tt_push_view) {
                        this.tt_push_view = new ui_tt_guess_like();
                        this.tt_push_view.on_enable();
                        this.multual_push_layout.addChild(this.tt_push_view);
                    } else {
                        this.tt_push_view.on_enable();
                    }
                } else {
                    this.multual_push_layout.visible = false;
                    this.multual_push_layout.removeChildren();
                }
            } else {
                this.multual_push_layout.visible = false;
            }
        }
        on_disable() {
            // SetGamePromoVisible(false);
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_show_horizontal_guess_like, {
                isShow: false
            });
            if (global.game.channel_type == igc.e_channel_type.tt || global.game.channel_type == igc.e_channel_type.web) {
                this.tt_push_view && this.tt_push_view.on_disable();
            }
        }
        init_view() {
            if (global.game.channel_type != igc.e_channel_type.tt) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
                    type: global.ad_type.banner.normal
                });
            }
            console.log("xiejinhui 当前关卡：", this.chapter_id, "当前进度：", this.progress);
            if (global.game.channel_type != igc.e_channel_type.wx) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.pre_load_native, {
                    native_type: global.ad_type.native.challenge_fail,
                    inster_type: global.ad_type.inster.challenge_fail,
                    duration: 500
                });
            }
            let self = this;
            this.b_show_video = false;
            let base_config = igc.igc_config_manager.instance.configs_data["base"];
            this.is_reborn = this.progress >= .3;
            if (igc.phone_manager.instance.call(phone_ids.get_reborn_state)) {
                this.is_reborn = false;
            }
            this.btn_double.visible = false;
            this.btn_reborn.visible = true;
            // if (global.game.channel_type == igc.e_channel_type.oppo_qg) {
            //     this.buttom.bottom = 350;
            //     this.btn_once.bottom = 480;
            //     this.btn_restart.bottom = 480;
            //     this.btn_once.visible = false;
            //     this.btn_restart.visible = false;
            //     this.delay_show_conitue();
            // } else if (global.game.channel_type == igc.e_channel_type.vivo_qg) {
            //     this.buttom.bottom = 100;
            //     this.btn_once.bottom = 180;
            //     this.btn_restart.bottom = 180;
            //     this.btn_once.visible = false;
            //     this.btn_restart.visible = false;
            //     this.delay_show_conitue();
            // } else {
            //     this.buttom.bottom = 300;
            // this.btn_double.visible = !this.is_reborn;
            // this.btn_reborn.visible = this.is_reborn;
            this.btn_once.visible = false;
            this.btn_restart.visible = true;
            //     if (global.game.channel_type == igc.e_channel_type.tt) {
            //         this.btn_once.bottom = 100;
            //         this.btn_restart.bottom = 100;
            //         igc.broadcast_manager.instance.broadcast(broadcast_ids.hide_banner);
            //         Laya.timer.once(1800, this, function () {
            //             if (self.parent) {
            //                 igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
            //                     type: global.ad_type.banner.normal
            //                 });
            //             }
            //         });
            //         Laya.timer.once(1e3, this, function () {
            //             self.btn_restart.visible = self.is_reborn;
            //             self.btn_once.visible = !self.is_reborn;
            //         });
            //     } else {
            //         this.fail.centerY = -600;
            //         this.buttom.bottom = 320;
            //         this.btn_once.bottom = 420;
            //         this.btn_restart.bottom = 420;
            // self.btn_restart.visible = self.is_reborn;
            // self.btn_once.visible = !self.is_reborn;
            //     }
            // }
            this.lb_reward.value = this.curRewardNum + "";
            if (global.game.channel_type == igc.e_channel_type.wx || global.game.channel_type == igc.e_channel_type.web) {
                // this.fail.centerY = -650;
            }
        }
        register_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.show_native_success, this, this.show_native_success);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.banner_show, this, this.update_btn_pos);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.oppo_native_in_cd, this, this.oppo_native_in_cd);
        }
        release_listener() {
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.show_native_success, this, this.show_native_success);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.banner_show, this, this.update_btn_pos);
            igc.broadcast_manager.instance.remove_listener(igc.igc_broadcast_ids.oppo_native_in_cd, this, this.oppo_native_in_cd);
        }
        oppo_native_in_cd() {
            if (this.parent) {}
        }
        update_btn_pos() {
            if (global.game.channel_type == igc.e_channel_type.tt) {
                // this.btn_once.bottom = 380;
                // this.btn_restart.bottom = 380;
            }
        }
        delay_show_conitue() {
            let self = this;
            // this.btn_double.visible = !this.is_reborn;
            // this.btn_reborn.visible = this.is_reborn;
            // this.btn_once.visible = !this.is_reborn;
            // this.btn_restart.visible = this.is_reborn;
        }
        show_native_success() {
            let self = this;
            if (this.parent && (global.game.channel_type == igc.e_channel_type.oppo_qg || global.game.channel_type == igc.e_channel_type.vivo_qg)) {
                // this.buttom.bottom = 100;
                // this.btn_once.bottom = 180;
                // this.btn_restart.bottom = 180;
            }
        }
        on_click_restart() {
            if (this.b_show_video) {
                return;
            }
            igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
                value: this.curRewardNum,
                reason: "fail"
            });

            platform.getInstance().showInterstitial(() => {
                this.game_restart();
            })
        }
        game_restart() {
            igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            this.hide();
            igc.broadcast_manager.instance.broadcast(broadcast_ids.chapter_restart);
            if (global.game.channel_type == igc.e_channel_type.wx || global.game.channel_type == igc.e_channel_type.web) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_show_game_share, {
                    isShow: true,
                    is_result: true
                });
            }
        }
        on_click_one() {
            if (this.b_show_video) {
                return;
            }
            igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
                value: this.curRewardNum,
                reason: "fail"
            });

            platform.getInstance().showInterstitial(() => {
                this.game_restart();
            })
        }
        on_click_double() {
            let self = this;
            // if (this.b_show_video) {
            //     return;
            // }
            Laya.timer.once(3e3, this, function() {
                self.b_show_video = false;
            });
            this.b_show_video = true;
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.show_video, {
            //     type: global.ad_type.video.fail_double,
            //     call_back: function () {
            //         igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
            //             value: self.curRewardNum * 3,
            //             reason: "fail_video"
            //         });
            //         self.game_restart();
            //     },
            //     error_back: function () {
            //         self.b_show_video = false;
            //     }
            // });

            platform.getInstance().showReward(() => {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
                    value: self.curRewardNum * 3,
                    reason: "fail_video"
                });
                self.game_restart();
            }, () => {
                self.b_show_video = false;
                platform.getInstance().prompt("ADS not availabe NOW! Please try again later");
            },1001)
        }
        hide() {
            let self = this;
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: self
            });
        }
        on_click_reborn() {
            let self = this;
            // if (this.b_show_video) {
            //     return;
            // }
            Laya.timer.once(3e3, this, function() {
                self.b_show_video = false;
            });
            this.b_show_video = true;
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
            //     value: this.curRewardNum * 2,
            //     reason: "fail"
            // });
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.show_video, {
            //     type: global.ad_type.video.challenge_fail,
            //     call_back: function () {
            //         console.log("xiejinhui 看视频复活！");
            //         igc.broadcast_manager.instance.broadcast(broadcast_ids.chapter_relife);
            //         self.hide();
            //         self.b_show_video = false;
            //     },
            //     error_back: function () {
            //         self.b_show_video = false;
            //     }
            // });

            platform.getInstance().showReward(() => {
                console.log("xiejinhui 看视频复活！");
                igc.broadcast_manager.instance.broadcast(broadcast_ids.chapter_relife);
                self.hide();
                self.b_show_video = false;
            }, () => {
                self.b_show_video = false;
                platform.getInstance().prompt("ADS not availabe NOW! Please try again later");
            },1002)
        }
    }
    class ui_success extends ui.scenes.ui_successUI {
        constructor() {
            super(...arguments);
            this.b_show_video = false;
            this.tt_push_view = undefined;
            this.dnsdk_view = undefined;
            this.has_share_video = false;
        }
        awake() {
            this.btn_double.on(Laya.Event.CLICK, this, this.on_click_double);
            this.btn_one.on(Laya.Event.CLICK, this, this.on_click_one);
            this.btn_share_video.on(Laya.Event.CLICK, this, this.on_click_share);
            this.btn_continue.on(Laya.Event.CLICK, this, this.on_click_one);
            this.register_listener();
        }
        on_enable(param) {
            nativeOpen("完成页",1)
            this.has_share_video = false;
            this.chapter_id = param.chapter_id || 1;
            console.log("success", param);
            this.diamondAni.play(0, false);
            this.b_show_video = false;
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.add_game_number);
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_show_most_popular, {
                isShow: true,
                uiPlaceType: igc.e_push_ui_place.success,
                chapterId: this.chapter_id
            });
            this.init_view(param.reward);
            this.init_tt_guess_like();
            this.init_dnsdk_view();
            platform.getInstance().initList(this.list_showA);
            // SetGamePromoVisible(true);
            setTimeout(function() {
                ShowInter();
            }, 500);
        }
        init_dnsdk_view() {
            igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_push_view_show_icon, {
                is_show_guess_like: false,
                is_show_icon: false
            });
            // if (global.game.channel_type == igc.e_channel_type.wx || global.game.channel_type == igc.e_channel_type.web) {
            //     if (!this.dnsdk_view) {
            //         this.dnsdk_view = new SplashList_panel();
            //         this.dnsdk_layout.addChild(this.dnsdk_view);
            //     }
            //     this.dnsdk_view && this.dnsdk_view.init_view();
            // }
        }
        init_tt_guess_like() {
            if (global.game.channel_type == igc.e_channel_type.tt) {
                if (global.game.is_support_tt_push) {
                    this.multual_push_layout.visible = true;
                    if (!this.tt_push_view) {
                        this.tt_push_view = new ui_tt_guess_like();
                        this.tt_push_view.on_enable();
                        this.multual_push_layout.addChild(this.tt_push_view);
                    } else {
                        this.tt_push_view.on_enable();
                    }
                } else {
                    this.multual_push_layout.visible = false;
                    this.multual_push_layout.removeChildren();
                }
            } else {
                this.multual_push_layout.visible = false;
            }
        }
        on_disable() {
            // SetGamePromoVisible(false);
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_show_most_popular, {
                isShow: false
            });
            if (global.game.channel_type == igc.e_channel_type.tt || global.game.channel_type == igc.e_channel_type.web) {
                this.tt_push_view && this.tt_push_view.on_disable();
            }
        }
        init_view(reward) {
            let self = this;
            if (global.game.channel_type != igc.e_channel_type.tt) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
                    type: global.ad_type.banner.normal
                });
            }
            this.curRewardNum = reward;
            this.lb_reward.value = this.curRewardNum + "";
            // if (igc.multual_push_manager.instance.check_is_limit_multual(igc.e_push_type.popular)) {
            //     this.top_view.centerY = -650;
            // } else {
            //     this.top_view.centerY = -700;
            // }
            // if (global.game.channel_type == igc.e_channel_type.wx || global.game.channel_type == igc.e_channel_type.web) {
            //     this.top_view.centerY = -700;
            // }
            this.btn_one.visible = false;
            Laya.timer.once(1e2, this, function() {
                self.btn_one.visible = !(global.game.channel_type == igc.e_channel_type.oppo_qg || global.game.channel_type == igc.e_channel_type.vivo_qg);
            });
            this.btn_share_video.visible = global.game.channel_type == igc.e_channel_type.tt;
            this.btn_double.visible = !(global.game.channel_type == igc.e_channel_type.oppo_qg || global.game.channel_type == igc.e_channel_type.vivo_qg);
            this.btn_continue.visible = false;
            // if (global.game.channel_type == igc.e_channel_type.tt) {
            //     igc.phone_manager.instance.call(phone_ids.show_ui, {
            //         ui: ui_class.ui_share_video,
            //         param: {}
            //     });
            //     igc.broadcast_manager.instance.broadcast(broadcast_ids.hide_banner);
            //     this.buttom_view.bottom = 350;
            //     this.btn_one.bottom = 100;
            //     Laya.timer.once(1800, this, function () {
            //         if (self.parent) {
            //             igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
            //                 type: global.ad_type.banner.normal
            //             });
            //         }
            //     });
            // } else if (global.game.channel_type == igc.e_channel_type.oppo_qg) {
            //     this.buttom_view.bottom = 200;
            //     this.btn_one.bottom = 250;
            //     this.delay_show_conitue();
            // } else if (global.game.channel_type == igc.e_channel_type.vivo_qg) {
            //     this.buttom_view.bottom = 200;
            //     this.btn_one.bottom = 250;
            //     this.delay_show_conitue();
            // } else {
            //     this.buttom_view.bottom = 370;
            //     this.btn_one.bottom = 420;
            // }
            let native_count = igc.phone_manager.instance.call(igc.igc_phone_ids.get_oppo_native_count);
            if (native_count >= 8) {
                this.show_oppo_video_btn();
            }
            if (global.game.channel_type != igc.e_channel_type.wx) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.pre_load_native, {
                    native_type: global.ad_type.native.challenge_success,
                    inster_type: global.ad_type.inster.challenge_success,
                    duration: 500
                });
            }
        }
        show_oppo_video_btn() {
            console.log("xiejinhui 展示Oppo5倍奖励按钮");
            // this.buttom_view.bottom = 400;
            // this.btn_one.bottom = 470;
            this.btn_double.visible = true;
            this.btn_continue.y = 480;
        }
        delay_show_conitue() {
            let self = this;
            this.btn_continue.y = 220;
            self.btn_continue.visible = true;
        }
        show_native_success() {
            if (global.game.channel_type == igc.e_channel_type.oppo_qg || global.game.channel_type == igc.e_channel_type.vivo_qg) {
                // this.buttom_view.bottom = 200;
                // this.btn_one.bottom = 250;
            }
        }
        register_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.show_native_success, this, this.show_native_success);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.banner_show, this, this.update_btn_pos);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.share_inner_video_compelete, this, this.share_inner_video_compelete);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.oppo_native_in_cd, this, this.oppo_native_in_cd);
        }
        release_listener() {
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.show_native_success, this, this.show_native_success);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.banner_show, this, this.update_btn_pos);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.share_inner_video_compelete, this, this.share_inner_video_compelete);
            igc.broadcast_manager.instance.remove_listener(igc.igc_broadcast_ids.oppo_native_in_cd, this, this.oppo_native_in_cd);
        }
        oppo_native_in_cd() {
            this.show_oppo_video_btn();
        }
        update_btn_pos() {
            if (global.game.channel_type == igc.e_channel_type.tt) {
                // this.btn_one.bottom = 350;
            }
        }
        share_inner_video_compelete() {
            if (this.parent && global.game.channel_type == igc.e_channel_type.tt) {
                this.has_share_video = true;
                this.btn_share_video.visible = false;
            }
        }
        on_click_one() {
            if (this.b_show_video) {
                return;
            }
            igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
                value: this.curRewardNum,
                reason: "win"
            });
            platform.getInstance().showInterstitial(() => {
                this.game_continue();
            })
        }
        on_click_double() {
            let self = this;
            // if (this.b_show_video) {
            //     return;
            // }
            Laya.timer.once(3e3, this, function() {
                self.b_show_video = false;
            });
            this.b_show_video = true;
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.show_video, {
            //     type: global.ad_type.video.chapter_double_reward,
            //     call_back: function () {
            //         self.b_show_video = false;
            //         igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
            //             value: self.curRewardNum * 5,
            //             reason: "win_video"
            //         });
            //         self.game_continue();
            //     },
            //     error_back: function () {
            //         self.b_show_video = false;
            //     }
            // });

            platform.getInstance().showReward(() => {
                self.b_show_video = false;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
                    value: self.curRewardNum * 5,
                    reason: "win_video"
                });
                self.game_continue();
            }, () => {
                self.b_show_video = false;
                platform.getInstance().prompt("ADS not availabe NOW! Please try again later");
            },1003)
        }
        on_click_share() {
            if (this.has_share_video) {
                igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.share_inner_video, {
                    on_failed: function() {
                        igc.phone_manager.instance.call(phone_ids.show_tips, {
                            desc: "视频分享失败"
                        });
                    },
                    on_succeed: function() {
                        igc.phone_manager.instance.call(phone_ids.show_tips, {
                            desc: "您已经领取过奖励"
                        });
                    }
                });
            } else {
                let env_id = igc.phone_manager.instance.call(phone_ids.get_share_env_id);
                console.log("分享可以获得的场景", env_id);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.record_screen, {
                    env_id: env_id
                });
            }
        }
        game_continue() {
            let self = this;
            igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: self
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.chapter_continue);
            if (global.game.channel_type == igc.e_channel_type.wx || global.game.channel_type == igc.e_channel_type.web) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_show_game_share, {
                    isShow: true,
                    is_result: true,
                    is_success: true
                });
            }
        }
    }
    class ui_adv extends ui.scenes.ui_advUI {
        constructor() {
            super(...arguments);
            this.native_data = null;
            this.ad_id = null;
        }
        awake() {
            this.btn_click_button.on(Laya.Event.CLICK, this, this.on_click_video);
            this.icon_video.on(Laya.Event.CLICK, this, this.on_click_video);
            this.btn_click_close.on(Laya.Event.CLICK, this, this.on_click_close);
            this.register_listener();
        }
        on_enable(param) {
            this.native_data = param.native_data || null;
            this.ad_id = param.ad_id || null;
            this.init_view();
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_temp_show, true);
        }
        on_disable() {
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_temp_show, false);
        }
        init_view() {
            if (this.native_data && this.ad_id) {
                this.icon_video.skin = this.native_data.imgUrlList[0];
                this.text_desc.text = this.native_data.desc;
                this.report_show();
            }
        }
        register_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.close_native, this, this.close_native);
        }
        release_listener() {
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.close_native, this, this.close_native);
        }
        close_native() {
            if (global.game.channel_type == igc.e_channel_type.oppo_qg || global.game.channel_type == igc.e_channel_type.vivo_qg) {
                this.on_click_close();
            }
        }
        report_show() {
            let self = this;
            if (self.native_data && this.ad_id) {
                let unit_id = self.native_data.adUnitId;
                console.log("xiejinhui 上报原生广告", unit_id, this.ad_id);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.report_show, {
                    unit_id: unit_id,
                    ad_id: this.ad_id
                });
                igc.broadcast_manager.instance.broadcast(broadcast_ids.display_native);
            }
        }
        report_click() {
            let self = this;
            if (self.native_data && this.ad_id) {
                let unit_id = self.native_data.adUnitId;
                console.log("xiejinhui 上报原生点击", unit_id, this.ad_id);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.report_click, {
                    unit_id: unit_id,
                    ad_id: this.ad_id
                });
            }
        }
        on_click_video() {
            console.log("xiejinhui 点击了原生广告");
            this.report_click();
        }
        on_click_close() {
            let self = this;
            if (!self.parent) {
                console.log("原生广告没有父节点  不接受监听");
                return;
            }
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: self
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.set_can_show_banner);
        }
        window_resize(_, param) {}
    }
    class ui_chapter_info extends ui.scenes.chapter_infoUI {
        awake() {
            this.register_listener();
        }
        on_enable() {
            this.coal_container.visible = false;
            this.window_resize(0, {
                new_width: window.innerWidth,
                new_height: window.innerHeight
            });
            this.update_chapter_info(0, {});
            this.init_view();
        }
        init_view() {
            let chapter_id = igc.phone_manager.instance.call(phone_ids.get_chapter_id) || 1;
            this.text_chaper.value = chapter_id + "";
            if (chapter_id <= 2) {
                igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.ui_guide,
                    param: {}
                });
            }
        }
        register_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.turn_speed_out, this, this.turn_speed_out);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_burn_progress, this, this.update_burn_progress);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.window_resize, this, this.window_resize);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_chapter_info, this, this.update_chapter_info);
        }
        release_listener() {
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.turn_speed_out, this, this.turn_speed_out);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.update_burn_progress, this, this.update_burn_progress);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.window_resize, this, this.window_resize);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.update_chapter_info, this, this.update_chapter_info);
        }
        update_burn_progress(id, param) {
            this.coal_container.visible = param.is_show;
            if (param.is_show) {
                this.coal_progress.graphics.clear();
                this.coal_progress.graphics.drawPie(75, 75, 75, -90 + 360 * (1 - param.progress), 270, "ff0000");
                this.tip_not_full.visible = param.progress <= .1;
            }
            this.tip_coal_empty.visible = param.progress <= 0;
            this._coal_progress = param.progress;
        }
        turn_speed_out(id, param) {
            this.tip_speed_out.visible = param.speed_out;
        }
        update_chapter_info(id, param) {
            let progress = param.progress || igc.phone_manager.instance.call(phone_ids.get_chapter_progress) || 0;
            this.progress_bar.width = 830 * progress;
        }
        window_resize(_, param) {
            let default_width = GameConfig.width;
            let default_height = GameConfig.height;
            let real_width = param.new_width;
            let real_height = param.new_height;
            let view_height = real_height * default_width / real_width;
            if (view_height > GameConfig.height) {}
        }
    }
    class ui_private_view extends ui.scenes.ui_private_viewUI {
        awake() {
            this.mp_scroll_panel.vScrollBarSkin = "";
        }
        on_enable(param) {
            this.register_listener();
        }
        on_click_close() {
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: this
            });
        }
        register_listener() {
            this.mp_btn_close.on(Laya.Event.CLICK, this, this.on_click_close);
        }
        release_listener() {
            this.mp_btn_close.off(Laya.Event.CLICK, this, this.on_click_close);
        }
        on_disable() {
            this.release_listener();
        }
    }
    class ui_load_res extends ui.scenes.ui_load_resUI {
        on_enable(param) {}
        hide_self() {
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: this
            });
        }
        update() {
            this.mp_img_load.rotation += 1;
        }
        on_disable() {}
    }
    class ui_login extends ui.scenes.ui_loginUI {
        constructor() {
            super();
            this.dt = 1 / 20;
            this.n_progress = 0;
            this.register_listener();
            this.init_view();
        }
        awake() {
            this.register_listener();
        }
        on_disable() {}
        init_view() {
            console.log("enter -login");
            this.n_progress = 0;
        }
        register_listener() {}
        release_listener() {}
        close() {
            this.destroy();
        }
        onDestroy() {}
        set_progress(progress) {
            if (this.n_progress >= progress) {
                return;
            }
            this.n_progress = Math.max(progress, 0);
            this.n_progress = Math.min(progress, 1);
            this.progress_mask.x = -this.img_progress.width * (1 - Math.min(progress, 1));
        }
        increase_progress() {
            this.set_progress(this.n_progress + .01);
        }
    }
    class ui_offline extends ui.scenes.ui_offlineUI {
        constructor() {
            super(...arguments);
            this.b_show_video = false;
            this.is_first = true;
        }
        awake() {
            this.btn_double.on(Laya.Event.CLICK, this, this.on_click_double);
            this.btn_one.on(Laya.Event.CLICK, this, this.on_click_one);
            this.register_listener();
        }
        on_enable(param) {
            console.log("ui_offline enter!!!");
            this.call_back = param.call_back;
            this.init_view(param.offline_reward);
        }
        on_disable() {}
        init_view(offline_reward) {
            console.log("ui_offline init_view!!!");
            let self = this;
            this.b_show_video = false;
            this.curRewardNum = offline_reward;
            this.lb_reward.value = this.curRewardNum + "";
            this.btn_one.visible = false;
            let delay_time = 1e2;
            if (global.game.channel_type == igc.e_channel_type.oppo_qg) {
                delay_time = 0;
            }
            Laya.timer.once(delay_time, this, function() {
                self.btn_one.visible = true;
            });
            this.buttom.bottom = 420;
            if (global.game.channel_type == igc.e_channel_type.tt) {
                this.btn_one.bottom = 100;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.hide_banner);
                Laya.timer.once(1800, this, function() {
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
                        type: global.ad_type.banner.normal
                    });
                });
            } else {
                this.btn_one.bottom = 420;
                let duration = 10;
                if (global.game.channel_type == igc.e_channel_type.oppo_qg && this.is_first) {
                    this.is_first = false;
                    duration = 5e3;
                }
                console.log("ui_offline satrt show first banner11111");
                Laya.timer.once(duration, this, function() {
                    console.log("ui_offline satrt show first banner2222");
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
                        type: global.ad_type.banner.normal
                    });
                });
            }
        }
        register_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.banner_show, this, this.update_btn_pos);
        }
        release_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.banner_show, this, this.update_btn_pos);
        }
        update_btn_pos() {
            // if (global.game.channel_type == igc.e_channel_type.tt) {
            //     this.btn_one.bottom = 350;
            // }
        }
        show_native_success() {
            if (global.game.channel_type == igc.e_channel_type.oppo_qg && this.parent) {}
        }
        on_click_one() {
            if (this.b_show_video) {
                return;
            }
            igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
                value: this.curRewardNum,
                reason: "offline"
            });
            platform.getInstance().showInterstitial(() => {
                this.hide();
            })
        }
        on_click_double() {
            let self = this;
            // if (this.b_show_video) {
            //     return;
            // }
            Laya.timer.once(3e3, this, function() {
                self.b_show_video = false;
            });
            this.b_show_video = true;
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.show_video, {
            //     type: global.ad_type.video.offline_double,
            //     call_back: function () {
            //         igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
            //             value: self.curRewardNum * 3,
            //             reason: "offline_video"
            //         });
            //         self.hide();
            //         self.b_show_video = false;
            //     },
            //     error_back: function () {
            //         self.b_show_video = false;
            //     }
            // });

            platform.getInstance().showReward(() => {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
                    value: self.curRewardNum * 3,
                    reason: "offline_video"
                });
                self.hide();
                self.b_show_video = false;
            }, () => {
                self.b_show_video = false;
                platform.getInstance().prompt("ADS not availabe NOW! Please try again later");
            },1004)
        }
        hide() {
            let self = this;
            igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: self
            });
            this.call_back && this.call_back();
        }
    }
    class ui_guide extends ui.scenes.ui_guideUI {
        awake() {}
        on_enable(param) {
            this.register_listener();
            this.init_view();
        }
        init_view() {
            let chapter_id = igc.phone_manager.instance.call(phone_ids.get_chapter_id);
            this.guide_1.visible = chapter_id == 1;
            this.guide_2.visible = chapter_id != 1;
        }
        on_click_close() {
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: this
            });
        }
        register_listener() {
            this.btn_continue.on(Laya.Event.CLICK, this, this.on_click_close);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_guide_state, this, this.update_guide_state);
        }
        release_listener() {
            this.btn_continue.off(Laya.Event.CLICK, this, this.on_click_close);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.update_guide_state, this, this.update_guide_state);
        }
        update_guide_state(id, param) {
            this.guide_1.visible = param.is_show;
        }
        on_disable() {
            this.release_listener();
        }
    }
    class ui_supply extends ui.scenes.ui_supplyUI {
        constructor() {
            super(...arguments);
            this.b_show_video = false;
        }
        awake() {
            this.btn_video.on(Laya.Event.CLICK, this, this.on_click_video);
            this.btn_cancel.on(Laya.Event.CLICK, this, this.on_click_close);
            this.register_listener();
        }
        on_enable(param) {
            this.call_back = param.call_back;
            this.init_view(param.reward);
        }
        on_disable() {}
        init_view(reward) {
            let self = this;
            this.b_show_video = false;
            let base_config = igc.igc_config_manager.instance.configs_data["base"];
            let supply_scale = base_config.supply_scale || 1;
            this.curRewardNum = Math.ceil(supply_scale * reward);
            this.lb_gold.value = this.curRewardNum + "";
            this.btn_cancel.visible = false;
            let delay_time = 1e3;
            if (global.game.channel_type == igc.e_channel_type.oppo_qg) {
                delay_time = 0;
            }
            Laya.timer.once(delay_time, this, function() {
                self.btn_cancel.visible = true;
            });
            if (global.game.channel_type == igc.e_channel_type.tt) {
                this.btn_cancel.bottom = 100;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.hide_banner);
                Laya.timer.once(1800, this, function() {
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
                        type: global.ad_type.banner.normal
                    });
                });
            } else {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
                    type: global.ad_type.banner.normal
                });
                this.btn_cancel.bottom = 420;
            }
        }
        register_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.banner_show, this, this.update_btn_pos);
        }
        release_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.banner_show, this, this.update_btn_pos);
        }
        update_btn_pos() {
            if (global.game.channel_type == igc.e_channel_type.tt) {
                this.btn_cancel.bottom = 380;
            }
        }
        show_native_success() {
            if (global.game.channel_type == igc.e_channel_type.oppo_qg && this.parent) {}
        }
        on_click_close() {
            this.hide();
        }
        on_click_video() {
            let self = this;
            // if (this.b_show_video) {
            //     return;
            // }
            Laya.timer.once(3e3, this, function() {
                self.b_show_video = false;
            });
            this.b_show_video = true;
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            // igc.broadcast_manager.instance.broadcast(broadcast_ids.show_video, {
            //     type: global.ad_type.video.supply,
            //     call_back: function () {
            //         igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
            //             value: self.curRewardNum,
            //             reason: "supply_video"
            //         });
            //         self.hide();
            //         self.b_show_video = false;
            //     },
            //     error_back: function () {
            //         self.b_show_video = false;
            //     }
            // });

            platform.getInstance().showReward(() => {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
                    value: self.curRewardNum,
                    reason: "supply_video"
                });
                self.hide();
                self.b_show_video = false;
            }, () => {
                self.b_show_video = false;
                platform.getInstance().prompt("ADS not availabe NOW! Please try again later");
            },1005)
        }
        hide() {
            let self = this;
            igc.broadcast_manager.instance.broadcast(broadcast_ids.close_native);
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: self
            });
            this.call_back && this.call_back();
        }
    }
    class ui_get_reward extends ui.scenes.ui_get_rewardUI {
        awake() {
            this.zhezhao.on(Laya.Event.CLICK, this, this.on_click_close);
            this.register_listener();
        }
        on_enable(param) {
            if (!param.env_id) {
                this.gole_title.visible = true;
                this.env_title.visible = false;
                this.lb_reward.value = 500 + "";
            } else {
                this.gole_title.visible = false;
                this.env_title.visible = true;
                this.txt_sand.visible = param.env_id == e_env_type.sand;
                this.txt_snow.visible = param.env_id == e_env_type.snow;
                this.icon_sand.visible = param.env_id == e_env_type.sand;
                this.icon_snow.visible = param.env_id == e_env_type.snow;
            }
        }
        on_disable() {}
        register_listener() {}
        release_listener() {}
        on_click_close() {
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: this
            });
        }
    }
    class ui_share_video extends ui.scenes.ui_share_videoUI {
        awake() {
            this.btn_video.on(Laya.Event.CLICK, this, this.on_click_share_video);
            this.btn_close.on(Laya.Event.CLICK, this, this.on_click_close);
            this.register_listener();
        }
        on_enable() {
            this.env_id = igc.phone_manager.instance.call(phone_ids.get_share_env_id);
            console.log("分享可以获得的场景", this.env_id);
            if (!this.env_id) {
                this.gold_box.visible = true;
                this.env_box.visible = false;
            } else {
                this.gold_box.visible = false;
                this.env_box.visible = true;
                this.txt_sand.visible = this.env_id == e_env_type.sand;
                this.txt_snow.visible = this.env_id == e_env_type.snow;
                this.icon_sand.visible = this.env_id == e_env_type.sand;
                this.icon_snow.visible = this.env_id == e_env_type.snow;
            }
        }
        on_disable() {}
        register_listener() {}
        release_listener() {}
        on_click_share_video() {
            igc.broadcast_manager.instance.broadcast(broadcast_ids.record_screen, {
                env_id: this.env_id
            });
        }
        on_click_close() {
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: this
            });
        }
    }
    class GameShareDialog extends ui.scenes.GameShareDialogUI {
        constructor() {
            super(...arguments);
            this.scroll_timer = null;
            this.close_timer = null;
            this.is_result = false;
        }
        awake() {
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.listManager = new ListManager();
            this.listManager.init(2, [this.list_dev_box, this.list_dev_pick]);
            this.btn_close.on("click", this, this.onClickClose);
            this.list_dev_box.vScrollBarSkin = "";
            this.list_dev_box.renderHandler = new Laya.Handler(this, this.list_dev_box_itemRenderHandler);
            this.list_dev_box_fill_list();
            this.list_dev_pick.hScrollBarSkin = "";
            this.list_dev_pick.scrollBar.elasticDistance = 10;
            this.list_dev_pick.scrollBar.elasticBackTime = 200;
            this.list_dev_pick.width = Laya.stage.width;
            this.list_dev_pick.renderHandler = new Laya.Handler(this, this.list_dev_pick_itemRenderHandler);
            this.list_dev_pick_fill_list();
            this.scroll_timer = new XSecTimer(1500, false);
            this.close_timer = new XSecTimer(8e3, false);
            this.btn_close.visible = false;
        }
        list_dev_box_fill_list() {
            // if (!Laya.Browser.window.dnsdk) return;
            // let dataSource = this.listManager.getDataSource("hotgameList", "moregame", "hotgame");
            // if (!dataSource || dataSource && dataSource.length == 0) {
            //     console.error("dnsdk hotgameList is null！");
            //     return;
            // }
            // this.list_dev_box.dataSource = dataSource;
        }
        list_dev_pick_fill_list() {
            // if (!Laya.Browser.window.dnsdk) return;
            // let dataSource = this.listManager.getDataSource("bottomList", "moregame", "bottom");
            // if (!dataSource || dataSource && dataSource.length == 0) {
            //     console.error("dnsdk bottomList is null！");
            //     return;
            // }
            // this.list_dev_pick.dataSource = dataSource;
        }
        list_dev_pick_itemRenderHandler(cell, index) {
            let data = cell.dataSource;
            cell.offAll();
            cell.on("click", this, this.list_dev_pick_itemClickHandler, [data]);
        }
        list_dev_box_itemRenderHandler(cell, index) {
            let data = cell.dataSource;
            cell.offAll();
            cell.on("click", this, this.list_dev_box_itemClickHandler, [data]);
            let sp = cell.getChildByName("icon");
            let mask = new Laya.Sprite();
            mask.loadImage("dev/ui_tj_01.png");
            sp.mask = mask;
        }
        list_dev_box_itemClickHandler(data) {
            let self = this;
            XWxad.Inst.JumpGame(data.dnsdkid, "moregame", "hotgame", data.sharename, data.shareid, data.openPath);
        }
        list_dev_pick_itemClickHandler(data) {
            let self = this;
            XWxad.Inst.JumpGame(data.dnsdkid, "FenFaYe", "bottom", data.sharename, data.shareid, data.openPath);
        }
        on_enable(param) {
            console.log("打开游戏汇聚页面");
            let self = this;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.is_result = param.is_result || false;
            this.btn_close.x = this.width / 2 - Laya.stage.width / 2 + 4;
            this.img_play.x = this.width / 2 - Laya.stage.width / 2 + 4;
            this.img_recm.x = this.width / 2 - Laya.stage.width / 2 + 4;
            this.list_dev_pick.x = -this.x;
            this.list_dev_pick.width = Laya.stage.width - this.x;
            let w = Math.min(Laya.Browser.clientWidth, Laya.Browser.clientHeight);
            let h = Math.max(Laya.Browser.clientWidth, Laya.Browser.clientHeight);
            let ui_scale = this.box_dev_box.scaleX;
            let ui_scale_h = this.box_dev_box.scaleX;
            this.list_dev_box.height *= ui_scale_h;
            Laya.timer.frameLoop(50, this, this.update_view);
            igc.broadcast_manager.instance.broadcast(broadcast_ids.hide_banner);
            this.btn_close.visible = false;
            Laya.timer.once(2e3, this, function() {
                self.btn_close.visible = true;
            });
            if (this.is_result) {
                let native_type = param.is_success ? global.ad_type.native.challenge_fail : global.ad_type.native.challenge_fail;
                let inster_type = param.is_success ? global.ad_type.inster.challenge_fail : global.ad_type.inster.challenge_fail;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.pre_load_native, {
                    native_type: native_type,
                    inster_type: inster_type,
                    duration: 500
                });
            }
        }
        onClickClose() {
            let self = this;
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: self
            });
        }
        on_disable() {
            Laya.timer.clear(this, this.update_view);
            igc.broadcast_manager.instance.broadcast(broadcast_ids.show_game_banner_wx, {
                type: global.ad_type.banner.normal
            });
            if (this.is_result) {}
        }
        update_view() {
            if (!this.parent) {
                return;
            }
            if (this.scroll_timer.check()) {
                this.listManager.checkListMove();
            }
        }
    }
    class SplashList_dialog extends ui.scenes.HallSplashListUI {
        constructor() {
            super(...arguments);
            this.scroll_timer = null;
        }
        awake() {
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.listManager = new ListManager();
            this.listManager.init(1, [this.list_dev_box]);
            this.btn_close.on(Laya.Event.CLICK, this, this.on_click_close);
            this.list_dev_box.vScrollBarSkin = "";
            this.list_dev_box.renderHandler = new Laya.Handler(this, this.list_dev_box_itemRenderHandler);
            this.list_dev_box_fill_list();
            this.scroll_timer = new XSecTimer(1500, false);
        }
        list_dev_box_fill_list() {
            // if (!Laya.Browser.window.dnsdk) return;
            // let dataSource = this.listManager.getDataSource("moregameList", "home", "grouppage");
            // console.log("moregameList------------\x3e", dataSource);
            // if (!dataSource || dataSource && dataSource.length == 0) {
            //     this.visible = false;
            //     this.hide();
            //     console.error("dnsdk moregameList is null------------\x3e", dataSource);
            //     return;
            // } else {
            //     this.list_dev_box.dataSource = dataSource;
            // }
        }
        list_dev_box_itemRenderHandler(cell, index) {
            let data = cell.dataSource;
            cell.offAll();
            cell.on("click", this, this.list_dev_box_itemClickHandler, [data]);
        }
        list_dev_box_itemClickHandler(data) {
            let self = this;
            XWxad.Inst.JumpGame(data.dnsdkid, "home", "home", data.sharename, data.shareid, data.openPath);
        }
        on_enable() {
            // let dataSource = this.listManager.getDataSource("moregameList", "home", "grouppage");
            // if (!dataSource || dataSource && dataSource.length == 0) {
            //     console.error("no has moregameList");
            // } else {
            //     Laya.timer.frameLoop(50, this, this.update_view);
            // }
        }
        on_disable() {
            Laya.timer.clear(this, this.update_view);
        }
        on_click_close() {
            this.hide();
        }
        hide() {
            let self = this;
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: self
            });
        }
        update_view() {
            if (!this.parent) {
                return;
            }
            if (this.scroll_timer.check()) {
                this.listManager.checkListMove();
            }
        }
    }
    class SplashSingleDialog extends ui.scenes.SplashSingleDialogUI {
        constructor() {
            super(...arguments);
            this.index = 0;
            this.count = 10;
        }
        awake() {
            this.btn_accept.on("click", this, this.onClickHandler);
            this.btn_close.on("click", this, this.onClickClose);
        }
        on_enable() {
            // this.width = Laya.stage.width;
            // this.height = Laya.stage.height;
            // let list = Laya.Browser.window.dnsdk.data.pushData.moregameList;
            // if (!list || list && list.length == 0) {
            //     console.log("dnsdk plaqueList is error", list);
            //     this.visible = false;
            //     this.hide();
            //     return;
            // } else {
            //     this.visible = true;
            // }
            // let length = list.length;
            // if (length) {
            //     this.index = Math.round(Math.random() * length) % length;
            //     let item = list[this.index];
            //     let skin = item.icon;
            //     let txt = item.gameName;
            //     this.game_icon.skin = skin;
            //     this.game_name.text = txt;
            //     if (Laya.Browser.window.dnsdk) {
            //         var tjData = {
            //             label: item.id,
            //             pushappid: item.pushAppID,
            //             placement: "plaque",
            //             eventid: "moregame"
            //         };
            //         Laya.Browser.window.dnsdk.tjSendShowEvent(tjData);
            //     }
            // }
            // let friend_icon_list = Laya.Browser.window.dnsdk.data.pushData.moregroupList;
            // let length1 = friend_icon_list.length;
            // if (length1) {
            //     let index = Math.round(Math.random() * length1) % length1;
            //     let item1 = list[index];
            //     this.friend_icon.skin = item1.icon;
            // }
        }
        onClickHandler() {
            // let list = Laya.Browser.window.dnsdk.data.pushData.moregameList;
            // if (list.length) {
            //     let item = list[this.index];
            //     XWxad.Inst.JumpGame(item.id, "plaque", "moregame", item.gameName, item.pushAppID, item.openPath);
            // }
        }
        onClickClose() {
            this.hide();
        }
        hide() {
            let self = this;
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: self
            });
        }
    }
    class XJumpButton extends Laya.Sprite {
        constructor(placement, interval, width, height, attach, click_paly) {
            super();
            this.index = 0;
            this.change_timer = null;
            this.placement = "";
            this.placement = placement;
            this.name = "XJumpButton";
            this.change_timer = new XSecTimer(interval);
            this.back_sprite = new Laya.Image();
            this.back_sprite.loadImage("dev/ui_jgg.png");
            this.back_sprite.x = -2;
            this.back_sprite.y = -2;
            this.last_sprite = new Laya.Image();
            this.cur_spirte = new Laya.Image();
            this.addChild(this.back_sprite);
            this.addChild(this.last_sprite);
            this.addChild(this.cur_spirte);
            this.width = width;
            this.height = height;
            if (attach) {
                let sp = new Laya.Sprite();
                sp.loadImage(attach);
                sp.pivot(sp.width / 2, sp.height / 2);
                sp.x = this.width;
                sp.y = -sp.y / 2;
                sp.scale(3, 3);
                this.addChild(sp);
            }
            if (click_paly) {
                let cp = new Laya.Sprite();
                cp.loadImage(click_paly);
                cp.pivot(cp.width / 2, cp.height / 2);
                cp.x = this.width / 2;
                cp.y = this.height + 60;
                cp.scale(2.6, 2.6);
                this.addChild(cp);
            }
            // this.random();
            this.on("click", this, this.onClick);
            Laya.timer.frameLoop(100, this, this.update_view);
        }
        onClick() {
            // console.log("点击跳转" + this.index);
            // let list = Laya.Browser.window.dnsdk.data.pushData.iconList;
            // let item = list[this.index];
            // XWxad.Inst.JumpGame(item.id, this.placement, "icon", item.gameName, item.pushAppID, item.openPath);
        }
        random() {
            // if (!Laya.Browser.window.dnsdk) {
            //     return;
            // }
            // let list = Laya.Browser.window.dnsdk.data.pushData.iconList;
            // let length = list.length;
            // this.index = Math.round(Math.random() * length) % length;
            // let item = list[this.index];
            // let skin = item.icon;
            // let self = this;
            // this.last_sprite.alpha = 1;
            // this.cur_spirte.skin = skin;
            // this.cur_spirte.width = this.width;
            // this.cur_spirte.height = this.height;
            // this.cur_spirte.alpha = 0;
            // Laya.Tween.to(this.cur_spirte, {
            //     alpha: 1
            // }, 1e3, Laya.Ease.linearIn, Laya.Handler.create(this, function () {
            //     self.cur_spirte.alpha = 0;
            //     self.last_sprite.skin = skin;
            //     self.last_sprite.width = self.width;
            //     self.last_sprite.height = self.height;
            // }), 0, true, true);
        }
        update_view() {
            // if (this.change_timer.check()) {
            //     this.random();
            // }
        }
    }
    class PushView extends ui.scenes.PushViewUI {
        constructor() {
            super(...arguments);
            this.scroll_timer = null;
            this.leftListScroll_timer = null;
            this.pop_timer = null;
            this.ui_scale = 0;
            this.chk_dev_box_x = 0;
            this.bannerIndex = 0;
            this.bannerImg_icon = 0;
            this.isMoveRight = true;
            this.is_show_guess_like = true;
            this.is_show_icon = true;
            this.is_show_more_play = true;
            this.is_show_banner = true;
            this.game_count = 0;
        }
        awake() {
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.listManager = new ListManager();
            this.box_dev_box.zOrder = 1e3;
            this.box_dev_pick.zOrder = 1e3;
            this.img_dev_share1.zOrder = 1e3;
            this.img_dev_share2.zOrder = 1e3;
            this.chk_dev_box_x = this.chk_dev_box.x;
            this.chk_dev_box.on("click", this, this.clickDevBoxHandler);
            this.banner.on("click", this, this.onClickBanner);
            this.list_dev_box.vScrollBarSkin = "";
            this.list_dev_box.renderHandler = new Laya.Handler(this, this.list_dev_box_itemRenderHandler);
            this.list_dev_box_fill_list();
            this.scroll_timer = new XSecTimer(1500, false);
            this.pop_timer = new XSecTimer(1600);
            this.leftListScroll_timer = new XSecTimer(1500, false);
            this.list_dev_pick.hScrollBarSkin = "";
            this.list_dev_pick.scrollBar.elasticDistance = 10;
            this.list_dev_pick.scrollBar.elasticBackTime = 200;
            this.list_dev_pick.width = Laya.stage.width;
            this.list_dev_pick.renderHandler = new Laya.Handler(this, this.list_dev_pick_itemRenderHandler);
            this.list_dev_pick_fill_list();
            let w = Math.min(Laya.Browser.clientWidth, Laya.Browser.clientHeight);
            let h = Math.max(Laya.Browser.clientWidth, Laya.Browser.clientHeight);
            this.ui_scale = w / h < .5 ? .7 : 1;
            this.img_dev_share1.scale(this.ui_scale, this.ui_scale);
            this.img_dev_share2.scale(this.ui_scale, this.ui_scale);
            this.img_dev_share1.addChild(new XJumpButton("home", 3e3, 250, 250, "dev/new.png", "dev/djqw.png"));
            this.img_dev_share2.addChild(new XJumpButton("home", 4e3, 250, 250, "dev/new.png", "dev/djqw.png"));
            this.comBanner();
            igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_push_view_show_icon, this, this.show_view_by_type);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_show_banner, this, this.show_banner);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.add_game_number, this, this.add_game_number);
        }
        add_game_number() {
            this.game_count++;
        }
        show_view_by_type(id, param) {
            this.is_show_guess_like = param.is_show_guess_like || false;
            this.is_show_icon = param.is_show_icon || false;
            this.is_show_more_play = param.is_show_more_play || false;
            this.box_dev_box.visible = this.is_show_more_play;
            this.box_dev_pick.visible = this.is_show_guess_like;
            this.img_dev_share1.visible = this.is_show_icon;
            this.img_dev_share2.visible = this.is_show_icon;
            if (param.icon_position) {
                this.img_dev_share1.top = param.icon_position;
                this.img_dev_share2.top = param.icon_position;
            }
        }
        show_banner(id, param) {
            // if (this.is_show_banner === false && param && param.is_show) {
            //     this.refreshBannerData();
            // }
            // this.is_show_banner = param.is_show;
            // this.banner.visible = this.is_show_banner;
        }
        list_dev_box_fill_list() {
            // if (!Laya.Browser.window.dnsdk) return;
            // let listManager = new ListManager();
            // listManager.init(1, [this.list_dev_box]);
            // let dataSource = listManager.getDataSource("grouppageList", "home", "grouppage");
            // if (!dataSource || dataSource && dataSource.length == 0) {
            //     console.error("dnsdk grouppageList is null！");
            //     return;
            // }
            // this.list_dev_box.dataSource = dataSource;
        }
        list_dev_pick_fill_list() {
            // if (!Laya.Browser.window.dnsdk) return;
            // let dataSource = this.listManager.getDataSource("bottomList", "home", "bottom");
            // if (!dataSource || dataSource && dataSource.length == 0) {
            //     console.error("dnsdk bottomList is null！");
            //     return;
            // }
            // this.list_dev_pick.dataSource = dataSource;
            // this.listManager.init(1, [this.list_dev_pick]);
        }
        list_dev_pick_itemRenderHandler(cell, index) {
            let data = cell.dataSource;
            cell.offAll();
            cell.on("click", this, this.list_dev_pick_itemClickHandler, [data]);
        }
        list_dev_box_itemRenderHandler(cell, index) {
            let data = cell.dataSource;
            cell.offAll();
            cell.on("click", this, this.list_dev_box_itemClickHandler, [data]);
        }
        list_dev_box_itemClickHandler(data) {
            let self = this;
            XWxad.Inst.JumpGame(data.dnsdkid, "home", "grouppage", data.sharename, data.shareid, data.openPath);
        }
        list_dev_pick_itemClickHandler(data) {
            let self = this;
            console.log("data.sharename" + data.sharename);
            XWxad.Inst.JumpGame(data.dnsdkid, "home", "bottom", data.sharename, data.shareid, data.openPath);
        }
        clickDevBoxHandler() {
            if (this.chk_dev_box.selected) {
                Laya.Tween.to(this.box_dev_box, {
                    x: 0
                }, 1e3, Laya.Ease.bounceOut, null, 0, true, true);
            } else {
                Laya.Tween.to(this.box_dev_box, {
                    x: -this.box_dev_box.width * this.box_dev_box.scaleX
                }, 1e3, Laya.Ease.bounceOut, null, 0, true, true);
            }
        }
        on_enable(param) {
            console.log("xiejinhui push view param", param);
            this.box_dev_box.x = -this.box_dev_box.width * this.box_dev_box.scaleX;
            Laya.timer.frameLoop(1, this, this.update_view);
        }
        update_ui() {
            if (this.leftListScroll_timer.check()) {
                if (Math.abs(this.list_dev_box.scrollBar.value) < 10) {
                    this.isMoveRight = true;
                }
                if (Math.abs(this.list_dev_box.scrollBar.value - Math.abs(this.list_dev_box.scrollBar.max)) < 20) {
                    this.isMoveRight = false;
                }
                if (this.list_dev_box.array) {
                    let count = this.list_dev_box.array.length - 1;
                    if (this.isMoveRight) {
                        this.list_dev_box.tweenTo(count, 2e4 * 1);
                    } else {
                        this.list_dev_box.tweenTo(0, 2e4 * 1);
                    }
                }
            }
            if (this.scroll_timer.check()) {
                this.listManager.checkListMove();
                if (this.pop_timer.check()) {
                    let self = this;
                    if (!this.chk_dev_box.selected && this.is_show_guess_like) {
                        let oldx = this.chk_dev_box_x;
                        Laya.Tween.to(this.chk_dev_box, {
                            x: oldx + 12
                        }, 800, Laya.Ease.bounceIn, Laya.Handler.create(this, function() {
                            Laya.Tween.to(self.chk_dev_box, {
                                x: oldx
                            }, 800, Laya.Ease.bounceOut, null, 0, true, true);
                        }), 0, true, true);
                    }
                    if (this.is_show_icon) {
                        Laya.Tween.to(this.img_dev_share1, {
                            scaleX: self.ui_scale,
                            scaleY: self.ui_scale
                        }, 800, Laya.Ease.linearIn, Laya.Handler.create(this, function() {
                            Laya.Tween.to(self.img_dev_share1, {
                                scaleX: self.ui_scale * .85,
                                scaleY: self.ui_scale * .85
                            }, 800, Laya.Ease.linearIn, null, 0, true, true);
                        }), 0, true, true);
                        Laya.Tween.to(this.img_dev_share2, {
                            scaleX: self.ui_scale,
                            scaleY: self.ui_scale
                        }, 800, Laya.Ease.linearIn, Laya.Handler.create(this, function() {
                            Laya.Tween.to(self.img_dev_share2, {
                                scaleX: self.ui_scale * .85,
                                scaleY: self.ui_scale * .85
                            }, 800, Laya.Ease.linearIn, null, 0, true, true);
                        }), 0, true, true);
                    }
                }
            }
        }
        update_view() {
            this.update_ui();
        }
        on_disable() {
            Laya.timer.clear(this, this.update_view);
        }
        comBanner() {
            let self = this;
            // this.refreshBannerData();
        }
        onClickBanner() {
            XWxad.Inst.JumpGame(this.bannerItem.dnsdkid, "home", "banner", this.bannerItem.sharename, this.bannerItem.shareid, this.bannerItem.openPath);
            // this.refreshBannerData();
        }
        refreshBannerData() {
            let list = Laya.Browser.window.dnsdk.data.pushData.bannerList;
            let length = list.length;
            if (length) {
                this.bannerIndex = Math.round(Math.random() * length) % length;
                let item = list[this.bannerIndex];
                let skin = item.icon;
                let txt = item.gameName;
                this.banner.skin = skin;
                let data = {
                    sharename: item.gameName,
                    dnsdkid: item.id,
                    openPath: item.openPath,
                    shareid: item.pushAppID,
                    icon: {
                        skin: skin
                    },
                    label: {
                        text: item.gameName
                    },
                    desc: {
                        text: item.extra
                    }
                };
                this.bannerItem = data;
                if (Laya.Browser.window.dnsdk) {
                    var tjData = {
                        label: item.id,
                        pushappid: item.pushAppID,
                        placement: "plaque",
                        eventid: "plaque"
                    };
                    Laya.Browser.window.dnsdk.tjSendShowEvent(tjData);
                }
            }
        }
    }
    let ui_class = {
        ui_main: ui_main,
        ui_fail: ui_fail,
        ui_success: ui_success,
        ui_loading: ui_loading,
        ui_adv: ui_adv,
        ui_chapter_info: ui_chapter_info,
        ui_private_view: ui_private_view,
        ui_login: ui_login,
        ui_load_res: ui_load_res,
        ui_offline: ui_offline,
        ui_guide: ui_guide,
        ui_supply: ui_supply,
        ui_get_reward: ui_get_reward,
        ui_share_video: ui_share_video,
        GameShareDialog: GameShareDialog,
        SplashList_dialog: SplashList_dialog,
        SplashSingleDialog: SplashSingleDialog,
        PushView: PushView
    };
    window["ui_class"] = ui_class;
    class ui_container_base {
        constructor(param) {
            this.ui_pool = {};
            this.ui_container = [];
            this.name = "";
            this.zorder = 0;
            this.param = {};
            this.dynamic_modify = true;
            this.name = param.name;
            this.zorder = param.zorder || 0;
            this.param = param || {};
            this.dynamic_modify = param.dynamic_modify;
        }
        get top_zorder() {
            let top_zorder = this.zorder;
            for (let i = 0; i < this.ui_container.length; ++i) {
                top_zorder = Math.max(top_zorder, this.ui_container[i].instance.zOrder);
            }
            return top_zorder + 1;
        }
        remove_ui_from_container(ui_instance) {
            for (let i = this.ui_container.length - 1; 0 <= i; --i) {
                if (this.ui_container[i].instance == ui_instance) {
                    this.ui_container.splice(i, 1);
                    break;
                }
            }
        }
        hijack_mouse_event(event) {
            event.stopPropagation();
        }
        show(name, config, param) {
            let self = this;
            let ui_instance = this.get(name);
            if (!this.param["exclude_mouse_hijack"]) {
                let view = ui_instance;
                view.on(Laya.Event.MOUSE_DOWN, this, this.hijack_mouse_event);
            }
            if (this.dynamic_modify) {
                ui_instance.width = Laya.stage.width;
                ui_instance.height = Laya.stage.height;
            }!ui_instance._is_awake && ui_instance.awake && ui_instance.awake();
            ui_instance._is_awake = true;
            ui_instance.on_enable && ui_instance.on_enable(param);
            !ui_instance._is_start && ui_instance.start && ui_instance.start();
            ui_instance._is_start = true;
            ui_instance._enable = true;
            ui_instance.zOrder = this.top_zorder;
            Laya.stage.addChild(ui_instance);
            return ui_instance;
        }
        hide(ui_instance) {
            let self = this;
            ui_instance.on_disable && ui_instance.on_disable();
            ui_instance._enable = false;
            if (!this.param["exclude_mouse_hijack"]) {
                let view = ui_instance;
                view.off(Laya.Event.MOUSE_DOWN, this, this.hijack_mouse_event);
            }
            this.recycle(ui_instance);
            Laya.stage.removeChild(ui_instance);
            return true;
        }
        get_ui(_class) {
            for (let i = this.ui_container.length - 1; 0 <= i; --i) {
                if (this.ui_container[i].instance.constructor.name == _class.name) {
                    return this.ui_container[i].instance;
                }
            }
            return null;
        }
        get_ui_by_name(ui_name) {
            for (let i = this.ui_container.length - 1; 0 <= i; --i) {
                if (this.ui_container[i].instance.constructor.name == ui_name) {
                    return this.ui_container[i].instance;
                }
            }
            return null;
        }
        move_foreground(_class) {}
        get(class_name) {
            if (!this.ui_pool[class_name]) {
                this.ui_pool[class_name] = [];
            }
            if (0 < this.ui_pool[class_name].length) {
                return this.ui_pool[class_name].shift();
            } else {
                let ui_type = ui_class[class_name];
                if (ui_type) {
                    return new ui_type();
                } else {
                    console.error("ui_container_base:get", class_name, "not registered");
                    return undefined;
                }
            }
        }
        recycle(ui_instance) {
            if (!this.ui_pool[ui_instance.constructor.name]) {
                this.ui_pool[ui_instance.constructor.name] = [];
            }
            this.ui_pool[ui_instance.constructor.name].push(ui_instance);
        }
        update() {
            for (let i = this.ui_container.length - 1; 0 <= i; --i) {
                if (this.ui_container[i] && this.ui_container[i].instance && this.ui_container[i].instance.update) {
                    this.ui_container[i].instance.update();
                } else {
                    if (!this.ui_container[i]) {}
                }
            }
        }
        get fullscreen_count() {
            let count = 0;
            for (let i = 0; i < this.ui_container.length; ++i) {
                if (this.ui_container[i].config.fullscreen === true) {
                    ++count;
                }
            }
            return count;
        }
        resize_screen(width, height) {
            if (this.dynamic_modify)
                for (let i = 0; i < this.ui_container.length; ++i) {
                    this.ui_container[i].instance.width = width || this.ui_container[i].instance.width;
                    this.ui_container[i].instance.height = height || this.ui_container[i].instance.height;
                }
        }
    }
    class ui_container_list extends ui_container_base {
        show(class_name, config, param) {
            let ui_instance = super.show(class_name, config, param);
            if (ui_instance) {
                this.ui_container.push({
                    class_name: class_name,
                    config: config,
                    instance: ui_instance
                });
            } else {
                console.error("ui_container_list:show", "invalid ui", class_name);
            }
            return ui_instance;
        }
        move_foreground(_class) {
            let ui_instance = this.get_ui(_class);
            if (ui_instance) {
                ui_instance.zOrder = this.top_zorder;
            }
        }
        hide(ui_instance) {
            this.remove_ui_from_container(ui_instance);
            return super.hide(ui_instance);
        }
    }
    class ui_container_stack extends ui_container_base {
        show(class_name, config, param) {
            let ui_instance = super.show(class_name, config, param);
            if (0 < this.ui_container.length) {
                Laya.stage.removeChild(this.ui_container[this.ui_container.length - 1].instance);
            }
            this.ui_container.push({
                class_name: class_name,
                config: config,
                instance: ui_instance
            });
            return ui_instance;
        }
        hide(ui_instance) {
            if (0 < this.ui_container.length && this.ui_container[this.ui_container.length - 1].instance == ui_instance) {
                this.ui_container.pop();
                if (0 < this.ui_container.length) {
                    Laya.stage.addChild(this.ui_container[this.ui_container.length - 1].instance);
                }
            } else {
                this.remove_ui_from_container(ui_instance);
            }
            return super.hide(ui_instance);
        }
    }
    class ui_manager extends igc.igc_manager_base {
        constructor() {
            super(...arguments);
            this.atlas = {};
            this.ui_config = {};
            this.ui_containers = {};
            this.last_fullscreen_count = 0;
            this.ui_arr = [];
            this.total_ui_arr = {};
        }
        load_async(finish_callback, res_update_callback) {
            this.do_load_async(finish_callback, res_update_callback, "loading", 10);
        }
        load_atlas(_ui_class, finish_callback) {
            let atlas_dict = {};
            let load_list = [];
            if (_ui_class && _ui_class.uiView) {
                for (let i = 0; i < _ui_class.uiView.loadList.length; ++i) {
                    let image_path = _ui_class.uiView.loadList[i];
                    let atlas_path = image_path.substring(0, image_path.lastIndexOf("/"));
                    atlas_dict[atlas_path] = image_path;
                }
                let self = this;
                for (let atlas in atlas_dict) {
                    let atlas_path = "ui/atlas/" + atlas + ".atlas";
                    if (igc.igc_config_manager.instance.configs_data["ui_atlas"][atlas_path] && !this.atlas[atlas_path]) {
                        load_list.push({
                            path: self.get_atlas_path(atlas_path),
                            id: atlas_path,
                            save: function(_id, atlas) {
                                self.save_atlas(_id, atlas);
                            }
                        });
                    }
                }
            }
            if (load_list.length === 0) {
                return true;
            } else {
                let instance = igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.ui_loading
                });
                igc.igc_resources_utils.async_load_res(load_list, function() {
                    igc.phone_manager.instance.call(phone_ids.hide_ui, {
                        instance: instance
                    });
                    finish_callback && finish_callback();
                }, 5, undefined);
                return false;
            }
        }
        get_atlas_path(path) {
            return igc.igc_resources_utils.get_url(path);
        }
        do_load_async(finish_callback, res_update_callback, preload, thread) {
            let self = this;
            let load_list = [];
            let configs = igc.igc_config_manager.instance.configs_data["ui_atlas"];
            for (let path in configs) {
                let config = configs[path];
                if (config && config.preload === preload) {
                    load_list.push({
                        path: self.get_atlas_path(config.path),
                        id: config.path,
                        save: function(id, data) {
                            self.save_atlas(id, data);
                        }
                    });
                }
            }
            igc.igc_resources_utils.async_load_res(load_list, finish_callback, thread, res_update_callback);
        }
        load_async_delay(finish_callback, res_update_callback) {
            this.do_load_async(finish_callback, res_update_callback, "hall", 5);
        }
        load_async_delay_in_game(finish_callback, res_update_callback) {
            this.do_load_async(finish_callback, res_update_callback, "", 5);
        }
        load_game_must_async(id, finish_callback, res_update_callback) {
            this.do_load_async(finish_callback, res_update_callback, "battle", 1);
        }
        init() {
            super.init();
            this.ui_config = igc.igc_config_manager.instance.configs_data["ui"];
            this.save_ui_container(igc.igc_config_manager.instance.configs_data["ui_container"]);
            igc.phone_manager.instance.add_listener(phone_ids.show_ui, this, this.show_ui);
            igc.phone_manager.instance.add_listener(phone_ids.hide_ui, this, this.hide_ui);
            igc.phone_manager.instance.add_listener(phone_ids.get_ui, this, this.phone_get_ui);
            igc.phone_manager.instance.add_listener(phone_ids.get_ui_by_name, this, this.phone_get_ui_by_name);
            igc.phone_manager.instance.add_listener(phone_ids.get_top_view, this, this.get_top_view);
            igc.phone_manager.instance.add_listener(phone_ids.get_top_view_name, this, this.get_top_view_name);
            igc.phone_manager.instance.add_listener(phone_ids.check_view_exist, this, this.check_view_exist);
            Laya.stage.on(Laya.Event.RESIZE, this, this.resize_screen);
        }
        get_top_view() {
            let top_zorder = 0;
            let top_view = undefined;
            for (let key in this.ui_containers) {
                let container = this.ui_containers[key];
                let views = container.ui_container;
                if (top_zorder < container.zorder && views.length > 0) {
                    top_zorder = container.zorder;
                    top_view = views[views.length - 1];
                }
            }
            return top_view;
        }
        get_top_view_name() {
            if (this.ui_arr.length > 0) {
                return this.ui_arr[this.ui_arr.length - 1];
            }
            return undefined;
        }
        check_view_exist(_, param) {
            return this.total_ui_arr[param.view_name] || false;
        }
        resize_screen() {
            for (let id in this.ui_containers) {
                let container = this.ui_containers[id];
                container.resize_screen(Laya.stage.width, Laya.stage.height);
            }
        }
        hide_ui(phone_id, param) {
            return this.hide(param.instance);
        }
        show_ui(phone_id, param) {
            igc.broadcast_manager.instance.broadcast(broadcast_ids.reset_drag);
            return this.show(param.ui, param.param);
        }
        phone_get_ui(phone_id, param) {
            return this.get_ui(param.ui);
        }
        save_ui_container(ui_container_config) {
            for (let i in ui_container_config) {
                let container = undefined;
                if (ui_container_config[i].type == "ui_container_list") {
                    container = new ui_container_list(ui_container_config[i]);
                } else if (ui_container_config[i].type == "ui_container_stack") {
                    container = new ui_container_stack(ui_container_config[i]);
                }
                if (container) {
                    this.ui_containers[ui_container_config[i].name] = container;
                }
            }
        }
        save_atlas(id, data) {
            this.atlas[id] = data;
        }
        get_ui_container(class_name) {
            let container = this.get_ui_config(class_name).container;
            return this.ui_containers[container];
        }
        get_ui_config(class_name) {
            return this.ui_config[class_name] && this.ui_config[class_name] || {};
        }
        do_show(_class, param, container) {
            let self = this;
            let name = _class.name;
            let cfg = this.get_ui_config(name);
            if (cfg && cfg.container === "popup" && this.ui_arr.indexOf(_class.name) < 0) {
                this.ui_arr.push(_class.name);
            }
            igc.igc_timer.frameOnce(5, this, function() {
                self.total_ui_arr[name] = true;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.enter_some_view, {
                    view_name: _class.name
                });
            }, undefined, true);
            let ui_instance = container && container.show(name, cfg, param);
            this.check_fullscreen();
            this.last_fullscreen_count = this.fullscreen_count;
            return ui_instance;
        }
        show(_class, param) {
            let name = _class.name;
            let container = this.get_ui_container(name);
            if (container) {
                let self = this;
                if (this.load_atlas(_class, function() {
                        self.do_show(_class, param, container);
                    })) {
                    return this.do_show(_class, param, container);
                } else {
                    return undefined;
                }
            } else {
                console.error("ui_manager:show", name, "not int config");
                return undefined;
            }
        }
        show_without_load(_class, param) {
            let name = _class.name;
            let container = this.get_ui_container(name);
            if (container) {
                return this.do_show(_class, param, container);
            } else {
                console.error("ui_manager:show", name, "not int config");
                return undefined;
            }
        }
        hide(ui_instance) {
            let self = this;
            if (ui_instance && ui_instance.constructor) {
                let index = this.ui_arr.indexOf(ui_instance.constructor.name);
                if (index >= 0) {
                    this.ui_arr.splice(index, 1);
                }
                igc.igc_timer.frameOnce(5, this, function() {
                    self.total_ui_arr[ui_instance.constructor.name] = false;
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.close_some_view, {
                        view_name: ui_instance.constructor.name
                    });
                }, undefined, true);
                let container = this.get_ui_container(ui_instance.constructor.name);
                let result = container && container.hide(ui_instance);
                this.check_fullscreen();
                this.last_fullscreen_count = this.fullscreen_count;
                return result;
            } else {
                return false;
            }
        }
        get_ui(_class) {
            let name = _class.name;
            if (name) {
                let container = this.get_ui_container(name);
                return container && container.get_ui(name);
            } else {
                return undefined;
            }
        }
        phone_get_ui_by_name(phone_id, param) {
            return this.get_ui_by_name(param.ui_name);
        }
        get_ui_by_name(ui_name) {
            if (ui_name) {
                let container = this.get_ui_container(ui_name);
                return container && container.get_ui_by_name(ui_name);
            } else {
                return undefined;
            }
        }
        check_fullscreen() {
            let current_fullscreen_count = this.fullscreen_count;
            if (this.last_fullscreen_count !== current_fullscreen_count) {
                if (0 === current_fullscreen_count) {} else if (1 === current_fullscreen_count && 0 === this.last_fullscreen_count) {}
            }
        }
        get fullscreen_count() {
            let count = 0;
            for (let name in this.ui_containers) {
                let container = this.ui_containers[name];
                if (container) {
                    count += container.fullscreen_count;
                }
            }
            return count;
        }
        update() {
            for (let name in this.ui_containers) {
                this.ui_containers[name].update();
            }
        }
    }
    class id_manager extends igc.igc_singleton_manager_base {
        static get instance() {
            return id_manager.get_instance();
        }
        init() {
            super.init();
            this.save_data = {
                id: 1
            };
        }
        get id() {
            let id = this.save_data["id"]++;
            this.save(false);
            return id;
        }
    }
    class game_time_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super(...arguments);
            this.offline_time = 0;
            this.old_time_scale = 1;
            this.is_paused = false;
        }
        static get instance() {
            return game_time_manager.get_instance();
        }
        init() {
            super.init();
            this.save_data = {
                last_relative_elapsed_time: 0,
                relative_elapsed_time: 0,
                last_absolute_elapsed_time: 0,
                absolute_elapsed_time: 0,
                last_online_time: 0
            };
            this.offline_time = 0;
            igc.broadcast_manager.instance.add_listener(broadcast_ids.game_pause, this, this.game_pause);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.game_resume, this, this.game_resume);
            igc.phone_manager.instance.add_listener(phone_ids.get_relative_game_elapsed_time, this, this.get_relative_game_elapsed_time);
            igc.phone_manager.instance.add_listener(phone_ids.get_absolutely_game_elapsed_time, this, this.get_absolutely_game_elapsed_time);
            igc.phone_manager.instance.add_listener(phone_ids.get_last_online_time, this, this.get_last_online_time);
            igc.phone_manager.instance.add_listener(phone_ids.get_offline_time, this, this.get_offline_time);
            igc.igc_timer.loop(1, this, this.update_time, undefined, true);
            igc.igc_timer.loop(10, this, this.update_online_time, undefined, true);
        }
        get_relative_game_elapsed_time(phone_id, param) {
            return this.save_data["last_relative_elapsed_time"] + igc.Time.time;
        }
        get_absolutely_game_elapsed_time(phone_id, param) {
            return this.save_data["last_absolute_elapsed_time"] + igc.Time.realtimeSinceStartup;
        }
        get_last_online_time(phone_id, param) {
            return this.save_data["last_online_time"];
        }
        get_offline_time(phone_id, param) {
            return this.offline_time;
        }
        update_time() {
            this.save_data["relative_elapsed_time"] = igc.Time.time;
            this.save_data["absolute_elapsed_time"] = igc.Time.realtimeSinceStartup;
            this.save(false);
        }
        update_online_time() {
            this.save_data["last_online_time"] = igc.time_manager.instance.get_server_time();
            this.save(true);
        }
        on_load_save_begin() {
            this.save_data["last_relative_elapsed_time"] += this.save_data["relative_elapsed_time"];
            this.save_data["relative_elapsed_time"] = 0;
            this.save_data["last_absolute_elapsed_time"] += this.save_data["absolute_elapsed_time"];
            this.save_data["absolute_elapsed_time"] = 0;
            this.save_data["last_online_time"] = this.save_data["last_online_time"] ? this.save_data["last_online_time"] : igc.time_manager.instance.get_server_time();
            this.offline_time = igc.time_manager.instance.get_server_time() - this.save_data["last_online_time"];
            this.save(true);
        }
        game_pause() {
            if (!this.is_paused) {
                this.is_paused = true;
                this.old_time_scale = igc.Time.timeScale;
                igc.Time.timeScale = 0;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.game_paused);
            } else {
                console.error("time_manager", "game_pause", "already pause");
            }
        }
        game_resume() {
            if (this.is_paused) {
                this.is_paused = false;
                igc.Time.timeScale = this.old_time_scale;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.game_resumed);
            } else {
                console.error("time_manager", "game_resume", "already resume");
            }
        }
        get relative_elapesed_time() {
            return this.save_data["relative_elapsed_time"].toFixed(2);
        }
    }
    class item_manager extends igc.igc_manager_base {
        constructor() {
            super(...arguments);
            this.can_gold_log = false;
            this.can_diamond_log = false;
        }
        init() {
            super.init();
            this.save_data = {
                items: {}
            };
            igc.phone_manager.instance.add_listener(phone_ids.add_item, this, this.phone_add_item);
            igc.phone_manager.instance.add_listener(phone_ids.use_item, this, this.phone_use_item);
            igc.phone_manager.instance.add_listener(phone_ids.get_item_amount, this, this.get_item_amount);
            igc.phone_manager.instance.add_listener(phone_ids.get_log_config, this, this.get_log_config);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.ui_gm_close, this, this.ui_gm_close);
        }
        get_log_config() {
            return {
                can_gold_log: this.can_gold_log,
                can_diamond_log: this.can_diamond_log
            };
        }
        ui_gm_close(_, param) {
            this.can_gold_log = param.can_gold_log;
            this.can_diamond_log = param.can_diamond_log;
        }
        phone_add_item(phone_id, param) {
            return this.add_item(param);
        }
        phone_use_item(phone_id, param) {
            return this.use_item(param);
        }
        get_item_amount(phone_id, param) {
            return this.save_data["items"][param.id] || 0;
        }
        use_item(param) {
            let self = this;
            this.save_data["items"][param.id] = this.save_data["items"][param.id] || 0;
            let old_amount = this.save_data["items"][param.id];
            param.amount = Math.floor(param.amount) || 0;
            if (param.amount <= this.save_data["items"][param.id]) {
                this.save_data["items"][param.id] -= param.amount;
                this.save(true);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.item_update, {
                    id: param.id,
                    amount: self.save_data["items"][param.id],
                    old_amount: old_amount,
                    change: self.save_data["items"][param.id] - old_amount
                });
                return true;
            } else {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.item_update_failed, {
                    id: param.id,
                    change: self.save_data["items"][param.id] - old_amount
                });
                return false;
            }
        }
        add_item(param) {
            if (null === param.amount || undefined === param.amount) {
                console.error("add item amount failed");
                return;
            }
            let self = this;
            this.save_data["items"][param.id] = this.save_data["items"][param.id] || 0;
            let old_amount = this.save_data["items"][param.id];
            param.amount = Math.floor(param.amount) || 0;
            this.save_data["items"][param.id] += param.amount;
            this.save(true);
            igc.broadcast_manager.instance.broadcast(broadcast_ids.item_update, {
                id: param.id,
                amount: this.save_data["items"][param.id],
                old_amount: old_amount,
                change_amount: self.save_data["items"][param.id] - old_amount
            });
            return true;
        }
    }
    class save_manager extends igc.igc_manager_base {
        constructor() {
            super();
            this.tpf_user_id = "";
            this.key_list = ["save_data"];
            this.last_save_time = 0;
            this.json_data = {};
            this._load_save_ok = false;
            this._model_init_ok = false;
            this.saving = false;
            this.register_listener();
        }
        init() {
            super.init();
        }
        register_listener() {
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.save, this, this.broadcast_save);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.clear_save, this, this.clear_save);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.plat_login_success, this, this.login_plat);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.get_storage_rsp, this, this.rsp_get_storage);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.load_save, this, this.do_load_save);
        }
        login_plat() {
            this.tpf_user_id = global.game.tpfUserId;
            if (global.game.is_local_stat != e_login_type.login_type_tpf) {
                let save = Laya.LocalStorage.getItem(this.get_root_key());
                if (save && save != "") {
                    let json_data_temp = JSON.parse(save) || {};
                    this.json_data = this.unserialize_save_data(json_data_temp);
                    console.log("save_manager login_plat local local have data--------------------");
                    if (global.game.is_local_stat == e_login_type.login_type_channel) {
                        igc.stat_manager.instance.send_user_login();
                    }
                } else {
                    this.json_data = {};
                    if (global.game.is_local_stat == e_login_type.login_type_channel) {
                        igc.stat_manager.instance.send_user_register();
                        igc.stat_manager.instance.send_user_login();
                    }
                    console.log("save_manager login_plat local local not have data--------------------");
                }
                this._load_save_ok = true;
                console.log("save_manager login_plat local this._load_save_ok--------------------", this._load_save_ok);
                if (this._model_init_ok === true) {
                    igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_begin, {
                        json: this.json_data
                    });
                    igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_end, {});
                    global.game.is_get_storage = true;
                }
            } else {
                console.log("save_manager login_plat--------------------");
                let save = Laya.LocalStorage.getItem(this.get_root_key());
                if (save && save != "") {
                    console.log("save_manager login_plat  local have data--------------------");
                    let json_data_temp = JSON.parse(save) || {};
                    this.json_data = this.unserialize_save_data(json_data_temp);
                    this._load_save_ok = true;
                    if (this._model_init_ok === true) {
                        console.log("save_manager login_plat  local have data & _model_init_ok == true--------------------");
                        igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_begin, {
                            json: this.json_data
                        });
                        igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_end, {});
                        global.game.is_get_storage = true;
                    } else {
                        console.log("save_manager login_plat  local have data & _model_init_ok !=== true--------------------");
                    }
                } else {
                    console.log("save_manager login_plat local dont have data  do get_tpf_storage-------------------");
                    this._load_save_ok = false;
                    igc.igc_main.instance.get_tpf_storage(this.tpf_user_id, this.key_list);
                    Laya.timer.once(2e3, this, this.delay_load_save);
                }
            }
        }
        delay_load_save() {
            if (this._load_save_ok === false) {
                igc.igc_main.instance.get_tpf_storage(this.tpf_user_id, this.key_list);
                Laya.timer.once(1e3, this, this.delay_load_save);
            }
        }
        rsp_get_storage(id, args) {
            console.log("save_manager:rsp_get_storage-----------------------");
            if (this._load_save_ok === false) {
                console.log("save_manager rsp_get_storage remote return-------------------");
                this._load_save_ok = true;
                if (args && args.map && args.map["save_data"]) {
                    console.log("save_manager rsp_get_storage remote return  _model_init_ok===true -------------------");
                    let save = args.map["save_data"];
                    let json_data_temp = JSON.parse(save) || {};
                    this.json_data = this.unserialize_save_data(json_data_temp);
                    if (this._model_init_ok === true) {
                        console.log("save_manager rsp_get_storage remote return  _model_init_ok===true -------------------");
                        igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_begin, {
                            json: this.json_data
                        });
                        igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_end, {});
                        global.game.is_get_storage = true;
                    }
                } else {
                    if (this._model_init_ok === true) {
                        console.log("save_manager rsp_get_storage remote return  _model_init_ok===true -------------------");
                        igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_begin, {
                            json: {}
                        });
                        igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_end, {});
                        global.game.is_get_storage = true;
                    }
                }
            } else {}
        }
        do_load_save() {
            this._model_init_ok = true;
            console.log("save_manager do_load_save  _model_init_ok===true -------------------");
            if (this._load_save_ok === true) {
                console.log("save_manager do_load_save  _load_save_ok===true -------------------");
                igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_begin, {
                    json: this.json_data
                });
                igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.load_save_end, {});
                global.game.is_get_storage = true;
            }
        }
        broadcast_save(broadcast_id, param) {
            if (param.key && param.value && this._load_save_ok) {
                this.json_data[param.key] = param.value;
                if (param.save) {
                    this.save();
                }
            }
        }
        do_save() {
            if (global.game.is_local_stat != e_login_type.login_type_tpf) {
                Laya.LocalStorage.setItem(this.get_root_key(), JSON.stringify(this.json_data));
            } else {
                Laya.LocalStorage.setItem(this.get_root_key(), JSON.stringify(this.json_data));
                let save_data = {};
                save_data["save_data"] = JSON.stringify(this.json_data);
                igc.igc_main.instance.set_tpf_storage(this.tpf_user_id, save_data);
            }
            this.saving = false;
        }
        save() {
            if (!this.saving) {
                this.saving = true;
                Laya.timer.once(1, this, this.do_save);
            }
        }
        clear_save() {
            if (global.game.is_local_stat != e_login_type.login_type_tpf) {
                Laya.timer.clear(this, this.do_save);
                Laya.LocalStorage.removeItem(this.get_root_key());
            } else {
                Laya.timer.clear(this, this.do_save);
                Laya.LocalStorage.removeItem(this.get_root_key());
                let save_data = {};
                save_data["save_data"] = "";
                igc.igc_main.instance.set_tpf_storage(this.tpf_user_id, save_data);
            }
        }
        get_root_key() {
            return "igc_train_" + this.tpf_user_id;
        }
        encrypt(v) {
            if (v) {
                v = LZString.compressToBase64(v);
                let new_v = "";
                for (let i = 0; i < v.length; ++i) {
                    new_v += String.fromCharCode(v.charCodeAt(i) + 1);
                }
                return new_v;
            } else {
                return v;
            }
        }
        decrypt(v) {
            if (v) {
                let new_result = "";
                for (let i = 0; i < v.length; ++i) {
                    new_result += String.fromCharCode(v.charCodeAt(i) - 1);
                }
                return LZString.decompressFromBase64(new_result);
            } else {
                return v;
            }
        }
    }
    class onetime_resource_base {
        constructor(id, sprite3d) {
            this._id = -1;
            this._instance_id = -1;
            this.sprite3d = undefined;
            this.up = new Laya.Vector3(0, 1, 0);
            this.right = new Laya.Vector3(0, 0, 1);
            if (sprite3d) {
                this._id = id;
                this._instance_id = id_manager.instance.id;
                this.sprite3d = sprite3d;
                this.active_resource();
            }
        }
        get id() {
            return this._id;
        }
        active_resource() {
            if (this.sprite3d) {
                this.sprite3d.active = true;
            }
            if (this.scene) {
                this.scene.add_child(this.sprite3d);
            }
        }
        init(param) {
            if (param.position) {
                this.position = param.position;
            }
            this.scene = param.scene;
            this.active_resource();
        }
        lookat_position(position, up) {
            this.sprite3d.transform.lookAt(position, up);
        }
        get instance_id() {
            return this._instance_id;
        }
        set position(value) {
            if (this.sprite3d) {
                this.sprite3d.transform.position = value;
            }
        }
        get position() {
            if (this.sprite3d) {
                return this.sprite3d.transform.position;
            } else {
                return undefined;
            }
        }
        set scale(value) {
            if (this.sprite3d) {
                this.sprite3d.transform.setWorldLossyScale(value);
            }
        }
        get scale() {
            if (this.sprite3d) {
                return this.sprite3d.transform.getWorldLossyScale();
            } else {
                return undefined;
            }
        }
        set eular_rotation(value) {
            if (this.sprite3d) {
                this.sprite3d.transform.rotationEuler = value;
            }
        }
        get eular_rotation() {
            if (this.sprite3d) {
                return this.sprite3d.transform.rotationEuler;
            } else {
                return undefined;
            }
        }
        broadcast_hidden() {}
        broadcast_recycle() {}
        show_effects() {}
        destroy() {
            this.show_effects();
            if (this.sprite3d.active) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.effect_show_complete, {
                    effect_id: this._id
                });
                this.broadcast_hidden();
                if (this.scene) {
                    this.scene.remove_child(this.sprite3d);
                }
                this.sprite3d.active = false;
                this.scene = undefined;
                this.broadcast_recycle();
            }
        }
        get config() {
            return {};
        }
    }
    class effect_base extends onetime_resource_base {
        constructor(id, sprite3d) {
            super(id, sprite3d);
        }
        init(param) {
            super.init(param);
            if (this.sprite3d) {
                if (this.config) {
                    if (this.config.loop) {} else {
                        igc.igc_timer.once(this.config.duration, this, this.destroy, undefined, true);
                    }
                }
            }
        }
        get config() {
            return igc.igc_config_manager.instance.configs_data["effects"][this._id];
        }
        broadcast_hidden() {
            let self = this;
            igc.broadcast_manager.instance.broadcast(broadcast_ids.effect_hidden, {
                instance_id: self.instance_id
            });
        }
        broadcast_recycle() {
            if (this.sprite3d) {
                let self = this;
                let children = utils_manager.GetComponentsInChildren(this.sprite3d, Laya.ShuriKenParticle3D);
                for (let i = 0; i < children.length; ++i) {
                    let child = children[i];
                    if (child) {
                        child.particleSystem.stop();
                    }
                }
                igc.broadcast_manager.instance.broadcast(broadcast_ids.recycle_effect, {
                    id: self._id,
                    instance: self
                });
            }
        }
    }
    class onetime_resource_manager extends igc.igc_manager_base {
        constructor() {
            super(...arguments);
            this.resource_templates = {};
            this.resource_pool = {};
            this.resource_instances = {};
            this.resource_instances_update = {};
            this.resource_amount = {};
            this.off_screen_position = new Laya.Vector3(-100, 0, -100);
        }
        load_async(finish_callback, res_update_callback) {
            this.do_load_async(finish_callback, res_update_callback, true, 10);
        }
        load_async_delay(finish_callback, res_update_callback) {
            this.do_load_async(finish_callback, res_update_callback, false, 1);
        }
        load_game_must_async(id, finish_callback, res_update_callback) {
            finish_callback && finish_callback();
        }
        do_load_async(finish_callback, res_update_callback, preload, thread) {
            let self = this;
            let configs = this.configs;
            let load_list = [];
            for (let id in configs) {
                let config = configs[id];
                if (preload === config.preload) {
                    self.add_resource_to_load_list(load_list, undefined, config.id);
                }
            }
            igc.igc_resources_utils.async_load_res(load_list, finish_callback, thread, res_update_callback);
        }
        add_resource_to_load_list(load_list, id_dict, id) {
            if (-1 === id) {
                return;
            }
            if (!this.configs[id]) {
                console.error("onetime_resource_manager:add_resource_to_load_list", "invalid id", id);
                return;
            }
            if (id_dict && id_dict[id]) {
                return;
            } else {
                if (-1 !== id) {
                    let self = this;
                    let path = self.get_path(id);
                    load_list.push({
                        path: self.get_path(id),
                        id: id,
                        save: function(_id, resource) {
                            self.resource_templates[_id] = resource;
                        }
                    });
                    if (id_dict) {
                        id_dict[id] = true;
                    }
                } else {
                    console.error("invalid resource id");
                }
            }
        }
        get configs() {
            return igc.igc_config_manager.instance.configs_data[this.path_name];
        }
        get path_name() {
            return "";
        }
        load_template(id) {
            let self = this;
            let configs = this.configs;
            let config = configs[id];
            if (config) {
                let load_list = [];
                load_list.push({
                    path: self.get_path(config.id),
                    id: config.id,
                    save: function(id, resource) {
                        self.resource_templates[id] = resource;
                    }
                });
                igc.igc_resources_utils.async_load_res(load_list, undefined, 1, function() {});
            }
        }
        get_path(id) {
            return igc.igc_resources_utils.get_url(this.path_name + "/" + id + ".lh");
        }
        init() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.exit_battle, this, this.hide_all_resources);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.load_battle_scene_finished, this, this.load_battle_scene_finished);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.unload_battle_scene_finished, this, this.unload_battle_scene_finished);
        }
        load_battle_scene_finished(broadcast_id, param) {
            let scene = igc.phone_manager.instance.call(phone_ids.get_active_game_scene);
            if (scene) {
                for (let id in this.resource_templates) {
                    let template = this.resource_templates[id];
                    if (template) {
                        template.transform.position = this.off_screen_position;
                        scene.add_child(template);
                    }
                }
                igc.igc_timer.frameOnce(1, this, this.remove_template_from_scene);
            }
        }
        remove_template_from_scene() {
            let scene = igc.phone_manager.instance.call(phone_ids.get_active_game_scene);
            if (scene) {
                for (let id in this.resource_templates) {
                    let template = this.resource_templates[id];
                    if (template) {
                        scene.remove_child(template);
                    }
                }
            }
        }
        unload_battle_scene_finished(broadcast_id, param) {
            igc.igc_timer.clear(this, this.remove_template_from_scene);
            this.remove_template_from_scene();
        }
        resource_hidden(broadcast_id, param) {
            if (this.resource_instances[param.instance_id]) {
                let resource = this.resource_instances[param.instance_id];
                this.resource_amount[resource.id] = this.resource_amount[resource.id] || 0;
                --this.resource_amount[resource.id];
                delete this.resource_instances[param.instance_id];
                delete this.resource_instances_update[param.instance_id];
            }
        }
        recycle_resource(broadcast_id, param) {
            if (param.instance) {
                this.resource_pool[param.id] = this.resource_pool[param.id] || [];
                this.resource_pool[param.id].push(param.instance);
            }
        }
        show_resource(phone_id, param) {
            let amount = this.resource_amount[param.id] || 0;
            if (game_config_manager.instance.get_config("onetime_resource_max_limit") <= amount) {
                return;
            }
            let instance = undefined;
            if (this.resource_pool[param.id] && 0 < this.resource_pool[param.id].length) {
                instance = this.resource_pool[param.id].pop();
            } else {
                if (this.resource_templates[param.id]) {
                    let sprite3d = this.resource_templates[param.id].clone();
                    instance = this.new_resource(param.id, sprite3d);
                } else {
                    this.load_template(param.id);
                }
            }
            if (instance) {
                let scene = param.scene || igc.phone_manager.instance.call(phone_ids.get_active_game_scene);
                instance.init({
                    id: param.id,
                    position: param.position,
                    scene: scene
                });
                this.resource_amount[param.id] = this.resource_amount[param.id] || 0;
                ++this.resource_amount[param.id];
                this.resource_instances[instance.instance_id] = instance;
                if (instance["update"]) {
                    this.resource_instances_update[instance.instance_id] = instance;
                }
            }
            return instance;
        }
        new_resource(id, sprite3d) {
            return undefined;
        }
        get_resource(phone_id, param) {
            return this.resource_instances[param.instance_id];
        }
        get_resource_template(phone_id, param) {
            return this.resource_templates[param.id];
        }
        hide_resource(broadcast_id, param) {
            let resource = this.resource_instances[param.instance_id];
            if (resource) {
                resource.destroy();
            }
        }
        hide_all_resources(broadcast_id, param) {
            let resources = [];
            for (let instance_id in this.resource_instances) {
                resources.push(this.resource_instances[instance_id]);
            }
            this.resource_instances = {};
            this.resource_instances_update = {};
            for (let i = 0; i < resources.length; ++i) {
                resources[i].destroy();
            }
            this.resource_amount = {};
        }
        update() {
            for (let instance_id in this.resource_instances_update) {
                this.resource_instances_update[instance_id].update();
            }
        }
    }
    class effect_lightning extends effect_base {
        constructor(id, sprite3d) {
            super(id, sprite3d);
            this.from = new Laya.Vector3();
            this.to = new Laya.Vector3();
            this.lerp = new Laya.Vector3();
            if (sprite3d) {
                let child = sprite3d.getChildAt(0);
                if (child) {
                    this.material = child.meshRenderer.material;
                    if (this.material) {
                        this.material._Time = 0;
                    }
                }
            }
        }
        init(param) {
            if (param.position && param.lookat_position) {
                this.move(param.position, param.lookat_position);
            }
        }
        move(position, lookat_position) {
            position.cloneTo(this.from);
            lookat_position.cloneTo(this.to);
            if (this.from.y < 1) {
                this.from.y = 1;
            }
            if (this.to.y < 1) {
                this.to.y = 1;
            }
            Laya.Vector3.lerp(this.from, this.to, .5, this.lerp);
            this.position = this.lerp;
            this.scale = new Laya.Vector3(1, 1, Laya.Vector3.distance(this.from, this.to) / 10);
            this.material.depthWrite = false;
            this.material.cull = Laya.RenderState.CULL_BACK;
            this.material.blend = Laya.RenderState.BLEND_ENABLE_ALL;
            this.material.blendSrc = Laya.RenderState.BLENDPARAM_SRC_ALPHA;
            this.material.blendDst = Laya.RenderState.BLENDPARAM_ONE_MINUS_SRC_ALPHA;
            this.lookat_position(this.to, this.up);
        }
        update() {
            if (this.material) {
                this.material._Time += .01;
            }
        }
    }
    class effect_ui extends effect_base {
        destroy() {
            if (this.scene) {
                let self = this;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.recycle_scene_effect, {
                    scene: self.scene
                });
            }
            super.destroy();
        }
    }
    class scene_base {
        constructor() {
            this._scene = null;
            this._camera = null;
            this.id = -1;
        }
        get scene() {
            return this._scene;
        }
        get camera() {
            return this._camera;
        }
        init(param) {
            if (!this._scene) {
                this._scene = new Laya.Scene3D();
                this._camera = new Laya.Camera(0, .1, 3e3);
                this._camera.fieldOfView = 60;
                this.camera_position = new Laya.Vector3(0, 1, 100);
                this._camera.orthographic = true;
                this._camera.orthographicVerticalSize = 6;
                this._scene.addChild(this._camera);
            }
        }
        get camera_position() {
            return this._camera.transform.position;
        }
        set camera_position(position) {
            this._camera.transform.position = position;
        }
        add_child(obj) {
            this._scene.addChild(obj);
        }
        remove_child(obj) {
            this._scene.removeChild(obj);
        }
        move_to(param) {}
        destroy() {
            if (this._scene) {
                if (this._scene.parent) {
                    this._scene.parent.removeChild(this._scene);
                }
                this._scene.destroy(true);
                Laya.Resource.destroyUnusedResources();
                this._scene = undefined;
                this._camera = undefined;
            }
        }
    }
    class scene_ui extends scene_base {
        constructor() {
            super(...arguments);
            this.temp_viewport = new Laya.Viewport(0, 0, 0, 0);
        }
        get scale() {
            return Laya.Browser.width / this._camera.viewport.width;
        }
        get_x(ui) {
            let x = 0;
            if (ui) {
                x = ui.x + this.get_x(ui.parent);
            }
            return x;
        }
        get_y(ui) {
            let y = 0;
            if (ui) {
                y = ui.y + this.get_y(ui.parent);
            }
            return y;
        }
        init(param) {
            super.init(param);
            let ui = param.ui_mount_point;
            if (ui) {
                let x = this.get_x(ui);
                let y = this.get_y(ui);
                if (window["qg"]) {
                    let width = ui.width * Laya.Browser.width / Laya.stage.width;
                    let height = ui.height * Laya.Browser.height / Laya.stage.height;
                    this._camera.viewport = new Laya.Viewport(x, y, width, height);
                } else {
                    this._camera.viewport = new Laya.Viewport(x, y, ui.width, ui.height);
                }
                ui.addChild(this._scene);
            }
        }
        move_to(param) {
            this.temp_viewport.x = param.x;
            this.temp_viewport.y = param.y;
            this.temp_viewport.width = param.width;
            this.temp_viewport.height = param.height;
            this._camera.viewport = this.temp_viewport;
        }
    }
    class effect_manager extends onetime_resource_manager {
        constructor() {
            super(...arguments);
            this.scene_effect = [];
        }
        get configs() {
            return igc.igc_config_manager.instance.configs_data["effects"];
        }
        get path_name() {
            return "effects";
        }
        init() {
            super.init();
            igc.phone_manager.instance.add_listener(phone_ids.show_effect, this, this.show_effect);
            igc.phone_manager.instance.add_listener(phone_ids.get_effect, this, this.get_resource);
            igc.phone_manager.instance.add_listener(phone_ids.get_effect_template, this, this.get_resource_template);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.hide_effect, this, this.hide_resource);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.hide_all_effects, this, this.hide_all_resources);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.recycle_effect, this, this.recycle_resource);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.effect_hidden, this, this.resource_hidden);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.recycle_scene_effect, this, this.recycle_scene_effect);
            igc.phone_manager.instance.add_listener(phone_ids.show_ui_effect, this, this.show_ui_effect);
        }
        show_ui_effect(phone_id, param) {
            let scene;
            if (this.scene_effect && 0 < this.scene_effect.length) {
                scene = this.scene_effect.pop();
            } else {
                scene = new scene_ui();
            }
            scene.init(param);
            return igc.phone_manager.instance.call(phone_ids.show_effect, {
                id: param.id,
                position: new Laya.Vector3(0, 0, param.scale || 0),
                scene: scene
            });
        }
        recycle_scene_effect(broadcast_id, param) {
            if (!param.scene) {
                console.error("ui_manager recycle_scene_effect run -> ", param);
                return;
            }
            let scene = param.scene;
            if (scene) {
                scene.scene.removeSelf();
                this.scene_effect.push(scene);
            }
        }
        show_resource(phone_id, param) {
            let resource = super.show_resource(phone_id, param);
            if (!resource && param.scene) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.recycle_scene_effect, {
                    scene: param.scene
                });
            }
            return resource;
        }
        show_effect(_, param) {
            if (param.id < 0) {
                return;
            }
            return this.show_resource(_, param);
        }
        load_game_must_async(id, finish_callback, res_update_callback) {
            let self = this;
            this.load_game_must_player_async(id, function() {
                self.load_game_must_enemy_async(id, function() {
                    finish_callback && finish_callback();
                }, function(progress) {
                    if (res_update_callback) {
                        return res_update_callback(.5 + .5 * progress);
                    } else {
                        return true;
                    }
                });
            }, function(progress) {
                if (res_update_callback) {
                    return res_update_callback(.5 * progress);
                } else {
                    return true;
                }
            });
        }
        add_effect_to_load_list(load_list, id_dict, config, unit_level) {
            if (config.dead_effect_id && config.dead_effect_id !== -1) {
                this.add_resource_to_load_list(load_list, id_dict, config.dead_effect_id);
            }
            if (config.attacked_effect_id && config.attacked_effect_id !== -1) {
                this.add_resource_to_load_list(load_list, id_dict, config.attacked_effect_id);
            }
            let level_datas = config.level_datas[unit_level];
            let skills = level_datas.skills;
            if (skills) {
                for (let skill_id in skills) {
                    let skill = skills[skill_id];
                    if (skill) {
                        if (skill.skill_effect && skill.skill_effect !== -1) {
                            this.add_resource_to_load_list(load_list, id_dict, skill.skill_effect);
                        }
                        if (skill.emit_effect_id && skill.emit_effect_id !== -1) {
                            this.add_resource_to_load_list(load_list, id_dict, skill.emit_effect_id);
                        }
                    }
                }
            }
        }
        load_game_must_player_async(id, finish_callback, res_update_callback) {
            finish_callback && finish_callback();
        }
        load_game_must_enemy_async(id, finish_callback, res_update_callback) {
            finish_callback && finish_callback();
        }
        new_resource(id, sprite3d) {
            switch (this.configs[id]["type"]) {
                case e_effect_type.normal:
                    return new effect_base(id, sprite3d);

                case e_effect_type.lightning:
                    return new effect_lightning(id, sprite3d);

                case e_effect_type.ui:
                    return new effect_ui(id, sprite3d);
            }
            return new effect_base(id, sprite3d);
        }
    }
    class camera_move extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.is_mouse_down = false;
            this.is_shaking = false;
            this.is_scaling = false;
            this.last_camera_position = new Laya.Vector3();
            this.last_mouse_position = new Laya.Vector2();
            this.temp_vector3 = new Laya.Vector3();
            this.world_to_screen_position = new Laya.Vector3();
            this.move_tween = undefined;
            this.mouse_down_time = 0;
            this.is_move_camera = false;
            this.two_finger = false;
            this.last_distance = 0;
            this.scale = 1;
            this.temp_pos = {};
            this.original_position = new Laya.Vector3();
            this.forward = new Laya.Vector3();
            this.right = new Laya.Vector3();
            this.mouse_up_target_position = new Laya.Vector3();
            this.mouse_up_result = new Laya.Vector3();
            this.camera_position = new Laya.Vector3();
        }
        onAwake() {}
        onEnable() {}
        get_camera_scale() {
            return this.camera.orthographicVerticalSize;
        }
        set_camera_scale(scale) {
            this.camera.orthographicVerticalSize = game_config_manager.instance.get_config("camera_orthographic_size") * scale * 2;
        }
        camera_scale_tween(_, param) {
            this.is_scaling = true;
            let self = this;
            igc.utils_manager.tween(this.camera, param.from, param.to, param.duration, function(target, from, to, t) {
                self.set_camera_scale(from + (to - from) * t);
            }, function() {
                self.is_scaling = false;
                self.set_camera_scale(param.to);
                param.finish_callback && param.finish_callback();
            }, true);
        }
        shake_camera() {
            if (!this.is_mouse_down) {
                if (!this.is_shaking) {
                    this.position.cloneTo(this.temp_vector3);
                    this.position.cloneTo(this.last_camera_position);
                    this.is_shaking = true;
                    let self = this;
                    let scale = game_config_manager.instance.get_config("max_shake_height");
                    igc.utils_manager.tween(this, 0, 1, game_config_manager.instance.get_config("shake_time"), function() {
                        self.temp_vector3.x += (.5 - Math.random()) * scale;
                        self.temp_vector3.z += (.5 - Math.random()) * scale;
                        self.position = self.temp_vector3;
                    }, function() {
                        self.is_shaking = false;
                        self.position = self.last_camera_position;
                    }, false);
                }
            }
        }
        key_press(param) {
            switch (param.keyCode) {
                case 187:
                    this.do_scale(this.last_distance + 5);
                    break;

                case 189:
                    this.do_scale(this.last_distance - 5);
                    break;
            }
        }
        onDisable() {}
        get_world_to_screen_position(phone_id, param) {
            if (this.camera) {
                this.camera.worldToViewportPoint(param.position, this.world_to_screen_position);
                return this.world_to_screen_position;
            } else {
                return undefined;
            }
        }
        update_last_mouse_position() {
            this.last_mouse_position.x = Laya.MouseManager.instance.mouseX;
            this.last_mouse_position.y = Laya.MouseManager.instance.mouseY;
        }
        get_distance(touches) {
            let distance = 0;
            if (touches && 2 <= touches.length) {
                let dx = touches[0].stageX - touches[1].stageX;
                let dy = touches[0].stageY - touches[1].stageY;
                distance = Math.sqrt(dx * dx + dy * dy);
            }
            return distance;
        }
        mouse_down(param) {
            let touches = param.touches;
            if (touches && 2 <= touches.length) {
                this.two_finger = true;
                this.last_distance = this.get_distance(touches);
            } else {
                if (!this.is_shaking && !this.is_scaling) {
                    this.is_mouse_down = true;
                    this.update_last_mouse_position();
                    this.position.cloneTo(this.last_camera_position);
                    if (this.move_tween) {
                        igc.utils_manager.stop_tween(this.move_tween);
                        this.move_tween = undefined;
                    }
                    this.mouse_down_time = igc.Time.real_time;
                    this.is_move_camera = false;
                    igc.igc_timer.frameLoop(1, this, this.mouse_move, undefined, true);
                }
            }
        }
        do_scale(distance) {
            let self = this;
            const factor = game_config_manager.instance.get_config("camera_scale_factor");
            this.scale -= (distance - this.last_distance) * factor;
            let camera_min_scale = game_config_manager.instance.get_config("camera_min_scale");
            let camera_max_scale = game_config_manager.instance.get_config("camera_max_scale");
            if (this.scale < camera_min_scale) {
                this.scale = camera_min_scale;
            } else if (camera_max_scale < this.scale) {
                this.scale = camera_max_scale;
            }
            this.set_camera_scale(this.scale);
            this.last_distance = distance;
        }
        mouse_move(param) {
            if (this.two_finger) {
                if (param) {
                    let touches = param.touches;
                    if (touches && 2 <= touches.length) {
                        let distance = this.get_distance(touches);
                        this.do_scale(distance);
                    }
                }
            } else if (this.is_mouse_down) {
                let press_place_army_inteval = game_config_manager.instance.get_config("press_place_army_interval");
                if (igc.Time.real_time < this.mouse_down_time + press_place_army_inteval) {
                    let move_too_much = 5 < Math.abs(this.last_mouse_position.x - Laya.MouseManager.instance.mouseX) + Math.abs(this.last_mouse_position.y - Laya.MouseManager.instance.mouseY);
                    if (move_too_much) {
                        this.is_move_camera = true;
                    }
                } else {
                    if (!this.is_move_camera) {
                        let self = this;
                        this.update_last_mouse_position();
                    }
                }
                if (this.is_move_camera) {
                    this.do_move_camera();
                }
            }
        }
        do_move_camera() {
            let camera_move_speed = game_config_manager.instance.get_config("camera_move_speed"); {
                let delta_x = this.last_mouse_position.x - Laya.MouseManager.instance.mouseX;
                this.camera.transform.getRight(this.right);
                Laya.Vector3.scale(this.right, delta_x * camera_move_speed, this.right);
                this.camera.transform.translate(this.right, false);
            } {
                let delta_z = this.last_mouse_position.y - Laya.MouseManager.instance.mouseY;
                this.camera.transform.getForward(this.forward);
                Laya.Vector3.scale(this.forward, delta_z * camera_move_speed, this.forward);
                this.camera.transform.translate(this.forward, false);
            }
            this.position = this.camera.transform.position;
            this.update_last_mouse_position();
        }
        mouse_up() {
            if (this.two_finger) {
                this.two_finger = false;
            } else if (this.is_mouse_down) {
                this.is_mouse_down = false;
                igc.igc_timer.clear(this, this.mouse_move);
                if (this.is_move_camera) {
                    let self = this;
                    Laya.Vector3.lerp(this.last_camera_position, this.position, 1.1, this.mouse_up_target_position);
                    this.move_tween = igc.utils_manager.tween(self.camera.transform, this.position.clone(), this.mouse_up_target_position, .1, function(target, from, to, t) {
                        Laya.Vector3.lerp(from, to, t, self.mouse_up_result);
                        self.position = self.mouse_up_result;
                    }, function() {
                        self.move_tween = undefined;
                    }, true);
                    this.position.cloneTo(this.last_camera_position);
                } else {
                    this.update_last_mouse_position();
                    let self = this;
                }
            }
        }
        get position() {
            return this.camera.transform.position;
        }
        set position(value) {
            value.cloneTo(this.camera_position);
            let battle_scene_size = game_config_manager.instance.get_config("camera_move_limit_size");
            let x = this.camera_position.x;
            let z = this.camera_position.z;
            if (this.camera_position.x - x < -battle_scene_size) {
                this.camera_position.x = -battle_scene_size + x;
            } else if (battle_scene_size < this.camera_position.x - x) {
                this.camera_position.x = battle_scene_size + x;
            }
            if (this.camera_position.z - z < -battle_scene_size) {
                this.camera_position.z = -battle_scene_size + z;
            } else if (battle_scene_size < this.camera_position.z - z) {
                this.camera_position.z = battle_scene_size + z;
            }
            this.camera.transform.position = this.camera_position;
        }
    }
    class scene_game extends scene_base {
        init(param) {
            this._scene = param.scene;
            this._camera = param.camera;
            if (param.id === undefined) {
                this.id = -1;
            } else {
                this.id = param.id;
            }
        }
    }
    class battle_scene_manager extends igc.igc_manager_base {
        constructor() {
            super(...arguments);
            this.last_mouse_position = new Laya.Vector3();
            this.battle_scene = undefined;
            this.last_battle_scene_id = -1;
            this.ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            this.mouse_position = new Laya.Vector3();
            this.outs = new Array();
            this.cached_obstalce = undefined;
            this.cached_obstalce_without_wall = undefined;
            this.cached_non_obstacle = undefined;
            this.last_place_army_time = 0;
            this.level_configs = {};
            this.pos_param = {};
            this.scenes_pool = {};
            this.can_position_place_army_coordinate = new Laya.Vector2();
            this.plane_normal = new Laya.Vector3(0, 1, 0);
            this.plane_point = new Laya.Vector3();
            this.intersection = new Laya.Vector3();
            this.place_army_mouse_position = new Laya.Vector2();
            this._boundray = new Laya.Vector4();
        }
        init() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.load_battle_scene, this, this.load_battle_scene);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.unload_battle_scene, this, this.unload_battle_scene);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.load_battle_scene_finished, this, this.load_battle_scene_finished);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.unload_battle_scene_finished, this, this.unload_battle_scene_finished);
            igc.broadcast_manager.instance.add_listener(e_guide_node.add_player, this, this.call_add_player);
            igc.phone_manager.instance.add_listener(phone_ids.get_active_game_scene, this, this.get_active_game_scene);
            igc.phone_manager.instance.add_listener(phone_ids.get_obstalces, this, this.get_obstalces);
            igc.phone_manager.instance.add_listener(phone_ids.can_position_place_army, this, this.can_position_place_army);
            igc.phone_manager.instance.add_listener(phone_ids.get_level_config, this, this.get_level_config);
        }
        get_guide_node_position(_, param) {
            if (!this.pos_param[param.chapter_id]) {
                let node = utils_manager.GetChildByName(this.get_active_game_scene(undefined, undefined).scene, "guide_node");
                if (node) {
                    let guide_scene_pos = igc.phone_manager.instance.call(phone_ids.get_world_to_screen_position, {
                        position: node.transform.position.clone()
                    });
                    this.pos_param[param.chapter_id] = guide_scene_pos.clone();
                } else {
                    this.pos_param[param.chapter_id] = new Laya.Vector2(0, 0);
                }
            }
            return this.pos_param[param.chapter_id];
        }
        get_level_config(phone_id, param) {
            let config = this.level_configs[param.id];
            if (config) {
                return config;
            } else {
                this.load_level_config_async(param.id, function() {}, undefined);
            }
        }
        load_level_config_async(id, finish_callback, res_update_callback) {
            let load_list = [];
            let self = this;
            let config = igc.igc_config_manager.instance.configs_data["levels"][id];
            if (config) {
                load_list.push({
                    path: igc.igc_resources_utils.get_url("configs/levels/" + id + ".json"),
                    id: id,
                    save: function(_id, config) {
                        if (config && !self.level_configs[_id]) {
                            self.level_configs[_id] = config;
                            for (let i = 0; i < config.track.track_points.length; ++i) {
                                let point = config.track.track_points[i];
                                self.level_configs[_id].track.track_points[i].point = new Laya.Vector3(point.point.x, point.point.y, point.point.z);
                                self.level_configs[_id].track.track_points[i].tangent0 = new Laya.Vector3(point.tangent0.x, point.tangent0.y, point.tangent0.z);
                                self.level_configs[_id].track.track_points[i].tangent1 = new Laya.Vector3(point.tangent1.x, point.tangent1.y, point.tangent1.z);
                            }
                        }
                    }
                });
                igc.igc_resources_utils.async_load_res(load_list, function() {
                    finish_callback && finish_callback();
                }, 1, res_update_callback);
            }
        }
        load_level_async(scene_id, finish_callback, res_update_callback) {
            let load_list = [];
            let path = igc.igc_resources_utils.get_url("levels/" + this.get_scene_name(scene_id) + ".ls");
            let self = this;
            load_list.push({
                path: path,
                id: scene_id,
                save: function(_id, scene) {
                    self.scenes_pool[_id] = scene;
                }
            });
            igc.igc_resources_utils.async_load_res(load_list, finish_callback, 1, res_update_callback);
        }
        load_game_must_async(id, finish_callback, res_update_callback) {
            let self = this;
            this.load_level_config_async(id, function() {
                self.load_level_async(id, finish_callback, function(progress) {
                    if (res_update_callback) {
                        return res_update_callback(.5 + .5 * progress);
                    } else {
                        return true;
                    }
                });
            }, function(progress) {
                if (res_update_callback) {
                    return res_update_callback(.5 * progress);
                } else {
                    return true;
                }
            });
        }
        can_position_place_army(phone_id, param) {
            let config = this.config;
            if (config) {
                let position = param.position;
                let coordinate = this.can_position_place_army_coordinate;
                utils_manager.position_to_coordinate(position, coordinate);
                let forbid_place_army = config.forbid_place_army;
                let y_array = forbid_place_army[coordinate.x];
                let scene_size = game_config_manager.instance.get_config("battle_scene_size");
                if (y_array) {
                    for (let i = 0; i < y_array.length; ++i) {
                        if (y_array[i][0] <= coordinate.y && coordinate.y <= y_array[i][1]) {
                            return false;
                        }
                    }
                }
                if (coordinate.x <= -scene_size || scene_size <= coordinate.x || coordinate.y <= -scene_size || scene_size <= coordinate.y) {
                    return false;
                }
                return true;
            } else {
                return false;
            }
        }
        get_obstalces(phone_id, param) {
            if (param.ignore_wall) {
                return this.cached_obstalce_without_wall;
            } else {
                return this.cached_obstalce;
            }
        }
        check_obstalces_by_coordinate(phone_id, param) {
            return false;
        }
        get_active_game_scene(phone_id, param) {
            return this.battle_scene;
        }
        load_battle_scene_finished(broadcast_id, param) {
            let self = this;
            this.cached_obstalce = undefined;
            this.cached_obstalce_without_wall = undefined;
            this.cached_non_obstacle = undefined;
            igc.broadcast_manager.instance.broadcast(broadcast_ids.enter_scene);
        }
        character_will_dead(broadcast_id, param) {}
        get current_scene_id() {
            let scene_id = -1;
            if (this.battle_scene) {
                scene_id = this.battle_scene.id;
            }
            return scene_id;
        }
        update_obstacles(enemy_instance_ids) {}
        get_obstacle_cells_array(x_size, y_size, x_offset, y_offset, cells_array, cells_array_without_wall, pernalty_array, pernalty_array_without_wall) {}
        broadcast_obstalce_change() {
            let self = this;
            let cells_array = [];
            let cells_array_without_wall = [];
            let cells_array_prune = [];
            let cells_array_without_wall_prune = [];
            let pernalty_array = [];
            let pernalty_array_without_wall = [];
            let pernalty_array_prune = [];
            let pernalty_array_without_wall_prune = [];
            let battle_scene_size = game_config_manager.instance.get_config("battle_scene_size");
            this.get_obstacle_cells_array(battle_scene_size * 2, battle_scene_size * 2, battle_scene_size, battle_scene_size, cells_array, cells_array_without_wall, pernalty_array, pernalty_array_without_wall);
            let boundary = this.config["boundary"];
            let path_find_prune_length = game_config_manager.instance.get_config("path_find_prune_length");
            let x_offset = Math.abs(boundary.x) + path_find_prune_length;
            let y_offset = Math.abs(boundary.z) + path_find_prune_length;
            this.get_obstacle_cells_array(boundary.y - boundary.x + path_find_prune_length * 2, boundary.w - boundary.z + path_find_prune_length * 2, x_offset, y_offset, cells_array_prune, cells_array_without_wall_prune, pernalty_array_prune, pernalty_array_without_wall_prune);
            igc.broadcast_manager.instance.broadcast(broadcast_ids.path_find_obstacles_changed, {
                cells_array: cells_array,
                pernalty_array: pernalty_array,
                offset: new Laya.Vector2(battle_scene_size, battle_scene_size),
                cells_array_without_wall: cells_array_without_wall,
                pernalty_array_without_wall: pernalty_array_without_wall,
                offset_without_wall: new Laya.Vector2(battle_scene_size, battle_scene_size),
                cells_array_prune: cells_array_prune,
                pernalty_array_prune: pernalty_array_prune,
                offset_prune: new Laya.Vector2(x_offset, y_offset),
                cells_array_without_wall_prune: cells_array_without_wall_prune,
                pernalty_array_without_wall_prune: pernalty_array_without_wall_prune,
                offset_without_wall_prune: new Laya.Vector2(x_offset, y_offset),
                boundary: boundary
            });
        }
        load_enemies() {}
        unload_battle_scene_finished(broadcast_id, param) {
            this.stop_battle();
        }
        get_scene_name(scene_id) {
            return igc.phone_manager.instance.call(phone_ids.get_level_config, {
                id: scene_id
            }).path;
        }
        load_battle_scene(broadcast_id, param) {
            let self = this;
            let scene_id = param.id;
            if (this.battle_scene && this.battle_scene.id === param.id) {
                let scene = this.battle_scene.scene;
                Laya.stage.addChild(scene);

                igc.broadcast_manager.instance.broadcast(broadcast_ids.load_battle_scene_finished, {
                    id: scene_id
                });
            } else {
                if (this.battle_scene) {
                    this.battle_scene.destroy();
                    this.battle_scene = undefined;
                }
                this.load_level_async(scene_id, function() {
                    let scene = self.scenes_pool[scene_id];
                    if (self.scenes_pool[scene_id]) {
                        Laya.stage.addChild(scene);
                        var camera = utils_manager.GetChildByName(scene, "Main Camera");
                        if (!camera.getComponent(camera_move)) {
                            camera.addComponent(camera_move);
                        }
                        self.battle_scene = new scene_game();
                        self.battle_scene.init({
                            scene: scene,
                            camera: camera,
                            id: scene_id
                        });

                        igc.broadcast_manager.instance.broadcast(broadcast_ids.load_battle_scene_finished, {
                            id: scene_id
                        });
                    }
                }, undefined);
            }
        }
        unload_battle_scene(broadcast_id, param) {
            if (this.battle_scene === undefined) {
                return;
            }
            let scene = this.battle_scene;
            let current_scene = scene.scene;
            igc.broadcast_manager.instance.broadcast(broadcast_ids.destroy_all_active_characters);
            if (current_scene) {
                Laya.stage.removeChild(current_scene);
                let self = this;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.unload_battle_scene_finished, {
                    id: self.battle_scene.id
                });
            }
        }
        start_battle() {
            Laya.stage.on(Laya.Event.RIGHT_MOUSE_DOWN, this, this.right_mouse_down);
        }
        stop_battle() {
            Laya.stage.off(Laya.Event.RIGHT_MOUSE_DOWN, this, this.right_mouse_down);
        }
        right_mouse_down() {}
        RayPlaneIntersection(ray, plane) {
            let p = new Laya.Vector3();
            let t = 0;
            t = (plane.n * plane.p1 - plane.n * ray.p0) / (plane.n * ray.u);
            p = ray.p0 + t * ray.u;
            return p;
        }
        call_add_player(_, param) {
            this.click_scene(param.click_pos);
        }
        click_scene(mouse_pos) {
            let self = this;
            let active_scene = this.battle_scene;
            if (!active_scene) {
                return;
            }
            let scene = active_scene.scene;
            let camera = active_scene.camera;
            if (scene && camera) {
                camera.viewportPointToRay(mouse_pos, self.ray);
                let a = Laya.Vector3.dot(this.plane_normal, this.plane_point);
                let b = Laya.Vector3.dot(this.plane_normal, self.ray.origin);
                let c = Laya.Vector3.dot(this.plane_normal, self.ray.direction);
                let t = (a - b) / c;
                Laya.Vector3.scale(self.ray.direction, t, this.intersection);
                Laya.Vector3.add(self.ray.origin, this.intersection, this.intersection);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.click_scene, {
                    position: self.intersection
                });
            }
        }
        place_army(broadcast_id, param) {
            if (this.last_place_army_time < igc.Time.real_time) {
                this.last_place_army_time = igc.Time.real_time + game_config_manager.instance.get_config("place_army_cd");
                this.click_scene(param.position);
            }
        }
        get_scene_boundary(phone_id, param) {
            let config = this.config;
            if (config) {
                this._boundray.x = config["boundary"].x;
                this._boundray.y = config["boundary"].y;
                this._boundray.z = config["boundary"].z;
                this._boundray.w = config["boundary"].w;
            }
            return this._boundray;
        }
        get config() {
            let self = this;
            return igc.phone_manager.instance.call(phone_ids.get_level_config, {
                id: self.current_scene_id
            });
        }
    }
    class loading_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super(...arguments);
            this.ui_instance = undefined;
        }
        static get instance() {
            return loading_manager.get_instance();
        }
        show(loading_type, progress) {
            if (!this.ui_instance) {
                if (loading_type === e_loading_type.enter_battle) {} else {
                    this.ui_instance = igc.phone_manager.instance.call(phone_ids.show_ui, {
                        ui: ui_class.ui_login
                    });
                }
                let self = this;
                igc.igc_timer.frameLoop(10, this, function() {
                    if (self.ui_instance) {
                        self.ui_instance.increase_progress();
                    }
                }, undefined, true);
            }
            if (this.ui_instance) {
                this.ui_instance.set_progress(progress);
            }
        }
        hide(loading_type, finish_callback) {
            igc.igc_timer.clearAll(this);
            let self = this;
            if (loading_type === e_loading_type.enter_battle) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.hide_battle_loading);
            }
            if (this.ui_instance !== undefined) {
                let self = this;
                igc.phone_manager.instance.call(phone_ids.hide_ui, {
                    instance: self.ui_instance
                });
                self.ui_instance = undefined;
            }
        }
    }
    class resource_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super(...arguments);
            this._managers = [];
            this.is_load_async = false;
        }
        init() {
            super.init();
            igc.broadcast_manager.instance.add_listener(broadcast_ids.do_after_account, this, this.do_after_account);
        }
        set managers(value) {
            this._managers = value;
        }
        do_after_account(broadcast_id, param) {
            resource_manager.instance.load_battle_must_async_fast(igc.phone_manager.instance.call(phone_ids.get_cur_chapter_id), function() {}, false);
        }
        static get instance() {
            return resource_manager.get_instance();
        }
        async_load_delay(delay) {
            igc.igc_timer.clear(this, this.load_async_delay);
            igc.igc_timer.once(delay, this, this.load_async_delay);
        }
        load_async_delay(finish_callback, res_update_callback) {
            this.is_load_async = true;
            let self = this;
            let load_list = [];
            for (let i = 0; i < this._managers.length; ++i) {
                if (this._managers[i].load_async_delay) {
                    load_list.push(this._managers[i]);
                }
            }
            igc.igc_resources_utils.async_load_delay(load_list, function() {
                finish_callback && finish_callback();
            }, function() {
                return self.is_load_async;
            });
        }
        stop_load_async_delay() {
            this.is_load_async = false;
            igc.igc_timer.clear(this, this.load_async_delay);
        }
        load_battle_must_async_fast(id, finish_callback, show_loading_ui) {
            this.stop_load_async_delay();
            let load_list = [];
            for (let i = 0; i < this._managers.length; ++i) {
                if (this._managers[i].load_game_must_async) {
                    load_list.push(this._managers[i]);
                }
            }
            for (let i = 0; i < load_list.length; ++i) {
                console.log(load_list[i]);
            }
            let self = this;
            igc.igc_resources_utils.async_load_game_must(id, load_list, function() {
                finish_callback && finish_callback();

                if (show_loading_ui) {
                    loading_manager.instance.hide(e_loading_type.enter_game);
                }
            }, function(progress) {
                for (let i = 0; i < load_list.length; ++i) {
                    console.log(load_list[i]);
                }
                if (show_loading_ui) {
                    loading_manager.instance.show(e_loading_type.enter_game, .67 + progress * .33);
                }
                return true;
            });
        }
        load_game_must_async(id, finish_callback) {
            this.stop_load_async_delay();
            let load_list = [];
            for (let i = 0; i < this._managers.length; ++i) {
                if (this._managers[i].load_game_must_async) {
                    load_list.push(this._managers[i]);
                }
            }
            let load_list_count = load_list.length;
            let self = this;
            igc.igc_resources_utils.async_load_game_must(id, load_list, function() {
                finish_callback && finish_callback();
                loading_manager.instance.hide(e_loading_type.enter_battle);
            }, function(progress) {
                loading_manager.instance.show(e_loading_type.enter_battle, progress);
                return true;
            });
            self.precompile_shader(function() {});
        }
        precompile_shader(finish_callback) {
            let shader_list = igc.igc_config_manager.instance.configs_data["shader_precompile"];
            this.do_precompile_shader(shader_list, finish_callback);
        }
        do_precompile_shader(shader_list, finish_callback) {
            if (0 < shader_list.length) {
                let shader = shader_list.pop();
                Laya.Shader3D.compileShaderByDefineNames(shader[0], shader[1], shader[2], shader[3]);
                igc.igc_timer.frameOnce(1, this, this.do_precompile_shader, [shader_list, finish_callback], true);
            } else {
                finish_callback && finish_callback();
            }
        }
    }
    var path_find_alg;
    (function(path_find_alg) {
        path_find_alg[path_find_alg["astar"] = 1] = "astar";
        path_find_alg[path_find_alg["jps"] = 2] = "jps";
    })(path_find_alg || (path_find_alg = {}));
    class map_grid {
        constructor(mesh, pernalty = null) {
            this._mesh_grid = mesh;
            this._pernalty_grid = pernalty;
            this._pf_grid = new PF.Grid(mesh, pernalty);
        }
        get org_pf_grid() {
            return this._pf_grid;
        }
        get pf_grid() {
            return this._pf_grid.clone();
        }
        set_walkable_at(x, y, walkable) {
            this._pf_grid.setWalkableAt(x, y, walkable);
        }
        is_walkable_at(x, y) {
            return this._pf_grid.isWalkableAt(x, y);
        }
        set_pernalty_at(x, y, pernalty) {
            this._pf_grid.setPernaltyAt(x, y, pernalty);
        }
        get_pernalty_at(x, y) {
            return this._pf_grid.getPernaltyAt(x, y);
        }
    }
    class path_find {
        constructor() {
            this.cache_path_find_results = {};
            this.cache_path_find_length = {};
            this.offset = new Laya.Vector2();
            this.do_find_path_from_coordinate = new Laya.Vector2();
            this.do_find_path_to_coordinate = new Laya.Vector2();
            this.find_path_predict_walkable_coordinate = new Laya.Vector2();
        }
        get finder() {
            return this._finder;
        }
        reset(param) {
            this.cache_path_find_results = {};
            this.cache_path_find_length = {};
            this.offset = param.offset;
            this._map = new map_grid(param.cells_array, param.pernalty_array);
        }
        init_algorithm(alg = path_find_alg.astar, opt = null) {
            switch (alg) {
                case path_find_alg.astar:
                    if (!opt) {
                        this._finder = new PF.AStarFinder({
                            diagonalMovement: PF.DiagonalMovement.Never,
                            heuristic: PF.Heuristic.manhattan
                        });
                    } else {
                        this._finder = new PF.AStarFinder(opt);
                    }
                    break;

                case path_find_alg.jps:
                    if (!opt) {
                        this._finder = PF.JumpPointFinder({
                            heuristic: PF.Heuristic.chebyshev
                        });
                    } else {
                        this._finder = PF.JumpPointFinder(opt);
                    }
                    break;

                default:
                    console.error("Error: Unknown Path Find Alg");
                    break;
            }
        }
        set_mesh_walkable(x, y, walkable) {
            this._map.org_pf_grid.setWalkableAt(x, y, walkable);
        }
        is_walkable_at(x, y) {
            return this._map.org_pf_grid.isWalkableAt(x, y);
        }
        set_mesh_penalty(x, y, pernalty) {
            this._map.org_pf_grid.setPernaltyAt(x, y, pernalty);
        }
        do_find_path(from_coordinate, to_coordinate, _map, _finder, cache_path_find_results, predict_walkable_coordinate) {
            let key = this.get_key(from_coordinate, to_coordinate, predict_walkable_coordinate);
            this.do_find_path_from_coordinate.x = from_coordinate.x + this.offset.x;
            this.do_find_path_from_coordinate.y = from_coordinate.y + this.offset.y;
            this.do_find_path_to_coordinate.x = to_coordinate.x + this.offset.x;
            this.do_find_path_to_coordinate.y = to_coordinate.y + this.offset.y;
            if (cache_path_find_results[key]) {
                return cache_path_find_results[key];
            }
            cache_path_find_results[key] = [];
            if (_map.org_pf_grid.isWalkableAt(this.do_find_path_to_coordinate.x, this.do_find_path_to_coordinate.y)) {
                let path = _finder.findPath(this.do_find_path_from_coordinate.x, this.do_find_path_from_coordinate.y, this.do_find_path_to_coordinate.x, this.do_find_path_to_coordinate.y, _map.org_pf_grid);
                if (path.length > 0) {
                    cache_path_find_results[key] = PF.Util.compressPath(path);
                }
            }
            for (let i = 0; i < cache_path_find_results[key].length; ++i) {
                cache_path_find_results[key][i][0] -= this.offset.x;
                cache_path_find_results[key][i][1] -= this.offset.y;
            }
            return cache_path_find_results[key];
        }
        get_key(from_coordinate, to_coordinate, predict_walkable_coordinate) {
            if (predict_walkable_coordinate !== undefined) {
                return from_coordinate.x + "." + from_coordinate.y + "." + to_coordinate.x + "." + to_coordinate.y + "." + predict_walkable_coordinate.x + "." + predict_walkable_coordinate.y;
            } else {
                return from_coordinate.x + "." + from_coordinate.y + "." + to_coordinate.x + "." + to_coordinate.y;
            }
        }
        find_path(from_coordinate, to_coordinate, predict_walkable_coordinate) {
            let walkable = undefined;
            if (predict_walkable_coordinate !== undefined) {
                this.find_path_predict_walkable_coordinate.x = predict_walkable_coordinate.x + this.offset.x;
                this.find_path_predict_walkable_coordinate.y = predict_walkable_coordinate.y + this.offset.y;
                walkable = this.is_walkable_at(this.find_path_predict_walkable_coordinate.x, this.find_path_predict_walkable_coordinate.y);
                this.set_mesh_walkable(this.find_path_predict_walkable_coordinate.x, this.find_path_predict_walkable_coordinate.y, true);
            }
            let result = this.do_find_path(from_coordinate, to_coordinate, this._map, this._finder, this.cache_path_find_results, predict_walkable_coordinate);
            if (predict_walkable_coordinate !== undefined) {
                if (walkable !== undefined) {
                    this.set_mesh_walkable(this.find_path_predict_walkable_coordinate.x, this.find_path_predict_walkable_coordinate.y, walkable);
                }
            }
            return result;
        }
        is_cached(from_coordinate, to_coordinate, predict_walkable_coordinate) {
            let key = this.get_key(from_coordinate, to_coordinate, predict_walkable_coordinate);
            if (this.cache_path_find_results[key] !== undefined) {
                return true;
            } else {
                return false;
            }
        }
        path_length(from_coordinate, to_coordinate, predict_walkable_coordinate) {
            let key = this.get_key(from_coordinate, to_coordinate, predict_walkable_coordinate);
            if (this.cache_path_find_length[key] !== undefined) {
                return this.cache_path_find_length[key];
            } else {
                let length = 0;
                let path = this.find_path(from_coordinate, to_coordinate, predict_walkable_coordinate);
                if (path) {
                    for (let i = 1; i < path.length; ++i) {
                        length += Math.abs(path[i][0] - path[i - 1][0]);
                        length += Math.abs(path[i][1] - path[i - 1][1]);
                    }
                }
                if (length === 0) {
                    if (!utils_manager.same_coordinate(from_coordinate, to_coordinate)) {
                        length = Infinity;
                    }
                }
                this.cache_path_find_length[key] = length;
                return length;
            }
        }
    }
    window["path_find"] = path_find;
    class path_find_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super(...arguments);
            this.boundary = new Laya.Vector4();
            this.hit_times = 0;
            this.missing_times = 0;
            this.hit_prune_times = 0;
            this.missing_prune_times = 0;
        }
        static get instance() {
            return path_find_manager.get_instance();
        }
        init() {
            super.init();
            this.path_find_with_wall = new path_find();
            this.path_find_without_wall = new path_find();
            this.path_find_with_wall_prune = new path_find();
            this.path_find_without_wall_prune = new path_find();
            igc.broadcast_manager.instance.add_listener(broadcast_ids.path_find_obstacles_changed, this, this.path_find_obstacles_changed);
        }
        path_find_obstacles_changed(broadcast_id, param) {
            this.path_find_with_wall.reset({
                cells_array: param.cells_array,
                pernalty_array: param.pernalty_array,
                offset: param.offset
            });
            this.path_find_without_wall.reset({
                cells_array: param.cells_array_without_wall,
                pernalty_array: param.pernalty_array_without_wall,
                offset: param.offset_without_wall
            });
            this.path_find_with_wall_prune.reset({
                cells_array: param.cells_array_prune,
                pernalty_array: param.pernalty_array_prune,
                offset: param.offset_prune
            });
            this.path_find_without_wall_prune.reset({
                cells_array: param.cells_array_without_wall_prune,
                pernalty_array: param.pernalty_array_without_wall_prune,
                offset: param.offset_without_wall_prune
            });
            let path_find_prune_length = game_config_manager.instance.get_config("path_find_prune_length");
            this.boundary.x = param.boundary.x - path_find_prune_length;
            this.boundary.y = param.boundary.y + path_find_prune_length;
            this.boundary.z = param.boundary.z - path_find_prune_length;
            this.boundary.w = param.boundary.w + path_find_prune_length;
        }
        init_algorithm(alg = path_find_alg.astar, opt = null) {
            this.path_find_with_wall.init_algorithm(alg, opt);
            this.path_find_without_wall.init_algorithm(alg, opt);
            this.path_find_with_wall_prune.init_algorithm(alg, opt);
            this.path_find_without_wall_prune.init_algorithm(alg, opt);
        }
        set_mesh_walkable(x, y, walkable, ignore_wall) {
            if (ignore_wall) {
                this.path_find_without_wall.set_mesh_walkable(x, y, walkable);
                this.path_find_without_wall_prune.set_mesh_walkable(x, y, walkable);
            } else {
                this.path_find_with_wall.set_mesh_walkable(x, y, walkable);
                this.path_find_with_wall_prune.set_mesh_walkable(x, y, walkable);
            }
        }
        is_walkable_at(x, y, ignore_wall) {
            if (ignore_wall) {
                return this.path_find_without_wall.is_walkable_at(x, y);
            } else {
                return this.path_find_with_wall.is_walkable_at(x, y);
            }
        }
        set_mesh_penalty(x, y, pernalty, ignore_wall) {
            if (ignore_wall) {
                this.path_find_without_wall.set_mesh_penalty(x, y, pernalty);
                this.path_find_without_wall_prune.set_mesh_penalty(x, y, pernalty);
            } else {
                this.path_find_with_wall.set_mesh_penalty(x, y, pernalty);
                this.path_find_with_wall_prune.set_mesh_penalty(x, y, pernalty);
            }
        }
        is_in_prune(from_coordinate, to_coordinate, predict_walkable_coordinate) {
            if (utils_manager.is_in_boundary(from_coordinate, this.boundary) && utils_manager.is_in_boundary(to_coordinate, this.boundary) && (!predict_walkable_coordinate || utils_manager.is_in_boundary(predict_walkable_coordinate, this.boundary))) {
                return true;
            } else {
                return false;
            }
        }
        print_debug() {
            console.log("path_find:print_debug", ", this.hit_times:", this.hit_times, ", this.hit_prune_times:", this.hit_prune_times);
        }
        find_path(from_coordinate, to_coordinate, predict_walkable_coordinate, ignore_wall) {
            if (this.is_in_prune(from_coordinate, to_coordinate, predict_walkable_coordinate)) {
                ++this.hit_prune_times;
                if (ignore_wall) {
                    return this.path_find_without_wall_prune.find_path(from_coordinate, to_coordinate, predict_walkable_coordinate);
                } else {
                    return this.path_find_with_wall_prune.find_path(from_coordinate, to_coordinate, predict_walkable_coordinate);
                }
            } else {
                ++this.hit_times;
                if (ignore_wall) {
                    return this.path_find_without_wall.find_path(from_coordinate, to_coordinate, predict_walkable_coordinate);
                } else {
                    return this.path_find_with_wall.find_path(from_coordinate, to_coordinate, predict_walkable_coordinate);
                }
            }
        }
        path_length(from_coordinate, to_coordinate, predict_walkable_coordinate, ignore_wall) {
            if (this.is_in_prune(from_coordinate, to_coordinate, predict_walkable_coordinate)) {
                if (ignore_wall) {
                    return this.path_find_without_wall_prune.path_length(from_coordinate, to_coordinate, predict_walkable_coordinate);
                } else {
                    return this.path_find_with_wall_prune.path_length(from_coordinate, to_coordinate, predict_walkable_coordinate);
                }
            } else {
                if (ignore_wall) {
                    return this.path_find_without_wall.path_length(from_coordinate, to_coordinate, predict_walkable_coordinate);
                } else {
                    return this.path_find_with_wall.path_length(from_coordinate, to_coordinate, predict_walkable_coordinate);
                }
            }
        }
        is_reachable(from_coordinate, to_coordinate, ignore_wall) {
            if (utils_manager.same_coordinate(from_coordinate, to_coordinate)) {
                return true;
            } else {
                let path = this.find_path(from_coordinate, to_coordinate, undefined, ignore_wall);
                return path && 0 < path.length;
            }
        }
    }
    class energy_manager extends igc.igc_manager_base {
        init() {
            super.init();
            this.save_data = {
                next_increase_time: 0,
                energy_amount: game_config_manager.instance.get_config("max_energy")
            };
            igc.phone_manager.instance.add_listener(phone_ids.use_energy, this, this.use_energy);
            igc.phone_manager.instance.add_listener(phone_ids.get_energy, this, this.get_energy);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.add_energy, this, this.add_energy);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.energy_changed, this, this.energy_changed);
            this.increase_energy();
            igc.igc_timer.loop(1, this, this.increase_energy, undefined, true);
        }
        energy_changed(broadcast_id, param) {
            this.save(true);
        }
        get_energy(phone_id, param) {
            return this.save_data["energy_amount"];
        }
        use_energy(phone_id, param) {
            let self = this;
            if (param.amount <= this.save_data["energy_amount"]) {
                let old_amount = this.save_data["energy_amount"];
                this.save_data["energy_amount"] -= param.amount;
                let max_energy = game_config_manager.instance.get_config("max_energy");
                if (old_amount === max_energy) {
                    let time = igc.time_manager.instance.get_server_time();
                    let energy_restore_interval = game_config_manager.instance.get_config("energy_restore_interval") * 1e3;
                    this.save_data["next_increase_time"] = time + energy_restore_interval;
                }
                igc.broadcast_manager.instance.broadcast(broadcast_ids.energy_changed, {
                    amount: self.save_data["energy_amount"],
                    old_amount: old_amount
                });
                return true;
            } else {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.use_energy_failed, {
                    amount: self.save_data["energy_amount"]
                });
                return false;
            }
        }
        add_energy(broadcast_id, param) {
            let max_energy = game_config_manager.instance.get_config("max_energy");
            let old_amount = this.save_data["energy_amount"];
            this.save_data["energy_amount"] += param.amount || 0;
            this.save_data["energy_amount"] = Math.min(this.save_data["energy_amount"], max_energy);
            if (old_amount !== this.save_data["energy_amount"]) {
                let self = this;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.energy_changed, {
                    amount: self.save_data["energy_amount"],
                    old_amount: old_amount
                });
            }
        }
        increase_energy() {
            let time = igc.time_manager.instance.get_server_time();
            if (this.save_data["next_increase_time"] <= time) {
                let energy_restore_interval = game_config_manager.instance.get_config("energy_restore_interval") * 1e3;
                let amount = Math.ceil((time - this.save_data["next_increase_time"]) / energy_restore_interval);
                this.save_data["next_increase_time"] += amount * energy_restore_interval;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.add_energy, {
                    amount: amount
                });
            }
        }
    }
    class COCCharacterMaterial extends Laya.UnlitMaterial {
        constructor() {
            super(...arguments);
            this._edgeColor = new Laya.Vector4(1, 1, 1, 1);
        }
        get _MainTex() {
            return this._shaderValues.getTexture(Laya.UnlitMaterial.ALBEDOTEXTURE);
        }
        set _MainTex(value) {
            if (value) this._shaderValues.addDefine(Laya.UnlitMaterial.SHADERDEFINE_ALBEDOTEXTURE);
            else this._shaderValues.removeDefine(Laya.UnlitMaterial.SHADERDEFINE_ALBEDOTEXTURE);
            this._shaderValues.setTexture(Laya.UnlitMaterial.ALBEDOTEXTURE, value);
        }
        get _EdgeColorR() {
            return this._shaderValues.getVector(COCCharacterMaterial.EDGECOLOR).x;
        }
        set _EdgeColorR(value) {
            this._shaderValues.getVector(COCCharacterMaterial.EDGECOLOR).x = value;
        }
        get _EdgeColorG() {
            return this._shaderValues.getVector(COCCharacterMaterial.EDGECOLOR).y;
        }
        set _EdgeColorG(value) {
            this._shaderValues.getVector(COCCharacterMaterial.EDGECOLOR).y = value;
        }
        get _EdgeColorB() {
            return this._shaderValues.getVector(COCCharacterMaterial.EDGECOLOR).z;
        }
        set _EdgeColorB(value) {
            this._shaderValues.getVector(COCCharacterMaterial.EDGECOLOR).z = value;
        }
        get _EdgeColorA() {
            return this._shaderValues.getVector(COCCharacterMaterial.EDGECOLOR).w;
        }
        set _EdgeColorA(value) {
            this._shaderValues.getVector(COCCharacterMaterial.EDGECOLOR).w = value;
        }
        set _EdgeColor(value) {
            this._shaderValues.setVector(COCCharacterMaterial.EDGECOLOR, value);
        }
        get _EdgeColor() {
            return this._shaderValues.getVector(COCCharacterMaterial.EDGECOLOR);
        }
        get _LineWidth() {
            return this._shaderValues.getNumber(COCCharacterMaterial.LINEWIDTH);
        }
        set _LineWidth(value) {
            this._shaderValues.setNumber(COCCharacterMaterial.LINEWIDTH, value);
        }
        set _Color(value) {
            this._shaderValues.setVector(COCCharacterMaterial.COLOR, value);
        }
        get _Color() {
            return this._shaderValues.getVector(COCCharacterMaterial.COLOR);
        }
        set _EnableShadow(value) {
            this._shaderValues.setNumber(COCCharacterMaterial.ENABLE_SHADOW, value);
        }
        get _EnableShadow() {
            return this._shaderValues.getNumber(COCCharacterMaterial.ENABLE_SHADOW);
        }
        set _ShadowColor(value) {
            this._shaderValues.setVector(COCCharacterMaterial.SHADOW_COLOR, value);
        }
        get _ShadowColor() {
            return this._shaderValues.getVector(COCCharacterMaterial.SHADOW_COLOR);
        }
        set _ShadowLightDir(value) {
            this._shaderValues.setVector(COCCharacterMaterial.SHADOW_LIGHT_DIR, value);
        }
        get _ShadowLightDir() {
            return this._shaderValues.getVector(COCCharacterMaterial.SHADOW_LIGHT_DIR);
        }
        set _ShadowPlane(value) {
            this._shaderValues.setVector(COCCharacterMaterial.SHADOW_PLANE, value);
        }
        get _ShadowPlane() {
            return this._shaderValues.getVector(COCCharacterMaterial.SHADOW_PLANE);
        }
        clone() {
            var dest = new COCCharacterMaterial();
            this.cloneTo(dest);
            return dest;
        }
        static __init__() {}
    }
    COCCharacterMaterial.ShaderName = "COCCharacter";
    COCCharacterMaterial.EDGECOLOR = Laya.Shader3D.propertyNameToID("u_edgeColor");
    COCCharacterMaterial.LINEWIDTH = Laya.Shader3D.propertyNameToID("u_lineWidth");
    COCCharacterMaterial.COLOR = Laya.Shader3D.propertyNameToID("u_AlbedoColor");
    COCCharacterMaterial.ENABLE_SHADOW = Laya.Shader3D.propertyNameToID("u_EnableShadow");
    COCCharacterMaterial.SHADOW_COLOR = Laya.Shader3D.propertyNameToID("u_ShadowColor");
    COCCharacterMaterial.SHADOW_LIGHT_DIR = Laya.Shader3D.propertyNameToID("u_ShadowLightDir");
    COCCharacterMaterial.SHADOW_PLANE = Laya.Shader3D.propertyNameToID("u_ShadowPlane");
    COCCharacterMaterial.ShadowPs = `\n#ifdef FSHIGHPRECISION\n    precision highp float;\n#else\n    precision mediump float;\n#endif\n\nuniform float u_EnableShadow;\nuniform vec4 u_ShadowPlane;\nuniform vec4 u_ShadowLightDir;\nuniform vec4 u_ShadowColor;\n\nfloat saturate(float x)\n{\n    return max(0.0, min(1.0, x));\n}\n\nvoid main()\n{\n    if (0.0 < u_EnableShadow) \n    {\n        gl_FragColor = u_ShadowColor;\n    }\n}\n        `;
    COCCharacterMaterial.ShadowVS = `\n#ifdef FSHIGHPRECISION\n    precision highp float;\n#else\n    precision mediump float;\n#endif\n\n#include "Lighting.glsl";\n\nattribute vec4 a_Position;\nuniform mat4 u_View;\nuniform mat4 u_Projection;\nuniform float u_EnableShadow;\nuniform vec4 u_ShadowPlane;\nuniform vec4 u_ShadowLightDir;\nuniform vec4 u_ShadowColor;\n\n#ifdef GPU_INSTANCE\n    attribute mat4 a_WorldMat;\n#else\n    uniform mat4 u_WorldMat;\n#endif\n\n#ifdef GPU_INSTANCE\n    attribute mat4 a_MvpMatrix;\n#else\n    uniform mat4 u_MvpMatrix;\n#endif\n\n#ifdef BONE\n    const int c_MaxBoneCount = 24;\n    attribute vec4 a_BoneIndices;\n    attribute vec4 a_BoneWeights;\n    uniform mat4 u_Bones[c_MaxBoneCount];\n#endif\n\nvoid main() \n{\n    if (0.0 < u_EnableShadow) \n    {       \n        vec4 worldPos;\n        #ifdef BONE\n            mat4 skinTransform = u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;\n            skinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;\n            skinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;\n            skinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;\n            worldPos = skinTransform * a_Position;\n        #else\n            worldPos = a_Position;\n        #endif\n\n        #ifdef GPU_INSTANCE\n            worldPos = a_WorldMat * worldPos;\n        #else\n            worldPos = u_WorldMat * worldPos;\n        #endif\n\n        vec4 lightDir = normalize(u_ShadowLightDir);\n        lightDir.x = -lightDir.x;\n        vec4 planeNormal = vec4(0.0, 1.0, 0.0, 1.0);\n        float d = dot(worldPos.xyz - u_ShadowPlane.xyz, planeNormal.xyz) / dot(lightDir.xyz, planeNormal.xyz);\n        vec4 vertex = vec4(worldPos.xyz - d * lightDir.xyz, 1.0);\n        gl_Position = u_Projection * u_View * vertex;\n        gl_Position = remapGLPositionZ(gl_Position);\n    }\n}\n        `;
    COCCharacterMaterial.OutlinePs = `\n                        #ifdef FSHIGHPRECISION\n                            precision highp float;\n                        #else\n                            precision mediump float;\n                        #endif\n\n                        uniform vec4 u_AlbedoColor;\n                        uniform vec4 u_edgeColor;\n\n                        void main()\n                        {\n                            gl_FragColor = u_edgeColor * u_AlbedoColor;\n                        }`;
    COCCharacterMaterial.UnlitPS = `\n                        #ifdef FSHIGHPRECISION\n                            precision highp float;\n                        #else\n                            precision mediump float;\n                        #endif\n                        \n                        #if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\n                            varying vec4 v_Color;\n                        #endif\n                        \n                        #ifdef ALBEDOTEXTURE\n                            uniform sampler2D u_AlbedoTexture;\n                            varying vec2 v_Texcoord0;\n                        #endif\n                        \n                        uniform vec4 u_AlbedoColor;\n                        \n                        #ifdef ALPHATEST\n                            uniform float u_AlphaTestValue;\n                        #endif\n                        \n                        #ifdef FOG\n                            uniform float u_FogStart;\n                            uniform float u_FogRange;\n                            #ifdef ADDTIVEFOG\n                            #else\n                                uniform vec3 u_FogColor;\n                            #endif\n                        #endif\n                        \n                        void main()\n                        {\n                            vec4 color =  u_AlbedoColor;\n                            #ifdef ALBEDOTEXTURE\n                                color *= texture2D(u_AlbedoTexture, v_Texcoord0);\n                            #endif\n                            #if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\n                                color *= v_Color;\n                            #endif\n                            #ifdef ALPHATEST\n                                if(color.a < u_AlphaTestValue)\n                                    discard;\n                            #endif\n                            \n                            gl_FragColor = color;\n                            \n                            //#ifdef FOG\n                            //    float lerpFact = clamp((1.0 / gl_FragCoord.w - u_FogStart) / u_FogRange, 0.0, 1.0);\n                            //    #ifdef ADDTIVEFOG\n                            //        gl_FragColor.rgb = mix(gl_FragColor.rgb, vec3(0.0), lerpFact);\n                            //    #else\n                            //        gl_FragColor.rgb = mix(gl_FragColor.rgb, u_FogColor, lerpFact);\n                            //    #endif\n                            //#endif\n                        }`;
    COCCharacterMaterial.OutlineVS = `\n                        #include "Lighting.glsl";\n\n                        attribute vec4 a_Position;\n                        attribute vec3 a_Normal;\n                        uniform mat4 u_View;\n                        uniform mat4 u_Projection;\n\n\n                        #ifdef GPU_INSTANCE\n                            // attribute mat4 a_MvpMatrix;\n                            attribute mat4 a_WorldMat;\n                        #else\n                            // uniform mat4 u_MvpMatrix;\n                            uniform mat4 u_WorldMat;\n                        #endif\n\n                        #ifdef BONE\n                            const int c_MaxBoneCount = 24;\n                            attribute vec4 a_BoneIndices;\n                            attribute vec4 a_BoneWeights;\n                            uniform mat4 u_Bones[c_MaxBoneCount];\n                        #endif\n\n                        uniform float u_lineWidth;\n\n                        void main() \n                        {\n                            vec4 position;\n                            #ifdef BONE\n                                mat4 skinTransform = u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;\n                                skinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;\n                                skinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;\n                                skinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;\n                                position=skinTransform*a_Position;\n                            #else\n                                position=a_Position;\n                            #endif\n\n                            #ifdef GPU_INSTANCE\n                                mat4 worldMat = a_WorldMat;\n                            #else\n                                mat4 worldMat = u_WorldMat;\n                            #endif\n\n                            // mat4 worldViewMat = u_View * worldMat;\n\n                            // #ifdef BONE\n                            //    mat3 worldViewInvMat = (worldMat*skinTransform) * inverse(u_View);\n                            // #else\n                            //    mat3 worldViewInvMat = (worldMat) * inverse(u_View);\n                            // #endif  \n\n\n                            position = worldMat * position;\n\n\n\n                            vec3 normal;\n                            #ifdef BONE\n                            //    normal = a_Normal * mat3(worldMat*skinTransform) * inverse(mat3(u_View);\n                                //   normal = a_Normal * inverse(mat3(worldMat*skinTransform))\n                                  normal =  mat3(worldMat*skinTransform) * a_Normal;\n                            #else\n                            //    normal = a_Normal * mat3(worldMat) * inverse(mat3(u_View));\n                                //   normal = a_Normal * inverse(mat3(worldMat))\n                                  normal =  mat3(worldMat) * a_Normal;\n                            #endif  \n\n\n\n                            // gl_Position.xy += normal.xy * u_lineWidth * 0.008;\n                            position.xyz += normal.xyz * u_lineWidth * 0.008;\n\n                            gl_Position = u_Projection * u_View * position;\n\n                            gl_Position=remapGLPositionZ(gl_Position);\n\n                        }`;
    COCCharacterMaterial.MeshBlinnPhongVS = `\n                        #include "Lighting.glsl";\n\n                        attribute vec4 a_Position;\n                        \n                        #ifdef GPU_INSTANCE\n                            attribute mat4 a_MvpMatrix;\n                        #else\n                            uniform mat4 u_MvpMatrix;\n                        #endif\n                        \n                        \n                        #if defined(DIFFUSEMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))||(defined(LIGHTMAP)&&defined(UV))\n                            attribute vec2 a_Texcoord0;\n                            varying vec2 v_Texcoord0;\n                        #endif\n                        \n                        #if defined(LIGHTMAP)&&defined(UV1)\n                            attribute vec2 a_Texcoord1;\n                        #endif\n                        \n                        #ifdef LIGHTMAP\n                            uniform vec4 u_LightmapScaleOffset;\n                            varying vec2 v_LightMapUV;\n                        #endif\n                        \n                        #ifdef COLOR\n                            attribute vec4 a_Color;\n                            varying vec4 v_Color;\n                        #endif\n                        \n                        #ifdef BONE\n                            const int c_MaxBoneCount = 24;\n                            attribute vec4 a_BoneIndices;\n                            attribute vec4 a_BoneWeights;\n                            uniform mat4 u_Bones[c_MaxBoneCount];\n                        #endif\n                        \n                        #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                            attribute vec3 a_Normal;\n                            varying vec3 v_Normal; \n                            uniform vec3 u_CameraPos;\n                            varying vec3 v_ViewDir; \n                        #endif\n                        \n                        #if (defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&defined(NORMALMAP)\n                            attribute vec4 a_Tangent0;\n                            varying vec3 v_Tangent;\n                            varying vec3 v_Binormal;\n                        #endif\n                        \n                        #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||defined(RECEIVESHADOW)\n                            #ifdef GPU_INSTANCE\n                                attribute mat4 a_WorldMat;\n                            #else\n                                uniform mat4 u_WorldMat;\n                            #endif\n                            varying vec3 v_PositionWorld;\n                        #endif\n                        \n                        varying float v_posViewZ;\n                        \n                        #ifdef RECEIVESHADOW\n                            #ifdef SHADOWMAP_PSSM1 \n                                varying vec4 v_lightMVPPos;\n                                uniform mat4 u_lightShadowVP[4];\n                            #endif\n                        #endif\n                        \n                        #ifdef TILINGOFFSET\n                            uniform vec4 u_TilingOffset;\n                        #endif\n                        \n                        void main_castShadow()\n                        {\n                            vec4 position;\n                            #ifdef BONE\n                                mat4 skinTransform = u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;\n                                skinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;\n                                skinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;\n                                skinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;\n                                position=skinTransform*a_Position;\n                            #else\n                                position=a_Position;\n                            #endif\n                            #ifdef GPU_INSTANCE\n                                gl_Position = a_MvpMatrix * position;\n                            #else\n                                gl_Position = u_MvpMatrix * position;\n                            #endif\n\n                            //TODO没考虑UV动画呢\n                            #if defined(DIFFUSEMAP)&&defined(ALPHATEST)\n                                v_Texcoord0=a_Texcoord0;\n                            #endif\n                            gl_Position=remapGLPositionZ(gl_Position);\n                            v_posViewZ = gl_Position.z;\n\n                        }\n                        \n                        void main_normal()\n                        {\n                            vec4 position;\n                            #ifdef BONE\n                                mat4 skinTransform = u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;\n                                skinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;\n                                skinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;\n                                skinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;\n                                position=skinTransform*a_Position;\n                            #else\n                                position=a_Position;\n                            #endif\n                            \n                            #ifdef GPU_INSTANCE\n                                gl_Position = a_MvpMatrix * position;\n                            #else\n                                gl_Position = u_MvpMatrix * position;\n                            #endif\n                            \n                            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||defined(RECEIVESHADOW)\n                                mat4 worldMat;\n                                #ifdef GPU_INSTANCE\n                                    worldMat = a_WorldMat;\n                                #else\n                                    worldMat = u_WorldMat;\n                                #endif\n                            #endif\n                            \n                            \n                            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                                mat3 worldInvMat;\n                                #ifdef BONE\n                                    worldInvMat=inverse(mat3(worldMat*skinTransform));\n                                #else\n                                    worldInvMat=inverse(mat3(worldMat));\n                                #endif  \n\n                                v_Normal=a_Normal*worldInvMat;\n                                #if (defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&defined(NORMALMAP)\n                                    v_Tangent=a_Tangent0.xyz*worldInvMat;\n                                    v_Binormal=cross(v_Normal,v_Tangent)*a_Tangent0.w;\n                                #endif\n                            #endif\n                            \n                            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||defined(RECEIVESHADOW)\n                                v_PositionWorld=(worldMat*position).xyz;\n                            #endif\n                            \n                            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                                v_ViewDir=u_CameraPos-v_PositionWorld;\n                            #endif\n\n                            #if defined(DIFFUSEMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))\n                                #ifdef TILINGOFFSET\n                                    v_Texcoord0=TransformUV(a_Texcoord0,u_TilingOffset);\n                                #else\n                                    v_Texcoord0=a_Texcoord0;\n                                #endif\n                            #endif\r\n\r\n\t#ifdef LIGHTMAP\r\n\t\t#ifdef SCALEOFFSETLIGHTINGMAPUV\r\n\t\t\t#ifdef UV1\r\n\t\t\t\tv_LightMapUV=vec2(a_Texcoord1.x,1.0-a_Texcoord1.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\r\n\t\t\t#else\r\n\t\t\t\tv_LightMapUV=vec2(a_Texcoord0.x,1.0-a_Texcoord0.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\r\n\t\t\t#endif \r\n\t\t\tv_LightMapUV.y=1.0-v_LightMapUV.y;\r\n\t\t#else\r\n\t\t\t#ifdef UV1\r\n\t\t\t\tv_LightMapUV=a_Texcoord1;\r\n\t\t\t#else\r\n\t\t\t\tv_LightMapUV=a_Texcoord0;\r\n\t\t\t#endif \r\n\t\t#endif \r\n\t#endif\r\n\r\n\t#if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\r\n\t\tv_Color=a_Color;\r\n\t#endif\r\n\r\n\t#ifdef RECEIVESHADOW\r\n\t\tv_posViewZ = gl_Position.w;\r\n\t\t#ifdef SHADOWMAP_PSSM1 \r\n\t\t\tv_lightMVPPos = u_lightShadowVP[0] * vec4(v_PositionWorld,1.0);\r\n\t\t#endif\r\n\t#endif\r\n\tgl_Position=remapGLPositionZ(gl_Position);\r\n}\r\n\r\nvoid main()\r\n{\r\n\t#ifdef CASTSHADOW\r\n\t\tmain_castShadow();\r\n\t#else\r\n\t\tmain_normal();\r\n\t#endif\r\n}`;
    COCCharacterMaterial.UnlitVS = `\n                        #include "Lighting.glsl";\n                        \n                        attribute vec4 a_Position;\n                        \n                        attribute vec2 a_Texcoord0;\n                        \n                        #ifdef GPU_INSTANCE\n                            attribute mat4 a_MvpMatrix;\n                        #else\n                            uniform mat4 u_MvpMatrix;\n                        #endif\n                        \n                        attribute vec4 a_Color;\n                        varying vec4 v_Color;\n                        varying vec2 v_Texcoord0;\n                        \n                        #ifdef TILINGOFFSET\n                            uniform vec4 u_TilingOffset;\n                        #endif\n                        \n                        #ifdef BONE\n                            const int c_MaxBoneCount = 24;\n                            attribute vec4 a_BoneIndices;\n                            attribute vec4 a_BoneWeights;\n                            uniform mat4 u_Bones[c_MaxBoneCount];\n                        #endif\n                        \n                        void main() {\n                            vec4 position;\n                            #ifdef BONE\n                                mat4 skinTransform = u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;\n                                skinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;\n                                skinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;\n                                skinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;\n                                position=skinTransform*a_Position;\n                            #else\n                                position=a_Position;\n                            #endif\n                            #ifdef GPU_INSTANCE\n                                gl_Position = a_MvpMatrix * position;\n                            #else\n                                gl_Position = u_MvpMatrix * position;\n                            #endif\n                            \n                            #ifdef TILINGOFFSET\n                                v_Texcoord0=TransformUV(a_Texcoord0,u_TilingOffset);\n                            #else\n                                v_Texcoord0=a_Texcoord0;\n                            #endif\n                            \n                            #if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\n                                v_Color = a_Color;\n                            #endif\n                                gl_Position=remapGLPositionZ(gl_Position);\n                        }`;
    COCCharacterMaterial.attributeMap = {
        a_Position: Laya.VertexMesh.MESH_POSITION0,
        a_Color: Laya.VertexMesh.MESH_COLOR0,
        a_Normal: Laya.VertexMesh.MESH_NORMAL0,
        a_Texcoord0: Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
        a_BoneWeights: Laya.VertexMesh.MESH_BLENDWEIGHT0,
        a_BoneIndices: Laya.VertexMesh.MESH_BLENDINDICES0,
        a_MvpMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW0,
        a_WorldMat: Laya.VertexMesh.MESH_WORLDMATRIX_ROW0
    };
    COCCharacterMaterial.uniformMap = {
        u_Bones: Laya.Shader3D.PERIOD_CUSTOM,
        u_AlbedoTexture: Laya.Shader3D.PERIOD_MATERIAL,
        u_AlbedoColor: Laya.Shader3D.PERIOD_MATERIAL,
        u_TilingOffset: Laya.Shader3D.PERIOD_MATERIAL,
        u_AlphaTestValue: Laya.Shader3D.PERIOD_MATERIAL,
        u_lineWidth: Laya.Shader3D.PERIOD_MATERIAL,
        u_edgeColor: Laya.Shader3D.PERIOD_MATERIAL,
        u_EnableShadow: Laya.Shader3D.PERIOD_MATERIAL,
        u_ShadowColor: Laya.Shader3D.PERIOD_MATERIAL,
        u_ShadowLightDir: Laya.Shader3D.PERIOD_MATERIAL,
        u_ShadowPlane: Laya.Shader3D.PERIOD_MATERIAL,
        u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
        u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
        u_FogStart: Laya.Shader3D.PERIOD_SCENE,
        u_FogRange: Laya.Shader3D.PERIOD_SCENE,
        u_FogColor: Laya.Shader3D.PERIOD_SCENE,
        u_View: Laya.Shader3D.PERIOD_CAMERA,
        u_Projection: Laya.Shader3D.PERIOD_CAMERA
    };
    COCCharacterMaterial.stateMap = {
        s_Cull: Laya.Shader3D.RENDER_STATE_CULL,
        s_Blend: Laya.Shader3D.RENDER_STATE_BLEND,
        s_BlendSrc: Laya.Shader3D.RENDER_STATE_BLEND_SRC,
        s_BlendDst: Laya.Shader3D.RENDER_STATE_BLEND_DST,
        s_DepthTest: Laya.Shader3D.RENDER_STATE_DEPTH_TEST,
        s_DepthWrite: Laya.Shader3D.RENDER_STATE_DEPTH_WRITE
    };
    class COCBuildingMaterial extends COCCharacterMaterial {
        constructor() {
            super();
            this.setShaderName(COCBuildingMaterial.ShaderName);
        }
        static __init__() {
            var shader = Laya.Shader3D.add(COCBuildingMaterial.ShaderName, null, null, true);
            var subShader = new Laya.SubShader(COCBuildingMaterial.attributeMap, COCBuildingMaterial.uniformMap);
            shader.addSubShader(subShader);
            subShader.addShaderPass(COCBuildingMaterial.UnlitVS, COCBuildingMaterial.UnlitPS, COCBuildingMaterial.stateMap);
            Laya.ClassUtils.regClass("COCBuildingMaterial", COCBuildingMaterial);
        }
    }
    COCBuildingMaterial.ShaderName = "COCBuilding";
    class COCForbidArmyAreaMaterial extends Laya.UnlitMaterial {
        constructor() {
            super();
            this.setShaderName(COCForbidArmyAreaMaterial.ShaderName);
        }
        clone() {
            var dest = new COCForbidArmyAreaMaterial();
            this.cloneTo(dest);
            return dest;
        }
        get _TintColor() {
            return this._shaderValues.getVector(COCForbidArmyAreaMaterial.TintColorID);
        }
        set _TintColor(value) {
            this._shaderValues.setVector(COCForbidArmyAreaMaterial.TintColorID, value);
        }
        static __init__() {
            let ForbidArmyAreaPs = `\n        #ifdef HIGHPRECISION\n            precision highp float;\n        #else\n            precision mediump float;\n        #endif\n        \n        uniform vec4 u_TintColor;\n\n        void main()\n        {\n            gl_FragColor = u_TintColor;\n        }`;
            let ForbidArmyAreaVS = `\n        #include "Lighting.glsl";\n        attribute vec4 a_Position;\n        attribute vec2 a_Texcoord0;\n        attribute mat4 a_MvpMatrix;\n        attribute mat4 a_MMatrix;\n        attribute mat4 a_VMatrix;\n        attribute mat4 a_PMatrix;\n\n        uniform mat4 u_MvpMatrix;\n        uniform mat4 u_WorldMat;\n        varying vec2 v_Texcoord0;\n\n        void main()\n        {\n            #ifdef GPU_INSTANCE\n                gl_Position = a_MvpMatrix * a_Position;\n            #else\n                gl_Position = u_MvpMatrix * a_Position;\n            #endif\n            gl_Position = remapGLPositionZ(gl_Position);\n\n            v_Texcoord0 = a_Texcoord0;\n        }`;
            let attributeMap = {
                a_Position: Laya.VertexMesh.MESH_POSITION0,
                a_Color: Laya.VertexMesh.MESH_COLOR0,
                a_Normal: Laya.VertexMesh.MESH_NORMAL0,
                a_Texcoord0: Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
                a_BoneWeights: Laya.VertexMesh.MESH_BLENDWEIGHT0,
                a_BoneIndices: Laya.VertexMesh.MESH_BLENDINDICES0,
                a_WorldMat: Laya.VertexMesh.MESH_WORLDMATRIX_ROW0,
                a_MvpMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW0,
                a_PMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW1,
                a_VMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW2,
                a_MMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW3
            };
            let uniformMap = {
                u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
                u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
                u_MainTex: Laya.Shader3D.PERIOD_MATERIAL,
                u_AlbedoTexture: Laya.Shader3D.PERIOD_MATERIAL,
                u_Noise: Laya.Shader3D.PERIOD_MATERIAL,
                u_SparkDist: Laya.Shader3D.PERIOD_MATERIAL,
                u_StartSeed: Laya.Shader3D.PERIOD_MATERIAL,
                u_SparkMag: Laya.Shader3D.PERIOD_MATERIAL,
                u_SparkWidth: Laya.Shader3D.PERIOD_MATERIAL,
                u_TintColor: Laya.Shader3D.PERIOD_MATERIAL
            };
            let stateMap = {
                s_Blend: Laya.Shader3D.RENDER_STATE_BLEND,
                s_BlendSrc: Laya.Shader3D.RENDER_STATE_BLEND_SRC_ALPHA,
                s_BlendDst: Laya.Shader3D.RENDER_STATE_BLEND_DST_ALPHA,
                s_DepthTest: Laya.Shader3D.RENDER_STATE_DEPTH_TEST
            };
            let shader = Laya.Shader3D.add(COCForbidArmyAreaMaterial.ShaderName, null, null, true);
            let subShader = new Laya.SubShader(attributeMap, uniformMap);
            shader.addSubShader(subShader);
            let pass = subShader.addShaderPass(ForbidArmyAreaVS, ForbidArmyAreaPs, stateMap);
            pass.renderState.cull = Laya.RenderState.CULL_NONE;
            pass.renderState.blend = Laya.RenderState.BLEND_ENABLE_ALL;
            pass.renderState.srcBlend = Laya.RenderState.BLENDPARAM_SRC_ALPHA;
            pass.renderState.dstBlend = Laya.RenderState.BLENDPARAM_ONE_MINUS_SRC_ALPHA;
            Laya.ClassUtils.regClass("COCForbidArmyAreaMaterial", COCForbidArmyAreaMaterial);
        }
    }
    COCForbidArmyAreaMaterial.ShaderName = "COCForbidArmyArea";
    COCForbidArmyAreaMaterial.TintColorID = Laya.Shader3D.propertyNameToID("u_TintColor");
    class COCGridMaterial extends Laya.UnlitMaterial {
        constructor() {
            super();
            this.setShaderName(COCGridMaterial.ShaderName);
        }
        clone() {
            var dest = new COCGridMaterial();
            this.cloneTo(dest);
            return dest;
        }
        get _Count() {
            return this._shaderValues.getVector(COCGridMaterial.CountID);
        }
        set _Count(value) {
            this._shaderValues.setVector(COCGridMaterial.CountID, value);
        }
        get _GridColor0() {
            return this._shaderValues.getVector(COCGridMaterial.GridColor0ID);
        }
        set _GridColor0(value) {
            this._shaderValues.setVector(COCGridMaterial.GridColor0ID, value);
        }
        get _GridColor1() {
            return this._shaderValues.getVector(COCGridMaterial.GridColor1ID);
        }
        set _GridColor1(value) {
            this._shaderValues.setVector(COCGridMaterial.GridColor1ID, value);
        }
        static __init__() {
            let GridMaterialPs = `\n        #ifdef HIGHPRECISION\n            precision highp float;\n        #else\n            precision mediump float;\n        #endif\n        \n        uniform vec4 u_GridColor0;\n        uniform vec4 u_GridColor1;\n        uniform float u_Count;\n        varying vec2 v_Texcoord0;\n\n        void main()\n        {\n            float u_CountInt = floor(u_Count);\n\n            float length = 1.0 / u_CountInt;\n            if ((mod(v_Texcoord0.x, length) < length * 0.5 \n                && mod(v_Texcoord0.y, length) < length * 0.5) ||\n                (length * 0.5 < mod(v_Texcoord0.x, length)\n                && length * 0.5 < mod(v_Texcoord0.y, length)))\n            {\n                gl_FragColor = u_GridColor0;\n            }\n            else \n            {\n                gl_FragColor = u_GridColor1;\n            }\n        }`;
            let GridMaterialVS = `\n        #include "Lighting.glsl";\n        attribute vec4 a_Position;\n        attribute vec2 a_Texcoord0;\n        attribute mat4 a_MvpMatrix;\n        attribute mat4 a_MMatrix;\n        attribute mat4 a_VMatrix;\n        attribute mat4 a_PMatrix;\n\n        uniform mat4 u_MvpMatrix;\n        uniform mat4 u_WorldMat;\n        varying vec2 v_Texcoord0;\n\n        void main()\n        {\n            #ifdef GPU_INSTANCE\n                gl_Position = a_MvpMatrix * a_Position;\n            #else\n                gl_Position = u_MvpMatrix * a_Position;\n            #endif\n            gl_Position = remapGLPositionZ(gl_Position);\n\n            v_Texcoord0 = a_Texcoord0;\n        }`;
            let attributeMap = {
                a_Position: Laya.VertexMesh.MESH_POSITION0,
                a_Color: Laya.VertexMesh.MESH_COLOR0,
                a_Normal: Laya.VertexMesh.MESH_NORMAL0,
                a_Texcoord0: Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
                a_BoneWeights: Laya.VertexMesh.MESH_BLENDWEIGHT0,
                a_BoneIndices: Laya.VertexMesh.MESH_BLENDINDICES0,
                a_WorldMat: Laya.VertexMesh.MESH_WORLDMATRIX_ROW0,
                a_MvpMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW0,
                a_PMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW1,
                a_VMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW2,
                a_MMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW3
            };
            let uniformMap = {
                u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
                u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
                u_MainTex: Laya.Shader3D.PERIOD_MATERIAL,
                u_AlbedoTexture: Laya.Shader3D.PERIOD_MATERIAL,
                u_Noise: Laya.Shader3D.PERIOD_MATERIAL,
                u_SparkDist: Laya.Shader3D.PERIOD_MATERIAL,
                u_StartSeed: Laya.Shader3D.PERIOD_MATERIAL,
                u_SparkMag: Laya.Shader3D.PERIOD_MATERIAL,
                u_SparkWidth: Laya.Shader3D.PERIOD_MATERIAL,
                u_GridColor0: Laya.Shader3D.PERIOD_MATERIAL,
                u_GridColor1: Laya.Shader3D.PERIOD_MATERIAL,
                u_Count: Laya.Shader3D.PERIOD_MATERIAL
            };
            let stateMap = {
                s_Blend: Laya.Shader3D.RENDER_STATE_BLEND,
                s_BlendSrc: Laya.Shader3D.RENDER_STATE_BLEND_SRC_ALPHA,
                s_BlendDst: Laya.Shader3D.RENDER_STATE_BLEND_DST_ALPHA,
                s_DepthTest: Laya.Shader3D.RENDER_STATE_DEPTH_TEST
            };
            let shader = Laya.Shader3D.add(COCGridMaterial.ShaderName, null, null, true);
            let subShader = new Laya.SubShader(attributeMap, uniformMap);
            shader.addSubShader(subShader);
            let pass = subShader.addShaderPass(GridMaterialVS, GridMaterialPs, stateMap);
            pass.renderState.cull = Laya.RenderState.CULL_BACK;
            pass.renderState.blend = Laya.RenderState.BLEND_ENABLE_ALL;
            pass.renderState.srcBlend = Laya.RenderState.BLENDPARAM_SRC_ALPHA;
            pass.renderState.dstBlend = Laya.RenderState.BLENDPARAM_ONE_MINUS_SRC_ALPHA;
            Laya.ClassUtils.regClass("COCGridMaterial", COCGridMaterial);
        }
    }
    COCGridMaterial.ShaderName = "COCGridMaterial";
    COCGridMaterial.CountID = Laya.Shader3D.propertyNameToID("u_Count");
    COCGridMaterial.GridColor0ID = Laya.Shader3D.propertyNameToID("u_GridColor0");
    COCGridMaterial.GridColor1ID = Laya.Shader3D.propertyNameToID("u_GridColor1");
    class COCLightningMaterial extends Laya.UnlitMaterial {
        constructor() {
            super();
            this.setShaderName(COCLightningMaterial.ShaderName);
        }
        clone() {
            var dest = new COCLightningMaterial();
            this.cloneTo(dest);
            return dest;
        }
        get _MainTex() {
            return this._shaderValues.getTexture(COCLightningMaterial.MainTexID);
        }
        set _MainTex(value) {
            if (value) {
                this._shaderValues.addDefine(COCLightningMaterial.MainTexID);
            } else {
                this._shaderValues.removeDefine(COCLightningMaterial.MainTexID);
            }
            this._shaderValues.setTexture(COCLightningMaterial.MainTexID, value);
        }
        get _Noise() {
            return this._shaderValues.getTexture(COCLightningMaterial.NoiseID);
        }
        set _Noise(value) {
            if (value) {
                this._shaderValues.addDefine(COCLightningMaterial.NoiseID);
            } else {
                this._shaderValues.removeDefine(COCLightningMaterial.NoiseID);
            }
            this._shaderValues.setTexture(COCLightningMaterial.NoiseID, value);
        }
        get _SparkDist() {
            return this._shaderValues.getNumber(COCLightningMaterial.SparkDistID);
        }
        set _SparkDist(value) {
            this._shaderValues.setNumber(COCLightningMaterial.SparkDistID, value);
        }
        get _StartSeed() {
            return this._shaderValues.getNumber(COCLightningMaterial.StartSeedID);
        }
        set _StartSeed(value) {
            this._shaderValues.setNumber(COCLightningMaterial.StartSeedID, value);
        }
        get _SparkMag() {
            return this._shaderValues.getNumber(COCLightningMaterial.SparkMagID);
        }
        set _SparkMag(value) {
            this._shaderValues.setNumber(COCLightningMaterial.SparkMagID, value);
        }
        get _SparkWidth() {
            return this._shaderValues.getNumber(COCLightningMaterial.SparkWidthID);
        }
        set _SparkWidth(value) {
            this._shaderValues.setNumber(COCLightningMaterial.SparkWidthID, value);
        }
        get _Time() {
            return this._shaderValues.getNumber(COCLightningMaterial.TimeID);
        }
        set _Time(value) {
            this._shaderValues.setNumber(COCLightningMaterial.TimeID, value);
        }
        get _LightningAmount() {
            return this._shaderValues.getNumber(COCLightningMaterial.LightningAmountID);
        }
        set _LightningAmount(value) {
            this._shaderValues.setNumber(COCLightningMaterial.LightningAmountID, value);
        }
        static __init__() {
            let LightningPs = `\n        #ifdef HIGHPRECISION\n            precision highp float;\n        #else\n            precision mediump float;\n        #endif\n        \n        uniform sampler2D u_MainTex;\n        uniform sampler2D u_Noise;\n        uniform float u_SparkDist;\n        uniform float u_StartSeed;\n        uniform float u_SparkMag;\n        uniform float u_SparkWidth;\n        uniform float u_Time;\n        uniform float u_LightningAmount;\n\n        varying vec2 v_Texcoord0;\n\n        void generate(float seed, inout vec4 color) {\n            vec2 noiseVec = vec2(v_Texcoord0.y / 5.0, abs(sin(u_Time + seed)) * 256.0);\t\n            vec4 noiseSamp = texture2D(u_Noise, noiseVec);\n\n            float dvdr = 1.0 - abs(v_Texcoord0.y - 0.5) * 2.0;\n            dvdr = clamp(dvdr + u_SparkDist, 0.0, 1.0);\n\n            float fullWidth = 1.0 - u_SparkWidth * 2.0;\n            float scaledTexel = (v_Texcoord0.x - u_SparkWidth) / fullWidth;\n\n            float offs = scaledTexel + ((0.5 - noiseSamp.x) / 2.0) * u_SparkMag * dvdr;\n            offs = clamp(offs, 0.0, 1.0);\n\n            vec2 texSampVec = vec2(offs, v_Texcoord0.y);\n            vec4 col = texture2D(u_MainTex, texSampVec);\n\n            vec4 c = vec4(1.0, 1.0, 1.0, 1.0);\n            color = c - (c - col) * (c - color);\n        }\n\n        void main()\n        {\n            vec4 col = vec4(0.0, 0.0, 0.0, 0.0);\n            generate(u_StartSeed, col);\n\n            int amount = int(u_LightningAmount);\n            if (1 < amount) {\n                for (int i = 1; i < 10; ++i) {\n                    if (i < amount) {\n                        generate(u_StartSeed + float(i), col);\n                    }\n                }\n            }\n\n            if (col.r + col.g + col.b < 0.001) {\n                //discard;\n            }\n\n            gl_FragColor = col;\n        }`;
            let LightningVS = `\n        #include "Lighting.glsl";\n        attribute vec4 a_Position;\n        attribute vec2 a_Texcoord0;\n        attribute mat4 a_MvpMatrix;\n        attribute mat4 a_MMatrix;\n        attribute mat4 a_VMatrix;\n        attribute mat4 a_PMatrix;\n\n        uniform mat4 u_MvpMatrix;\n        uniform mat4 u_WorldMat;\n        uniform sampler2D u_MainTex;\n        uniform sampler2D u_Noise;\n        uniform float u_SparkDist;\n        uniform float u_StartSeed;\n        uniform float u_SparkMag;\n        uniform float u_SparkWidth;\n        uniform float u_Time;\n        uniform float u_LightningAmount;\n\n        varying vec2 v_Texcoord0;\n\n        void main()\n        {\n            #ifdef GPU_INSTANCE\n                gl_Position = a_MvpMatrix * a_Position;\n            #else\n                gl_Position = u_MvpMatrix * a_Position;\n            #endif\n            gl_Position = remapGLPositionZ(gl_Position);\n\n            v_Texcoord0 = a_Texcoord0;\n        }`;
            let attributeMap = {
                a_Position: Laya.VertexMesh.MESH_POSITION0,
                a_Color: Laya.VertexMesh.MESH_COLOR0,
                a_Normal: Laya.VertexMesh.MESH_NORMAL0,
                a_Texcoord0: Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
                a_BoneWeights: Laya.VertexMesh.MESH_BLENDWEIGHT0,
                a_BoneIndices: Laya.VertexMesh.MESH_BLENDINDICES0,
                a_WorldMat: Laya.VertexMesh.MESH_WORLDMATRIX_ROW0,
                a_MvpMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW0,
                a_PMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW1,
                a_VMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW2,
                a_MMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW3
            };
            let uniformMap = {
                u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
                u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
                u_MainTex: Laya.Shader3D.PERIOD_MATERIAL,
                u_AlbedoTexture: Laya.Shader3D.PERIOD_MATERIAL,
                u_Noise: Laya.Shader3D.PERIOD_MATERIAL,
                u_SparkDist: Laya.Shader3D.PERIOD_MATERIAL,
                u_StartSeed: Laya.Shader3D.PERIOD_MATERIAL,
                u_SparkMag: Laya.Shader3D.PERIOD_MATERIAL,
                u_SparkWidth: Laya.Shader3D.PERIOD_MATERIAL,
                u_Time: Laya.Shader3D.PERIOD_MATERIAL,
                u_LightningAmount: Laya.Shader3D.PERIOD_MATERIAL
            };
            let stateMap = {
                s_Cull: Laya.Shader3D.RENDER_STATE_CULL,
                s_Blend: Laya.Shader3D.RENDER_STATE_BLEND,
                s_BlendSrc: Laya.Shader3D.RENDER_STATE_BLEND_SRC,
                s_BlendDst: Laya.Shader3D.RENDER_STATE_BLEND_DST,
                s_DepthTest: Laya.Shader3D.RENDER_STATE_DEPTH_TEST,
                s_DepthWrite: Laya.Shader3D.RENDER_STATE_DEPTH_WRITE
            };
            let shader = Laya.Shader3D.add(COCLightningMaterial.ShaderName, null, null, true);
            let subShader = new Laya.SubShader(attributeMap, uniformMap);
            shader.addSubShader(subShader);
            subShader.addShaderPass(LightningVS, LightningPs, stateMap);
            Laya.ClassUtils.regClass("COCLightningMaterial", COCLightningMaterial);
        }
    }
    COCLightningMaterial.ShaderName = "COCLightning";
    COCLightningMaterial.MainTexID = Laya.Shader3D.propertyNameToID("u_MainTex");
    COCLightningMaterial.NoiseID = Laya.Shader3D.propertyNameToID("u_Noise");
    COCLightningMaterial.SparkDistID = Laya.Shader3D.propertyNameToID("u_SparkDist");
    COCLightningMaterial.StartSeedID = Laya.Shader3D.propertyNameToID("u_StartSeed");
    COCLightningMaterial.SparkMagID = Laya.Shader3D.propertyNameToID("u_SparkMag");
    COCLightningMaterial.SparkWidthID = Laya.Shader3D.propertyNameToID("u_SparkWidth");
    COCLightningMaterial.TimeID = Laya.Shader3D.propertyNameToID("u_Time");
    COCLightningMaterial.LightningAmountID = Laya.Shader3D.propertyNameToID("u_LightningAmount");
    class COCPlayerMaterial extends COCCharacterMaterial {
        constructor() {
            super();
            this.setShaderName(COCPlayerMaterial.ShaderName);
        }
        static __init__() {
            var shader = Laya.Shader3D.add(COCPlayerMaterial.ShaderName, null, null, true);
            var subShader = new Laya.SubShader(COCPlayerMaterial.attributeMap, COCPlayerMaterial.uniformMap);
            shader.addSubShader(subShader);
            subShader.addShaderPass(COCPlayerMaterial.UnlitVS, COCPlayerMaterial.UnlitPS, COCPlayerMaterial.stateMap);
            var pass = subShader.addShaderPass(COCPlayerMaterial.OutlineVS, COCPlayerMaterial.OutlinePs);
            pass.renderState.cull = Laya.RenderState.CULL_FRONT;
            pass.renderState.blend = Laya.RenderState.BLEND_ENABLE_ALL;
            pass.renderState.srcBlend = Laya.RenderState.BLENDPARAM_SRC_ALPHA;
            pass.renderState.dstBlend = Laya.RenderState.BLENDPARAM_ONE_MINUS_SRC_ALPHA;
            Laya.ClassUtils.regClass("COCPlayerMaterial", COCPlayerMaterial);
        }
    }
    COCPlayerMaterial.ShaderName = "COCPlayer";
    class COCWallMaterial extends COCCharacterMaterial {
        constructor() {
            super();
            this.setShaderName(COCWallMaterial.ShaderName);
        }
        static __init__() {
            var shader = Laya.Shader3D.add(COCWallMaterial.ShaderName, null, null, true);
            var subShader = new Laya.SubShader(COCWallMaterial.attributeMap, COCWallMaterial.uniformMap);
            shader.addSubShader(subShader);
            subShader.addShaderPass(COCWallMaterial.UnlitVS, COCWallMaterial.UnlitPS, COCWallMaterial.stateMap);
            Laya.ClassUtils.regClass("COCWallMaterial", COCWallMaterial);
        }
    }
    COCWallMaterial.ShaderName = "COCWall";
    class role_data {
        init_data(args) {
            this.channel_uid = args.uid;
        }
        init_channel_data(args) {
            this.channel_type = args.channel_type;
            this.channel_id = args.channel_id;
        }
    }
    class login_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this.is_same_day = false;
            this._role_data = new role_data();
            this.is_login = false;
            this.login_compelete = false;
            this._is_server_test = false;
            this.n_progress = 0;
            this.dt = 1 / 12;
            this.is_show_exit = false;
            this.getRandomValue = function(arr) {
                var index = 0;
                index = Math.floor(Math.random() * arr.length);
                return arr[index];
            };
            this.register_listener();
        }
        static get instance() {
            return login_manager.get_instance();
        }
        load_async(finish_callback) {
            let self = this;
            console.log("login_manager load_async-------------------------------------");
            igc.igc_login_manager.instance.load_async(function() {
                self.login();
                if (finish_callback) {
                    finish_callback();
                }
            }, function() {
                return true;
            });
        }
        register_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.loading_complete, this, this.loading_complete);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.new_player_init, this, this.new_player_init);
            igc.phone_manager.instance.add_listener(phone_ids.get_role_data, this, this.get_role_data);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.channel_login_result, this, this.on_channel_login_result);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.http_login_result, this, this.on_login_account);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.socket_login_result, this, this.on_login_plat);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.socket_relogin_success, this, this.on_relogin_success);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.socket_disconnect, this, this.on_socket_disconnect);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.socket_connect_error, this, this.on_socket_error);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.begin_load_battle_scene, this, this.begin_load_battle_scene);
        }
        get_role_data() {
            return this._role_data;
        }
        get role_id() {
            return this._role_data.channel_uid;
        }
        on_socket_error() {}
        on_socket_disconnect() {}
        on_relogin_success() {}
        login() {
            let config = igc.igc_login_manager.instance.get_config(global.game.channel_type);
            console.log("begin login");
            // if (this._is_server_test) {
            config.login_url = "";
            config.ws_url = config.stat_event_url = config.batch_stat_event_url = "";
            // }
            if (global.game.is_local_stat == e_login_type.login_type_local) {
                if (global.game.channel_type === igc.e_channel_type.apk) {
                    this._channel_config = config;
                    console.log("login_manager", JSON.stringify(config));
                    igc.igc_main.instance.init_param(config);
                    igc.igc_main.instance.init(true);
                }
                console.log("login_manager is_local == true,is_login == true");
                this.is_login = true;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.plat_login_success);
                return;
            }
            console.log("xiejinhui 连接环境", config.login_url, config.ws_url);
            this._channel_config = config;
            console.log("login_manager", JSON.stringify(config));
            igc.igc_main.instance.init_param(config);
            igc.igc_main.instance.init(true);
            if (global.game.channel_type == igc.e_channel_type.oppo_qg) {}
            if (global.game.is_local_stat == e_login_type.login_type_tpf) {
                igc.igc_main.instance.login_wrap();
            } else if (global.game.is_local_stat == e_login_type.login_type_channel) {
                igc.igc_main.instance.only_login_channel();
            } else {
                console.error("login_manager global.game.is_local_stat error:", global.game.is_local_stat);
            }
        }
        get_random_name() {
            var name = "role_";
            var pos = 0;
            var arr = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"];
            for (var i = 0; i < 8; i++) {
                pos = Math.round(Math.random() * (arr.length - 1));
                name += arr[pos];
            }
            name += "_";
            name += Date.now();
            return name;
        }
        on_channel_login_result(_, res) {

            if (global.game.is_local_stat == e_login_type.login_type_channel) {
                global.game.login_account = true;
                global.game.login_plat = true;
                this.is_login = true;
                if (global.game.channel_type == igc.e_channel_type.tt) {
                    let save = Laya.LocalStorage.getItem("tt_random_uid");
                    if (save && save != "") {
                        global.game.tpfUserId = save;
                        global.game.platUserId = save;
                        global.game.tpfToken = "";
                    } else {
                        let temp_random_uid = this.get_random_name();
                        global.game.tpfUserId = temp_random_uid;
                        global.game.platUserId = temp_random_uid;
                        global.game.tpfToken = "";
                        Laya.LocalStorage.setItem("tt_random_uid", temp_random_uid);
                    }
                } else {
                    global.game.tpfUserId = res.channel_user_info.uid;
                    global.game.platUserId = res.channel_user_info.uid;
                    global.game.tpfToken = "";
                }
                igc.stat_manager.instance.set_uid(global.game.tpfUserId, 1);
                igc.stat_manager.instance._account = global.game.tpfUserId;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.plat_login_success);
                this.setShowShareMenu();
            }
        }
        begin_load_battle_scene() {}
        get_channel_config() {
            return this._channel_config;
        }
        on_login_account(id, param) {
            global.game.login_account = true;
            let success = param.success;
            let info = param.account_login_info;
            console.log("on_login_account", success, JSON.stringify(param));
            if (success) {
                global.game.tpfUserId = param.account_login_info.id;
                global.game.platUserId = param.account_login_info.channelUid;
                global.game.tpfToken = param.account_login_info.token;
            } else {}
        }
        on_login_plat(id, success) {
            console.log("on_login_plat", JSON.stringify(success));
            if (success) {
                global.game.login_plat = true;
                this.is_login = true;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.plat_login_success);
                this.setShowShareMenu();
            }
        }
        setShowShareMenu() {
            if (global.game.channel_type === igc.e_channel_type.qq || global.game.channel_type === igc.e_channel_type.wx) {
                let txtList = [""];
                let urlList = [""];
                igc.igc_main.instance.set_show_share_menu({
                    txt: txtList[0],
                    url: urlList[0]
                });
            }
        }
        check_can_enter() {
            if (global.game.is_local_stat != e_login_type.login_type_tpf) {
                return global.game.is_get_storage;
            }
            return global.game.login_account && global.game.login_plat && global.game.is_get_storage;
        }
        new_player_init() {}
        loading_complete() {
            if (!this.is_same_day) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.reset_data_next_day);
            }
        }
        on_load_save_begin() {
            this.is_same_day = utils_manager.check_is_same_day(igc.time_manager.instance.get_server_time(), this.save_data["login_timestamp"]);
            this.save_data["login_timestamp"] = igc.time_manager.instance.get_server_time();
            this.save(true);
        }
    }
    class point_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this._is_in_battle = false;
            this.temp_coordinate = new Laya.Vector2();
            this.add_player_list = [];
            this.register_listener();
        }
        static get instance() {
            return point_manager.get_instance();
        }
        init() {}
        register_listener() {
            igc.phone_manager.instance.add_listener(phone_ids.send_user_point_event, this, this.send_user_event);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.login_unlock_new_player, this, this.unlock_new_player);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.upgrade_player, this, this.upgrade_player);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.req_enter_battle, this, this.req_enter_battle);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.add_player_to_scene, this, this.add_player_to_scene);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.show_account_view, this, this.show_account_view);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.reset_data_next_day, this, this.reset_data_next_day);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.new_player_init, this, this.new_player_init);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.loading_complete, this, this.load_complete);
        }
        load_complete() {
            console.log("point_manager load_complete run ", igc.phone_manager.instance.call(phone_ids.check_is_new_player), login_manager.instance.get_role_data().channel_uid);
            igc.phone_manager.instance.call(phone_ids.send_user_point_event, {
                event_type: e_dot_type.loading_complete
            });
        }
        new_player_init() {}
        reset_data_next_day() {}
        show_account_view(_, param) {}
        chapter_pass_star(event_type, chapter_index, star_count) {
            this.send_user_event(undefined, {
                event_type: event_type,
                event_id: chapter_index,
                extra2: star_count
            });
        }
        add_player_to_scene(_, param) {
            if (this.add_player_list.length === 0) {
                this._is_in_battle = true;
                this.upload_battle_frame();
            }
            if (this.add_player_list.indexOf(param.id) < 0) {
                this.send_user_event(undefined, {
                    event_type: e_dot_type.use_player_in_chapter,
                    event_id: param.chapter_index,
                    place_id: param.id
                });
                this.add_player_list.push(param);
            }
            if (this.add_player_list.length === 1) {
                utils_manager.position_to_coordinate(param.position, this.temp_coordinate);
                this.send_user_event(undefined, {
                    event_type: e_dot_type.first_player_position,
                    event_id: param.chapter_index,
                    place_id: param.id,
                    place_type: "x: " + this.temp_coordinate.x + ",y: " + this.temp_coordinate.y
                });
            }
        }
        req_enter_battle(_, param) {
            this.add_player_list.splice(0);
            this.send_user_event(undefined, {
                event_type: e_dot_type.chapter_battle,
                event_id: param.chapter_index
            });
        }
        upload_battle_frame() {
            if (this._is_in_battle) {
                this.send_user_event(undefined, {
                    event_type: e_dot_type.upload_battle_frame,
                    extra2: Math.ceil(1e3 / Laya.timer.delta)
                });
                igc.igc_timer.once(20, this, this.upload_battle_frame, undefined, true);
            }
        }
        upgrade_player(_, param) {}
        unlock_new_player(_, param) {
            this.send_user_event(undefined, {
                event_type: e_dot_type.unlock_new_player,
                event_id: igc.phone_manager.instance.call(phone_ids.get_max_unlock_level)
            });
        }
        send_user_event(_, param) {
            if (!param.event_type) {
                console.error("point_manager send_user_event error run (need event_type)", param);
                return;
            }
            let event_id = param.event_id || 1;
            let event_type = param.event_type;
            let place_id = param.place_id || "";
            let place_type = param.place_type || "";
            let extra = param.extra || "";
            let extra2 = param.extra2 || undefined;
            if (Laya.Browser.onMobile) {
                igc.stat_manager.instance.send_user_event(event_id, event_type, place_id, place_type, JSON.stringify(param.extra), undefined, undefined, extra2);
            } else {
                console.log("point_manager send_user_event run -> ", param);
            }
        }
    }
    class SegmentInfo {
        constructor() {
            this.bezierIndex = 0;
            this.bezierInfo = new BezierInfo();
            this.t = 0;
            this.length = 0;
            this.track_type = e_track_type.none;
            this.bezierInfo = new BezierInfo();
        }
    }
    class BezierInfo {
        constructor() {
            this.point = new Laya.Vector3();
            this.length = 0;
            this.t = 0;
        }
    }
    class track_manager extends igc.igc_manager_base {
        constructor() {
            super(...arguments);
            this.cache_segment_info = {
                cache_hit: 0,
                cache_count: 0
            };
            this.cache_bezier_by_length = {
                cache_hit: 0,
                cache_count: 0
            };
            this.cache_bezier_by_index = {
                cache_hit: 0,
                cache_count: 0
            };
            this.length_accurate = 100;
            this._temp_vector3 = new Laya.Vector3();
            this.bezier_vec0 = new Laya.Vector3();
            this.bezier_vec1 = new Laya.Vector3();
            this._bezier_0 = new Laya.Vector3();
            this._bezier_1 = new Laya.Vector3();
        }
        init() {
            igc.phone_manager.instance.add_listener(phone_ids.get_track_total_length, this, this.get_track_total_length);
            igc.phone_manager.instance.add_listener(phone_ids.get_track_point_by_length, this, this.get_track_point_by_length);
            igc.phone_manager.instance.add_listener(phone_ids.get_segment_info_by_length, this, this.phone_get_segment_info_by_length);
        }
        get_track_point_by_length(phone_id, param) {
            let segment_info = this.phone_get_segment_info_by_length(phone_id, param);
            if (segment_info) {
                return segment_info.bezierInfo.point;
            }
            return this._temp_vector3;
        }
        phone_get_segment_info_by_length(phone_id, param) {
            let config = igc.phone_manager.instance.call(phone_ids.get_level_config, {
                id: param.id
            });
            if (config) {
                if (param.length === undefined) {
                    console.error("param.length === undefined");
                }
                let index = Math.floor(param.length * this.length_accurate);
                if (index === NaN) {
                    console.error("index === NaN");
                }
                this.cache_segment_info[index] = this.cache_segment_info[index] || {
                    id: -1
                };
                let cache_segment_info = this.cache_segment_info[index];
                if (cache_segment_info.id == param.id) {
                    ++this.cache_segment_info.cache_hit;
                    return cache_segment_info.cache;
                } else {
                    if (!this.cache_segment_info[index].cache) {
                        ++this.cache_segment_info.cache_count;
                    }
                    let result = this.cache_segment_info[index].cache || new SegmentInfo();
                    this.cache_segment_info[index].cache = result;
                    this.cache_segment_info[index].id = param.id;
                    this.get_segment_info_by_length(param.id, config.track.track_points, param.length, this.length_accurate, result);
                    result.bezierInfo.point.x = -result.bezierInfo.point.x;
                    return result;
                }
            } else {
                return undefined;
            }
        }
        get_track_total_length(phone_id, param) {
            let config = igc.phone_manager.instance.call(phone_ids.get_level_config, {
                id: param.id
            });
            if (config) {
                return config.track.track_total_length;
            } else {
                return 0;
            }
        }
        greater_equal(left, right) {
            if (Math.abs(left - right) < 1e-4) {
                return true;
            }
            return left <= right;
        }
        get_segment_info_by_length(id, points, length, accurate, segmentInfo) {
            if (1 < points.length) {
                let totalLength = igc.phone_manager.instance.call(phone_ids.get_track_total_length, {
                    id: id
                });
                let startPoint;
                let endPoint;
                let currentLength = 0;
                let lastLength = 0;
                let lastT = 0;
                for (let i = 0; i < points.length - 1; ++i) {
                    let segment_length = points[i + 1].length;
                    currentLength += segment_length;
                    segmentInfo.bezierInfo.length = length - lastLength;
                    segmentInfo.bezierIndex = i;
                    segmentInfo.track_type = points[i + 1].track_type;
                    if (length <= currentLength) {
                        break;
                    } else {
                        lastLength += segment_length;
                        lastT += segment_length / totalLength;
                    }
                }
                startPoint = points[segmentInfo.bezierIndex];
                endPoint = points[segmentInfo.bezierIndex + 1];
                this.bezier_by_length(id, segmentInfo.bezierIndex, startPoint.point, endPoint.tangent0, endPoint.tangent1, endPoint.point, segmentInfo.bezierInfo.length, accurate, segmentInfo.bezierInfo);
                segmentInfo.length = lastLength + segmentInfo.bezierInfo.length;
                segmentInfo.t = lastT + segmentInfo.bezierInfo.length / totalLength;
            }
            return segmentInfo;
        }
        bezier_by_length(id, segment_index, a, b, c, d, targetLength, accurate, result) {
            let total_key = Math.floor(targetLength * this.length_accurate);
            if (total_key == NaN) {
                console.error("NaN");
            }
            if (targetLength < 0) {
                // console.error("nagetive value");
            }
            this.cache_bezier_by_length[segment_index] = this.cache_bezier_by_length[segment_index] || {};
            this.cache_bezier_by_length[segment_index][total_key] = this.cache_bezier_by_length[segment_index][total_key] || {};
            if (this.cache_bezier_by_length[segment_index][total_key].id == id) {
                let cache_total = this.cache_bezier_by_length[segment_index][total_key].cache;
                result.length = cache_total.length;
                result.t = cache_total.t;
                cache_total.point.cloneTo(result.point);
                ++this.cache_bezier_by_length.cache_hit;
            } else {
                if (!this.cache_bezier_by_length[segment_index][total_key].cache) {
                    ++this.cache_bezier_by_length.cache_count;
                }
                let cache_total = this.cache_bezier_by_length[segment_index][total_key].cache || new BezierInfo();
                this.cache_bezier_by_length[segment_index][total_key].cache = cache_total;
                this.cache_bezier_by_length[segment_index][total_key].id = id;
                let ptCount = Math.ceil(Laya.Vector3.distance(a, d) * accurate);
                let lastVec = this.bezier_vec0;
                a.cloneTo(lastVec);
                let dVec = this.bezier_vec1;
                result.length = 0;
                this.cache_bezier_by_index[segment_index] = this.cache_bezier_by_index[segment_index] || {
                    id: -1,
                    cache: [],
                    length: 0
                };
                if (this.cache_bezier_by_index[segment_index].id != id) {
                    this.cache_bezier_by_index[segment_index].id = id;
                    this.cache_bezier_by_index[segment_index].length = 0;
                }
                let i = 1;
                let cache_length = this.cache_bezier_by_index[segment_index].length;
                if (0 < cache_length) {
                    let last_cache = this.cache_bezier_by_index[segment_index].cache[cache_length - 1];
                    if (last_cache.length < targetLength) {
                        i = cache_length;
                    } else {
                        let l = 0;
                        let h = cache_length;
                        while (l < h) {
                            let m = Math.floor((l + h) / 2);
                            let cache_result = this.cache_bezier_by_index[segment_index].cache[m];
                            if (cache_result) {
                                if (cache_result.length < targetLength) {
                                    l = m + 1;
                                } else {
                                    h = m - 1;
                                }
                            } else {
                                break;
                            }
                        }
                        i = Math.min(ptCount, l - 1);
                        i = Math.max(1, i);
                    }
                }
                for (; i <= ptCount; i++) {
                    result.t = i * 1 / ptCount;
                    let cache_segment = undefined;
                    if (i - 1 < this.cache_bezier_by_index[segment_index].length) {
                        cache_segment = this.cache_bezier_by_index[segment_index].cache[i - 1];
                    }
                    if (cache_segment) {
                        cache_segment.point.cloneTo(lastVec);
                        cache_segment.point.cloneTo(result.point);
                        result.length = cache_segment.length;
                        ++this.cache_bezier_by_index.cache_hit;
                    } else {
                        let pt = this.bezier(a, b, c, d, result.t);
                        Laya.Vector3.subtract(pt, lastVec, dVec);
                        pt.cloneTo(lastVec);
                        result.length += Laya.Vector3.scalarLength(dVec);
                        lastVec.cloneTo(result.point);
                        if (i - 1 < this.cache_bezier_by_index[segment_index].cache.length) {
                            cache_segment = this.cache_bezier_by_index[segment_index].cache[i - 1];
                            this.cache_bezier_by_index[segment_index].length = i;
                        } else {
                            cache_segment = new BezierInfo();
                            this.cache_bezier_by_index[segment_index].cache.push(cache_segment);
                            ++this.cache_bezier_by_index.cache_count;
                        }
                        cache_segment.length = result.length;
                        cache_segment.t = result.t;
                        lastVec.cloneTo(cache_segment.point);
                    }
                    if (this.greater_equal(targetLength, result.length)) {
                        break;
                    }
                }
                cache_total.length = result.length;
                cache_total.t = result.t;
                result.point.cloneTo(cache_total.point);
            }
            return result;
        }
        bezier(start_point, tangent0, tangent1, end_point, t) {
            Laya.Vector3.scale(start_point, Math.pow(1 - t, 3), this._bezier_0);
            Laya.Vector3.scale(tangent0, 3 * Math.pow(1 - t, 2) * t, this._bezier_1);
            Laya.Vector3.add(this._bezier_0, this._bezier_1, this._bezier_0);
            Laya.Vector3.scale(tangent1, 3 * (1 - t) * t * t, this._bezier_1);
            Laya.Vector3.add(this._bezier_0, this._bezier_1, this._bezier_0);
            Laya.Vector3.scale(end_point, t * t * t, this._bezier_1);
            Laya.Vector3.add(this._bezier_0, this._bezier_1, this._bezier_0);
            return this._bezier_0;
        }
        test() {
            let config = igc.phone_manager.instance.call(phone_ids.get_level_config, {
                id: 1001
            });
            if (config) {
                this.do_test(config, 207, 209);
            }
        }
        do_test(config, start, end) {
            let start_point = new Laya.Vector3();
            this.get_track_point_by_length(0, {
                id: 1001,
                length: 0
            }).cloneTo(start_point);
            for (let distance = start; distance < end; distance += .1) {
                let end_point = new Laya.Vector3();
                this.get_track_point_by_length(0, {
                    id: 1001,
                    length: distance
                }).cloneTo(end_point);
                console.log(distance, Laya.Vector3.distance(start_point, end_point));
                console.log("x: ", start_point.x, ", y: ", start_point.y, ", z: ", start_point.z);
                console.log("x: ", end_point.x, ", y: ", end_point.y, ", z: ", end_point.z);
                end_point.cloneTo(start_point);
            }
        }
    }
    class character_speed {
        constructor() {
            this.u = .1;
            this.g = 32;
            this.speed_min = -40;
            this.coal_time = .4;
            this.reborn_speed = 40;
            this.reborn_progress = .5;
            this.train_capacity = 10;
            this.min_angle = .1;
            this.min_huohua = .02;
            this.turn_over_speed = 30;
            this.turn_over_time = 1;
            this.no_coal_speed = .5;
            this.no_coal_time = 2;
            this.pre_look_dis = 60;
            this.turn_g_limit = .1;
            this.begin_dis = 15;
            this.end_dis = 20;
            this.clock_speed = 6;
            this.clock_max = 45;
            this.head_mass = .5;
            this.body_mass = .25;
            this.body_coal_num = 15;
            this.game_time = 0;
            this._sound_time = 0;
            this._move_speed = 0;
            this._burn_time = 0;
            this._turn_time = 0;
            this._straight_time = 0;
            this._mouse_down_duration = 0;
            this._train_forward = new Laya.Vector3(0, 0, 1);
            this._is_mouse_down = false;
        }
        get train_mass() {
            return this.head_mass + role_manager.instance.coal / this.train_capacity * this.body_mass;
        }
        get train_num() {
            return Math.ceil(role_manager.instance.coal / this.train_capacity);
        }
        get train_forward() {
            return this._train_forward;
        }
        get is_mouse_down() {
            return this._is_mouse_down;
        }
        set is_mouse_down(value) {
            this._is_mouse_down = value;
            if (!this._is_mouse_down) {
                this._mouse_down_duration = 0;
            } else {
                if (this.burn_progress > 0) {
                    this.play_sound();
                }
            }
        }
        get dot_g() {
            return Laya.Vector3.dot(this.train_forward, new Laya.Vector3(0, 1, 0));
        }
        get dot_u() {
            return Math.sqrt(1 - this.dot_g * this.dot_g);
        }
        get u_a() {
            return this.u * this.dot_u * this.g;
        }
        get g_a() {
            return this.g * this.dot_g;
        }
        get power() {
            return this.curr_power * this.fix;
        }
        get curr_power() {
            if (this._mouse_down_duration >= role_manager.instance.power_duration) {
                return role_manager.instance.power;
            } else {
                return (role_manager.instance.power - role_manager.instance.power_min) * this.easeInSine(this._mouse_down_duration / role_manager.instance.power_duration) + role_manager.instance.power_min;
            }
        }
        get f_a() {
            if (this.is_mouse_down && this.has_coal) {
                return this.power / this.train_mass;
            } else {
                return 0;
            }
        }
        get real_a() {
            if (this.move_speed > 0) {
                return this.f_a - this.u_a - this.g_a;
            } else if (this.move_speed < 0) {
                return this.f_a + this.u_a - this.g_a;
            } else if (this.move_speed == 0) {
                return this.f_a - this.g_a;
            }
        }
        get move_speed() {
            return this._move_speed;
        }
        get burn_time() {
            return this._burn_time;
        }
        get burn_sum() {
            return this.coal_time * role_manager.instance.coal * this.fix;
        }
        get burn_left() {
            return Math.max(0, this.burn_sum - this.burn_time);
        }
        get burn_progress() {
            return this.burn_left / this.burn_sum;
        }
        get has_coal() {
            return this.burn_time < this.burn_sum;
        }
        get turn_time() {
            return this._turn_time;
        }
        get is_show_huohua() {
            return Math.abs(this.move_speed) > 1;
        }
        get left_coal() {
            return Math.ceil(role_manager.instance.coal * this.burn_progress * 1.5);
        }
        get fix() {
            return igc.phone_manager.instance.call(phone_ids.get_fix) || 1;
        }
        get speed_max() {
            return role_manager.instance.speed_max;
        }
        play_sound() {
            if (this.game_time - this._sound_time > 2) {
                this._sound_time = this.game_time;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.play_sound, {
                    id: "add_coal"
                });
            }
        }
        easeInline(x) {
            return x;
        }
        easeInQuad(x) {
            return Math.pow(x, 2);
        }
        easeInSine(z) {
            return -Math.cos(z * (Math.PI / 2)) + 1;
        }
        easeInCubic(x) {
            return Math.pow(x, 3);
        }
        easeInQuart(x) {
            return Math.pow(x, 4);
        }
        easeInQuint(x) {
            return Math.pow(x, 5);
        }
        easeInExpo(x) {
            return x == 0 ? 0 : Math.pow(2, 10 * (x - 1));
        }
        easeInCirc(x) {
            return -(Math.sqrt(1 - x * x) - 1);
        }
        update_speed(forward, dt, b_begin) {
            this.game_time += dt;
            if (b_begin && !this.is_mouse_down && this.burn_progress > 0) {
                this._move_speed = 0;
                return;
            }
            if (this.is_mouse_down) {
                this._mouse_down_duration += dt;
            }
            forward.cloneTo(this._train_forward);
            this._move_speed = this.real_a * dt + this.move_speed;
            this._move_speed = Math.max(Math.min(this.move_speed, this.speed_max), this.speed_min);
            if (this.is_mouse_down) {
                this._burn_time = Math.min(this._burn_time + dt, this.burn_sum);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_burn_progress, {
                    progress: this.burn_progress,
                    is_show: true
                });
            }
            if (this.burn_progress <= 0 && this.move_speed < this.no_coal_speed) {
                this._no_coal_duration += dt;
                if (this._no_coal_duration >= this.no_coal_time) {
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.chapter_fail, {
                        fail_reason: e_fail_reason.no_coal
                    });
                }
            } else {
                this._no_coal_duration = 0;
            }
        }
        reborn() {
            this._sound_time = 0;
            this.game_time = 10;
            this._move_speed = this.reborn_speed;
            this._burn_time = this.burn_sum * (1 - this.reborn_progress);
            this._turn_time = 0;
            this._straight_time = 0;
        }
        reset() {
            this._sound_time = 0;
            this.game_time = 10;
            this._move_speed = 0;
            this._burn_time = 0;
            this._turn_time = 0;
            this._straight_time = 0;
        }
        update_turn(b_turn, dt) {
            if (this.burn_progress > 0) {
                if (b_turn && this.dot_g < this.turn_g_limit) {
                    if (this.move_speed >= this.turn_over_speed && this.is_mouse_down) {
                        this._turn_time += dt;
                    } else {
                        this._turn_time = 0;
                    }
                    this._straight_time = 0;
                } else {
                    this._straight_time += dt;
                    if (this._straight_time > 1 / 20) {
                        this._turn_time = 0;
                    }
                }
                igc.broadcast_manager.instance.broadcast(broadcast_ids.turn_speed_out, {
                    speed_out: this.turn_time >= 1 / 20
                });
                if (this.turn_time > this.turn_over_time) {
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.train_turn_over);
                }
            } else {
                this._turn_time = 0;
                this._straight_time = 0;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.turn_speed_out, {
                    speed_out: false
                });
            }
        }
    }
    class character_player extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.collider = undefined;
            this._is_play = false;
            this._is_begin = false;
            this._position = new Laya.Vector3();
            this._rotation = new Laya.Vector3(.1, 0, 0);
            this._frame = 60;
            this.is_mouse_down = false;
            this.look_dis = 5;
            this.run_dis = 5;
            this.run_max = 5;
            this.time_scale = 1;
            this.use_lerp = false;
            this.lerp_frame = 0;
            this.lerp_count = 10;
            this.pre_rotaion = new Laya.Quaternion(0, 0, 0, 0);
            this.first_next = -1.5;
            this.body_length = 2.3;
            this.train_body = [];
            this.level_id = 1001;
            this.gift_limit = 28;
            this.fake_eye = new Laya.MeshSprite3D();
            this.b_show = false;
            this.fly_action_list = [];
            this.b_init = false;
            this.clock_rotation = 0;
            this.clock_dirction = 1;
            this.begin_dis = 5;
            this.b_reborn = false;
            this.chapter_id = 1;
            this._move_type = e_move_type.empty;
            this.train_pos_list = [];
            this.state_name = "empty";
            this.train_capcity = 4;
            this.mat_list = [];
            this.gift_pos_list = [
                [{
                    position: new Laya.Vector3(-.04, .44, 1.14),
                    rotation: new Laya.Vector3(90, 0, 0),
                    scale: new Laya.Vector3(.6511972, .573455, .8869679),
                    model_type: e_model_type.train_passenger_2
                }, {
                    position: new Laya.Vector3(.01699998, -.428, 1.21),
                    rotation: new Laya.Vector3(90, 0, 0),
                    scale: new Laya.Vector3(.6397953, .6839001, 1.026018),
                    model_type: e_model_type.train_passenger_3
                }, {
                    position: new Laya.Vector3(-.227, .367, 1.63),
                    rotation: new Laya.Vector3(90, 0, 0),
                    scale: new Laya.Vector3(.6056166, .6056167, .6056167),
                    model_type: e_model_type.train_passenger_1
                }, {
                    position: new Laya.Vector3(.307, .253, 1.58),
                    rotation: new Laya.Vector3(90, 0, 0),
                    scale: new Laya.Vector3(.5941, .5941026, .5941026),
                    model_type: e_model_type.train_passenger_4
                }],
                [{
                    position: new Laya.Vector3(-.221, -.382, 1.219),
                    rotation: new Laya.Vector3(-.781, -90.00001, -90.00001),
                    scale: new Laya.Vector3(.6397953, .6839001, .64091),
                    model_type: e_model_type.train_passenger_3
                }, {
                    position: new Laya.Vector3(.241, -.308, 1.085),
                    rotation: new Laya.Vector3(-.431, -90.00001, -90.00001),
                    scale: new Laya.Vector3(.6511972, .573455, .5978962),
                    model_type: e_model_type.train_passenger_2
                }, {
                    position: new Laya.Vector3(.01, .54, 1.18),
                    rotation: new Laya.Vector3(90, 0, 0),
                    scale: new Laya.Vector3(1.058355, .68477, .68477),
                    model_type: e_model_type.train_passenger_1
                }, {
                    position: new Laya.Vector3(.116, .079, 1.634),
                    rotation: new Laya.Vector3(90, 0, 0),
                    scale: new Laya.Vector3(.5852854, .5852854, .5852854),
                    model_type: e_model_type.train_passenger_4
                }]
            ];
            this.passenger_idx = 0;
            this.passenger_list = [];
            this.player_position = new Laya.Vector3(0, 0, 0);
            this.camera_position = new Laya.Vector3(0, 0, 0);
            this._translation = new Laya.Vector3();
            this.get_race_pos_vec0 = new Laya.Vector3(0, 0, 0);
            this.get_race_pos_vec1 = new Laya.Vector3(0, 0, 0);
            this.get_race_pos_vec2 = new Laya.Vector3(0, 0, 0);
            this.right_pos = new Laya.Vector3(0, 0, 0);
            this.up_pos = new Laya.Vector3(0, 1, 0);
            this.up_v3 = new Laya.Vector3(0, 1, 0);
            this.right_v3 = new Laya.Vector3(0, 1, 0);
            this.head_forward = new Laya.Vector3(0, 0, 0);
            this.preLocalRotation = new Laya.Vector3(0, 0, 0);
            this.upDirection = new Laya.Vector3(0, 1, 0);
            this._wudi_state = false;
        }
        get move_type() {
            return this._move_type;
        }
        set move_type(value) {
            this._move_type = value;
            this.update_train_state();
        }
        init() {
            let self = this;
            let env_type = igc.phone_manager.instance.call(phone_ids.get_env_type);
            if (!this.b_init) {
                this._scene = igc.phone_manager.instance.call(phone_ids.get_active_game_scene)._scene;
                this.player = this.owner;
                this.train_main = utils_manager.GetChildByName(this.player, "train");
                this.player_camera = utils_manager.GetChildByName(this._scene, "player_camera");
                this.level_id = igc.phone_manager.instance.call(phone_ids.get_scene_level);
                this.gift_limit = igc.phone_manager.instance.call(phone_ids.get_gift_limit);
                let main_camera = utils_manager.GetChildByName(this.player_camera, "Main Camera");
                main_camera.farPlane = 300;
                main_camera.clearFlag = Laya.BaseCamera.CLEARFLAG_SKY;
                igc.phone_manager.instance.call(phone_ids.get_sky_box, {
                    env_type: env_type,
                    call_back: function(mat) {
                        var skyRenderer = self._scene.skyRenderer;
                        skyRenderer.mesh = Laya.SkyDome.instance;
                        skyRenderer.material = mat;
                    }
                });
                this._scene.addChild(this.fake_eye);
                this.train_speed = new character_speed();
                this.effect_lihua = utils_manager.GetChildByName(this.player_camera, "huoche_lihua");
                this.init_light();
                this.b_init = true;
                this.cj_sha = utils_manager.GetChildByName(this.player_camera, "cj_sha");
                this.cj_xue = utils_manager.GetChildByName(this.player_camera, "cj_xue");
                this.cj_sha.active = env_type == e_env_type.sand;
                this.cj_xue.active = env_type == e_env_type.snow;
            }
            this.chapter_id = igc.phone_manager.instance.call(phone_ids.get_chapter_id);
            this.load_train();
            if (env_type == e_env_type.sand) {
                this.show_cj_effect();
            }
        }
        show_cj_effect() {
            this.cj_sha.active = true;
            Laya.timer.once(3e3, this, this.hide_cj_effect);
        }
        hide_cj_effect() {
            this.cj_sha.active = false;
            Laya.timer.once(2e3, this, this.show_cj_effect);
        }
        init_light() {
            let self = this;
            let base_config = igc.igc_config_manager.instance.configs_data["base"];
            let directionLight = utils_manager.GetChildByName(this._scene, "Directional Light");
            let env_type = igc.phone_manager.instance.call(phone_ids.get_env_type);
            this._scene.enableFog = true;
            this._scene.fogStart = 0;
            this._scene.fogRange = 300;
            directionLight.shadow = false;
            directionLight.shadowDistance = base_config.shadow_distance;
            directionLight.shadowResolution = 4096;
            directionLight.shadowPSSMCount = base_config.shadowPSSMCount;
            directionLight.shadowPCFType = base_config.shadowPCFType;
            directionLight.transform.rotationEuler = new Laya.Vector3(-110, 180, -5);
            if (env_type == e_env_type.grass) {
                this._scene.fogColor = new Laya.Vector3(73 / 255, 224 / 255, 169 / 255);
                directionLight.color = new Laya.Vector3(204 / 255, 209 / 255, 198 / 255);
            } else if (env_type == e_env_type.sand) {
                this._scene.fogColor = new Laya.Vector3(205 / 255, 135 / 255, 75 / 255);
                directionLight.color = new Laya.Vector3(214 / 255, 209 / 255, 183 / 255);
            } else if (env_type == e_env_type.snow) {
                this._scene.fogColor = new Laya.Vector3(191 / 255, 245 / 255, 255 / 255);
                directionLight.color = new Laya.Vector3(202 / 255, 242 / 255, 248 / 255);
            }
            let chunks = utils_manager.GetChildByName(this._scene, "chunks");
            igc.phone_manager.instance.call(phone_ids.get_mat, {
                env_type: env_type,
                call_back: function(mat) {
                    if (chunks) {
                        for (let idx = 0; idx < chunks.numChildren; idx++) {
                            let child = chunks.getChildAt(idx);
                            child.meshRenderer.material = mat;
                        }
                    }
                }
            });
            let tracks = utils_manager.GetChildByName(this._scene, "tracks");
            igc.phone_manager.instance.call(phone_ids.get_track_mat, {
                env_type: env_type,
                call_back: function(mat) {
                    if (tracks) {
                        for (let idx = 0; idx < tracks.numChildren; idx++) {
                            let child = tracks.getChildAt(idx);
                            child.meshRenderer.material = mat;
                        }
                    }
                }
            });
            let train_port_1 = utils_manager.GetChildByName(this._scene, "train_port Variant (1)");
            if (train_port_1) {
                for (let idx = 0; idx < train_port_1.numChildren; idx++) {
                    let child = train_port_1.getChildAt(idx);
                    child.meshRenderer.material.albedoIntensity = 1.2;
                }
            }
            let train_port_2 = utils_manager.GetChildByName(this._scene, "train_port Variant");
            if (train_port_2) {
                for (let idx = 0; idx < train_port_2.numChildren; idx++) {
                    let child = train_port_2.getChildAt(idx);
                    child.meshRenderer.material.albedoIntensity = 1.2;
                }
            }
        }
        load_train() {
            this.train_head = igc.phone_manager.instance.call(phone_ids.get_model, {
                model_type: e_model_type.train_head
            });
            this.train_main.addChild(this.train_head);
            this.train_head.transform.localPosition = new Laya.Vector3(0, 0, 0);
            let cheTou = utils_manager.GetChildByName(this.train_head, "cheTou");
            this.train_ani = cheTou.getComponent(Laya.Animator);
            this.train_pos_list.push(new Laya.Vector3(0, 0, 0));
            let cheDouMehs = utils_manager.GetChildByName(cheTou, "01_huochetou");
            cheDouMehs.skinnedMeshRenderer.material.albedoIntensity = 1;
            for (let idx = 0; idx < this.train_speed.train_num; idx++) {
                let new_model = igc.phone_manager.instance.call(phone_ids.get_model, {
                    model_type: e_model_type.train_gift
                });
                this.train_main.addChild(new_model);
                this.train_body.push(new_model);
                this.train_pos_list.push(new Laya.Vector3(0, 0, 0));
                let cheDou = utils_manager.GetChildByName(new_model, "cheDou");
                cheDou.meshRenderer.material.albedoIntensity = 1;
            }
            if (global.game.channel_type == igc.e_channel_type.tt && Laya.Browser.onIOS) {
                this.left_huohua = utils_manager.GetChildByName(this.train_head, "huoche_saiche_l_tt");
                this.right_huohua = utils_manager.GetChildByName(this.train_head, "huoche_saiche_r_tt");
                let temp_left_huohua = utils_manager.GetChildByName(this.train_head, "huoche_saiche_l");
                let temp_right_huohua = utils_manager.GetChildByName(this.train_head, "huoche_saiche_r");
                temp_left_huohua.active = false;
                temp_right_huohua.active = false;
            } else {
                this.left_huohua = utils_manager.GetChildByName(this.train_head, "huoche_saiche_l");
                this.right_huohua = utils_manager.GetChildByName(this.train_head, "huoche_saiche_r");
                let temp_left_huohua = utils_manager.GetChildByName(this.train_head, "huoche_saiche_l_tt");
                let temp_right_huohua = utils_manager.GetChildByName(this.train_head, "huoche_saiche_r_tt");
                temp_left_huohua.active = false;
                temp_right_huohua.active = false;
            }
            this.state_name = "empty";
            this.train_yan = utils_manager.GetChildByName(this.train_head, "huoche_yan");
            this.init_train();
        }
        play_run() {
            this.state_name = "run";
            this.train_ani.play("run", 0);
        }
        play_empty() {
            this.state_name = "empty";
            this.train_ani.play("empty", 0);
        }
        update_train_state() {
            if (this.move_type == e_move_type.run && this.state_name == "empty") {
                this.play_run();
            } else if (this.move_type == e_move_type.empty && this.state_name == "run") {
                this.play_empty();
            }
        }
        update_coal_state() {
            if (!this.train_body[this.train_speed.train_num - 1]) {
                let new_model = igc.phone_manager.instance.call(phone_ids.get_model, {
                    model_type: e_model_type.train_gift
                });
                this.train_main.addChild(new_model);
                this.train_body.push(new_model);
                this.train_pos_list.push(new Laya.Vector3(0, 0, 0));
                let cheDou = utils_manager.GetChildByName(new_model, "cheDou");
                cheDou.meshRenderer.material.albedoIntensity = 1;
                this.init_passenger();
            }
            this.set_train_pos(1 / 60, true);
        }
        destroy_all_active_characters() {
            let self = this;
            igc.phone_manager.instance.call(phone_ids.recycle_model, {
                model_type: e_model_type.train_head,
                model: this.train_head
            });
            this.recycle_passenger();
            this.train_head = null;
            for (let idx = 0; idx < this.train_body.length; idx++) {
                igc.phone_manager.instance.call(phone_ids.recycle_model, {
                    model_type: e_model_type.train_gift,
                    model: this.train_body[idx]
                });
            }
            this.train_body = [];
            this.train_pos_list = [];
            for (let idx = 0; idx < self.mat_list.length; idx++) {
                if (self.mat_list[idx]) {
                    self.mat_list[idx].destroy();
                }
            }
            self.mat_list = [];
        }
        add_listener() {
            if (this.b_show) {
                return;
            }
            this.b_show = true;
            Laya.stage.on(Laya.Event.MOUSE_UP, this, this.mouse_up);
            Laya.stage.on(Laya.Event.MOUSE_OUT, this, this.mouse_up);
            Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.mouse_down);
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this.mouse_move);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.character_restart, this, this.reset);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.character_success, this, this.win);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.character_fail, this, this.lose);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.character_play, this, this.play);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.character_relife, this, this.relife);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.destroy_all_active_characters, this, this.destroy_all_active_characters);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.train_turn_over, this, this.train_turn_over);
            igc.phone_manager.instance.add_listener(phone_ids.get_reborn_state, this, this.get_reborn_state);
            igc.phone_manager.instance.add_listener(phone_ids.get_chapter_progress, this, this.get_chapter_progress);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_coal, this, this.update_coal_state);
            this.init();
        }
        remove_listener() {
            if (!this.b_show) {
                return;
            }
            this.b_show = false;
            Laya.stage.off(Laya.Event.MOUSE_UP, this, this.mouse_up);
            Laya.stage.off(Laya.Event.MOUSE_OUT, this, this.mouse_up);
            Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.mouse_down);
            Laya.stage.off(Laya.Event.MOUSE_MOVE, this, this.mouse_move);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.character_restart, this, this.reset);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.character_success, this, this.win);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.character_fail, this, this.lose);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.character_play, this, this.play);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.character_relife, this, this.relife);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.destroy_all_active_characters, this, this.destroy_all_active_characters);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.train_turn_over, this, this.train_turn_over);
            igc.phone_manager.instance.remove_listener(phone_ids.get_chapter_progress, this, this.get_chapter_progress);
            igc.broadcast_manager.instance.remove_listener(broadcast_ids.update_coal, this, this.update_coal_state);
            igc.phone_manager.instance.remove_listener(phone_ids.get_reborn_state, this, this.get_reborn_state);
            Laya.timer.clear(this, this.show_cj_effect);
            Laya.timer.clear(this, this.hide_cj_effect);
        }
        onEnable() {
            this.add_listener();
        }
        onDisable() {
            this.stop_train_fly();
            this.remove_listener();
        }
        box_back() {}
        box_move(dt) {}
        is_guide_mask() {
            let ui_guide = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                ui_name: "ui_guide"
            });
            if (ui_guide && this.chapter_id == 2) {
                return true;
            } else {
                return false;
            }
        }
        close_guide() {
            if (this.chapter_id <= 2) {
                let ui_guide = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                    ui_name: "ui_guide"
                });
                igc.phone_manager.instance.call(phone_ids.hide_ui, {
                    instance: ui_guide
                });
            }
        }
        mouse_up() {
            if (this.is_mouse_down) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_burn_progress, {
                    progress: this.train_speed.burn_progress,
                    is_show: false
                });
                this.is_mouse_down = false;
                this.train_speed.is_mouse_down = this.is_mouse_down;
            }
            if (this.chapter_id == 1) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_guide_state, {
                    is_show: true
                });
            }
        }
        mouse_down() {
            if (!this._is_play) {
                return;
            }
            if (this.is_guide_mask()) {
                return;
            }
            this.is_mouse_down = true;
            this.train_speed.is_mouse_down = this.is_mouse_down;
            if (this.chapter_id == 1) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_guide_state, {
                    is_show: false
                });
            }
        }
        mouse_move() {
            if (!this._is_play) {
                return;
            }
        }
        get_reborn_state() {
            return this.b_reborn;
        }
        get position() {
            return this.player.transform.position;
        }
        set position(value) {
            this.player.transform.position = value;
        }
        init_train() {
            this.lerp_frame = this.lerp_count;
            this.b_reborn = false;
            this.time_scale = 1;
            this.train_speed.reset();
            this.stop_train_fly();
            this.begin_dis = Math.max(this.train_speed.begin_dis, (this.train_speed.train_num + 2) * this.body_length);
            this.run_dis = this.begin_dis;
            this.run_max = this.run_dis;
            this.look_dis = this.run_dis;
            this.clock_rotation = 0;
            this.clock_dirction = 1;
            let race_info = this.get_race_pos(this.run_dis);
            race_info.position.cloneTo(this.player_position);
            this.position = this.player_position;
            race_info.position.cloneTo(this.camera_position);
            this.player_camera.transform.position = this.camera_position;
            this.player.transform.lookAt(race_info.next, this.upDirection, false);
            this.player_camera.transform.rotation = this.player.transform.rotation;
            this.player_camera.transform.localRotationEuler.cloneTo(this.preLocalRotation);
            this.set_train_pos(1 / 60, true);
            this.left_huohua.active = false;
            this.right_huohua.active = false;
            this.train_yan.active = false;
            this.effect_lihua.active = false;
            this.move_type = e_move_type.empty;
            this.init_passenger();
        }
        reset_gift() {
            for (let train_idx = 0; train_idx < this.train_speed.train_num; train_idx++) {
                let new_gift = this.train_body[train_idx];
                let cheDou = utils_manager.GetChildByName(new_gift, "cheDou");
                let pos_idx = train_idx % 2;
                for (let idx = 0; idx < cheDou.numChildren; idx++) {
                    let child = cheDou.getChildAt(idx);
                    child.transform.localRotationEuler = this.gift_pos_list[pos_idx][idx].rotation.clone();
                    child.transform.localPosition = this.gift_pos_list[pos_idx][idx].position.clone();
                }
            }
        }
        get total_length() {
            return igc.phone_manager.instance.call(phone_ids.get_track_total_length, {
                id: this.level_id
            });
        }
        get_race_pos(run_dis) {
            let total_length = this.total_length;
            let pos_1 = this.get_race_pos_vec0;
            let pos_next = this.get_race_pos_vec1;
            let forward = this.get_race_pos_vec2;
            igc.phone_manager.instance.call(phone_ids.get_track_point_by_length, {
                id: this.level_id,
                length: run_dis
            }).cloneTo(pos_1);
            igc.phone_manager.instance.call(phone_ids.get_track_point_by_length, {
                id: this.level_id,
                length: run_dis + .1
            }).cloneTo(pos_next);
            Laya.Vector3.subtract(pos_next, pos_1, forward);
            Laya.Vector3.normalize(forward, forward);
            Laya.Vector3.subtract(pos_1, forward, pos_next);
            return {
                position: pos_1,
                forward: forward,
                next: pos_next
            };
        }
        init_passenger() {
            this.recycle_passenger();
            let passenger_num = this.train_speed.train_num * this.train_capcity;
            passenger_num = Math.min(passenger_num, this.gift_limit);
            let interval = (this.total_length - 100) / passenger_num;
            this.passenger_idx = 0;
            for (let idx = 0; idx < passenger_num; idx++) {
                let train_idx = Math.floor(idx / this.train_capcity);
                let gift_idx = idx - train_idx * this.train_capcity;
                let pos_idx = train_idx % 2;
                this.up_pos.x = 0;
                this.up_pos.y = 1;
                this.up_pos.z = 0;
                let passenger_dis = interval * (idx + .5 + Math.random()) + 50;
                let race_info = this.get_race_pos(passenger_dis);
                let passenger_type = this.gift_pos_list[pos_idx][gift_idx].model_type;
                let passenger_model = igc.phone_manager.instance.call(phone_ids.get_model, {
                    model_type: passenger_type
                });
                this._scene.addChild(passenger_model);
                Laya.Vector3.cross(race_info.forward, this.up_pos, this.right_pos);
                let passenger_pos = race_info.position.clone();
                Laya.Vector3.normalize(this.right_pos, this.right_pos);
                let up_dis = 1 + Math.random() * 2;
                Laya.Vector3.scale(this.up_pos, up_dis, this.up_pos);
                let right_dis = 3 + Math.random() * 2;
                if (idx % 2 == 1) {
                    Laya.Vector3.scale(this.right_pos, right_dis, this.right_pos);
                } else {
                    Laya.Vector3.scale(this.right_pos, -right_dis, this.right_pos);
                }
                Laya.Vector3.add(passenger_pos, this.up_pos, passenger_pos);
                Laya.Vector3.add(passenger_pos, this.right_pos, passenger_pos);
                passenger_model.transform.position = passenger_pos;
                passenger_model.transform.localScale = new Laya.Vector3(1, 1, 1);
                passenger_model.transform.localRotationEuler = new Laya.Vector3(0, 0, 0);
                let gift_model = passenger_model.getChildAt(0);
                gift_model.meshRenderer.material.albedoIntensity = 1.5;
                this.passenger_list.push({
                    dis: passenger_dis,
                    model_type: passenger_type,
                    model: passenger_model,
                    pos_idx: pos_idx
                });
            }
        }
        recycle_passenger() {
            for (let idx = 0; idx < this.passenger_list.length; idx++) {
                igc.phone_manager.instance.call(phone_ids.recycle_model, {
                    model_type: this.passenger_list[idx].model_type,
                    model: this.passenger_list[idx].model
                });
            }
            this.passenger_list = [];
        }
        set_train_pos(dt, b_init) {
            let race_info = this.get_race_pos(this.run_dis);
            this.set_pos(this.train_head, race_info, 0);
            let head_forward = new Laya.Vector3(0, 0, 0);
            race_info.forward.cloneTo(head_forward);
            let dot_delta = 0;
            let b_trun = false;
            let b_huohua = false;
            let dot_x = 0;
            let body_coal_num = this.train_speed.body_coal_num;
            Laya.Vector3.cross(head_forward, this.up_v3, this.right_v3);
            let curr_body = Math.ceil(this.train_speed.left_coal / body_coal_num);
            let curr_body_coal_num = this.train_speed.left_coal - (curr_body - 1) * body_coal_num;
            let dot_sum = 0;
            for (let idx = 0; idx < this.train_body.length; idx++) {
                let local_y = this.first_next - this.body_length * idx;
                let race_info = this.get_race_pos(this.run_dis + local_y);
                let dot_forward = Laya.Vector3.dot(race_info.forward, head_forward);
                let temp_dot_delta = Math.sqrt(1 - dot_forward * dot_forward);
                let temp_dot_x = Laya.Vector3.dot(race_info.forward, this.right_v3);
                dot_sum += Math.abs(temp_dot_delta);
                if (Math.abs(temp_dot_delta) > Math.abs(dot_delta)) {
                    dot_delta = temp_dot_delta;
                }
                if (Math.abs(temp_dot_x) > Math.abs(dot_x)) {
                    dot_x = temp_dot_x;
                }
                if (Math.abs(dot_delta) > this.train_speed.min_angle) {
                    b_trun = true;
                }
                if (Math.abs(dot_delta) > this.train_speed.min_huohua) {
                    b_huohua = true;
                }
                this.set_pos(this.train_body[idx], race_info, idx + 1);
            }
            if (dot_sum / this.train_body.length > this.train_speed.min_angle) {
                b_trun = true;
            } else {
                b_trun = false;
            }
            if (!b_init) {
                this.train_speed.update_turn(b_trun, dt);
                if (this.left_huohua && this._is_play) {
                    if (b_huohua && this.train_speed.is_show_huohua) {
                        this.left_huohua.active = dot_x < 0;
                        this.right_huohua.active = dot_x > 0;
                    } else {
                        this.left_huohua.active = false;
                        this.right_huohua.active = false;
                    }
                }
            }
        }
        up_train(run_dis) {
            // nativeOpen("游戏页",1)
            if (this.passenger_list[this.passenger_idx] && this.passenger_list[this.passenger_idx].dis <= run_dis) {
                let fly_step = 0;
                let fly_sum = 7;
                let train_idx = Math.floor(this.passenger_idx / this.train_capcity);
                let gift_idx = this.passenger_idx - train_idx * this.train_capcity;
                let pos_idx = this.passenger_list[this.passenger_idx].pos_idx;
                let cheDou = utils_manager.GetChildByName(this.train_body[train_idx], "cheDou");
                let child = this.passenger_list[this.passenger_idx].model;
                let fake_gift = utils_manager.GetChildByName(this.train_body[train_idx], "fake_gift");
                fake_gift.transform.position = child.transform.position;
                cheDou.addChild(this.passenger_list[this.passenger_idx].model);
                child.transform.localPosition = fake_gift.transform.localPosition;
                let target_rotaion = this.gift_pos_list[pos_idx][gift_idx].rotation.clone();
                let target_postion = this.gift_pos_list[pos_idx][gift_idx].position.clone();
                let target_scale = this.gift_pos_list[pos_idx][gift_idx].scale.clone();
                let begin_rotaion = child.transform.localRotationEuler.clone();
                let begin_postion = child.transform.localPosition.clone();
                let begin_scale = child.transform.localScale.clone();
                let curr_rotaion = child.transform.localRotationEuler;
                let curr_postion = child.transform.localPosition.clone();
                let curr_scale = child.transform.localScale;
                let fly_action = function() {
                    fly_step++;
                    Laya.Vector3.lerp(begin_rotaion, target_rotaion, fly_step / fly_sum, curr_rotaion);
                    Laya.Vector3.lerp(begin_postion, target_postion, fly_step / fly_sum, curr_postion);
                    Laya.Vector3.lerp(begin_scale, target_scale, fly_step / fly_sum, curr_scale);
                    child.transform.localRotationEuler = curr_rotaion;
                    child.transform.localPosition = curr_postion;
                    child.transform.localScale = target_scale;
                    if (fly_step >= fly_sum) {
                        child.transform.localRotationEuler = target_rotaion;
                        child.transform.localPosition = target_postion;
                        child.transform.localScale = target_scale;
                        Laya.timer.clear(this, fly_action);
                    }
                };
                Laya.timer.loop(1e3 / 60, this, fly_action);
                this.passenger_idx++;
            }
        }
        set_coal() {}
        set_pos(obj, race_info, idx) {
            if (!this.train_pos_list[idx]) {
                this.train_pos_list.push(new Laya.Vector3(0, 0, 0));
            }
            if (this.train_pos_list[idx]) {
                race_info.position.cloneTo(this.train_pos_list[idx]);
                obj.transform.position = this.train_pos_list[idx];
                obj.transform.lookAt(race_info.next, new Laya.Vector3(0, 1, 0), false);
            }
        }
        init_model() {}
        reborn_train() {
            this.b_reborn = true;
            this.train_speed.reborn();
            this.stop_train_fly();
            this.reset_gift();
        }
        init_final() {}
        onUpdate() {
            if (this._is_play) {
                let dt = Laya.timer.delta / 1e3;
                dt = Math.min(dt, .1);
                this.do_update(dt);
            }
        }
        do_update(dt) {
            if (this.run_dis > this.total_length - this.train_speed.end_dis) {
                this.time_scale = Math.max(0, this.time_scale - dt * 2);
                if (this.time_scale <= 0 || this.run_dis > this.total_length - 3) {
                    console.log("broadcast_ids.chapter_success");
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.chapter_success, {});
                    return;
                }
            }
            let race_info = this.get_race_pos(this.run_dis);
            this.train_speed.update_speed(race_info.forward, dt, this.run_dis < this.begin_dis);
            if (this.train_speed.move_speed > 0) {
                this.move_type = e_move_type.run;
            } else {
                this.move_type = e_move_type.empty;
            }
            if (this.train_speed.move_speed == 0) {
                return;
            }
            this.run_dis += this.train_speed.move_speed * this.time_scale * dt;
            this.run_max = Math.max(this.run_dis, this.run_max);
            race_info = this.get_race_pos(this.run_dis);
            race_info.position.cloneTo(this.player_position);
            this.position = this.player_position;
            race_info.position.cloneTo(this.camera_position);
            this.player_camera.transform.position = this.camera_position;
            this.player.transform.lookAt(race_info.next, this.upDirection, false);
            this.look_dis += this.train_speed.move_speed * this.time_scale * dt * 1.5;
            this.look_dis = Math.max(this.run_dis, Math.min(this.look_dis, this.run_dis + this.train_speed.pre_look_dis));
            if (this.lerp_frame >= this.lerp_count) {
                this.lerp_frame = 0;
                let camera_info = this.get_race_pos(this.look_dis);
                camera_info.position.cloneTo(this.fake_eye.transform.position);
                this.fake_eye.transform.lookAt(camera_info.next, this.upDirection, false);
            } else {
                this.lerp_frame++;
            }
            this.clock_rotation += this.clock_dirction * dt * this.train_speed.clock_speed;
            if (this.clock_rotation >= this.train_speed.clock_max) {
                this.clock_dirction = -1;
                this.clock_rotation = this.train_speed.clock_max;
            } else if (this.clock_rotation <= -this.train_speed.clock_max) {
                this.clock_dirction = 1;
                this.clock_rotation = -this.train_speed.clock_max;
            }
            this.player_camera.transform.rotation = this.fake_eye.transform.rotation;
            let localRotationEuler = new Laya.Vector3(0, 1, 0);
            localRotationEuler.z = this.player_camera.transform.localRotationEulerZ;
            localRotationEuler.y = this.player_camera.transform.localRotationEulerY + this.clock_rotation;
            localRotationEuler.x = this.player.transform.localRotationEulerX;
            let frame = 10;
            if (Math.abs(this.preLocalRotation.x - localRotationEuler.x) > .1 || Math.abs(this.preLocalRotation.y - localRotationEuler.y) > .1) {
                let p1x = Math.abs(this.preLocalRotation.x - localRotationEuler.x);
                let p1y = Math.abs(this.preLocalRotation.y - localRotationEuler.y);
                if (p1y > 180 || p1x > 180) {
                    console.log(this.preLocalRotation.y, localRotationEuler.y);
                    if (localRotationEuler.y > this.preLocalRotation.y) {
                        this.preLocalRotation.y += 360;
                    } else {
                        this.preLocalRotation.y -= 360;
                    }
                } else {}
                frame = Math.floor(Math.max(Math.abs(this.preLocalRotation.x - localRotationEuler.x), Math.abs(this.preLocalRotation.y - localRotationEuler.y)));
                frame = 20;
                Laya.Vector3.lerp(this.preLocalRotation, localRotationEuler, 1 / frame, localRotationEuler);
            }
            this.player_camera.transform.localRotationEuler = localRotationEuler;
            localRotationEuler.cloneTo(this.preLocalRotation);
            if (this.player_camera.transform.localRotationEuler.y - this.player.transform.localRotationEuler.y > 90) {
                this.clock_dirction = -1;
            } else if (this.player_camera.transform.localRotationEuler.y - this.player.transform.localRotationEuler.y < -90) {
                this.clock_dirction = 1;
            }
            if (this._is_play) {
                this.set_train_pos(dt, false);
                this.up_train(this.run_dis);
                if (this.is_mouse_down && this.train_speed.burn_progress > 0) {
                    this.train_yan.active = true;
                } else {
                    this.train_yan.active = false;
                }
            } else {
                this.train_yan.active = false;
            }
            igc.broadcast_manager.instance.broadcast(broadcast_ids.update_chapter_info, {
                progress: this.get_chapter_progress()
            });
        }
        get_chapter_progress() {
            return this.run_max / this.total_length;
        }
        reset() {
            this.init_train();
        }
        play() {
            let self = this;
            this._is_begin = true;
            this._is_play = true;
        }
        relife() {
            if (this._is_play == false) {
                this.reborn_train();
            }
        }
        delay_relife() {
            this._wudi_state = false;
        }
        get_player_play() {
            return this._is_play;
        }
        get_player_begin() {
            return this._is_begin;
        }
        win() {
            if (this._is_play == true) {
                this.left_huohua.active = false;
                this.right_huohua.active = false;
                this.train_yan.active = false;
                this.effect_lihua.active = true;
                this._is_play = false;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.play_sound, {
                    id: "win"
                });
                let scene_level = igc.phone_manager.instance.call(phone_ids.get_scene_level);
                resource_manager.instance.load_battle_must_async_fast(scene_level, function() {}, false);
                this.close_guide();
                this.move_type = e_move_type.empty;
            }
        }
        lose(id, msg) {
            if (this._is_play == true) {
                console.log("character_player lose");
                this.left_huohua.active = false;
                this.right_huohua.active = false;
                this.train_yan.active = false;
                this._is_play = false;
                this.move_type = e_move_type.empty;
                this.close_guide();
            }
        }
        train_turn_over(id, param) {
            let self = this;
            this.lose(0, {});
            Laya.timer.frameOnce(2, this, function() {
                self.do_turn_over();
            });
            Laya.timer.once(1500, this, function() {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.chapter_fail, {
                    fail_reason: e_fail_reason.turn_over
                });
            });
        }
        do_train_fly(obj, race_info) {
            let self = this;
            let begin_pos = new Laya.Vector3(0, 0, 0);
            race_info.position.cloneTo(begin_pos);
            let begin_forward = new Laya.Vector3(0, 0, 0);
            race_info.forward.cloneTo(begin_forward);
            obj.transform.position = begin_pos.clone();
            obj.transform.lookAt(race_info.next, this.upDirection, false);
            let fly_dis = 0;
            let fly_speed = 10 + Math.random() * 20;
            let fly_pos = new Laya.Vector3(0, 0, 0);
            let dt = 30 / 1e3;
            let fly_duration = 0;
            let rotate_speed = new Laya.Vector3(1 + Math.random(), 1 + Math.random(), 1 + Math.random());
            let fly_action = function() {
                fly_dis += fly_speed * dt;
                fly_duration += dt;
                Laya.Vector3.scale(begin_forward, fly_dis, fly_pos);
                Laya.Vector3.add(begin_pos, fly_pos, fly_pos);
                obj.transform.position = fly_pos;
                obj.transform.rotate(rotate_speed, true, false);
                if (fly_duration >= 5) {
                    self.stop_train_fly();
                }
            };
            this.fly_action_list.push(fly_action);
            Laya.timer.loop(dt * 1e3, this, fly_action);
        }
        stop_train_fly() {
            if (this.fly_action_list[0]) {
                for (let idx in this.fly_action_list) {
                    Laya.timer.clear(this, this.fly_action_list[idx]);
                }
                this.fly_action_list = [];
            }
        }
        do_turn_over() {
            this.train_yan.active = false;
            let race_info = this.get_race_pos(this.run_dis);
            this.do_train_fly(this.train_head, race_info);
            let body_coal_num = this.train_speed.body_coal_num;
            for (let idx = 0; idx < this.train_body.length; idx++) {
                let local_y = this.first_next - this.body_length * idx;
                let race_info = this.get_race_pos(this.run_dis + local_y);
                let body = utils_manager.GetChildByName(this.train_body[idx], "body").getChildAt(0);
                for (let coal_idx = 0; coal_idx < body.numChildren; coal_idx++) {
                    this.do_train_fly(body.getChildAt(coal_idx), race_info);
                }
                this.do_train_fly(this.train_body[idx], race_info);
            }
        }
        onTriggerEnter(other) {}
        onTriggerStay(other) {}
        onTriggerExit(other) {}
        onCollisionEnter(collision) {}
        onCollisionStay(collision) {}
        onCollisionExit(collision) {}
    }
    class ui_guess_like extends ui.scenes.guess_likeUI {
        constructor() {
            super();
            this.is_move = false;
            this.is_init_success = false;
            this.is_support_push = false;
            this.updateIconInfo = {};
            this.gifAniMap = {};
            this.show_update_icon = null;
            this.bUpdateIconShowing = false;
            this.hGuessLikeCellList = [];
            this.hPreStageX = 0;
            this.bHGuessLikeAutoMoving = true;
            this.vGuessLikeCellList = [];
            this.vPreStageY = 0;
            this.bVGuessLikeAutoMoving = true;
            this.vGuessForbidMove = false;
            this.mostPopularCellList = [];
            this.bTest = false;
            this.chapterId = 0;
            this.addListener();
            this.checkIsCanOpenMultual();
            let channel_type = global.game.channel_type;
            this.mutualPushDefaultCfg = igc.igc_config_manager.instance.configs_data["mutual_push"];
            if (channel_type == igc.e_channel_type.tt) {
                this.mutualPushDefaultCfg = igc.igc_config_manager.instance.configs_data["mutual_push_tt"];
            }
            if (this.bTest) {
                this.timerOnce(100, this, () => {
                    this.onPushConfigLoaded(null, true);
                    this.showHGuessLikePanel(null, {
                        isShow: true
                    });
                    this.showVGuessLikePanel(null, {
                        isShow: true
                    });
                    this.showGifPanel(null, {
                        isShow: true
                    });
                    this.showMostPopularPanel(null, {
                        isShow: true
                    });
                });
            }
        }
        addListener() {
            this.show_btn.on(Laya.Event.CLICK, this, this.onButtonClickShow);
            this.hide_btn.on(Laya.Event.CLICK, this, this.onButtonClickHide);
            this.vGuessLikePanel.on(Laya.Event.MOUSE_DOWN, this, this.onVGuessLikeMouseDown);
            this.vGuessLikePanel.on(Laya.Event.MOUSE_UP, this, this.onVGuessLikeMouseUp);
            this.vGuessLikePanel.on(Laya.Event.MOUSE_MOVE, this, this.onVGuessLikeMouseMove);
            this.gifRoot.on(Laya.Event.CLICK, this, this.onClickGif);
            this.hGuessLikePanel.on(Laya.Event.MOUSE_DOWN, this, this.onHGuessLikeMouseDown);
            this.hGuessLikePanel.on(Laya.Event.MOUSE_UP, this, this.onHGuessLikeMouseUp);
            this.hGuessLikePanel.on(Laya.Event.MOUSE_MOVE, this, this.onHGuessLikeMouseMove);
            this.on(Laya.Event.REMOVED, this, this.onRelease);
            console.log("xiejinhui  互推事件监听");
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.multual_push_temp_show, this, this.onAdOpened);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.multual_push_show, this, this.onPushConfigLoaded);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.multual_push_show_side_guess_like, this, this.showVGuessLikePanel);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.multual_push_show_update_icon, this, this.showGifPanel);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.multual_push_show_horizontal_guess_like, this, this.showHGuessLikePanel);
            igc.broadcast_manager.instance.add_listener(igc.igc_broadcast_ids.multual_push_show_most_popular, this, this.showMostPopularPanel);
        }
        onRelease() {
            console.log("xiejinhui 销毁互推资源");
            this.removeEventListener();
        }
        removeEventListener() {
            this.show_btn.off(Laya.Event.CLICK, this, this.onButtonClickShow);
            this.hide_btn.off(Laya.Event.CLICK, this, this.onButtonClickHide);
            console.log("xiejinhui  销毁互推事件监听");
            igc.broadcast_manager.instance.remove_listener(igc.igc_broadcast_ids.multual_push_temp_show, this, this.onAdOpened);
            igc.broadcast_manager.instance.remove_listener(igc.igc_broadcast_ids.multual_push_show, this, this.onPushConfigLoaded);
            igc.broadcast_manager.instance.remove_listener(igc.igc_broadcast_ids.multual_push_show_side_guess_like, this, this.showVGuessLikePanel);
            igc.broadcast_manager.instance.remove_listener(igc.igc_broadcast_ids.multual_push_show_update_icon, this, this.showGifPanel);
            igc.broadcast_manager.instance.remove_listener(igc.igc_broadcast_ids.multual_push_show_horizontal_guess_like, this, this.showHGuessLikePanel);
            igc.broadcast_manager.instance.remove_listener(igc.igc_broadcast_ids.multual_push_show_most_popular, this, this.showMostPopularPanel);
            this.vGuessLikePanel.off(Laya.Event.MOUSE_DOWN, this, this.onVGuessLikeMouseDown);
            this.vGuessLikePanel.off(Laya.Event.MOUSE_UP, this, this.onVGuessLikeMouseUp);
            this.vGuessLikePanel.off(Laya.Event.MOUSE_MOVE, this, this.onVGuessLikeMouseMove);
            this.gifRoot.off(Laya.Event.CLICK, this, this.onClickGif);
            this.hGuessLikePanel.off(Laya.Event.MOUSE_DOWN, this, this.onHGuessLikeMouseDown);
            this.hGuessLikePanel.off(Laya.Event.MOUSE_UP, this, this.onHGuessLikeMouseUp);
            this.hGuessLikePanel.off(Laya.Event.MOUSE_MOVE, this, this.onHGuessLikeMouseMove);
        }
        onAdOpened(id, bOpen) {
            this.visible = !bOpen;
        }
        onPushConfigLoaded(id, isSuccess) {
            console.log("xiejinhui 互推初始化结果", isSuccess);
            if (isSuccess) {
                this.mutualPushDefaultCfg = igc.igc_config_manager.instance.configs_data["mutual_push"];
                let channel_type = global.game.channel_type;
                if (channel_type == igc.e_channel_type.tt) {
                    this.mutualPushDefaultCfg = igc.igc_config_manager.instance.configs_data["mutual_push_tt"];
                }
                this.initGif();
                this.initVGuessLike();
                this.initHGuessLike();
                this.initMostPopular();
                this.is_init_success = true;
            } else {
                this.is_init_success = false;
                this.destroy();
            }
        }
        compareVersion(v1, v2) {
            if (v1 === v2) {
                return 1;
            }
            let v1_arr = v1.split(".");
            let v2_arr = v2.split(".");
            let index = 0;
            let minLen = Math.min(v1_arr.length, v2_arr.length);
            let diff = 0;
            while (index < minLen && (diff = parseInt(v1_arr[index]) - parseInt(v2_arr[index])) == 0) {
                index++;
            }
            if (diff == 0) {
                for (let i = index; i < v1_arr.length; i++) {
                    if (parseInt(v1_arr[i]) > 0) {
                        return 2;
                    }
                }
                for (let i = index; i < v2_arr.length; i++) {
                    if (parseInt(v2_arr[i]) > 0) {
                        return 3;
                    }
                }
                return 1;
            } else {
                return diff > 0 ? 2 : 3;
            }
        }
        checkIsCanOpenMultual() {
            let self = this;
            if (global.game.channel_type == igc.e_channel_type.oppo_qg && window["qg"]) {
                window["qg"].getSystemInfo({
                    success: function(res) {
                        let version = res["COREVersion"];
                        let result = self.compareVersion(version, "1.3.2");
                        console.log("xiejinhui 设备版本号", version, "是否开启互推：", result != 3);
                        if (result == 1 || result == 2) {
                            self.is_support_push = true;
                            if (self.is_init_success) {}
                        } else {
                            console.log("xiejinhui 销毁互推");
                            self.is_support_push = false;
                            self.destroy();
                        }
                    },
                    fail: function() {
                        self.is_support_push = false;
                        self.destroy();
                        console.log("xiejinhui 获取系统信息失败");
                    },
                    complete: function() {}
                });
            }
        }
        onButtonClickShow() {
            let self = this;
            if (self.is_move) {
                return;
            }
            self.is_move = true;
            let posX = self.vGuessLikeRoot.x + 320;
            Laya.Tween.to(self.vGuessLikeRoot, {
                x: posX
            }, 1e3, Laya.Ease.backOut, Laya.Handler.create(self, function() {
                self.is_move = false;
                self.show_btn.visible = false;
                self.hide_btn.visible = true;
            }));
        }
        onButtonClickHide() {
            let self = this;
            if (self.is_move) {
                return;
            }
            self.is_move = true;
            let posX = self.vGuessLikeRoot.x - 320;
            Laya.Tween.to(self.vGuessLikeRoot, {
                x: posX
            }, 1e3, Laya.Ease.backOut, Laya.Handler.create(self, function() {
                self.is_move = false;
                self.show_btn.visible = true;
                self.hide_btn.visible = false;
            }));
        }
        initVGuessLike() {
            this.vGuessLikeRoot.visible = false;
            this.show_btn.visible = true;
            this.hide_btn.visible = false;
            let vGuessLikeData = igc.multual_push_manager.instance.get_multual_push_info(igc.e_push_type.side).cellList;
            if (this.bTest) vGuessLikeData = this.mutualPushDefaultCfg.side.cellList;
            this.vGuessForbidMove = vGuessLikeData.length <= 5;
            let vBox = this.vGuessLikePanel.content.getChildAt(0);
            for (let i = 0; i < vGuessLikeData.length; ++i) {
                if (i >= vBox.numChildren) break;
                let item = vBox.getChildAt(i);
                item.tag = i;
                let info = {};
                this.vGuessLikeCellList[i] = info;
                info.data = vGuessLikeData[i];
                info.gamePlace = i + 1;
                info.item = item;
                info.index = 0;
            }
            for (let j = vBox.numChildren - 1; j >= vGuessLikeData.length; --j) {
                vBox.removeChildAt(j);
            }
        }
        showVGuessLikePanel(id, args) {
            if (!this.is_init_success) {
                return;
            }
            if (igc.multual_push_manager.instance.check_is_limit_multual(igc.e_push_type.side)) {
                return;
            }
            if (args.chapterId) {
                this.chapterId = args.chapterId;
            }
            if (args.isShow) {
                let position = args.position;
                if (position) {
                    for (let key in position) {
                        this.vGuessLikeRoot[key] = position[key];
                    }
                }
                this.vGuessUiPlace = args.uiPlaceType;
                if (this.vGuessLikeRoot.visible) return;
                this.vGuessLikeRoot.visible = true;
                this.updateVGuessLikeGameList();
                this.frameLoop(1, this, this.vGuessLikeAutoMove, null, true);
            } else {
                this.vGuessLikeRoot.visible = false;
                this.clearTimer(this, this.vGuessLikeAutoMove);
            }
        }
        updateVGuessLikeGameList() {
            var r = this.vGuessLikePanel.content.scrollRect;
            r.y = 0;
            this.vGuessLikePanel.content.scrollRect = r;
            for (let i = 0; i < this.vGuessLikeCellList.length; ++i) {
                let info = this.vGuessLikeCellList[i];
                info.curGameData = this.refreshGame(info);
                let item = info.item;
                let iconImage = item.getChildByName("app_icon");
                iconImage.skin = info.curGameData.icon;
                let nameLabel = item.getChildByName("app_name");
                nameLabel.text = info.curGameData.name;
                let tag = item.getChildByName("app_tag");
                tag.visible = info.curGameData.popular == 1;
            }
        }
        onVGuessLikeMouseDown(e) {
            this.vPreStageY = e.stageY;
            this.bVGuessLikeAutoMoving = false;
        }
        onVGuessLikeMouseUp(e) {
            this.bVGuessLikeAutoMoving = true;
            let scrollRectY = this.vGuessLikePanel.content.scrollRect.y;
            let y = this.vGuessLikePanel.mouseY + scrollRectY;
            let box = this.vGuessLikePanel.content.getChildAt(0);
            let item = box.getChildAt(0);
            let index = Math.floor(y / (item.height + box.space));
            let clickItem = box.getChildAt(index);
            let cell = this.vGuessLikeCellList[clickItem.tag];
            let gameData = cell.curGameData;
            let relativeIndex = (clickItem.y + clickItem.height - scrollRectY) / (clickItem.height + box.space);
            relativeIndex = Math.ceil(relativeIndex);
            relativeIndex = clickItem.tag + 1;
            let param = {
                app_id: gameData.pkgName + "",
                targetAppId: gameData.appId + "",
                eventId: igc.e_push_type.side,
                placeType: this.vGuessUiPlace,
                placeId: relativeIndex,
                chapterId: this.chapterId,
                on_succeed: function() {
                    console.log("navigate_to_mini_program success pkgName ->", gameData.pkgName);
                }
            };
            igc.multual_push_manager.instance.navigate_to_mini_program(param);
            console.log("navigate_to_mini_program name ->", gameData.name);
        }
        onVGuessLikeMouseMove(e) {
            let delta = e.stageY - this.vPreStageY;
            this.vPreStageY = e.stageY;
            this.vGuessLikeOffset(delta);
        }
        vGuessLikeAutoMove() {
            if (this.bVGuessLikeAutoMoving) this.vGuessLikeOffset(-100 / 1e3 * Laya.timer.delta);
        }
        vGuessLikeOffset(delta) {
            if (this.vGuessForbidMove) return;
            var r = this.vGuessLikePanel.content.scrollRect;
            r.y -= delta;
            let box = this.vGuessLikePanel.content.getChildAt(0);
            if (delta > 0) {
                let lastItem = box.getChildAt(box.numChildren - 1);
                if (r.y + r.height < lastItem.y - box.space) {
                    lastItem.y = -1;
                    lastItem.parent.setChildIndex(lastItem, 0);
                    box.refresh();
                    r.y += lastItem.height + box.space;
                }
            } else {
                let firstItem = box.getChildAt(0);
                if (firstItem.y + firstItem.height + box.space < r.y) {
                    firstItem.removeSelf();
                    firstItem.y = box.height;
                    box.addChild(firstItem);
                    box.refresh();
                    r.y -= firstItem.height + box.space;
                }
            }
            this.vGuessLikePanel.content.scrollRect = r;
        }
        initGif() {
            this.gifRoot.visible = false;
            this.updateIconInfo = {};
            let data = igc.multual_push_manager.instance.get_multual_push_info(igc.e_push_type.gif);
            if (this.bTest) data = this.mutualPushDefaultCfg.update_icon;
            this.updateIconInfo.data = data;
            this.updateIconInfo.gamePlace = 1;
            this.updateIconInfo.item = null;
            this.updateIconInfo.index = 0;
        }
        showGifPanel(id, args) {
            if (!this.is_init_success) {
                return;
            }
            if (igc.multual_push_manager.instance.check_is_limit_multual(igc.e_push_type.gif)) {
                return;
            }
            if (args.chapterId) {
                this.chapterId = args.chapterId;
            }
            if (args.isShow) {
                let position = args.position;
                if (position) {
                    for (let key in position) {
                        this.gifRoot[key] = position[key];
                    }
                }
                this.gifUiPlace = args.uiPlaceType;
                this.bUpdateIconShowing = true;
                if (this.gifIcon) this.gifRoot.visible = true;
                this.changeGif();
                this.timerLoop(this.updateIconInfo.data.gifInterval * 1e3, this, this.changeGif);
            } else {
                this.gifRoot.visible = false;
                this.bUpdateIconShowing = false;
                this.clearTimer(this, this.changeGif);
            }
        }
        changeGif() {
            this.updateIconInfo.curGameData = this.refreshGame(this.updateIconInfo);
            let gifUrl = this.updateIconInfo.curGameData.gif;
            let gif = this.gifAniMap[gifUrl];
            if (!gif) {
                gif = new Laya.Animation();
                this.update_icon.addChild(gif);
                this.gifAniMap[gifUrl] = gif;
                gif.loadAtlas(gifUrl, Laya.Handler.create(this, () => {
                    if (this.gifIcon) {
                        this.gifIcon.visible = false;
                        this.gifIcon.active = false;
                    } else {
                        if (this.bUpdateIconShowing) this.gifRoot.visible = true;
                    }
                    gif.play(0, true);
                    this.gifIcon = gif;
                }));
            } else {
                if (this.gifIcon) {
                    this.gifIcon.visible = false;
                    this.gifIcon.active = false;
                }
                gif.active = true;
                gif.visible = true;
                this.gifIcon = gif;
            }
        }
        onClickGif() {
            console.log("xiejinhui 点击了轮播");
            let gameData = this.updateIconInfo.curGameData;
            let placeId = this.updateIconInfo.data.displayMode == 2 ? 999 : this.updateIconInfo.index + 1;
            let param = {
                app_id: gameData.pkgName + "",
                targetAppId: gameData.appId + "",
                eventId: igc.e_push_type.gif,
                placeType: this.gifUiPlace,
                placeId: placeId,
                chapterId: this.chapterId,
                on_succeed: function() {
                    console.log("navigate_to_mini_program success pkgName ->", gameData.pkgName);
                }
            };
            igc.multual_push_manager.instance.navigate_to_mini_program(param);
        }
        initHGuessLike() {
            this.hGuessLikeRoot.visible = false;
            let hGuessLikeData = igc.multual_push_manager.instance.get_multual_push_info(igc.e_push_type.guess).cellList;
            if (this.bTest) hGuessLikeData = this.mutualPushDefaultCfg.guess_like.cellList;
            let hBox = this.hGuessLikePanel.content.getChildAt(0);
            for (let i = 0; i < hGuessLikeData.length; ++i) {
                if (i >= hBox.numChildren) break;
                let item = hBox.getChildAt(i);
                item.tag = i;
                let info = {};
                this.hGuessLikeCellList[i] = info;
                info.data = hGuessLikeData[i];
                info.gamePlace = i + 1;
                info.item = item;
                info.index = 0;
            }
            for (let j = hBox.numChildren - 1; j >= hGuessLikeData.length; --j) {
                hBox.removeChildAt(j);
            }
        }
        showHGuessLikePanel(id, args) {
            if (!this.is_init_success) {
                return;
            }
            if (igc.multual_push_manager.instance.check_is_limit_multual(igc.e_push_type.guess)) {
                return;
            }
            if (args.chapterId) {
                this.chapterId = args.chapterId;
            }
            if (args.isShow) {
                let position = args.position;
                if (position) {
                    for (let key in position) {
                        this.hGuessLikeRoot[key] = position[key];
                    }
                }
                this.hGuessUiPlace = args.uiPlaceType;
                this.hGuessLikeRoot.visible = true;
                this.updateHGuessLikeGameList();
                this.frameLoop(1, this, this.hGuessLikeAutoMove, null, true);
            } else {
                this.hGuessLikeRoot.visible = false;
                this.clearTimer(this, this.hGuessLikeAutoMove);
            }
        }
        updateHGuessLikeGameList() {
            var r = this.hGuessLikePanel.content.scrollRect;
            r.x = 0;
            this.hGuessLikePanel.content.scrollRect = r;
            for (let i = 0; i < this.hGuessLikeCellList.length; ++i) {
                let info = this.hGuessLikeCellList[i];
                info.curGameData = this.refreshGame(info);
                let item = info.item;
                let iconImage = item.getChildAt(0).getChildByName("gameIcon");
                iconImage.skin = info.curGameData.icon;
                let nameLabel = item.getChildAt(0).getChildByName("name");
                nameLabel.text = info.curGameData.name;
            }
        }
        onHGuessLikeMouseDown(e) {
            this.hPreStageX = e.stageX;
            this.bHGuessLikeAutoMoving = false;
        }
        onHGuessLikeMouseUp(e) {
            this.bHGuessLikeAutoMoving = true;
            let scrollRectX = this.hGuessLikePanel.content.scrollRect.x;
            let x = this.hGuessLikePanel.mouseX + scrollRectX;
            let box = this.hGuessLikePanel.content.getChildAt(0);
            let item = box.getChildAt(0);
            let index = Math.floor(x / (item.width + box.space));
            let clickItem = box.getChildAt(index);
            let cell = this.hGuessLikeCellList[clickItem.tag];
            let gameData = cell.curGameData;
            let relativeIndex = (clickItem.x + clickItem.width - scrollRectX) / (clickItem.width + box.space);
            relativeIndex = Math.ceil(relativeIndex);
            relativeIndex = clickItem.tag + 1;
            let param = {
                app_id: gameData.pkgName + "",
                targetAppId: gameData.appId + "",
                eventId: igc.e_push_type.guess,
                placeType: this.hGuessUiPlace,
                placeId: relativeIndex,
                chapterId: this.chapterId,
                on_succeed: function() {
                    console.log("navigate_to_mini_program success pkgName ->", gameData.pkgName);
                }
            };
            igc.multual_push_manager.instance.navigate_to_mini_program(param);
            console.log("navigate_to_mini_program name ->", gameData.name, relativeIndex);
        }
        onHGuessLikeMouseMove(e) {
            let delta = e.stageX - this.hPreStageX;
            this.hPreStageX = e.stageX;
            this.hGuessLikeOffset(delta);
        }
        hGuessLikeAutoMove() {
            if (this.bHGuessLikeAutoMoving) this.hGuessLikeOffset(-100 / 1e3 * Laya.timer.delta);
        }
        hGuessLikeOffset(delta) {
            var r = this.hGuessLikePanel.content.scrollRect;
            r.x -= delta;
            let box = this.hGuessLikePanel.content.getChildAt(0);
            if (delta > 0) {
                let lastItem = box.getChildAt(box.numChildren - 1);
                if (r.x + r.width < lastItem.x - box.space) {
                    lastItem.x = -1;
                    lastItem.parent.setChildIndex(lastItem, 0);
                    box.refresh();
                    r.x += lastItem.width + box.space;
                }
            } else {
                let firstItem = box.getChildAt(0);
                if (firstItem.x + firstItem.width + box.space < r.x) {
                    firstItem.removeSelf();
                    firstItem.x = box.width;
                    box.addChild(firstItem);
                    box.refresh();
                    r.x -= firstItem.width + box.space;
                }
            }
            this.hGuessLikePanel.content.scrollRect = r;
        }
        initMostPopular() {
            this.mostPopularRoot.visible = false;
            let mostPopularData = igc.multual_push_manager.instance.get_multual_push_info(igc.e_push_type.popular).cellList;
            if (this.bTest) mostPopularData = this.mutualPushDefaultCfg.most_popular.cellList;
            let box = this.mostPopularRoot.getChildByName("box");
            for (let i = 0; i < mostPopularData.length; ++i) {
                if (i >= box.numChildren) break;
                let item = box.getChildByName("game" + (i + 1));
                item.tag = i;
                let info = {};
                this.mostPopularCellList[i] = info;
                info.data = mostPopularData[i];
                info.gamePlace = i + 1;
                info.item = item;
                info.index = 0;
                info.curGameData = null;
                item.on(Laya.Event.CLICK, this, this.onMostPopularClicked);
            }
            for (let j = box.numChildren - 1; j >= mostPopularData.length; --j) {
                box.removeChildAt(j);
            }
        }
        onMostPopularClicked(e) {
            let target = e.currentTarget;
            let cell = this.mostPopularCellList[target.tag];
            let gameData = cell.curGameData;
            let param = {
                app_id: gameData.pkgName + "",
                targetAppId: gameData.appId + "",
                eventId: igc.e_push_type.popular,
                placeType: this.popularUiPlace,
                placeId: target.tag + 1,
                chapterId: this.chapterId,
                on_succeed: function() {
                    console.log("navigate_to_mini_program success pkgName ->", gameData.pkgName);
                }
            };
            igc.multual_push_manager.instance.navigate_to_mini_program(param);
            console.log("navigate_to_mini_program name ->", gameData.name);
        }
        showMostPopularPanel(id, args) {
            if (!this.is_init_success) {
                return;
            }
            if (igc.multual_push_manager.instance.check_is_limit_multual(igc.e_push_type.popular)) {
                return;
            }
            if (args.chapterId) {
                this.chapterId = args.chapterId;
            }
            if (args.isShow) {
                this.mostPopularRoot.visible = true;
                let row = args.row || 2;
                let position = args.position;
                if (position) {
                    for (let key in position) {
                        this.mostPopularRoot[key] = position[key];
                    }
                }
                this.popularUiPlace = args.uiPlaceType;
                let bg = this.mostPopularRoot.getChildByName("bg");
                if (row == 2) {
                    bg.height = 596;
                } else if (row == 1) {
                    bg.height = 306;
                }
                for (let i = 0; i < this.mostPopularCellList.length; ++i) {
                    let info = this.mostPopularCellList[i];
                    if (i < row * 4) {
                        info.item.visible = true;
                        info.curGameData = this.refreshGame(info);
                        let item = info.item;
                        let iconImage = item.getChildAt(0).getChildByName("gameIcon");
                        iconImage.skin = info.curGameData.icon;
                        let nameLabel = item.getChildAt(0).getChildByName("name");
                        nameLabel.text = info.curGameData.name;
                    } else {
                        info.item.visible = false;
                    }
                }
            } else {
                this.mostPopularRoot.visible = false;
            }
        }
        refreshGame(info) {
            let gameData = info.data;
            if (gameData.displayMode == 1) {
                if (info.index >= gameData.gameList1.length) info.index = 0;
                if (info.index == 0) {
                    gameData.gameList1.sort((a, b) => {
                        return a.priority - b.priority;
                    });
                }
                return gameData.gameList1[info.index++];
            } else if (gameData.displayMode == 2) {
                return this.randomByWeight(gameData.gameList2);
            } else {
                console.warn("互推游戏配置表包含不支持的displayMode", gameData.displayMode);
            }
        }
        randomByWeight(gameList) {
            let totalWeight = 0;
            for (let i = gameList.length - 1; i >= 0; --i) {
                let info = gameList[i];
                totalWeight += info.weight;
            }
            let targetWeight = Math.random() * totalWeight;
            for (let i = gameList.length - 1; i >= 0; --i) {
                let info = gameList[i];
                let weight = info.weight;
                if (targetWeight <= weight) {
                    return info;
                } else {
                    targetWeight -= weight;
                }
            }
        }
    }
    class chapter_manager extends igc.igc_manager_base {
        constructor() {
            super();
            this._is_play = false;
            this._ball_position_init = new Laya.Vector3();
            this._cur_chapter_distance = 0;
            this.side_data = [];
            this.shadow_open = true;
            this.shadow_distance = 200;
            this.shadow_resolution = 1024;
            this.shadowPSSMCount = 1;
            this.shadowPCFType = 1;
            this.lose_count = 0;
            this.last_record_chapter = 0;
            this.obstacle_pool = {};
            this.obstacle_obj = {};
            this.unit_data = [];
            this.model_list = {};
            this.unit_max = 1;
            this.skin_list = [];
            this.skin_try_list = [];
            this.skin_video_list = [];
            this.mat_list = {};
            this.game_state = e_game_state.play;
            this._reset_data = false;
            this._first_enter = true;
            this.save_data = {
                chapter_id: 1,
                version: 1,
                env_list: [e_env_type.grass],
                now_env: e_env_type.grass,
                next_env: undefined
            };
            this.add_listener();
        }
        add_listener() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.enter_scene, this, this.enter_scene);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.chapter_success, this, this.win);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.chapter_fail, this, this.lose);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.chapter_restart, this, this.restart);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.chapter_continue, this, this.continue);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.chapter_play, this, this.start);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.chapter_relife, this, this.relife);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.send_dot, this, this.do_send_dot);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.record_screen, this, this.share_record_screen);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.battle_prepare_complete, this, this.battle_prepare_complete);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.unload_battle_scene_finished, this, this.unload_battle_scene_finished);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.clear_data, this, this.clear_data);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.need_supply_gold, this, this.need_supply_gold);
            igc.phone_manager.instance.add_listener(phone_ids.get_scene_level, this, this.get_scene_level);
            igc.phone_manager.instance.add_listener(phone_ids.get_chapter_id, this, this.get_chapter_id);
            igc.phone_manager.instance.add_listener(phone_ids.get_chapter_config, this, this.get_chapter_config);
            igc.phone_manager.instance.add_listener(phone_ids.get_fix, this, this.get_fix);
            igc.phone_manager.instance.add_listener(phone_ids.get_env_type, this, this.get_env_type);
            igc.phone_manager.instance.add_listener(phone_ids.get_share_env_id, this, this.get_share_env_id);
            igc.phone_manager.instance.add_listener(phone_ids.get_gift_limit, this, this.get_gift_limit);
            igc.phone_manager.instance.add_listener(phone_ids.get_is_play, this, this.get_is_play);
            igc.phone_manager.instance.add_listener(phone_ids.get_game_state, this, this.get_game_state);
        }
        battle_prepare_complete() {
            this.load_scene();
        }
        unload_battle_scene_finished() {
            this.load_scene();
        }
        load_scene() {

            let scene_level = this.get_scene_level();
            console.log("scene_level=====", scene_level)
            resource_manager.instance.load_battle_must_async_fast(scene_level, function() {

                loading_manager.instance.hide(e_loading_type.enter_game);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.load_battle_scene, {
                    id: scene_level
                });
            }, true);
        }
        init() {
            super.init();
        }
        get_scene_level() {
            return this.get_chapter_config().level;
        }
        get_fix() {
            return this.get_chapter_config().fix;
        }
        get_gift_limit() {
            return this.get_chapter_config().gift_limit || 28;
        }
        get_env_type() {
            let env_type = e_env_type.grass;
            if (global.game.channel_type == igc.e_channel_type.tt) {
                if (this.save_data["next_env"]) {
                    console.log("当前场景---------------------------11111>", this.save_data["next_env"]);
                    return this.save_data["next_env"];
                }
                console.log("拥有的场景列表", this.save_data["env_list"]);
                if (this.save_data["env_list"] && this.save_data["env_list"].length > 1) {
                    env_type = this.get_next_env(this.save_data["now_env"]);
                } else {
                    env_type = e_env_type.grass;
                }
            } else if (global.game.channel_type == igc.e_channel_type.web || global.game.channel_type == igc.e_channel_type.vivo_qg || global.game.channel_type == igc.e_channel_type.oppo_qg) {
                env_type = this.get_chapter_config().env_type || e_env_type.grass;
            } else {
                env_type = this.get_chapter_config().env_type || e_env_type.grass;
            }
            console.log("当前场景---------------------------2222>", env_type);
            return env_type;
        }
        get_next_env(env) {
            if (this.save_data["env_list"]) {
                let list = this.save_data["env_list"];
                let index = 0;
                for (let i in list) {
                    if (env == list[i]) {
                        index = parseInt(i);
                        break;
                    }
                }
                console.log("下一个场景id", list[(index + 1) % list.length]);
                return list[(index + 1) % list.length];
            }
        }
        get_share_env_id() {
            if (!this.save_data["env_list"]) {
                return undefined;
            }
            return this.save_data["env_list"].length < 3 ? this.save_data["env_list"].length + 1 : undefined;
        }
        get_chapter_id() {
            return this.save_data["chapter_id"];
        }
        get_game_state() {
            return this.game_state;
        }
        get_chapter_config() {
            let level_base_config = igc.igc_config_manager.instance.configs_data["chapter_cfg"];
            let chapet_id = this.get_chapter_id();
            return level_base_config[chapet_id] || level_base_config[1];
        }
        do_send_dot(b_id, param) {
            this.send_dot(param.event_type);
        }
        send_dot(event_type) {
            nativeOpen("游戏说明页",1)
            console.log("send_dot", event_type);
            if (global.game.channel_type == igc.e_channel_type.web || global.game.is_local_stat === e_login_type.login_type_local) {
                return;
            }
            let event_id = this.get_chapter_id() || 1;
            if (event_type == global.dot_type.continue) {
                event_id--;
            }
            let extra = {};
            igc.stat_manager.instance.send_user_event(event_id, event_type, "enter_scene", "", JSON.stringify(extra));
        }
        enter_scene(broadcast_id, param) {
            console.log("enter_scene");
            if (this._first_enter && !this._reset_data) {
                igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.change_scene, {
                    ad_scene: this.get_chapter_id()
                });
                this.init_offline();
            } else {
                this.hide_loading();
                this.show_main();
            }
            if (this._first_enter) {
                this.show_multal_push();
            }
            this._first_enter = false;
            this.load_player();
        }
        show_multal_push() {
            let config = igc.igc_login_manager.instance.get_config(global.game.channel_type);
            nativeOpen("游戏主页",1)
            console.log("xiejinhui config.has_multual_push", config.has_multual_push);
            if (config.has_multual_push) {
                let ui_guess = new ui_guess_like();
                Laya.stage.addChild(ui_guess);
                ui_guess.zOrder = 10000001;
                console.log("远端互推------\x3e", igc.multual_push_manager.instance._config_remote_init);
                if (!igc.multual_push_manager.instance._config_remote_init) {
                    console.log("远端互推没有拉取到 先使用本地配置");
                    let mutual_push_cfg = "mutual_push";
                    igc.multual_push_manager.instance._multual_push_data = igc.igc_config_manager.instance.configs_data[mutual_push_cfg];
                    igc.multual_push_manager.instance.init_chapter_limit();
                }
            }
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.multual_push_show, true);
        }
        load_player() {
            let battle_scence = igc.phone_manager.instance.call(phone_ids.get_active_game_scene);
            let player = utils_manager.GetChildByName(battle_scence._scene, "player");
            if (!player.getComponent(character_player)) {
                player.addComponent(character_player);
            }
        }
        init_offline() {
            let self = this;
            let offline_time = Math.ceil(igc.phone_manager.instance.call(phone_ids.get_offline_time) / 1e3);
            console.log("离线时长", offline_time);
            let base_config = igc.igc_config_manager.instance.configs_data["base"];
            if (offline_time < base_config.min_offline_time) {
                this.show_main();
            } else {
                offline_time = Math.min(base_config.max_offline_time, offline_time);
                let offline_reward = Math.ceil(role_manager.instance.offline * offline_time);
                console.log("离线奖励", offline_reward, "实际时长", offline_time, "奖励每秒", role_manager.instance.offline);
                console.log("打开离线奖励面板");
                igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.ui_offline,
                    param: {
                        offline_time: offline_time,
                        offline_reward: offline_reward,
                        call_back: function() {
                            self.show_main();
                        }
                    }
                });
            }
        }
        show_main() {
            igc.phone_manager.instance.call(phone_ids.show_ui, {
                ui: ui_class.ui_main,
                param: {}
            });
        }
        need_supply_gold(id, param) {
            nativeOpen("金币页",1)
            igc.phone_manager.instance.call(phone_ids.show_ui, {
                ui: ui_class.ui_supply,
                param: {
                    reward: param.reward
                }
            });
        }
        hide_main() {
            let ui_main = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                ui_name: "ui_main"
            });
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: ui_main
            });
        }
        on_chapter_init() {
            if (this.save_data["version"] == global.game.version) {
                if (global.game.chapter_init != 0) {
                    this.save_data["chapter_id"] = global.game.chapter_init;
                    console.log("1111111111111", global.game.chapter_init);
                }
                this._reset_data = false;
            } else {
                this._reset_data = true;
                this.save_data["chapter_id"] = 1;
                this.save_data["version"] = global.game.version;
            }
            this.save(true);
            this.load_chapter();
        }
        get_is_play() {
            return this._is_play;
        }
        load_chapter() {
            let self = this;
            let level_base_config = igc.igc_config_manager.instance.configs_data["chapter_cfg"];
            if (!level_base_config[this.get_chapter_id()]) {
                this.save_data["chapter_id"] = this.save_data["chapter_id"] - 2;
                this.save(true);
                this.load_chapter();
                return;
            }
        }
        clear_data() {
            if (this.save_data["chapter_id"] != 1) {
                this.save_data["chapter_id"] = 1;
                this.hide_main();
                this.save(true);
                this.show_loading();
                igc.broadcast_manager.instance.broadcast(broadcast_ids.unload_battle_scene);
            } else {
                Laya.timer.once(100, this, function() {
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.update_chapter_info);
                });
            }
        }
        win(id, param) {
            if (this._is_play == true) {
                this.game_state = e_game_state.win;
                this.send_dot(global.dot_type.win);
                this.save_data["now_env"] = this.get_env_type();
                console.log("当前场景-----------\x3e", this.save_data["now_env"]);
                if (this.save_data["next_env"]) {
                    this.save_data["next_env"] = undefined;
                }
                igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.stop_inner_video);
                this._is_play = false;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.update_chapter_info, {
                    chapter_id: this.save_data["chapter_id"],
                    progress: 1
                });
                param.chapter_id = this.save_data["chapter_id"];
                param.reward = this.get_chapter_config().reward_success;
                this.save_data["chapter_id"] = this.save_data["chapter_id"] + 1;
                igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.change_scene, {
                    ad_scene: this.save_data["chapter_id"]
                });
                this.save(true);
                this.delay_win(param);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.character_success);
            }
        }
        delay_win(param) {
            let self = this;
            let base_config = igc.igc_config_manager.instance.configs_data["base"];
            Laya.timer.once(2500, this, function() {
                self.hide_play();
                igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.ui_success,
                    param: {
                        chapter_id: param.chapter_id,
                        reward: param.reward
                    }
                });
            });
        }
        lose(id, msg) {
            if (this._is_play == true) {
                this.game_state = e_game_state.fail;
                igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.pause_inner_video);
                this.send_dot(global.dot_type.lose);
                console.log("lose");
                this._is_play = false;
                igc.broadcast_manager.instance.broadcast(broadcast_ids.play_shake);
                this.delay_lose_complete(msg);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.character_fail, msg);
                this.lose_count++;
                if (this.lose_count % 3 == 0) {}
            }
        }
        delay_lose_complete(msg) {
            let self = this;
            Laya.timer.once(1e3, self, function() {
                self.hide_play();
                igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.ui_fail,
                    param: {
                        chapter_id: self.get_chapter_id(),
                        reward: self.get_chapter_config().reward_success,
                        fail_reason: msg.fail_reason
                    }
                });
            });
        }
        restart(id, args) {
            if (this._is_play == false) {
                console.log("restart");
                this.game_state = e_game_state.play;
                this.send_dot(global.dot_type.restart);
                this.show_loading();
                igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.stop_inner_video);
                igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.ui_main,
                    param: {}
                });
                igc.igc_timer.frameOnce(3, this, this.delay_restart_complete);
            }
        }
        show_loading() {
            igc.phone_manager.instance.call(phone_ids.show_ui, {
                ui: ui_class.ui_loading,
                param: {
                    chapter_id: this.save_data["chapter_id"]
                }
            });
        }
        hide_loading() {
            let ui_loading = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                ui_name: "ui_loading"
            });
            if (ui_loading) {
                igc.phone_manager.instance.call(phone_ids.hide_ui, {
                    instance: ui_loading
                });
            }
        }
        delay_restart_complete() {
            this.hide_loading();
            igc.broadcast_manager.instance.broadcast(broadcast_ids.character_restart);
        }
        delay_continue_complete() {
            this.load_chapter();
            igc.broadcast_manager.instance.broadcast(broadcast_ids.unload_battle_scene);
        }
        continue () {
            if (this._is_play == false) {
                this.game_state = e_game_state.play;
                this.send_dot(global.dot_type.continue);
                console.log("continue");
                igc.igc_timer.frameOnce(3, this, this.delay_continue_complete);
                this.show_loading();
            }
        }
        do_play() {
            this._is_play = true;
            this.hide_loading();
            this.hide_play();
            igc.phone_manager.instance.call(phone_ids.show_ui, {
                ui: ui_class.ui_chapter_info
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.character_play);
        }
        start() {
            if (this._is_play == false) {
                this.game_state = e_game_state.play;
                igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.start_inner_video);
                this.send_dot(global.dot_type.start);
                let cur_chapter = this.get_chapter_id();
                this.last_record_chapter = this.save_data["last_record_chapter"] || 0;
                if (this.last_record_chapter != cur_chapter) {
                    this.send_dot(global.dot_type.enter_scene);
                    this.save_data["last_record_chapter"] = cur_chapter;
                    this.save(true);
                }
                this.do_play();
            }
            this.update_wx_guess_like();
        }
        update_wx_guess_like() {
            let self = this;
            if (global.game.channel_type == igc.e_channel_type.wx) {
                if (this.wx_call_back) {
                    Laya.timer.clear(this, this.wx_call_back);
                }
                this.wx_call_back = function() {
                    if (self._is_play) {
                        igc.broadcast_manager.instance.broadcast(broadcast_ids.show_banner, {
                            type: global.ad_type.banner.normal
                        });
                    }
                };
                Laya.timer.once(1e4, this, this.wx_call_back);
            }
        }
        relife() {
            if (this._is_play == false) {
                this.game_state = e_game_state.play;
                if (global.game.channel_type === igc.e_channel_type.tt) {
                    igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.resume_inner_video);
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.hide_banner);
                }
                this.send_dot(global.dot_type.relife);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.character_relife);
                igc.igc_timer.frameOnce(3, this, this.do_play);
                this.show_loading();
                this._is_play = true;
            }
        }
        hide_play() {
            let ui_chapter_info = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                ui_name: "ui_chapter_info"
            });
            if (ui_chapter_info) {
                igc.phone_manager.instance.call(phone_ids.hide_ui, {
                    instance: ui_chapter_info
                });
            }
        }
        on_load_save_begin() {
            this.on_chapter_init();
        }
        record_screen(param) {
            if (!param.env_id) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.add_gold, {
                    value: 500,
                    reason: "share_inner_video"
                });
            } else {
                this.save_data["env_list"].push(param.env_id);
                this.save_data["next_env"] = param.env_id;
                this.save(true);
            }
            let ui_share_video = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                ui_name: "ui_share_video"
            });
            igc.phone_manager.instance.call(phone_ids.hide_ui, {
                instance: ui_share_video
            });
            igc.phone_manager.instance.call(phone_ids.show_ui, {
                ui: ui_class.ui_get_reward,
                param: param
            });
            igc.broadcast_manager.instance.broadcast(broadcast_ids.share_inner_video_compelete);
        }
        share_record_screen(broadcast_id, param) {
            let self = this;
            console.log("是否在移动设备", Laya.Browser.onMobile);
            if (!Laya.Browser.onMobile) {
                self.record_screen(param);
                return;
            }
            console.log("开始分享录屏");
            igc.broadcast_manager.instance.broadcast(igc.igc_broadcast_ids.share_inner_video, {
                on_failed: function() {
                    igc.phone_manager.instance.call(phone_ids.show_tips, {
                        desc: "视频分享失败"
                    });
                },
                on_succeed: function() {
                    self.record_screen(param);
                }
            });
        }
    }
    class shake_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this.is_shake = false;
        }
        static get instance() {
            return shake_manager.get_instance();
        }
        init() {
            this.init_event();
            this.save_data = {
                is_shake: 0
            };
            this.save(true);
        }
        on_load_save_begin() {}
        init_event() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_shake, this, this.set_shake);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.play_shake, this, this.play_shake);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.little_shake, this, this.little_shake);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.device_shake, this, this.device_shake);
            igc.phone_manager.instance.add_listener(phone_ids.get_shake, this, this.get_shake);
        }
        set_shake(broadcast_id, param) {
            let is_shake = param.is_shake;
            this.save_data["is_shake"] = 0;
            this.save(true);
        }
        get_shake() {
            return 0 //this.save_data["is_shake"];
        }
        play_shake(broadcast_id, param) {
            if (this.save_data["is_shake"] == 0) {
                return;
            }
            igc.broadcast_manager.instance.broadcast(broadcast_ids.shake_camera);
            this.device_shake();
        }
        little_shake(broadcast_id, param) {
            if (this.save_data["is_shake"] == 0) {
                return;
            }
            igc.broadcast_manager.instance.broadcast(broadcast_ids.little_shake_camera);
        }
        device_shake() {
            if (this.save_data["is_shake"] == 0 || this.is_shake) {
                return;
            }
            let self = this;
            self.is_shake = true;
            igc.igc_main.instance.device_shake({
                on_failed: function() {
                    self.is_shake = false;
                },
                on_complete: function() {
                    self.is_shake = false;
                }
            });
        }
    }
    class sound_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this.b_pause = false;
            this.has_bg = false;
        }
        static get instance() {
            return sound_manager.get_instance();
        }
        init() {
            this.init_event();
            this.save_data = {
                cur_vol: 1
            };
            this.save(true);
            let self = this;
            if (igc.e_channel_type.wx === global.game.channel_type) {
                // window["wx"]["onAudioInterruptionBegin"](function() {
                //     console.log("wx 音频中断开始");
                // igc.broadcast_manager.instance.broadcast(broadcast_ids.pause_sound, {
                //     b_pause: true
                // });
                // });
                // window["wx"]["onAudioInterruptionEnd"](function() {
                //     console.log("wx 音频中断结束");
                //     if (self.save_data["cur_vol"] > 0) {
                //         igc.broadcast_manager.instance.broadcast(broadcast_ids.pause_sound, {
                //             b_pause: false
                //         });
                //     }
                // });
                // window["wx"]["onShow"](function(res) {
                //     console.log("wx 回到前台", res);
                //     if (self.save_data["cur_vol"] > 0) {
                //         igc.broadcast_manager.instance.broadcast(broadcast_ids.pause_sound, {
                //             b_pause: false
                //         });
                //     }
                // });
                // window["wx"]["onHide"](function(res) {
                //     console.log("wx 来到后台", res);
                //     igc.broadcast_manager.instance.broadcast(broadcast_ids.pause_sound, {
                //         b_pause: true
                //     });
                // });
            }
        }
        on_load_save_begin() {
            // if (this.save_data["cur_vol"] > 0) {
            this.play_music(0, {
                id: "bg"
            });
            // }
        }
        init_event() {
            igc.broadcast_manager.instance.add_listener(broadcast_ids.pause_sound, this, this.pause_sound);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_vol, this, this.set_vol);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.play_sound, this, this.play_sound);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.play_music, this, this.play_music);
            igc.phone_manager.instance.add_listener(phone_ids.get_vol, this, this.get_vol);
        }
        set_vol(broadcast_id, param) {
            let vol = param.vol;
            this.save_data["cur_vol"] = vol;
            this.save(true);
            if (vol == 0) {
                this.has_bg = false;
                igc.igc_audio_manager.instance.stop_music();
            } else {
                this.play_music(0, {
                    id: "bg"
                });
            }
        }
        pause_sound(broadcast_id, param) {
            this.b_pause = param.b_pause;
            // if (this.save_data["cur_vol"] > 0) {
            if (this.b_pause) {
                this.has_bg = false;
                // igc.igc_audio_manager.instance.stop_music();
                Laya.SoundManager.stopMusic();
            } else {
                this.play_music(0, {
                    id: "bg"
                });
            }
            // } else { }
        }
        get_vol() {
            return this.save_data["cur_vol"];
        }
        play_sound(broadcast_id, param) {
            let id = param.id;
            // if (this.save_data["cur_vol"] > 0) {
            Laya.SoundManager.playSound(igc.igc_audio_manager.instance.get_path(id));
            // igc.igc_audio_manager.instance.play_sound(id);
            // }
        }
        play_music(broadcast_id, param) {
//            let id = param.id;
//            // if (this.save_data["cur_vol"] > 0 && !this.has_bg) {
//            this.has_bg = true;
//            Laya.SoundManager.playMusic(igc.igc_audio_manager.instance.get_path(id), -1);

            // igc.igc_audio_manager.instance.play_music(id);
        }
        // }
    }
    var resulation_type;
    (function(resulation_type) {
        resulation_type[resulation_type["r_169"] = 0] = "r_169";
        resulation_type[resulation_type["r_21"] = 1] = "r_21";
        resulation_type[resulation_type["r_43"] = 2] = "r_43";
    })(resulation_type || (resulation_type = {}));
    class user_setting_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this.res_ratio_169_width = 1080;
            this.res_ratio_169_height = 1920;
            this.res_offset = [];
            this.res_type = resulation_type.r_169;
            this.on_resize();
        }
        static get instance() {
            return user_setting_manager.get_instance();
        }
        init_stage_info() {
            let browser_width = Laya.Browser.clientWidth;
            let browser_height = Laya.Browser.clientHeight;
            let ratio = browser_height / browser_width;
            this.stage_width = GameConfig.width;
            this.stage_height = GameConfig.height;
            let is_spec_status = false;
            if (ratio >= 1.8 && ratio < 2.2) {
                this.stage_height = this.res_ratio_169_width * ratio;
                this.res_type = resulation_type.r_21;
                this.window_offset = (this.stage_height - this.res_ratio_169_height) / 2;
                this.res_offset[this.res_type] = new Laya.Point(0, this.window_offset);
            } else if (ratio > 1.7) {
                this.stage_height = this.res_ratio_169_height;
                this.res_type = resulation_type.r_169;
            } else if (ratio > 1.3) {
                this.res_type = resulation_type.r_43;
            }
            if (window["Laya3D"]) {
                Laya3D.init(this.stage_width, this.stage_height);
            } else {
                Laya.init(this.stage_width, this.stage_height, Laya["WebGL"]);
            }
            Laya.timer.callLater(this, () => {
                Laya.stage.scaleMode = GameConfig.scaleMode;
                if (window.innerHeight / window.innerWidth > 1920 / 1080)
                    Laya.stage.scaleMode = "fixedwidth";
                Laya.SoundManager.useAudioMusic = false;
                Laya.stage.screenMode = GameConfig.screenMode;
                Laya.stage.alignV = GameConfig.alignV;
                Laya.stage.alignH = GameConfig.alignH;
            });
        }
        set_res_window_offset(type, root) {
            if (this.res_type == type) {
                if (this.res_offset.length > 0) {
                    let point = this.res_offset[type];
                    root.x += point.x;
                    root.y += point.y;
                }
            }
        }
        get_res_window_offset(type) {
            if (type == resulation_type.r_21) {
                return this.res_offset[type];
            }
        }
        on_resize() {
            let self = this;
            window.onresize = (() => {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.window_resize, {
                    new_width: window.innerWidth,
                    new_height: window.innerHeight
                });
            });
        }
        get_stage_size() {
            return {
                width: this.stage_width,
                height: this.stage_height
            };
        }
    }
    class adv_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this.pre_load_native_suceess = false;
            this.video_call_back = null;
            this.isVideoCompelete = false;
            this.max_chapter_id = 6;
            this.banner_list = [global.ad_type.banner.normal, global.ad_type.banner.normal2];
            this.inster_cd = 0;
            this.is_init_app_box = false;
            this.b_show_banner = false;
            this.vivo_banner_show_time = 0;
            this.vivo_banner_switch = false;
            this.adv_config = {
                [igc.e_channel_type.oppo_qg]: {
                    [global.ad_type.video.challenge_fail]: "150396",
                    [global.ad_type.video.chapter_double_reward]: "150399",
                    [global.ad_type.video.fail_double]: "150398",
                    [global.ad_type.video.offline_double]: "150397",
                    [global.ad_type.video.supply]: "151890",
                    [global.ad_type.banner.normal]: "150391",
                    [global.ad_type.banner.normal2]: "150391",
                    [global.ad_type.native.challenge_success]: "150393",
                    [global.ad_type.native.challenge_fail]: "150394",
                    [global.ad_type.native.pause]: "143893",
                    [global.ad_type.inster.challenge_success]: "150392",
                    [global.ad_type.inster.challenge_fail]: "150392"
                },
                [igc.e_channel_type.vivo_qg]: {
                    [global.ad_type.video.challenge_fail]: "7fc944f8684c40b2b4d7012d4f544e89",
                    [global.ad_type.video.chapter_double_reward]: "138a2eb4ffd04efe9d60c4393708a88f",
                    [global.ad_type.video.fail_double]: "138a2eb4ffd04efe9d60c4393708a88f",
                    [global.ad_type.video.offline_double]: "bdaa955e7f924d86be4ca7e1bcdd89fc",
                    [global.ad_type.video.supply]: "fe9ec619e26c4a089d3305b30c1934f2",
                    [global.ad_type.video.video_up_lv]: "32d4def0800a46018310f500d3799560",
                    [global.ad_type.banner.normal]: "99dd1c652ce742bd9f12041cfbc09d1e",
                    [global.ad_type.banner.normal2]: "99dd1c652ce742bd9f12041cfbc09d1e",
                    [global.ad_type.native.challenge_success]: "bac28f0fd3124ca798eac0f274304cd7",
                    [global.ad_type.native.challenge_fail]: "df02a877cba443dda4042f1367ad3e04",
                    [global.ad_type.native.pause]: "debe89fc5d0842febea34324c22388a4",
                    [global.ad_type.inster.challenge_success]: "8c048cf5f8154b93a8c7384febdfb00f",
                    [global.ad_type.inster.challenge_fail]: "8c048cf5f8154b93a8c7384febdfb00f"
                },
                [igc.e_channel_type.wx]: {
                    [global.ad_type.video.challenge_fail]: "adunit-134982b7987136f8",
                    [global.ad_type.video.chapter_double_reward]: "adunit-1a145ad96798a42d",
                    [global.ad_type.video.fail_double]: "adunit-1a145ad96798a42d",
                    [global.ad_type.video.offline_double]: "adunit-d33d01d71ee2c711",
                    [global.ad_type.video.supply]: "adunit-e716ca5f56121d50",
                    [global.ad_type.video.video_up_lv]: "adunit-9a7eab1df0a7e3bc",
                    [global.ad_type.banner.normal]: "adunit-4265236d7dd57e54",
                    [global.ad_type.banner.normal2]: "adunit-4265236d7dd57e54",
                    [global.ad_type.native.challenge_success]: "",
                    [global.ad_type.native.challenge_fail]: "",
                    [global.ad_type.native.pause]: "",
                    [global.ad_type.inster.challenge_success]: "adunit-ccad1d76063fd566",
                    [global.ad_type.inster.challenge_fail]: "adunit-ca47e53a2ef32dd1"
                },
                [igc.e_channel_type.qq]: {
                    [global.ad_type.video.challenge_fail]: "ed7cfc5c735496cced008a7e32a869b1",
                    [global.ad_type.banner.normal]: "06a1b1c8047b2575d4dea5ae69b2f202",
                    [global.ad_type.banner.normal2]: "06a1b1c8047b2575d4dea5ae69b2f202",
                    [global.ad_type.video.chapter_double_reward]: "2521c65972e1700d11178834f34723a8",
                    [global.ad_type.video.fail_double]: "fa8344a2ac85e097b5dd43c16e3b9f26",
                    [global.ad_type.video.offline_double]: "010409eba5030fb48c56dc9e749846c3",
                    [global.ad_type.video.supply]: "151890",
                    [global.ad_type.native.challenge_success]: "123",
                    [global.ad_type.native.challenge_fail]: "123",
                    [global.ad_type.native.pause]: "123",
                    [global.ad_type.inster.challenge_success]: "123",
                    [global.ad_type.inster.challenge_fail]: "123",
                    [global.ad_type.app_box.normal]: "ab09708b3ce0dd23780d9855037fea07"
                },
                [igc.e_channel_type.apk]: {
                    [global.ad_type.video.challenge_fail]: "level_fail_mfzs",
                    [global.ad_type.banner.normal]: "banner",
                    [global.ad_type.banner.normal2]: "banner",
                    [global.ad_type.video.fail_double]: "double_mfzs",
                    [global.ad_type.video.fail_double]: "add_energy_mfzs",
                    [global.ad_type.video.offline_double]: "skin",
                    [global.ad_type.video.supply]: "151890",
                    [global.ad_type.native.challenge_success]: "123",
                    [global.ad_type.native.challenge_fail]: "123",
                    [global.ad_type.native.pause]: "123",
                    [global.ad_type.inster.challenge_success]: "level_win",
                    [global.ad_type.inster.challenge_fail]: "level_fail",
                    [global.ad_type.inster.exit_game]: "exit_game"
                },
                [igc.e_channel_type.tt]: {
                    [global.ad_type.video.challenge_fail]: "ebjbpphkmo31g5gc4h",
                    [global.ad_type.video.chapter_double_reward]: "39l1albj8c2akju665",
                    [global.ad_type.video.fail_double]: "39l1albj8c2akju665",
                    [global.ad_type.video.offline_double]: "1i2ch3k92a8b1b6jj1",
                    [global.ad_type.video.supply]: "1c989gccdhgb7hjpbd",
                    [global.ad_type.banner.normal]: "haoimlm8a29jfk28gf",
                    [global.ad_type.banner.normal2]: "haoimlm8a29jfk28gf",
                    [global.ad_type.native.challenge_success]: "",
                    [global.ad_type.native.challenge_fail]: "",
                    [global.ad_type.native.pause]: "",
                    [global.ad_type.inster.challenge_success]: "",
                    [global.ad_type.inster.challenge_fail]: ""
                }
            };
        }
        static get instance() {
            return adv_manager.get_instance();
        }
        init() {
            super.init();
            igc.broadcast_manager.instance.add_listener(broadcast_ids.show_video, this, this.show_video);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.show_banner, this, this.show_banner);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.hide_banner, this, this.hide_banner);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.update_banner, this, this.update_banner);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.pre_load_native, this, this.pre_load_native);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.report_show, this, this.report_show);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.report_click, this, this.report_click);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.set_can_show_banner, this, this.set_can_show_banner);
            igc.broadcast_manager.instance.add_listener(broadcast_ids.show_game_banner_wx, this, this.show_game_banner_wx);
            let self = this;
            if (igc.e_channel_type.vivo_qg === global.game.channel_type) {
                console.log("xiejinhui 第一个banner倒计时开始");
                this.vivo_banner_switch = false;
                Laya.timer.once(3e3, this, function() {
                    console.log("xiejinhui 3s等待结束");
                    self.vivo_banner_switch = true;
                    self.show_banner(undefined, {
                        type: global.ad_type.banner.normal
                    }, true);
                });
                Laya.timer.loop(1e3, this, function() {
                    if (self.b_show_banner) {
                        console.log("xiejinhui advMgr self.vivo_banner_show_time--------\x3e", self.vivo_banner_show_time);
                        self.vivo_banner_show_time++;
                        if (self.vivo_banner_show_time % 20 == 0) {
                            self.show_banner(undefined, {
                                type: global.ad_type.banner.normal
                            }, true);
                        }
                    }
                });
            }
            this.init_pre_interstitial();
            this.init_qq_app_box();
        }
        init_pre_interstitial() {
            if (igc.e_channel_type.wx === global.game.channel_type) {
                let ad_list = [global.ad_type.inster.challenge_fail, global.ad_type.inster.challenge_success];
                for (let i in ad_list) {
                    let adUnitId = this.getInstertAdId(ad_list[i]);
                    let ad_param = {
                        ad_type: igc.e_ad_type.interstitial,
                        ad_id: adUnitId,
                        ad_pos_id: adUnitId,
                        ad_event: adUnitId,
                        ad_scene: adUnitId,
                        onLoad: function() {
                            console.log("xiejinhui 插屏加载成功", adUnitId);
                        },
                        onShow: function() {
                            console.log("xiejinhui 插屏显示成功", adUnitId);
                        },
                        onClose: function() {
                            console.log("interstitial 插屏广告关闭", adUnitId);
                            self.inster_cd = 30;
                        },
                        onError: function(param, err) {
                            console.log("xiejinhui interstitial error", adUnitId, JSON.stringify(err));
                        }
                    };
                    if (!igc.igc_main.instance.has_ad(ad_param)) {
                        igc.igc_main.instance.create_ad(ad_param);
                    }
                }
                let self = this;
                Laya.timer.loop(1e3, this, function() {
                    self.inster_cd > 0 && self.inster_cd--;
                });
            }
        }
        init_qq_app_box() {
            let self = this;
            if (igc.e_channel_type.qq === global.game.channel_type) {
                let adUnitId = this.getInstertAdId(global.ad_type.app_box.normal);
                let ad_param = {
                    ad_type: igc.e_ad_type.app_box,
                    ad_id: adUnitId,
                    ad_pos_id: adUnitId,
                    ad_event: adUnitId,
                    ad_scene: adUnitId,
                    onLoad: function() {
                        self.is_init_app_box = true;
                        console.log("xiejinhui 广告盒子加载成功", adUnitId);
                    },
                    onClose: function() {
                        console.log("interstitial 广告盒子广告关闭", adUnitId);
                        self.inster_cd = 30;
                    },
                    onError: function(param, err) {
                        self.is_init_app_box = false;
                        console.log("xiejinhui app_box error", adUnitId, JSON.stringify(err));
                    }
                };
                if (!igc.igc_main.instance.has_ad(ad_param)) {
                    igc.igc_main.instance.create_ad(ad_param);
                }
            }
        }
        get_is_init_app_box() {
            return this.is_init_app_box;
        }
        set_can_show_banner() {
            let self = this;
            if (global.game.channel_type === igc.e_channel_type.wx) {
                this.show_game_banner_wx(1, {
                    type: global.ad_type.banner.normal2
                });
            } else {
                self.show_banner(1, {
                    type: global.ad_type.banner.normal
                });
            }
        }
        show_game_banner_wx(id, param) {
            if (global.game.channel_type == igc.e_channel_type.wx) {
                this.hide_banner();
                this.show_banner(1, {
                    type: param.type
                });
            }
        }
        show_video(id, args) {
            let type = args.type;
            this.isVideoCompelete = false;
            let end_handler = args.call_back || function() {};
            this.video_call_back = end_handler;
            if (igc.e_channel_type.web === global.game.channel_type) {
                end_handler && end_handler();
                return;
            }
            if (!global.game.supportVideo) {
                igc.phone_manager.instance.call(phone_ids.show_tips, {
                    desc: "目前暂时无广告!"
                });
                args.error_back && args.error_back();
                igc.broadcast_manager.instance.broadcast(broadcast_ids.video_not_complete);
                return;
            }
            let self = this;
            let adUnitId = this.getVideoAdId(type);
            let ad_param = {
                ad_type: igc.e_ad_type.video,
                ad_id: adUnitId,
                ad_pos_id: adUnitId,
                ad_event: adUnitId,
                ad_scene: adUnitId,
                onLoad: function() {
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.pause_sound, {
                        b_pause: true
                    });
                },
                onError: function(param, err) {
                    console.log("param", JSON.stringify(param));
                    console.log("err", JSON.stringify(err));
                    igc.phone_manager.instance.call(phone_ids.show_tips, {
                        desc: "目前暂时无广告，请稍后再试"
                    });
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.video_not_complete);
                    args.error_back && args.error_back();
                },
                onShow: function() {},
                onClose: function(param, res) {
                    console.log("关闭广告-----------------------------------------" + JSON.stringify(res));
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.pause_sound, {
                        b_pause: false
                    });
                    if (res.isEnded) {
                        self.isVideoCompelete = true;
                        Laya.timer.once(1e3, self, function() {
                            self.video_call_back && self.video_call_back();
                            self.video_call_back = null;
                            self.isVideoCompelete = false;
                        });
                    } else {
                        igc.phone_manager.instance.call(phone_ids.show_tips, {
                            desc: "广告没看完，无法领取奖励"
                        });
                        args.error_back && args.error_back();
                        igc.broadcast_manager.instance.broadcast(broadcast_ids.video_not_complete);
                    }
                }
            };
            console.log("xiejinhui show_video", adUnitId);
            if (global.game.channel_type === igc.e_channel_type.apk) {
                igc.igc_main.instance.show_ad(ad_param);
            } else {
                if (!igc.igc_main.instance.has_ad(ad_param)) {
                    igc.igc_main.instance.create_ad(ad_param);
                }
                igc.igc_main.instance.show_ad(ad_param);
            }
        }
        show_banner(id, args, is_auto_update) {
            let self = this;
            if (igc.e_channel_type.web === global.game.channel_type || !global.game.supportVideo) {
                return;
            }
            if (self.b_show_banner && !is_auto_update && global.game.channel_type == igc.e_channel_type.vivo_qg) {
                return;
            }
            if (global.game.channel_type == igc.e_channel_type.vivo_qg && !this.vivo_banner_switch) {
                console.log("游戏刚开始不能展示banner");
                return;
            }
            let banner_type = args.type;
            let adUnitId = this.getBannerAdId(banner_type);
            let ad_param = {
                ad_type: igc.e_ad_type.banner,
                ad_id: adUnitId,
                ad_pos_id: adUnitId,
                ad_event: adUnitId,
                ad_scene: adUnitId,
                onShow: function() {
                    console.log("xiejinhui advmgr show_banner success", adUnitId);
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.banner_show);
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_show_banner, {
                        is_show: false
                    });
                    self.vivo_banner_show_time = 0;
                    self.b_show_banner = true;
                    let is_play = igc.phone_manager.instance.call(phone_ids.get_is_play);
                    let is_hall = igc.phone_manager.instance.call(phone_ids.get_is_hall);
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_push_view_show_icon, {
                        is_show_guess_like: false,
                        is_show_icon: is_hall || is_play,
                        is_show_more_play: is_hall,
                        icon_position: is_play ? 410 : 700
                    });
                },
                onLoad: function() {
                    console.log("create bannner success ---------------------");
                },
                onError: function(args, err) {
                    console.log("create bannner fail ---------------------");
                    console.log("create bannner error", JSON.stringify(err));
                    let is_play = igc.phone_manager.instance.call(phone_ids.get_is_play);
                    let is_hall = igc.phone_manager.instance.call(phone_ids.get_is_hall);
                    igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_push_view_show_icon, {
                        is_show_guess_like: true,
                        is_show_icon: is_hall || is_play,
                        is_show_more_play: is_hall,
                        icon_position: is_play ? 410 : 700
                    });
                }
            };
            console.log("xiejinhui start show_banner", adUnitId);
            if (!igc.igc_main.instance.has_ad(ad_param)) {
                console.log("create_ad banner ", adUnitId);
                igc.igc_main.instance.create_ad(ad_param);
            }
            if (igc.igc_main.instance.has_ad(ad_param)) {
                console.log("xiejinhui banner  show_ad  .load", adUnitId);
                igc.igc_main.instance.show_ad(ad_param);
            }
        }
        hide_banner() {
            console.log("隐藏banner");
            igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_show_banner, {
                is_show: false
            });
            if (global.game.channel_type == igc.e_channel_type.web) {
                return;
            }
            if (!global.game.supportVideo || global.game.channel_type == igc.e_channel_type.vivo_qg) {
                return;
            }
            for (let i in this.banner_list) {
                let type = this.banner_list[i];
                let adUnitId = this.getBannerAdId(type);
                let ad_param = {
                    ad_type: igc.e_ad_type.banner,
                    ad_id: adUnitId,
                    ad_pos_id: adUnitId,
                    ad_event: adUnitId,
                    ad_scene: adUnitId,
                    onHide: function() {
                        console.log("xiejinhui advMgr 隐藏banner", adUnitId);
                    }
                };
                if (igc.igc_main.instance.has_ad(ad_param)) {
                    igc.igc_main.instance.hide_ad(ad_param);
                    console.log("隐藏banner成功");
                }
            }
        }
        update_banner(id, args) {
            if (global.game.channel_type == igc.e_channel_type.wx) {
                for (let i in this.banner_list) {
                    let type = this.banner_list[i];
                    let adUnitId = this.getBannerAdId(type);
                    let ad_param = {
                        ad_type: igc.e_ad_type.banner,
                        ad_id: adUnitId,
                        ad_pos_id: adUnitId,
                        ad_event: adUnitId,
                        ad_scene: adUnitId
                    };
                    if (igc.igc_main.instance.has_ad(ad_param)) {
                        igc.igc_main.instance.destroy_ad(ad_param);
                        console.log("销毁banner成功", adUnitId);
                    }
                }
                this.show_banner(1, {
                    type: args.type
                });
            } else if (global.game.channel_type == igc.e_channel_type.qq) {
                let type = global.ad_type.banner.normal;
                let adUnitId = this.getBannerAdId(type);
                let ad_param = {
                    ad_type: igc.e_ad_type.banner,
                    ad_id: adUnitId,
                    ad_pos_id: adUnitId,
                    ad_event: adUnitId,
                    ad_scene: adUnitId
                };
                if (igc.igc_main.instance.has_ad(ad_param)) {
                    igc.igc_main.instance.destroy_ad(ad_param);
                    console.log("销毁banner成功", adUnitId);
                }
                this.show_banner(1, {
                    type: args.type
                });
            }
        }
        show_insert_ad(id, args) {
            let self = this;
            let type = args.type;
            let duration = args.duration || 10;
            if (igc.e_channel_type.web === global.game.channel_type || !global.game.supportVideo) {
                return;
            }
            if (igc.e_channel_type.wx == global.game.channel_type && self.inster_cd > 0) {
                console.log("微信插屏处于cd中禁止显示", self.inster_cd);
                return;
            }
            let adUnitId = this.getInstertAdId(type);
            let ad_param = {
                ad_type: igc.e_ad_type.interstitial,
                ad_id: adUnitId,
                ad_pos_id: adUnitId,
                ad_event: adUnitId,
                ad_scene: adUnitId,
                onShow: function() {
                    console.log("xiejinhui 插屏显示成功");
                    if (igc.e_channel_type.oppo_qg === global.game.channel_type) {
                        self.hide_banner();
                    }
                },
                onClose: function() {
                    self.inster_cd = 30;
                    console.log("interstitial插屏广告关闭");
                },
                onError: function(param, err) {
                    console.log("xiejinhui interstitial error", JSON.stringify(err));
                    if (igc.e_channel_type.wx === global.game.channel_type) {
                        igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_show_single_splash, {
                            isShow: true
                        });
                    }
                }
            };
            console.log("xiejinhui show_insert_ad", adUnitId);
            if (!igc.igc_main.instance.has_ad(ad_param)) {
                igc.igc_main.instance.create_ad(ad_param);
            }
            Laya.timer.once(10, this, () => {
                if (igc.igc_main.instance.has_ad(ad_param)) {
                    igc.igc_main.instance.show_ad(ad_param);
                }
            });
        }
        getVideoAdId(type) {
            return this.adv_config[global.game.channel_type][type] || "120519";
        }
        getBannerAdId(type) {
            return this.adv_config[global.game.channel_type][type] || "120516";
        }
        getInstertAdId(type) {
            return this.adv_config[global.game.channel_type][type] || "120520";
        }
        getNativeAdId(type) {
            return this.adv_config[global.game.channel_type][type] || "120522";
        }
        report_click(id, args) {
            if (global.game.channel_type == igc.e_channel_type.web || !global.game.supportVideo) {
                return;
            }
            console.log("xiejinhui adv report_click 上报原生点击", args.unit_id);
            let unit_id = args.unit_id;
            let ad_id = args.ad_id;
            let ad_param = {
                ad_id: ad_id,
                ad_unit_id: unit_id,
                ad_type: igc.e_ad_type.native,
                ad_pos_id: ad_id,
                ad_event: ad_id,
                ad_scene: ad_id
            };
            igc.igc_main.instance.report_ad_click(ad_param);
        }
        report_show(id, args) {
            if (global.game.channel_type == igc.e_channel_type.web || !global.game.supportVideo) {
                return;
            }
            if (global.game.channel_type == igc.e_channel_type.oppo_qg || global.game.channel_type == igc.e_channel_type.vivo_qg) {
                igc.broadcast_manager.instance.broadcast(broadcast_ids.show_native_success);
                this.hide_banner();
            }
            console.log("xiejinhui adv report_click 上报原生曝光", args.unit_id);
            let unit_id = args.unit_id;
            let ad_id = args.ad_id;
            let ad_param = {
                ad_id: ad_id,
                ad_unit_id: unit_id,
                ad_type: igc.e_ad_type.native,
                ad_pos_id: ad_id,
                ad_event: ad_id,
                ad_scene: ad_id
            };
            igc.igc_main.instance.report_ad_show(ad_param);
        }
        pre_load_native(id, args) {
            let self = this;
            if (global.game.channel_type == igc.e_channel_type.web || !global.game.supportVideo) {
                return;
            }
            let native_count = igc.phone_manager.instance.call(igc.igc_phone_ids.get_oppo_native_count);
            if (native_count >= 8) {
                self.show_banner(1, {
                    type: global.ad_type.banner.normal
                });
                return;
            }
            let native_type = args.native_type;
            let inster_type = args.inster_type;
            let ad_id = this.getNativeAdId(native_type);
            if (global.game.channel_type == igc.e_channel_type.wx) {
                this.show_insert_ad(undefined, {
                    type: inster_type,
                    duration: 100
                });
                return;
            }
            if (global.game.channel_type == igc.e_channel_type.apk) {
                this.show_insert_ad(undefined, {
                    type: inster_type,
                    duration: 100
                });
                return;
            }
            self.pre_load_native_suceess = false;
            if (!igc.igc_main.instance.has_ad({
                    ad_type: igc.e_ad_type.native,
                    ad_id: ad_id
                })) {
                igc.igc_main.instance.create_ad({
                    ad_type: igc.e_ad_type.native,
                    ad_id: ad_id,
                    ad_pos_id: ad_id,
                    ad_event: ad_id,
                    ad_scene: ad_id,
                    onLoad: function() {},
                    onError: function(param, err) {
                        console.log("xiejinhui advmgr create_native error", JSON.stringify(err));
                        self.show_insert_ad(1, {
                            type: inster_type,
                            duration: 100
                        });
                    }
                });
            }
            console.log("xiejinhui 预加载原生", ad_id);
            igc.igc_main.instance.load_ad_just({
                ad_type: igc.e_ad_type.native,
                ad_id: ad_id,
                ad_pos_id: ad_id,
                ad_event: ad_id,
                ad_scene: ad_id,
                onLoad: function(ad_data_list) {
                    let data = JSON.stringify(ad_data_list[0]);
                    if (ad_data_list == undefined || !ad_data_list[0]) {
                        console.log("xiejinhui advmgr native error 原生数据返回异常");
                        self.show_insert_ad(1, {
                            type: inster_type,
                            duration: 100
                        });
                    } else {
                        let native_data = ad_data_list[0];
                        self.pre_load_native_suceess = true;
                        Laya.timer.once(10, self, () => {
                            console.log("show ui_adv native_data====>", JSON.stringify(native_data));
                            igc.phone_manager.instance.call(phone_ids.show_ui, {
                                ui: ui_class.ui_adv,
                                param: {
                                    native_data: native_data,
                                    ad_id: ad_id
                                }
                            });
                        });
                    }
                },
                onClose: function() {}
            });
        }
        check_meet_chapter() {
            let chapter_id = igc.phone_manager.instance.call(phone_ids.get_chapter_id);
            return chapter_id > this.max_chapter_id || chapter_id <= this.max_chapter_id && chapter_id % 2 == 0;
        }
        destroy_banner(id, args) {
            let banner_type = args.type;
            let adUnitId = this.getBannerAdId(banner_type);
            let ad_param = {
                ad_type: igc.e_ad_type.banner,
                ad_id: adUnitId,
                ad_pos_id: adUnitId,
                ad_event: adUnitId,
                ad_scene: adUnitId
            };
            if (igc.igc_main.instance.has_ad(ad_param)) {
                igc.igc_main.instance.destroy_ad(ad_param);
                console.log("销毁banner成功", adUnitId);
            }
        }
        show_app_box() {
            if (igc.e_channel_type.qq === global.game.channel_type) {
                if (!this.is_init_app_box) {
                    console.log("不支持广告盒子或加载失败");
                    return;
                }
                let adUnitId = this.getInstertAdId(global.ad_type.app_box.normal);
                let ad_param = {
                    ad_type: igc.e_ad_type.app_box,
                    ad_id: adUnitId,
                    ad_pos_id: adUnitId,
                    ad_event: adUnitId,
                    ad_scene: adUnitId,
                    onShow: function() {
                        console.log("xiejinhui 广告盒子显示成功", adUnitId);
                    }
                };
                if (igc.igc_main.instance.has_ad(ad_param)) {
                    console.log("准备显示游戏盒子", adUnitId);
                    igc.igc_main.instance.show_ad(ad_param);
                }
            }
        }
    }
    class model_manager extends igc.igc_manager_base {
        constructor() {
            super();
            this.model_list = {};
            this.model_pool = {};
            this.mate_list = {};
            this.add_listener();
        }
        load_async(finish_callback, res_update_callback) {
            let self = this;
            let load_list = [];
            load_list.push({
                path: igc.igc_resources_utils.get_url("models/100000002.lh"),
                id: e_model_type.train_head,
                save: function(id, model) {
                    self.model_list[id] = model;
                }
            }, {
                path: igc.igc_resources_utils.get_url("models/100000003.lh"),
                id: e_model_type.train_gift,
                save: function(id, model) {
                    self.model_list[id] = model;
                }
            }, {
                path: igc.igc_resources_utils.get_url("models/100000005.lh"),
                id: e_model_type.train_passenger_1,
                save: function(id, model) {
                    self.model_list[id] = model;
                }
            }, {
                path: igc.igc_resources_utils.get_url("models/100000006.lh"),
                id: e_model_type.train_passenger_2,
                save: function(id, model) {
                    self.model_list[id] = model;
                }
            }, {
                path: igc.igc_resources_utils.get_url("models/100000007.lh"),
                id: e_model_type.train_passenger_3,
                save: function(id, model) {
                    self.model_list[id] = model;
                }
            }, {
                path: igc.igc_resources_utils.get_url("models/100000008.lh"),
                id: e_model_type.train_passenger_4,
                save: function(id, model) {
                    self.model_list[id] = model;
                }
            });
            igc.igc_resources_utils.async_load_res(load_list, finish_callback, 10, res_update_callback);
        }
        init() {}
        add_listener() {
            igc.phone_manager.instance.add_listener(phone_ids.get_track_mat, this, this.get_track_mat);
            igc.phone_manager.instance.add_listener(phone_ids.get_mat, this, this.get_mat);
            igc.phone_manager.instance.add_listener(phone_ids.get_model, this, this.get_model);
            igc.phone_manager.instance.add_listener(phone_ids.recycle_model, this, this.recycle_model);
            igc.phone_manager.instance.add_listener(phone_ids.get_sky_box, this, this.get_sky_box);
        }
        get_model(id, param) {
            if (this.model_pool[param.model_type] && this.model_pool[param.model_type][0]) {
                return this.model_pool[param.model_type].pop();
            } else {
                return this.model_list[param.model_type].clone();
            }
        }
        recycle_model(id, param) {
            if (!this.model_pool[param.model_type]) {
                this.model_pool[param.model_type] = [];
            }
            param.model.parent.removeChild(param.model);
            this.model_pool[param.model_type].push(param.model);
        }
        get_mat(id, param) {
            let path_list = {
                [e_env_type.grass]: igc.igc_resources_utils.get_url("levels/Assets/Models/train/1002/Grassland.lmat"),
                [e_env_type.sand]: igc.igc_resources_utils.get_url("levels/Assets/Models/train/1002/sand.lmat"),
                [e_env_type.snow]: igc.igc_resources_utils.get_url("levels/Assets/Models/train/1002/Snowfield.lmat")
            };
            let load_list = [];
            load_list.push({
                path: path_list[param.env_type],
                id: e_env_type.grass,
                save: function(id, model) {
                    param.call_back && param.call_back(model);
                }
            });
            igc.igc_resources_utils.async_load_res(load_list, function() {}, 10);
        }
        get_track_mat(id, param) {
            let path_list = {
                [e_env_type.grass]: igc.igc_resources_utils.get_url("levels/Assets/Models/train/track/track_cao.lmat"),
                [e_env_type.sand]: igc.igc_resources_utils.get_url("levels/Assets/Models/train/track/track_sha.lmat"),
                [e_env_type.snow]: igc.igc_resources_utils.get_url("levels/Assets/Models/train/track/track_xue.lmat")
            };
            let load_list = [];
            load_list.push({
                path: path_list[param.env_type],
                id: e_env_type.grass,
                save: function(id, model) {
                    param.call_back && param.call_back(model);
                }
            });
            igc.igc_resources_utils.async_load_res(load_list, function() {}, 10);
        }
        get_sky_box(id, param) {
            let path_list = {
                [e_env_type.grass]: igc.igc_resources_utils.get_url("levels/Assets/Models/player/Material/sky_box_1.lmat"),
                [e_env_type.sand]: igc.igc_resources_utils.get_url("levels/Assets/Models/player/Material/sky_box_2.lmat"),
                [e_env_type.snow]: igc.igc_resources_utils.get_url("levels/Assets/Models/player/Material/sky_box_3.lmat")
            };
            let load_list = [];
            load_list.push({
                path: path_list[param.env_type],
                id: param.env_type,
                save: function(id, model) {
                    param.call_back && param.call_back(model);
                }
            });
            igc.igc_resources_utils.async_load_res(load_list, function() {}, 10);
        }
    }
    class ui_toast extends ui.scenes.ui_toastUI {
        constructor() {
            super(...arguments);
            this._frames = 0;
            this._frameEnd = 60;
        }
        onAwake() {
            console.log("ui_toast onAwake Run");
        }
        on_update() {
            this._frames++;
            if (this._frames === this._frameEnd) {
                Laya.timer.clear(this, this.on_update);
                this.removeSelf();
                this.destroy();
            }
            this.mp_img_bg.y -= 2;
        }
        set_tips(str) {
            this.mp_label_desc.text = str;
            this.mp_img_bg.width = this.mp_label_desc.width + 100;
            this.mp_label_desc.x = this.mp_img_bg.width / 2;
            Laya.timer.frameLoop(1, this, this.on_update);
        }
    }
    class tips_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this._zOrder = 11e6;
            this.register_global_listener();
        }
        static get instance() {
            return tips_manager.get_instance();
        }
        init() {
            console.log("tips_manager init run");
            super.init();
        }
        show_tips(_, param) {
            let ui = new ui_toast();
            ui.set_tips(param.desc);
            ui.zOrder = this._zOrder;
            this._zOrder++;
            Laya.stage.addChild(ui);
        }
        register_global_listener() {
            igc.phone_manager.instance.add_listener(phone_ids.show_tips, this, this.show_tips);
        }
    }
    class LamberCustomMaterial extends Laya.BlinnPhongMaterial {
        constructor() {
            super();
            this._diffuseColor = new Laya.Vector4(1, 1, 1, 1);
            this.setShaderName(LamberCustomMaterial.ShaderName);
        }
        set _DiffParam(value) {
            this._shaderValues.setVector(LamberCustomMaterial.DIFFUSE_PARAM, value);
        }
        get _DiffParam() {
            return this._shaderValues.getVector(LamberCustomMaterial.DIFFUSE_PARAM);
        }
        get _MainTex() {
            return this.albedoTexture;
        }
        set _MainTex(value) {
            this.albedoTexture = value;
        }
        get _Color() {
            return this.albedoColor;
        }
        set _Color(value) {
            this.albedoColor = value;
        }
        static __init__() {
            var lamber_custom_ps = `\n        #ifdef HIGHPRECISION\n            precision highp float;\n        #else\n            precision mediump float;\n            #endif\n\n            #include "Lighting.glsl";\n\n            uniform vec4 u_DiffuseColor;\n\n            #if defined(COLOR) && defined(ENABLEVERTEXCOLOR)\n        varying vec4 v_Color;\n        #endif\n\n        uniform vec4 u_DiffuseParam;   //custom param!\n\n        #if defined(DIRECTIONLIGHT) || defined(POINTLIGHT) || defined(SPOTLIGHT)\n        varying vec3 v_ViewDir;\n        #endif\n\n        #ifdef ALPHATEST\n        uniform float u_AlphaTestValue;\n        #endif\n\n        #ifdef DIFFUSEMAP\n        uniform sampler2D u_DiffuseTexture;\n        #endif\n\n        #if defined(DIFFUSEMAP) || ((defined(DIRECTIONLIGHT) || defined(POINTLIGHT) || defined(SPOTLIGHT)) && (defined(SPECULARMAP) || defined(NORMALMAP)))\n        varying vec2 v_Texcoord0;\n        #endif\n\n        #ifdef LIGHTMAP\n        varying vec2 v_LightMapUV;\n        uniform sampler2D u_LightMap;\n        #endif\n\n        #if defined(DIRECTIONLIGHT) || defined(POINTLIGHT) || defined(SPOTLIGHT)\n        uniform vec3 u_MaterialSpecular;\n        uniform float u_Shininess;\n        #ifdef SPECULARMAP\n        uniform sampler2D u_SpecularTexture;\n        #endif\n        #endif\n\n        #ifdef FOG\n        uniform float u_FogStart;\n        uniform float u_FogRange;\n        uniform vec3 u_FogColor;\n        #endif\n\n        #if defined(DIRECTIONLIGHT) || defined(POINTLIGHT) || defined(SPOTLIGHT)\n        varying vec3 v_Normal;\n        #endif\n\n        #if (defined(DIRECTIONLIGHT) || defined(POINTLIGHT) || defined(SPOTLIGHT))&& defined(NORMALMAP)\n        uniform sampler2D u_NormalTexture;\n        varying vec3 v_Tangent;\n        varying vec3 v_Binormal;\n        #endif\n\n        #ifdef DIRECTIONLIGHT\n        uniform DirectionLight u_DirectionLight;\n        #endif\n\n        #ifdef POINTLIGHT\n        uniform PointLight u_PointLight;\n        #endif\n\n        #ifdef SPOTLIGHT\n        uniform SpotLight u_SpotLight;\n        #endif\n\n        uniform vec3 u_AmbientColor;\n\n        #if defined(POINTLIGHT) || defined(SPOTLIGHT) || defined(RECEIVESHADOW)\n        varying vec3 v_PositionWorld;\n        #endif\n\n        #include "ShadowHelper.glsl"\n        varying float v_posViewZ;\n        #ifdef RECEIVESHADOW\n        #if defined(SHADOWMAP_PSSM2) || defined(SHADOWMAP_PSSM3)\n            uniform mat4 u_lightShadowVP[4];\n        #endif\n        #ifdef SHADOWMAP_PSSM1\n        varying vec4 v_lightMVPPos;\n        #endif\n        #endif\n\n        void main_castShadow()\n        {\n            //gl_FragColor=vec4(v_posViewZ,0.0,0.0,1.0);\n            gl_FragColor = packDepth(v_posViewZ);\n            #if defined(DIFFUSEMAP) && defined(ALPHATEST)\n            float alpha = texture2D(u_DiffuseTexture, v_Texcoord0).w;\n            if (alpha < u_AlphaTestValue) {\n                discard;\n            }\n            #endif\n        }\n        void main_normal()\n        {\n            vec3 globalDiffuse = u_AmbientColor;\n            #ifdef LIGHTMAP\n            globalDiffuse += DecodeLightmap(texture2D(u_LightMap, v_LightMapUV));\n            #endif\n\n            #if defined(DIRECTIONLIGHT) || defined(POINTLIGHT) || defined(SPOTLIGHT)\n            vec3 normal;\n            #if (defined(DIRECTIONLIGHT) || defined(POINTLIGHT) || defined(SPOTLIGHT))&& defined(NORMALMAP)\n            vec3 normalMapSample = texture2D(u_NormalTexture, v_Texcoord0).rgb;\n            normal = normalize(NormalSampleToWorldSpace(normalMapSample, v_Normal, v_Tangent, v_Binormal));\n            #else\n            normal = normalize(v_Normal);\n            #endif\n            vec3 viewDir = normalize(v_ViewDir);\n            #endif\n\n            vec4 mainColor = u_DiffuseColor;\n            #ifdef DIFFUSEMAP\n            vec4 difTexColor = texture2D(u_DiffuseTexture, v_Texcoord0);\n            mainColor = mainColor * difTexColor;\n            #endif\n            #if defined(COLOR) && defined(ENABLEVERTEXCOLOR)\n            mainColor = mainColor * v_Color;\n            #endif\n\n            #ifdef ALPHATEST\n            if (mainColor.a < u_AlphaTestValue)\n                discard;\n            #endif\n\n\n            vec3 diffuse = vec3(0.0);\n            vec3 specular = vec3(0.0);\n            #if defined(DIRECTIONLIGHT) || defined(POINTLIGHT) || defined(SPOTLIGHT)\n            vec3 dif, spe;\n            #ifdef SPECULARMAP\n            vec3 gloss = texture2D(u_SpecularTexture, v_Texcoord0).rgb;\n            #else\n            #ifdef DIFFUSEMAP\n            vec3 gloss = vec3(difTexColor.a);\n            #else\n            vec3 gloss = vec3(1.0);\n            #endif\n            #endif\n            #endif\n\n            #ifdef DIRECTIONLIGHT\n            LayaAirBlinnPhongDiectionLight(u_MaterialSpecular, u_Shininess, normal, gloss, viewDir, u_DirectionLight, dif, spe);\n            //diffuse += dif;\n            //specular += spe;\n\n            diffuse = diffuse + (dif*u_DiffuseParam.x + u_DiffuseParam.y);\n            #endif\n\n            #ifdef POINTLIGHT\n            LayaAirBlinnPhongPointLight(v_PositionWorld, u_MaterialSpecular, u_Shininess, normal, gloss, viewDir, u_PointLight, dif, spe);\n            //diffuse += dif;\n            //specular += spe;\n\n            diffuse = diffuse + (dif*u_DiffuseParam.x + u_DiffuseParam.y);\n            #endif\n\n            #ifdef SPOTLIGHT\n            LayaAirBlinnPhongSpotLight(v_PositionWorld, u_MaterialSpecular, u_Shininess, normal, gloss, viewDir, u_SpotLight, dif, spe);\n            //diffuse += dif;\n            //specular += spe;\n\n            diffuse = diffuse + (dif*u_DiffuseParam.x + u_DiffuseParam.y);\n            #endif\n\n            #ifdef RECEIVESHADOW\n            float shadowValue = 1.0;\n            #ifdef SHADOWMAP_PSSM3\n            shadowValue = getShadowPSSM3(u_shadowMap1, u_shadowMap2, u_shadowMap3, u_lightShadowVP, u_shadowPSSMDistance, u_shadowPCFoffset, v_PositionWorld, v_posViewZ, 0.001);\n            #endif\n            #ifdef SHADOWMAP_PSSM2\n            shadowValue = getShadowPSSM2(u_shadowMap1, u_shadowMap2, u_lightShadowVP, u_shadowPSSMDistance, u_shadowPCFoffset, v_PositionWorld, v_posViewZ, 0.001);\n            #endif\n            #ifdef SHADOWMAP_PSSM1\n            shadowValue = getShadowPSSM1(u_shadowMap1, v_lightMVPPos, u_shadowPSSMDistance, u_shadowPCFoffset, v_posViewZ, 0.001);\n            #endif\n            gl_FragColor = vec4(mainColor.rgb * (globalDiffuse + diffuse), mainColor.a);\n            #else\n            gl_FragColor = vec4(mainColor.rgb * (globalDiffuse + diffuse), mainColor.a);\n            #endif\n\n            #if defined(DIRECTIONLIGHT) || defined(POINTLIGHT) || defined(SPOTLIGHT)\n            \n            #ifdef RECEIVESHADOW\n\n    \n            //shadowValue += 0.3;\n            //shadowValue = clamp(shadowValue,0.0,1.0);\n\n            if(shadowValue < 0.5)\n            {\n                gl_FragColor.rgba *= vec4(0.8,0.8,0.8,1.0);\n            }\n        \n            \n        \n            #else\n            \n            gl_FragColor.rgb += specular;\n\n            \n            #endif\n            #endif\n\n            #ifdef FOG\n            float lerpFact = clamp((1.0 / gl_FragCoord.w - u_FogStart) / u_FogRange, 0.0, 1.0);\n            gl_FragColor.rgb = mix(gl_FragColor.rgb, u_FogColor, lerpFact);\n            #endif\n        }\n\n        void main()\n        {\n            #ifdef CASTSHADOW\n            main_castShadow();\n            #else\n            main_normal();\n            #endif\n        }`;
            var attributeMap = {
                a_Position: Laya.VertexMesh.MESH_POSITION0,
                a_Color: Laya.VertexMesh.MESH_COLOR0,
                a_Normal: Laya.VertexMesh.MESH_NORMAL0,
                a_Texcoord0: Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
                a_Texcoord1: Laya.VertexMesh.MESH_TEXTURECOORDINATE1,
                a_BoneWeights: Laya.VertexMesh.MESH_BLENDWEIGHT0,
                a_BoneIndices: Laya.VertexMesh.MESH_BLENDINDICES0,
                a_Tangent0: Laya.VertexMesh.MESH_TANGENT0,
                a_MvpMatrix: Laya.VertexMesh.MESH_MVPMATRIX_ROW0,
                a_WorldMat: Laya.VertexMesh.MESH_WORLDMATRIX_ROW0
            };
            var uniformMap = {
                u_Bones: Laya.Shader3D.PERIOD_CUSTOM,
                u_DiffuseTexture: Laya.Shader3D.PERIOD_MATERIAL,
                u_SpecularTexture: Laya.Shader3D.PERIOD_MATERIAL,
                u_NormalTexture: Laya.Shader3D.PERIOD_MATERIAL,
                u_AlphaTestValue: Laya.Shader3D.PERIOD_MATERIAL,
                u_DiffuseColor: Laya.Shader3D.PERIOD_MATERIAL,
                u_MaterialSpecular: Laya.Shader3D.PERIOD_MATERIAL,
                u_Shininess: Laya.Shader3D.PERIOD_MATERIAL,
                u_TilingOffset: Laya.Shader3D.PERIOD_MATERIAL,
                u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
                u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
                u_LightmapScaleOffset: Laya.Shader3D.PERIOD_SPRITE,
                u_LightMap: Laya.Shader3D.PERIOD_SPRITE,
                u_CameraPos: Laya.Shader3D.PERIOD_CAMERA,
                u_ReflectTexture: Laya.Shader3D.PERIOD_SCENE,
                u_ReflectIntensity: Laya.Shader3D.PERIOD_SCENE,
                u_FogStart: Laya.Shader3D.PERIOD_SCENE,
                u_FogRange: Laya.Shader3D.PERIOD_SCENE,
                u_FogColor: Laya.Shader3D.PERIOD_SCENE,
                "u_DirectionLight.Color": Laya.Shader3D.PERIOD_SCENE,
                "u_DirectionLight.Direction": Laya.Shader3D.PERIOD_SCENE,
                "u_PointLight.Position": Laya.Shader3D.PERIOD_SCENE,
                "u_PointLight.Range": Laya.Shader3D.PERIOD_SCENE,
                "u_PointLight.Color": Laya.Shader3D.PERIOD_SCENE,
                "u_SpotLight.Position": Laya.Shader3D.PERIOD_SCENE,
                "u_SpotLight.Direction": Laya.Shader3D.PERIOD_SCENE,
                "u_SpotLight.Range": Laya.Shader3D.PERIOD_SCENE,
                "u_SpotLight.Spot": Laya.Shader3D.PERIOD_SCENE,
                "u_SpotLight.Color": Laya.Shader3D.PERIOD_SCENE,
                u_AmbientColor: Laya.Shader3D.PERIOD_SCENE,
                u_shadowMap1: Laya.Shader3D.PERIOD_SCENE,
                u_shadowMap2: Laya.Shader3D.PERIOD_SCENE,
                u_shadowMap3: Laya.Shader3D.PERIOD_SCENE,
                u_shadowPSSMDistance: Laya.Shader3D.PERIOD_SCENE,
                u_lightShadowVP: Laya.Shader3D.PERIOD_SCENE,
                u_shadowPCFoffset: Laya.Shader3D.PERIOD_SCENE,
                u_DiffuseParam: Laya.Shader3D.PERIOD_MATERIAL
            };
            var stateMap = {
                s_Cull: Laya.Shader3D.RENDER_STATE_CULL,
                s_Blend: Laya.Shader3D.RENDER_STATE_BLEND,
                s_BlendSrc: Laya.Shader3D.RENDER_STATE_BLEND_SRC,
                s_BlendDst: Laya.Shader3D.RENDER_STATE_BLEND_DST,
                s_DepthTest: Laya.Shader3D.RENDER_STATE_DEPTH_TEST,
                s_DepthWrite: Laya.Shader3D.RENDER_STATE_DEPTH_WRITE
            };
            var lamber_custom_vs = '#include "Lighting.glsl";\r\n\r\nattribute vec4 a_Position;\r\n\r\n#ifdef GPU_INSTANCE\r\n\tattribute mat4 a_MvpMatrix;\r\n#else\r\n\tuniform mat4 u_MvpMatrix;\r\n#endif\r\n\r\n\r\n#if defined(DIFFUSEMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))||(defined(LIGHTMAP)&&defined(UV))\r\n\tattribute vec2 a_Texcoord0;\r\n\tvarying vec2 v_Texcoord0;\r\n#endif\r\n\r\n#if defined(LIGHTMAP)&&defined(UV1)\r\n\tattribute vec2 a_Texcoord1;\r\n#endif\r\n\r\n#ifdef LIGHTMAP\r\n\tuniform vec4 u_LightmapScaleOffset;\r\n\tvarying vec2 v_LightMapUV;\r\n#endif\r\n\r\n#ifdef COLOR\r\n\tattribute vec4 a_Color;\r\n\tvarying vec4 v_Color;\r\n#endif\r\n\r\n#ifdef BONE\r\n\tconst int c_MaxBoneCount = 24;\r\n\tattribute vec4 a_BoneIndices;\r\n\tattribute vec4 a_BoneWeights;\r\n\tuniform mat4 u_Bones[c_MaxBoneCount];\r\n#endif\r\n\r\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\r\n\tattribute vec3 a_Normal;\r\n\tvarying vec3 v_Normal; \r\n\tuniform vec3 u_CameraPos;\r\n\tvarying vec3 v_ViewDir; \r\n#endif\r\n\r\n#if (defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&defined(NORMALMAP)\r\n\tattribute vec4 a_Tangent0;\r\n\tvarying vec3 v_Tangent;\r\n\tvarying vec3 v_Binormal;\r\n#endif\r\n\r\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||defined(RECEIVESHADOW)\r\n\t#ifdef GPU_INSTANCE\r\n\t\tattribute mat4 a_WorldMat;\r\n\t#else\r\n\t\tuniform mat4 u_WorldMat;\r\n\t#endif\r\n\tvarying vec3 v_PositionWorld;\r\n#endif\r\n\r\nvarying float v_posViewZ;\r\n#ifdef RECEIVESHADOW\r\n  #ifdef SHADOWMAP_PSSM1 \r\n  varying vec4 v_lightMVPPos;\r\n  uniform mat4 u_lightShadowVP[4];\r\n  #endif\r\n#endif\r\n\r\n#ifdef TILINGOFFSET\r\n\tuniform vec4 u_TilingOffset;\r\n#endif\r\n\r\nvoid main_castShadow()\r\n{\r\n\tvec4 position;\r\n\t#ifdef BONE\r\n\t\tmat4 skinTransform = u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;\r\n\t\tskinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;\r\n\t\tskinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;\r\n\t\tskinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;\r\n\t\tposition=skinTransform*a_Position;\r\n\t#else\r\n\t\tposition=a_Position;\r\n\t#endif\r\n\t#ifdef GPU_INSTANCE\r\n\t\tgl_Position = a_MvpMatrix * position;\r\n\t#else\r\n\t\tgl_Position = u_MvpMatrix * position;\r\n\t#endif\r\n\t\r\n\t//TODO没考虑UV动画呢\r\n\t#if defined(DIFFUSEMAP)&&defined(ALPHATEST)\r\n\t\tv_Texcoord0=a_Texcoord0;\r\n\t#endif\r\n\tgl_Position=remapGLPositionZ(gl_Position);\r\n\tv_posViewZ = gl_Position.z;\r\n}\r\n\r\nvoid main_normal()\r\n{\r\n\tvec4 position;\r\n\t#ifdef BONE\r\n\t\tmat4 skinTransform = u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;\r\n\t\tskinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;\r\n\t\tskinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;\r\n\t\tskinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;\r\n\t\tposition=skinTransform*a_Position;\r\n\t#else\r\n\t\tposition=a_Position;\r\n\t#endif\r\n\t#ifdef GPU_INSTANCE\r\n\t\tgl_Position = a_MvpMatrix * position;\r\n\t#else\r\n\t\tgl_Position = u_MvpMatrix * position;\r\n\t#endif\r\n\t\r\n\t#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||defined(RECEIVESHADOW)\r\n\t\tmat4 worldMat;\r\n\t\t#ifdef GPU_INSTANCE\r\n\t\t\tworldMat = a_WorldMat;\r\n\t\t#else\r\n\t\t\tworldMat = u_WorldMat;\r\n\t\t#endif\r\n\t#endif\r\n\t\r\n\r\n\t#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\r\n\t\tmat3 worldInvMat;\r\n\t\t#ifdef BONE\r\n\t\t\tworldInvMat=inverse(mat3(worldMat*skinTransform));\r\n\t\t#else\r\n\t\t\tworldInvMat=inverse(mat3(worldMat));\r\n\t\t#endif  \r\n\t\tv_Normal=a_Normal*worldInvMat;\r\n\t\t#if (defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&defined(NORMALMAP)\r\n\t\t\tv_Tangent=a_Tangent0.xyz*worldInvMat;\r\n\t\t\tv_Binormal=cross(v_Normal,v_Tangent)*a_Tangent0.w;\r\n\t\t#endif\r\n\t#endif\r\n\r\n\t#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||defined(RECEIVESHADOW)\r\n\t\tv_PositionWorld=(worldMat*position).xyz;\r\n\t#endif\r\n\t\r\n\t#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\r\n\t\tv_ViewDir=u_CameraPos-v_PositionWorld;\r\n\t#endif\r\n\r\n\t#if defined(DIFFUSEMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))\r\n\t\t#ifdef TILINGOFFSET\r\n\t\t\tv_Texcoord0=TransformUV(a_Texcoord0,u_TilingOffset);\r\n\t\t#else\r\n\t\t\tv_Texcoord0=a_Texcoord0;\r\n\t\t#endif\r\n\t#endif\r\n\r\n\t#ifdef LIGHTMAP\r\n\t\t#ifdef SCALEOFFSETLIGHTINGMAPUV\r\n\t\t\t#ifdef UV1\r\n\t\t\t\tv_LightMapUV=vec2(a_Texcoord1.x,1.0-a_Texcoord1.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\r\n\t\t\t#else\r\n\t\t\t\tv_LightMapUV=vec2(a_Texcoord0.x,1.0-a_Texcoord0.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\r\n\t\t\t#endif \r\n\t\t\tv_LightMapUV.y=1.0-v_LightMapUV.y;\r\n\t\t#else\r\n\t\t\t#ifdef UV1\r\n\t\t\t\tv_LightMapUV=a_Texcoord1;\r\n\t\t\t#else\r\n\t\t\t\tv_LightMapUV=a_Texcoord0;\r\n\t\t\t#endif \r\n\t\t#endif \r\n\t#endif\r\n\r\n\t#if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\r\n\t\tv_Color=a_Color;\r\n\t#endif\r\n\r\n\t#ifdef RECEIVESHADOW\r\n\t\tv_posViewZ = gl_Position.w;\r\n\t\t#ifdef SHADOWMAP_PSSM1 \r\n\t\t\tv_lightMVPPos = u_lightShadowVP[0] * vec4(v_PositionWorld,1.0);\r\n\t\t#endif\r\n\t#endif\r\n\tgl_Position=remapGLPositionZ(gl_Position);\r\n}\r\n\r\nvoid main()\r\n{\r\n\t#ifdef CASTSHADOW\r\n\t\tmain_castShadow();\r\n\t#else\r\n\t\tmain_normal();\r\n\t#endif\r\n}';
            var shader = Laya.Shader3D.add(LamberCustomMaterial.ShaderName, null, null, true);
            var subShader = new Laya.SubShader(attributeMap, uniformMap);
            shader.addSubShader(subShader);
            subShader.addShaderPass(lamber_custom_vs, lamber_custom_ps, stateMap);
            Laya.ClassUtils.regClass(LamberCustomMaterial.ShaderName, LamberCustomMaterial);
        }
    }
    LamberCustomMaterial.ShaderName = "LamberCustom";
    LamberCustomMaterial.DIFFUSE_PARAM = Laya.Shader3D.propertyNameToID("u_DiffuseParam");
    class dnsdk_manager extends igc.igc_singleton_manager_base {
        constructor() {
            super();
            this.chk_dev_box_x = 0;
            this.get_data_success = false;
        }
        static get instance() {
            return dnsdk_manager.get_instance();
        }
        init() {
            console.log("dnsdk_manager 初始化");
            if (global.game.channel_type === igc.e_channel_type.wx || global.game.channel_type === igc.e_channel_type.web) {
                Laya.Browser.window.dnsdk.log = function() {};
                this.dnsdk_init(1, {
                    appid: "37823",
                    pt: "wx"
                });
                this.register_listener();
            }
        }
        register_listener() {
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_init, this, this.dnsdk_init);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_share, this, this.dnsdk_share);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_send_event, this, this.send_event);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_chapter_start, this, this.chapter_start);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_chapter_running, this, this.chapter_running);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_chapter_end, this, this.chapter_end);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_get_data, this, this.get_data);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_report_show, this, this.report_show);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_report_click, this, this.report_click);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_show_push_view, this, this.dnsdk_show_push_view);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_show_game_share, this, this.dnsdk_show_game_share);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_show_splash_list, this, this.dnsdk_show_splash_list);
            // igc.broadcast_manager.instance.add_listener(broadcast_ids.dnsdk_show_single_splash, this, this.dnsdk_show_single_splash);
            // igc.phone_manager.instance.add_listener(phone_ids.dnsdk_init_compelete, this, this.get_is_init_compelete);
        }
        get_is_init_compelete() {
            return this.get_data_success;
        }
        dnsdk_show_push_view(id, param) {
            if (!this.get_data_success) {
                return;
            }
            if (param.isShow) {
                let dialog = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                    ui_name: "PushView"
                });
                if (dialog) {
                    console.log("ui 已经存在 PushView");
                    return;
                }
                igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.PushView
                });
            } else {
                let PushView = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                    ui_name: "PushView"
                });
                if (PushView) {
                    igc.phone_manager.instance.call(phone_ids.hide_ui, {
                        instance: PushView
                    });
                }
            }
        }
        dnsdk_show_game_share(id, param) {
            if (!this.get_data_success) {
                return;
            }
            if (param.isShow) {
                let dialog = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                    ui_name: "GameShareDialog"
                });
                if (dialog) {
                    console.log("ui 已经存在 GameShareDialog");
                    return;
                }
                igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.GameShareDialog,
                    param: {
                        is_result: param.is_result,
                        is_success: param.is_success || false
                    }
                });
            } else {
                let GameShareDialog = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                    ui_name: "GameShareDialog"
                });
                if (GameShareDialog) {
                    igc.phone_manager.instance.call(phone_ids.hide_ui, {
                        instance: GameShareDialog
                    });
                }
            }
        }
        dnsdk_show_splash_list(id, param) {
            if (!this.get_data_success) {
                return;
            }
            if (param.isShow) {
                let dialog = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                    ui_name: "SplashList_dialog"
                });
                if (dialog) {
                    console.log("ui 已经存在 SplashList_dialog");
                    return;
                }
                igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.SplashList_dialog
                });
            } else {
                let SplashList_dialog = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                    ui_name: "SplashList_dialog"
                });
                if (SplashList_dialog) {
                    igc.phone_manager.instance.call(phone_ids.hide_ui, {
                        instance: SplashList_dialog
                    });
                }
            }
        }
        dnsdk_show_single_splash(id, param) {
            if (!this.get_data_success) {
                return;
            }
            if (param.isShow) {
                let dialog = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                    ui_name: "SplashSingleDialog"
                });
                if (dialog) {
                    console.log("ui 已经存在 SplashSingleDialog");
                    return;
                }
                igc.phone_manager.instance.call(phone_ids.show_ui, {
                    ui: ui_class.SplashSingleDialog
                });
            } else {
                let SplashSingleDialog = igc.phone_manager.instance.call(phone_ids.get_ui_by_name, {
                    ui_name: "SplashSingleDialog"
                });
                if (SplashSingleDialog) {
                    igc.phone_manager.instance.call(phone_ids.hide_ui, {
                        instance: SplashSingleDialog
                    });
                }
            }
        }
        dnsdk_init(id, param) {
            console.log("dnsdk init", param);
            Laya.Browser.window.dnsdk.init(param.appid, param.pt);
            this.set_data_received_listener();
        }
        dnsdk_share(id, param) {
            console.log("dnsdk init", param);
            Laya.Browser.window.dnsdk.onShareAppMessage(function() {
                return {
                    imageUrl: param.imageUrl,
                    title: param.title,
                    query: param.query
                };
            });
        }
        send_event(id, param) {
            Laya.Browser.window.dnsdk.tjSendEvent(param.eventId, param.object);
        }
        chapter_start(id, param) {
            let userId = global.game.tpfUserId;
            console.log("xiejinhui 用户id", userId);
            Laya.Browser.window.dnsdk.tjOnStart({
                stageId: param.chapterId,
                stageName: param.chapterName,
                userId: userId
            });
        }
        chapter_running(id, param) {}
        chapter_end(id, param) {}
        set_data_received_listener() {
            let self = this;
            Laya.Browser.window.dnsdk.onDataReceived(function(data) {
                Laya.Browser.window.dnsdk.log(data);
                console.log("获取动能互推数据成功！", data);
                self.get_data_success = true;
                XWxad.Inst.init(Laya.Browser.window.wx);
                igc.broadcast_manager.instance.broadcast(broadcast_ids.dnsdk_init_compelete);
            });
        }
        get_data(id, param) {
            // switch (param.type) {
            //     case "iconList":
            //         return Laya.Browser.window.dnsdk.data.pushData.iconList;

            //     case "bannerList":
            //         return Laya.Browser.window.dnsdk.data.pushData.bannerList;

            //     case "plaqueList":
            //         return Laya.Browser.window.dnsdk.data.pushData.plaqueList;

            //     case "buttomList":
            //         return Laya.Browser.window.dnsdk.data.pushData.buttomList;

            //     case "gouppageList":
            //         return Laya.Browser.window.dnsdk.data.pushData.gouppageList;

            //     case "moregroupList":
            //         return Laya.Browser.window.dnsdk.data.pushData.moregroupList;

            //     case "hotgameList":
            //         return Laya.Browser.window.dnsdk.data.pushData.hotgameList;

            //     case "fungameList":
            //         return Laya.Browser.window.dnsdk.data.pushData.fungameList;
            // }
        }
        report_show(id, param) {
            var tjData = {
                label: param.id,
                pushappid: param.pushAppID,
                placement: param.placement,
                eventid: param.grouppage
            };
            Laya.Browser.window.dnsdk.tjSendShowEvent("bottom", tjData);
        }
        report_click(id, param) {
            var tjData = {
                label: param.id,
                pushappid: param.pushAppID,
                placement: param.placement,
                eventid: param.grouppage
            };
            Laya.Browser.window.dnsdk.tjSendClickEvent(tjData);
        }
    }
    class Main {
        constructor() {

            let version = "1.0.0.0";
            user_setting_manager.instance.init_stage_info();
            igc.igc_patch_laya_manager.patch_laya(global.game.channel_type);
            igc.utils_manager.patch_touch();
            this.game_init(version);
        }
        game_init(version) {

            igc.igc_resources_utils.set_remote_path("");

            Laya.Shader3D.debugMode = true;
            igc.igc_resources_utils.add_local_file("version.json", true);
            igc.igc_resources_utils.add_local_file("configs", true);
            igc.igc_resources_utils.add_local_file("sounds", true);
            igc.igc_resources_utils.add_local_file("models", true);
            igc.igc_resources_utils.add_local_file("ui", true);
            // if (igc.e_channel_type.oppo_qg === global.game.channel_type) {
            //     igc.igc_resources_utils.add_local_file("version.json", false);
            //     igc.igc_resources_utils.add_local_file("configs", false);
            //     igc.igc_resources_utils.add_local_file("ui", false);
            //     igc.igc_resources_utils.add_local_file("levels", false);
            //     igc.igc_resources_utils.add_local_file("sounds", false);
            //     igc.igc_resources_utils.add_local_file("models", false);
            // } else if (igc.e_channel_type.vivo_qg === global.game.channel_type) {
            //     igc.igc_resources_utils.add_local_file("version.json", false);
            //     igc.igc_resources_utils.add_local_file("configs", false);
            //     igc.igc_resources_utils.add_local_file("ui", false);
            //     igc.igc_resources_utils.add_local_file("sounds", false);
            //     igc.igc_resources_utils.add_local_file("models", false);
            // } else if (igc.e_channel_type.tt === global.game.channel_type) {
            //     igc.igc_resources_utils.add_local_file("version.json", true);
            //     igc.igc_resources_utils.add_local_file("configs", true);
            //     igc.igc_resources_utils.add_local_file("ui", true);
            //     igc.igc_resources_utils.add_local_file("levels", true);
            //     igc.igc_resources_utils.add_local_file("sounds", true);
            //     igc.igc_resources_utils.add_local_file("models", true);
            // } else if (igc.e_channel_type.wx === global.game.channel_type) {
            //     igc.igc_resources_utils.add_local_file("version.json", true);
            //     igc.igc_resources_utils.add_local_file("configs", true);
            //     igc.igc_resources_utils.add_local_file("sounds", true);
            //     igc.igc_resources_utils.add_local_file("models", true);
            //     igc.igc_resources_utils.add_local_file("ui", true);
            // } else {
            //     igc.igc_resources_utils.add_local_file("version.json", true);
            //     igc.igc_resources_utils.add_local_file("configs", true);
            //     igc.igc_resources_utils.add_local_file("ui", true);
            //     igc.igc_resources_utils.add_local_file("sounds", true);
            //     igc.igc_resources_utils.add_local_file("levels", true);
            //     igc.igc_resources_utils.add_local_file("models", true);
            // }
            igc.igc_resources_utils.add_jpack_file("levels");
            igc.igc_resources_utils.add_jpack_file("effects");
            igc.igc_resources_utils.add_jpack_file("models");
            igc.igc_resources_utils.add_jpack_all_in_one_file("configs");
            igc.igc_audio_manager.instance.sound_volume = .4;
            Laya.Shader3D.debugMode = false;
            if (global.game.is_local_stat !== e_login_type.login_type_tpf) {
                igc.igc_timer.loop(1, this, function() {
                    igc.igc_main.instance.update_per_second();
                }, undefined, true);
            } {
                COCBuildingMaterial.__init__();
                COCForbidArmyAreaMaterial.__init__();
                COCGridMaterial.__init__();
                COCLightningMaterial.__init__();
                COCPlayerMaterial.__init__();
                COCWallMaterial.__init__();
                LamberCustomMaterial.__init__();
            }
            Laya.timer.frameLoop(1, this, function() {
                igc.igc_main.instance.Update();
            });
            Laya["DebugPanel"] && Laya["DebugPanel"].enable();
            Laya.stage.scaleMode = GameConfig.scaleMode;
            Laya.stage.screenMode = GameConfig.screenMode;
            Laya.stage.alignV = GameConfig.alignV;
            Laya.stage.alignH = GameConfig.alignH;
            if (window["qg"]) {}
            Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;
            if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true") {
                Laya.enableDebugPanel();
            }
            Laya.alertGlobalError = true;
            let self = this;
            Laya.ResourceVersion.enable("version.json", new Laya.Handler(this, function() {
                igc.igc_patch_laya_manager.patch_unpack(function() {
                    self.onConfigLoaded();
                });
            }), Laya.ResourceVersion.FILENAME_VERSION);
        }
        load_game_preload(finish_callback) {
            let preload_managers = [];
            preload_managers.push(ui_manager);
            preload_managers.push(save_manager);
            let preload_singleton_managers = [];
            preload_singleton_managers.push(igc.igc_config_manager.instance);
            preload_singleton_managers.push(igc.igc_login_manager.instance);
            preload_singleton_managers.push(login_manager.instance);
            preload_singleton_managers.push(loading_manager.instance);
            for (let i = 0; i < preload_managers.length; ++i) {
                let instance = new preload_managers[i]();
                instance.set_instance(instance);
                preload_singleton_managers.push(instance);
            }
            let load_list = [];
            for (let i = preload_singleton_managers.length - 1; 0 <= i; --i) {
                if (preload_singleton_managers[i].load_async) {
                    load_list.push(preload_singleton_managers[i]);
                }
            }
            let load_list_count = load_list.length;
            igc.igc_resources_utils.async_load(load_list, function() {
                for (let i = 0; i < preload_singleton_managers.length; ++i) {
                    window[preload_singleton_managers[i].constructor.name] = preload_singleton_managers[i];
                    preload_singleton_managers[i].init();
                }
                let update_list = [];
                for (let i = 0; i < preload_singleton_managers.length; ++i) {
                    if (preload_singleton_managers[i].update) {
                        update_list.push(preload_singleton_managers[i]);
                    }
                }
                igc.igc_timer.frameLoop(1, this, function() {
                    for (let i = 0; i < update_list.length; ++i) {
                        update_list[i].update();
                    }
                }, undefined, true);
                loading_manager.instance.show(e_loading_type.enter_game, 0);
                let load_list_delay = [];
                for (let i = preload_singleton_managers.length - 1; 0 <= i; --i) {
                    if (preload_singleton_managers[i].load_async_delay) {
                        load_list_delay.push(preload_singleton_managers[i]);
                    }
                }
                igc.igc_resources_utils.async_load_delay(load_list_delay, function() {
                    loading_manager.instance.show(e_loading_type.enter_game, .33);
                    finish_callback && finish_callback();
                    if (window["qg"] && global.game.channel_type === igc.e_channel_type.oppo_qg) {
                        igc.igc_timer.once(1, this, function() {
                            window["qg"].loadingComplete({
                                complete: function(res) {}
                            });
                        }, undefined, true);
                    }
                }, function(progress) {
                    loading_manager.instance.show(e_loading_type.enter_game, progress * .33);
                    return true;
                });
            }, function(progress) {
                if (window["qg"] && global.game.channel_type === igc.e_channel_type.oppo_qg) {
                    window["qg"].setLoadingProgress({
                        progress: progress * 100
                    });
                }
                console.info(progress);

                return true;
            });
        }
        load_game_must(finish_callback) {
            let managers = [];
            managers.push(battle_scene_manager);
            managers.push(item_manager);
            managers.push(effect_manager);
            managers.push(energy_manager);
            managers.push(track_manager);
            managers.push(chapter_manager);
            managers.push(model_manager);
            managers.push(dnsdk_manager);
            let singleton_managers = [];
            singleton_managers.push(igc.igc_audio_manager.instance);
            singleton_managers.push(sound_manager.instance);
            singleton_managers.push(id_manager.instance);
            singleton_managers.push(game_time_manager.instance);
            singleton_managers.push(path_find_manager.instance);
            singleton_managers.push(atlas_animation_manager.instance);
            singleton_managers.push(game_config_manager.instance);
            singleton_managers.push(point_manager.instance);
            singleton_managers.push(role_manager.instance);
            singleton_managers.push(shake_manager.instance);
            singleton_managers.push(adv_manager.instance);
            singleton_managers.push(tips_manager.instance);
            for (let i = 0; i < managers.length; ++i) {
                let instance = new managers[i]();
                instance.set_instance(instance);
                singleton_managers.push(instance);
            }
            let load_list = [];
            for (let i = singleton_managers.length - 1; 0 <= i; --i) {
                if (singleton_managers[i].load_async) {
                    load_list.push(singleton_managers[i]);
                }
            }
            let load_list_count = load_list.length;
            let self = this;
            igc.igc_resources_utils.async_load(load_list, function() {
                let check_is_login = function() {
                    if (login_manager.instance.is_login) {
                        for (let i = 0; i < singleton_managers.length; ++i) {
                            window[singleton_managers[i].constructor.name] = singleton_managers[i];
                            singleton_managers[i].init();
                        }
                        igc.broadcast_manager.instance.broadcast(broadcast_ids.load_save);
                        let update_list = [];
                        for (let i = 0; i < singleton_managers.length; ++i) {
                            if (singleton_managers[i].update) {
                                update_list.push(singleton_managers[i]);
                            }
                        }
                        igc.igc_timer.frameLoop(1, this, function() {
                            for (let i = 0; i < update_list.length; ++i) {
                                update_list[i].update();
                            }
                        }, undefined, true);

                        let temp_managers = [];
                        for (let i = singleton_managers.length - 1; 0 <= i; --i) {
                            temp_managers.push(singleton_managers[i]);
                        }
                        resource_manager.instance.init();
                        resource_manager.instance.managers = temp_managers;
                        // htmlfs.saveui();
                        platform.getInstance().startup("Off-The-Rails-3D", () => {
                            if (!Laya.LocalStorage.getItem("Off-The-Rails-3D-Music")) {
                                Laya.LocalStorage.setItem("Off-The-Rails-3D-Music", "false");
                            }

                            // igc.igc_audio_manager.instance.play_music("bg");
                            sound_manager.instance.play_music(0, {
                                id: "bg"
                            });
                            Laya.SoundManager.muted = Laya.LocalStorage.getItem("Off-The-Rails-3D-Music");
                            finish_callback && finish_callback();
                        });
                    } else {
                        Laya.timer.frameOnce(1, this, check_is_login);
                    }
                };
                Laya.timer.frameOnce(1, this, check_is_login);
            }, function(progress) {
                loading_manager.instance.show(e_loading_type.enter_game, .33 + progress * .33);
                return true;
            });
        }
        onConfigLoaded() {
            let self = this;
            this.load_game_preload(function() {
                self.load_game_must(function() {

                    igc.broadcast_manager.instance.broadcast(broadcast_ids.battle_prepare_complete);
                });
            });
        }
    }
    new Main();
})();